#$Id: custom.pm,v 1.8 2004/06/11 22:02:26 pattieja Exp $
#This package is released under the GNU General Public License.
#You should have recieved a copy of the GPL with it.
# Copyright (c) 2000 HLR http://www.pcxperience.org  All rights reserved.
# This is the customization file for all our programs
package custom;
require Exporter;
@ISA = qw(Exporter);
@EXPORT = qw($transaction $result $server_interface $prog_name $prog_version $user_tb $client_tb $job_tb $payrate_tb $task_tb $wage_unit_tb $time_sheet_tb $sys_admin $back_button $module_name $menu_bgcolor $menu_fgcolor $body_bgcolor $body_fgcolor $edit_bgcolor $edit_fgcolor $prog_fgcolor $user_fgcolor $table_cellpadding %input $conn $WebAuth $db_host $db_name $db_user $site_dir $date_format PrintErrorHeader CleanUp commify IsValidDateSyntax MakeValidDate IsValidString IsValidInteger IsValidUInteger IsValidFloat IsValidFloating PrintStandardMainMenu PrintStandardLedgerMainMenu ReverseDateString $db_passwd setDBDateStyle);

use strict;
# bring in the unique module which is created by the setup script
use unique;

# global variables
use vars '$transaction';
use vars '$result';
use vars '$prog_name';
use vars '$prog_version';
use vars '$sys_admin';
use vars '$back_button';
use vars '$module_name';
use vars '$menu_bgcolor';
use vars '$menu_fgcolor';
use vars '$body_bgcolor';
use vars '$body_fgcolor';
use vars '$edit_bgcolor';
use vars '$edit_fgcolor';
use vars '$prog_fgcolor';
use vars '$user_fgcolor';
use vars '$table_cellpadding';
use vars '%input';
use vars '$conn';
use vars '$WebAuth';
use vars '$date_format';

$transaction = 0;
$result=0;

# START OF CONFIGURABLE OPTIONS

$prog_name = "PCX Accounting"; 
$prog_version = "1.6.0";

# set $WebAuth = "true" if using .htaccess for extra authentication else
# set = "false".

$WebAuth = "false";

$date_format = "%m-%d-%Y";  # month-day-long year    ex.: 06-02-2000

$sys_admin = "Please notify the systems administrator.<br>\n";
$back_button = "Please press the <font color=\"blue\"><a href=\"javascript:window.history.back();\">back</a></font> button and fix it.<br>\n";

$module_name = $prog_name . " " . $prog_version;

# module colors
$menu_bgcolor = "indianred";
$menu_fgcolor = "white";
$body_bgcolor = "white";
$body_fgcolor = "black";
$edit_bgcolor = "darkgray";
$edit_fgcolor = "white";
$prog_fgcolor = "brown";
$user_fgcolor = "red";

# table defines
$table_cellpadding = "4";  # not always used.

# END OF CONFIGURABLE OPTIONS

# Worker SubRoutines
sub PrintErrorHeader
{
  print "<head><title>Error: $module_name</title></head>\n";
  print "<body bgcolor=$body_bgcolor>\n";
  return 1;
}

sub CleanUp
{
  if ($transaction == 1)
  { # we need to end the work block
    $result = $conn->exec("end work");
  }

  print "</body>\n";
  print "</html>\n";
  exit 1;
}

sub commify
{
  my $text = reverse $_[0];
  $text =~ s/(\d\d\d)(?=\d)(?!\d*\.)/$1,/g;
  return scalar reverse $text;
}

sub IsValidDateSyntax
{
  my $date_to_check = $_[0];
  if (not ($date_to_check =~ /^\d{1,2}[-\/]\d{1,2}[-\/](\d\d|\d\d\d\d)$/))
  {
    return 0;
  }
  return 1;
}

sub MakeValidDate
{
  my $date_string = $_[0];

  (my $month, my $day, my $year) = split (/[-\/]/, $date_string);
  $date_string = `/bin/date --date="$month/$day/$year" +%m-%d-%Y`;
  chomp $date_string;  # strip the trailing new line.

  return $date_string;
}

sub IsValidString
{
  my $string = $_[0];
  my @invalid_chars = qw( ' ` " | : ; * ? $ % # @ ^ ! ~ { } [ ] < > \ + = );

  foreach my $char (@invalid_chars)
  {
    my $char2 = quotemeta $char;  # escape the character if necessary.
    if ($string =~ /$char2/)
    {
      return $char;
    }
  }

  return "";
}

sub IsValidInteger
{
  my $string = $_[0];
  my @string = split //, $string;

  my $i;
  for ($i=0; $i < length $string; $i++)
  {
    if ($string[$i] =~ /[^\-0-9]/)
    {
      return $string[$i];
    }
    if ($string[$i] eq "-" && $i > 0)
    {
      return $string[$i];
    }
  }
  return "";
}

# Valid Unsigned Integer Check (Can't have - in front).
sub IsValidUInteger
{
  my $string = $_[0];
  my @string = split //, $string;

  my $i;
  for ($i=0; $i < length $string; $i++)
  {
    if ($string[$i] =~ /[^0-9]/)
    {
      return $string[$i];
    }
  }
  return "";
}

sub IsValidFloat
{
  my $string = $_[0];
  my @string = split //, $string;

  my $i;
  for ($i=0; $i < length $string; $i++)
  {
    if ($string[$i] =~ /[^\-\.0-9]/)
    {
      return $string[$i];
    }
    if ($string[$i] eq "-" && $i > 0)
    {
      return $string[$i];
    }
    if ($string[$i] eq "." && $i != (length $string) - 3)
    {
      return $string[$i];
    }
  }
  if (length $string < 4)
  {
    return $string;  # Must have at least 3 digits and a . to be a valid floating point number!
  }
  if (not $string[$i-3] eq ".")
  {
    return $string;  # It must have a . to be a floating point number!
  }
  return "";
}

sub IsValidFloating
{
  # takes a string as input
  # if the string exactly matches a floating point value, the string is returned
  # otherwise, the "" string is returned indicating an error in the input not matching
  # a floating point value exactly
  my $string = $_[0];

  if ($string =~ /^-?(([0-9]+)|([0-9]*\.[0-9]+))$/)
  {
    return $string;
  }
  return "";
}

sub PrintStandardLedgerMainMenu
{
 return "";
}

sub PrintStandardMainMenu
{
  return "";
}

sub ReverseDateString
{
  my $date_string = $_[0];
  my $reversed_string;
  my ($month, $day, $year);
  my $separator_token;
  my $temp_string;

  if (!IsValidDateSyntax($date_string))
  {
    return "";
  }

  if ($date_string =~ /-/)
  {
    $separator_token = "-";
  }
  else
  {
    $separator_token = "/";
  }

  ($month, $day, $year) = split "$separator_token", $date_string;

  # reverse the date_string
  $reversed_string = `date -d '$month/$day/$year' +%Y%m%d`;

  return $reversed_string;
}

# setDBDateStyle
# requires: $conn
# returns: $result
sub setDBDateStyle
{
  my $conn = shift;
  my $result = $conn->exec("SET datestyle TO 'POSTGRES,US'");
  
  return $result;
}

1;
