#!/usr/bin/perl
#$Id: journal_activity_rows.cgi,v 1.1 2001/09/06 10:21:19 moreejt Exp $
#This package is released under the GPL.  You should have recieved the GPL with it.
# Copyright (c) 2000 HLR http://www.pcxperience.org  All rights reserved.

# journal_activity_rows.cgi  -  Created by Jason A. Pattie, 09/23/1999
# This script allows the user to enter the rows of information for the journal entry
# they are working with.  This includes Sub Entities, Accounts, Sub Accounts, Debits, and Credits.
# It takes the current working mode by which this script was reached and, upon submittal, sends the
# entered information to the appropriate script to create a new entry or update an existing entry.

use strict;

use Pg;  # PostgreSQL Database Module
use cgi_lib;  # CGI Library routines
use custom;  # our customizable features
use reports;

use vars '$date';
use vars '$count';
use vars '$count2';
use vars '$count3';
use vars '$temp_count';
use vars '$count_sub_entities';
use vars '$count_accounts';
use vars '$count_sub_accounts';
use vars '$trans_date';
use vars '$trans_month';
use vars '$trans_day1';
use vars '$trans_day2';
use vars '$trans_year';
use vars '$payee_payer';
use vars '$memo';
use vars '$remember';
use vars '$current_fiscal_year';
use vars '$start_fiscal';
use vars '$stop_fiscal';
use vars '$start_month_fiscal';
use vars '$stop_month_fiscal';
use vars '$start_day_fiscal';
use vars '$stop_day_fiscal';
use vars '$start_year_fiscal';
use vars '$stop_year_fiscal';
use vars '$ref_num';
use vars '@sub_e_codes';
use vars '@account_nums';
use vars '@sub_account_nums';
use vars '@amounts';
use vars '@dorcs';
use vars '@cleareds';
use vars '@counters';
use vars '$num_rows';
use vars '$max_rows';
use vars '$temp_rows';
use vars '$sub_entity_value';
use vars '$local_account_name';
use vars '$local_account_id';
use vars '$local_account_type';
use vars '$sub_account_name';
use vars '$sub_account_id';
use vars '%sub_account_bank';
use vars '$account_numbers_string';
use vars '$payee_payer_exists';
use vars '$payee_payer_id';
use vars '$temp';
use vars '$last_check';
use vars '$last_deposit';
use vars '%check_hash';
use vars '%deposit_hash';
use vars '$local_accounts_string';
use vars '$other_mode';

use vars '@sub_entity_array';
use vars '@account_array';
use vars '@sub_entity_reset_array';
use vars '@account_reset_array';
use vars '$journal_command';
use vars '$journal_view_command';
use vars '$journal_display_string';
my $error_string;

# get the values being passed in from the client
%input = ();  # make sure it is empty!
cgi_lib::ReadParse(*input);

# begin the HTML Output
print cgi_lib::PrintHeader();
print "<html>\n";

my $mode;  # modes are "edit" or "new"
my $ledger_name;  # name of ledger to work with
my $ledger_db;
my $ledger_color;
my $journal_name;
my $journal_code;
my $result2;
my $result3;
my $result4;
my $date_from;
my $date_to;
my $sort_journal;
my $sort_by;
my $journal_bgcolor;
my $num_journal_entries;
my $num_extra_rows;
$num_extra_rows = 20;
my $num_extra_refresh_rows;
$num_extra_refresh_rows = 5;
my $fewer_rows_available;
$fewer_rows_available = 0;
my $ledger_code;
my $report_obj;

use PortalWrapper; # The Portal Wrapper library.

my $portalObj;
$portalObj = PortalWrapper->new;
if ($portalObj->didErrorOccur)
{
  # begin the HTML Output
  print cgi_lib::PrintHeader();
  print "<html>\n";

  PrintErrorHeader();
  print $portalObj->errorMessage;
  CleanUp();
}
my $dbObj;
$dbObj = $portalObj->getDBInfo;
if (!defined $dbObj)
{
  if ($portalObj->didErrorOccur)
  {
    # begin the HTML Output
    print cgi_lib::PrintHeader();
    print "<html>\n";
  
    PrintErrorHeader();
    print $portalObj->errorMessage;
    CleanUp();
  }
}
else
{
  if ($dbObj->didErrorOccur)
  {
    # begin the HTML Output
    print cgi_lib::PrintHeader();
    print "<html>\n";
  
    PrintErrorHeader();
    print $dbObj->errorMessage;
    CleanUp();
  }
}
$db_host = $dbObj->dbHost;
$db_name = $dbObj->dbName;
$db_user = $dbObj->dbUser;
$db_passwd = $dbObj->dbPasswd;

my $database_connected;
$database_connected = 0;

$payee_payer_exists = "false";

if (not (exists $input{'edit_submit'} or exists $input{'create_submit'} or exists $input{'refresh1'} or exists $input{'refresh2'}))
{
  PrintErrorHeader();
  print "<h1>Error:  Access Denied!</h1>\n";
  print "Invalid options.<br>$sys_admin";
  CleanUp();
}

$ledger_db = $input{'ledger_db'};
if (length $ledger_db == 0)
{
  PrintErrorHeader();
  print "<h1>Error: You must specify a ledger to work with!</h1>\n";
  print "$back_button";
  CleanUp();
}
$error_string = IsValidString($ledger_db);
if (length $error_string > 0)
{
  PrintErrorHeader();
  print "<h1>Error:  Invalid Database Name!</h1>\n";
  print "<b>$error_string</b> is invalid!<br>$back_button";
  CleanUp();
}

# validate we got valid input from the user.
if (exists $input{'edit_submit'})
{
  $mode = "edit";
}
elsif (exists $input{'create_submit'})
{
  $mode = "new";
}
elsif (exists $input{'refresh1'} or exists $input{'refresh2'})
{
  $mode = "refresh";
  $other_mode = $input{'mode'};
  if ($other_mode eq "edit")
  {
    # check to make sure that we have a reference number to edit
    if (not exists $input{'ref_num'})
    {
      PrintErrorHeader();
      print "<h1>Access Denied!</h1>\n";
      print "Error: Reference Number not specified for editing journal entry!<br>$sys_admin";
      CleanUp();
    }
    $ref_num = $input{'ref_num'};
    $error_string = IsValidUInteger($ref_num);
    if (length $error_string > 0)
    {
      PrintErrorHeader();
      print "<h1>Error:  Invalid Reference Number!</h1>\n";
      print "<b>$error_string</b> is invalid!<br>$back_button";
      CleanUp();
    }
  }
}
else
{
  PrintErrorHeader();
  print "<h1>Access Denied!</h1>\n";
  print "Error: Invalid options given!\n<br>$sys_admin";
  CleanUp();
}

if ($mode eq "refresh")
{
  $journal_code = $input{'journal_code'};
}
else
{
  $journal_code = $input{'journal_code_select'};
}
if (length $journal_code == 0)
{
  PrintErrorHeader();
  print "<h1>Error: You must specify a journal to work with!</h1>\n";
  print "$back_button";
  CleanUp();
}
$error_string = IsValidString($journal_code);
if (length $error_string > 0)
{
  PrintErrorHeader();
  print "<h1>Error:  Invalid Journal Code!</h1>\n";
  print "<b>$error_string</b> is invalid!<br>$back_button";
  CleanUp();
}

$journal_bgcolor = $input{'journal_bgcolor'};
if (length $journal_bgcolor == 0)
{
  $journal_bgcolor = "deepskyblue";
}
$error_string = IsValidString($journal_bgcolor);
if (length $error_string > 0)
{
  PrintErrorHeader();
  print "<h1>Error:  Invalid Journal Color!</h1>\n";
  print "<b>$error_string</b> is invalid!<br>$back_button";
  CleanUp();
}

if ($mode eq "edit")
{
  # check to make sure that we have a reference number to edit
  if (not exists $input{'ref_num'})
  {
    PrintErrorHeader();
    print "<h1>Access Denied!</h1>\n";
    print "Error: Reference Number not specified for editing journal entry!<br>$sys_admin";
    CleanUp();
  }
  $ref_num = $input{'ref_num'};
  $error_string = IsValidUInteger($ref_num);
  if (length $error_string > 0)
  {
    PrintErrorHeader();
    print "<h1>Error:  Invalid Reference Number!</h1>\n";
    print "<b>$error_string</b> is invalid!<br>$back_button";
    CleanUp();
  }
}

# check to see if we are running under mod_perl
if (exists $ENV{MOD_PERL})
{
  # check to see if the database is still connected
  if (defined $conn)
  {
    # check the status of the connection
    if ($conn->status != PGRES_CONNECTION_OK)
    {
      $database_connected = 0;
    }
    else
    {
      # connection still good!
      $database_connected = 1;
    }
  }
  else
  {
    $database_connected = 0;
  }
}

if (not $database_connected)
{
  # connect to the database.
  $conn = Pg::connectdb("host = $db_host dbname = $db_name user = $db_user password = $db_passwd");
  if ($conn->status == PGRES_CONNECTION_BAD)
  {
    PrintErrorHeader();
    print "<h1>Error:  Couldn't connect to the database!</h1><br>\n";
    print $conn->errorMessage . "<br>$sys_admin";
    CleanUp();
  }
}

# set the DateStyle for the Database.
$result = setDBDateStyle($conn);
if ($result->resultStatus != PGRES_COMMAND_OK)
{
  PrintErrorHeader();
  print "<h1>Error:  Setting Date Style failed!</h1>\n";
  print $conn->errorMessage . "<br>$sys_admin";
  CleanUp();
}

# now validate that the ledger they specified is valid
$result = $conn->exec("select name from entity_tb where database_name = '$ledger_db'");
if ($result->resultStatus != PGRES_TUPLES_OK)
{
  PrintErrorHeader();
  print "<h1>Error: Accessing database failed!</h1>\n";
  print $conn->errorMessage . "<br>Trying to check entity table.<br>$sys_admin";
  CleanUp();
}
if ($result->ntuples == 0)
{
  PrintErrorHeader();
  print "<h1>Error: Ledger <font color=\"blue\">$ledger_db</font> does not exist!</h1>\n";
  print "$sys_admin";
  CleanUp();
}
else
{
  $ledger_name = $result->getvalue(0, 0);
}

# create the reports object
$report_obj = reports->new($conn, $ledger_db);
if ($report_obj->didErrorOccur())
{
  PrintErrorHeader();
  print $report_obj->getErrorMessage();
  CleanUp();
}
$ledger_code = $report_obj->getLedgerCode();
if ($report_obj->didErrorOccur())
{
  PrintErrorHeader();
  print $report_obj->getErrorMessage();
  CleanUp();
}
$ledger_color = $report_obj->getLedgerColor();
if ($report_obj->didErrorOccur())
{
  PrintErrorHeader();
  print $report_obj->getErrorMessage();
  CleanUp();
}

# now make sure that the journal exists that we are supposed to work with
if ($journal_code eq "all_journals")
{ # this will be a special case
  $journal_name = "All Journals";
}
else
{
  $result = $conn->exec("select name from journal_tb where code = '$journal_code'");
  if ($result->resultStatus != PGRES_TUPLES_OK)
  {
    PrintErrorHeader();
    print "<h1>Error:  Accessing database <font color=\"blue\">$ledger_db</font> failed!</h1>\n";
    print $conn->errorMessage . "<br>Tried to validate Journal with code = <font color=\"blue\">$journal_code</font>.<br>$sys_admin";
    CleanUp();
  }
  if ($result->ntuples == 0)
  {
    PrintErrorHeader();
    print "<h1>Error:  Journal with code = <font color=\"blue\">$journal_code</font> does not exist!</h1>\n";
    print "$sys_admin";
    CleanUp();
  }
  $journal_name = $result->getvalue(0, 0);
}

# get current fiscal year and verify that it is not closed
$result = $conn->exec("select working_year from variables_tb WHERE ledger_code = '$ledger_code'");
if ($result->resultStatus != PGRES_TUPLES_OK)
{
  print "<h1>Error: Accessing database <font color=\"blue\"$ledger_db</font> failed!</h1>\n";
  print $conn->errorMessage . "<br>Tried to get current fiscal year from database.<br>$sys_admin";
  CleanUp();
}
if ($result->ntuples != 1)
{
  print "<h1>Error: Wrong number of records returned!</h1>\n";
  print "There should only be one record in the variables_tb.  " . $result->ntuples . " were returned.<br>$sys_admin";
  CleanUp();
}
$current_fiscal_year = $result->getvalue(0, 0);
# get the date ranges for the current fiscal year if it is not closed
$result = $conn->exec("select closed, start_date, end_date from known_years_tb where year = $current_fiscal_year AND ledger_code = '$ledger_code'");
if ($result->resultStatus != PGRES_TUPLES_OK)
{
  print "<h1>Error: Accessing database <font color=\"blue\"$ledger_db</font> failed!</h1>\n";
  print $conn->errorMessage . "<br>Tried to get current fiscal year info. from database.<br>$sys_admin";
  CleanUp();
}
if ($result->ntuples != 1)
{
  print "<h1>Error: Wrong number of records returned!</h1>\n";
  print "There should only be one record for each individual fiscal year.<br>$sys_admin";
  CleanUp();
}
if ($result->getvalue(0, 0) eq "t")
{
  print "<h1>Fiscal Year ($current_fiscal_year) is Closed!</h1>\n";
  print "You cannot work with the records in a closed fiscal year.<br>$sys_admin";
  CleanUp();
}
$start_fiscal = $result->getvalue(0, 1);
$stop_fiscal = $result->getvalue(0, 2);
($start_month_fiscal, $start_day_fiscal, $start_year_fiscal) = split "-", $start_fiscal;
($stop_month_fiscal, $stop_day_fiscal, $stop_year_fiscal) = split "-", $stop_fiscal;

if ($mode eq "edit")
{
  $payee_payer_id = $input{'payee_payer_select'};
  $error_string = IsValidInteger($payee_payer_id);
  if (length $error_string > 0)
  {
    PrintErrorHeader();
    print "<h1>Error:  Invalid Payee-Payer ID!</h1>\n";
    print "<b>$error_string</b> is invalid!<br>$back_button";
    CleanUp();
  }
  if ($payee_payer_id != -1)
  {
    $result = $conn->exec("select payee_payer from journal_entry_tb where ref_num = $payee_payer_id AND ledger_code = '$ledger_code'");
    if ($result->resultStatus != PGRES_TUPLES_OK)
    {
      print "<h1>Error: Accessing database failed!</h1>\n";
      print $conn->errorMessage . "<br>Tried to get payee-payer name for record $payee_payer_id.<br>$sys_admin";
      CleanUp();
    }
    if ($result->ntuples != 1)
    {
      print "<h1>Error: Wrong number of records returned!</h1>\n";
      print "There should be only one record returned, not " . $result->ntuples . ".<br>$sys_admin";
      CleanUp();
    }
    $payee_payer = $result->getvalue(0, 0);
    # determine whether the payee-payer is remembered or recalled or does not exist yet
    if ($input{'payee_payer_text'} =~ /^R>.+/)
    {
      $payee_payer_exists = "true";
    }
    else
    {
      # see if payee-payer matches what is entered in the payee-payer text field
      if ($payee_payer eq $input{'payee_payer_text'})
      {
        $payee_payer_exists = "true";
      }
      else
      {
        $payee_payer_exists = "false";
      }
    }
  }
  else
  {
    $payee_payer_exists = "false";
  }
  if ($payee_payer_exists eq "false")
  {
    $payee_payer = $input{'payee_payer_text'};
    $error_string = IsValidString($payee_payer);
    if (length $error_string > 0)
    {
      PrintErrorHeader();
      print "<h1>Error:  Invalid Payee-Payer!</h1>\n";
      print "<b>$error_string</b> is invalid!<br>$back_button";
      CleanUp();
    }
  }
  # get the row data for the journal entry pointed to by ref_num
  $result = $conn->exec("select parent_num, sub_e_code, account_num, sub_account_num, amount, dorc, cleared, counter from debitcredit_tb where parent_num = $ref_num and dorc = true AND ledger_code = '$ledger_code'");
  if ($result->resultStatus != PGRES_TUPLES_OK)
  {
    print "<h1>Error: Accessing database <font color=\"blue\">$ledger_db</font> failed!</h1>\n";
    print $conn->errorMessage . "<br>Tried to retrieve Journal Entry rows data for ref_num = <font color=\"blue\">$ref_num</font>.<br>$sys_admin";
    CleanUp();
  }
  for ($count=0; $count < $result->ntuples; $count++)
  {
    # load the arrays with the row data from the transaction
    $sub_e_codes[$count] = $result->getvalue($count, 1);
    $account_nums[$count] = $result->getvalue($count, 2);
    $sub_account_nums[$count] = $result->getvalue($count, 3);
    # if account is bank account (cash), then sub-account is check/deposit number; put into sub_account_text field
    $result2 = $conn->exec("select type from account_tb where number = $account_nums[$count]");
    if ($result2->resultStatus != PGRES_TUPLES_OK)
    {
      print "<h1>Error: Accessing database failed!</h1>\n";
      print $conn->errorMessage . "<br>Tried to lookup account type for $account_nums[$count].<br>$sys_admin";
      CleanUp();
    }
    if ($result2->ntuples != 1)
    {
      print "<h1>Error: Wrong number of records returned!</h1>\n";
      print $result2->ntuples . " records were returned. There should be only one.<br>$sys_admin";
      CleanUp();
    }
    if ($result2->getvalue(0, 0) == 0)
    {
      # this is a bank (cash) account; mark it
      $sub_account_bank{$account_nums[$count]} = 1;
    }
    $amounts[$count] = $result->getvalue($count, 4);
    # remove ($)s and (,)s from amount; database doesn't like these
    $amounts[$count] =~ s/\$//g;
    $amounts[$count] =~ s/\,//g;
    $dorcs[$count] = $result->getvalue($count, 5);
    $cleareds[$count] = $result->getvalue($count, 6);
    $counters[$count] = $result->getvalue($count, 7);
  }
  $result = $conn->exec("select parent_num, sub_e_code, account_num, sub_account_num, amount, dorc, cleared, counter from debitcredit_tb where parent_num = $ref_num and dorc = false AND ledger_code = '$ledger_code'");
  if ($result->resultStatus != PGRES_TUPLES_OK)
  {
    print "<h1>Error: Accessing database <font color=\"blue\">$ledger_db</font> failed!</h1>\n";
    print $conn->errorMessage . "<br>Tried to retrieve Journal Entry rows data for ref_num = <font color=\"blue\">$ref_num</font>.<br>$sys_admin";
    CleanUp();
  }
  for ($count2=0; $count2 < $result->ntuples; $count++, $count2++)
  {
    # load the arrays with the row data from the transaction
    $sub_e_codes[$count] = $result->getvalue($count2, 1);
    $account_nums[$count] = $result->getvalue($count2, 2);
    $sub_account_nums[$count] = $result->getvalue($count2, 3);
    # if account is bank account (cash), then sub-account is check number; put into sub_account_text field
    $result2 = $conn->exec("select type from account_tb where number = $account_nums[$count]");
    if ($result2->resultStatus != PGRES_TUPLES_OK)
    {
      print "<h1>Error: Accessing database failed!</h1>\n";
      print $conn->errorMessage . "<br>Tried to lookup account type for $account_nums[$count].<br>$sys_admin";
      CleanUp();
    }
    if ($result2->ntuples != 1)
    {
      print "<h1>Error: Wrong number of records returned!</h1>\n";
      print $result2->ntuples . " records were returned. There should be only one.<br>$sys_admin";
      CleanUp();
    }
    if ($result2->getvalue(0, 0) == 0)
    {
      # this is a bank (cash) account; mark it
      $sub_account_bank{$account_nums[$count]} = 1;
    }
    $amounts[$count] = $result->getvalue($count2, 4);
    # remove ($)s and (,)s from amount; database doesn't like these
    $amounts[$count] =~ s/\$//g;
    $amounts[$count] =~ s/\,//g;
    $dorcs[$count] = $result->getvalue($count2, 5);
    $cleareds[$count] = $result->getvalue($count2, 6);
    $counters[$count] = $result->getvalue($count2, 7);
  }
  $num_rows = $count;

  # run through all accounts that are cash accounts (type == 0) and get the next available check/deposit #'s
  $result = $conn->exec("select acct_num from local_accounts_tb WHERE ledger_code = '$ledger_code'");
  if ($result->resultStatus != PGRES_TUPLES_OK)
  {
    PrintErrorHeader();
    print "<h1>Error: Accessing database failed!</h1>\n";
    print $conn->errorMessage . "<br>1006: Tried to get the list of local accounts assigned to this ledger.<br>$sys_admin";
    CleanUp();
  }
  # build a string with the list of local account numbers in it
  $local_accounts_string = "";
  for ($count=0; $count < $result->ntuples; $count++)
  {
    $local_accounts_string .= $result->getvalue($count, 0);
    if ($count < $result->ntuples - 1)
    {
      $local_accounts_string .= ", ";
    }
  }
  if ($local_accounts_string eq "")
  {
    PrintErrorHeader();
    print "<h1>Error: No Accounts Found!</h1>\n";
    print "It appears that there are no accounts assigned to this ledger.  You must assign some accounts to continue.<br>$sys_admin";
    CleanUp();
  }
  $result = $conn->exec("select number from account_tb where type = 0 and number in ($local_accounts_string)");
  if ($result->resultStatus != PGRES_TUPLES_OK)
  {
    PrintErrorHeader();
    print "<h1>Error: Accessing database failed!</h1>\n";
    print $conn->errorMessage . "<br>1007: Tried to get all accounts from the main database with type = 0.<br>$sys_admin";
    CleanUp();
  }
  for ($count=0; $count < $result->ntuples; $count++)
  {
    # get last used check/deposit #'s
    $result2 = $conn->exec("select max(sub_account_num) from debitcredit_tb where dorc = true and parent_num = (select max(parent_num) from debitcredit_tb where account_num = " . $result->getvalue($count, 0) . " and dorc = true and sub_account_num > -1 AND ledger_code = '$ledger_code') AND ledger_code = '$ledger_code'");
    if ($result2->resultStatus != PGRES_TUPLES_OK)
    {
      print "<h1>Error: Accessing database failed!</h1>\n";
      print "Error 1000<br>\n";
      print $conn->errorMessage . "<br>Tried to get the last used deposit# for account " . $result->getvalue($count, 0) . ".<br>$sys_admin";
      CleanUp();
    }
    if ($result2->ntuples > 1)
    {
      print "<h1>Error: Wrong number of records returned!</h1>\n";
      print "Error 1001<br>\n";
      print $result2->ntuples . " records were returned.  There should be only one.<br>$sys_admin";
      CleanUp();
    }
    if ($result2->ntuples == 0)
    {
      $last_deposit = -1;
    }
    else
    {
      $last_deposit = $result2->getvalue(0, 0);
      if ($last_deposit eq "")
      {
        $last_deposit = -1;
      }
    }
    $result2 = $conn->exec("select max(sub_account_num) from debitcredit_tb where dorc = false and parent_num = (select max(parent_num) from debitcredit_tb where account_num = " . $result->getvalue($count, 0) . " and dorc = false and sub_account_num > -1 AND ledger_code = '$ledger_code') AND ledger_code = '$ledger_code'");
    if ($result2->resultStatus != PGRES_TUPLES_OK)
    {
      print "<h1>Error: Accessing database failed!</h1>\n";
      print "Error 1002<br>\n";
      print $conn->errorMessage . "<br>Tried to get the last used check# for account " . $result->getvalue($count, 0) . ".<br>$sys_admin";
      CleanUp();
    }
    if ($result2->ntuples > 1)
    {
      print "<h1>Error: Wrong number of records returned!</h1>\n";
      print "Error 1003<br>\n";
      print $result2->ntuples . " records were returned.  There should be only one.<br>$sys_admin";
      CleanUp();
    }
    if ($result2->ntuples == 0)
    {
      $last_check = -1;
    }
    else
    {
      $last_check = $result2->getvalue(0, 0);
      if ($last_check eq "")
      {
        $last_check = -1;
      }
    }
    # increment last_deposit and last_check and check for duplicates in database
    do {
      $last_deposit++;
      $result2 = $conn->exec("select parent_num from debitcredit_tb where account_num = " . $result->getvalue($count, 0) . " and dorc = true and sub_account_num = $last_deposit AND ledger_code = '$ledger_code'");
    } while ($result2->resultStatus == PGRES_TUPLES_OK && $result2->ntuples > 0);
    if ($result2->resultStatus != PGRES_TUPLES_OK)
    {
      PrintErrorHeader();
      print "<h1>Error: Accessing database failed!</h1>\n";
      print $conn->errorMessage . "<br>1004:  Tried to see if the incremented deposit exists in the database.<br>$sys_admin";
      CleanUp();
    }
    do {
      $last_check++;
      $result2 = $conn->exec("select parent_num from debitcredit_tb where account_num = " . $result->getvalue($count, 0) . " and dorc = false and sub_account_num = $last_check AND ledger_code = '$ledger_code'");
    } while ($result2->resultStatus == PGRES_TUPLES_OK && $result2->ntuples > 0);
    if ($result2->resultStatus != PGRES_TUPLES_OK)
    {
      PrintErrorHeader();
      print "<h1>Error: Accessing database failed!</h1>\n";
      print $conn->errorMessage . "<br>1005:  Tried to see if the incremented check exists in the database.<br>$sys_admin";
      CleanUp();
    }

    $temp = $result->getvalue($count, 0);
    $deposit_hash{$temp} = $last_deposit;

    $temp = $result->getvalue($count, 0);
    $check_hash{$temp} = $last_check;
  }
}
elsif ($mode eq "new")
{
  $payee_payer_id = $input{'payee_payer_select'};
  $error_string = IsValidInteger($payee_payer_id);
  if (length $error_string > 0)
  {
    PrintErrorHeader();
    print "<h1>Error:  Invalid Payee-Payer ID!</h1>\n";
    print "<b>$error_string</b> is invalid!<br>$back_button";
    CleanUp();
  }
  if ($payee_payer_id eq "-1")
  {
    $payee_payer_id = 0;
  }
  if ($payee_payer_id != -1)
  {
    $result = $conn->exec("select payee_payer from journal_entry_tb where ref_num = $payee_payer_id AND ledger_code = '$ledger_code'");
    if ($result->resultStatus != PGRES_TUPLES_OK)
    {
      print "<h1>Error: Accessing database failed!</h1>\n";
      print $conn->errorMessage . "<br>Tried to get payee-payer name for record $payee_payer_id.<br>$sys_admin";
      CleanUp();
    }
    if ($result->ntuples > 1)
    {
      print "<h1>Error: Wrong number of records returned!</h1>\n";
      print "There should be only one record returned, not " . $result->ntuples . ".<br>$sys_admin";
      CleanUp();
    }
    if ($result->ntuples == 0)
    {
      $payee_payer = "";
    }
    else
    {
      $payee_payer = $result->getvalue(0, 0);
    }
    # determine whether the payee-payer is remembered or recalled or does not exist yet
    if ($input{'payee_payer_text'} =~ /^R>.+/)
    {
      $payee_payer_exists = "true";
    }
    else
    {
      # see if payee-payer matches what is entered in the payee-payer text field
      if ($payee_payer eq $input{'payee_payer_text'})
      {
        $payee_payer_exists = "true";
      }
      else
      {
        $payee_payer_exists = "false";
      }
    }
  }
  else
  {
    $payee_payer_exists = "false";
  }
  if ($payee_payer_exists eq "true")
  {
    # get recalled/remembered data for the payee-payer previously entered
    # get the row data for the journal entry pointed to by ref_num
    $result = $conn->exec("select parent_num, sub_e_code, account_num, sub_account_num, amount, dorc, cleared, counter from debitcredit_tb where parent_num = $payee_payer_id and dorc = true AND ledger_code = '$ledger_code'");
    if ($result->resultStatus != PGRES_TUPLES_OK)
    {
      print "<h1>Error: Accessing database <font color=\"blue\">$ledger_db</font> failed!</h1>\n";
      print $conn->errorMessage . "<br>Tried to retrieve Journal Entry rows data for ref_num = <font color=\"blue\">$ref_num</font>.<br>$sys_admin";
      CleanUp();
    }
    for ($count=0; $count < $result->ntuples; $count++)
    {
      # load the arrays with the row data from the transaction
      $sub_e_codes[$count] = $result->getvalue($count, 1);
      $account_nums[$count] = $result->getvalue($count, 2);
      $dorcs[$count] = $result->getvalue($count, 5);
      # if account is bank account (cash), then sub-account is check/deposit number; put into sub_account_text field
      $result2 = $conn->exec("select type from account_tb where number = $account_nums[$count]");
      if ($result2->resultStatus != PGRES_TUPLES_OK)
      {
        print "<h1>Error: Accessing database failed!</h1>\n";
        print $conn->errorMessage . "<br>Tried to lookup account type for $account_nums[$count].<br>$sys_admin";
        CleanUp();
      }
      if ($result2->ntuples != 1)
      {
        print "<h1>Error: Wrong number of records returned!</h1>\n";
        print $result2->ntuples . " records were returned. There should be only one.<br>$sys_admin";
        CleanUp();
      }
      if ($result2->getvalue(0, 0) == 0)
      {
        # this is a bank (cash) account; mark it
        $sub_account_bank{$account_nums[$count]} = 1;
        # get last used check/deposit #'s
        $result2 = $conn->exec("select max(sub_account_num) from debitcredit_tb where dorc = true and parent_num = (select max(parent_num) from debitcredit_tb where account_num = $account_nums[$count] and dorc = true and sub_account_num > -1 AND ledger_code = '$ledger_code') AND ledger_code = '$ledger_code'");
        if ($result2->resultStatus != PGRES_TUPLES_OK)
        {
          print "<h1>Error: Accessing database failed!</h1>\n";
          print "Error 1000<br>\n";
          print $conn->errorMessage . "<br>Tried to get the last used deposit# for account " . $account_nums[$count] . ".<br>$sys_admin";
          CleanUp();
        }
        if ($result2->ntuples > 1)
        {
          print "<h1>Error: Wrong number of records returned!</h1>\n";
          print "Error 1001<br>\n";
          print $result2->ntuples . " records were returned.  There should be only one.<br>$sys_admin";
          CleanUp();
        }
        if ($result2->ntuples == 0)
        {
          $last_deposit = -1;
        }
        else
        {
          $last_deposit = $result2->getvalue(0, 0);
          if ($last_deposit eq "")
          {
            $last_deposit = -1;
          }
        }
        $result2 = $conn->exec("select max(sub_account_num) from debitcredit_tb where dorc = false and parent_num = (select max(parent_num) from debitcredit_tb where account_num = $account_nums[$count] and dorc = false and sub_account_num > -1 AND ledger_code = '$ledger_code') AND ledger_code = '$ledger_code'");
        if ($result2->resultStatus != PGRES_TUPLES_OK)
        {
          print "<h1>Error: Accessing database failed!</h1>\n";
          print "Error 1002<br>\n";
          print $conn->errorMessage . "<br>Tried to get the last used check# for account " . $account_nums[$count] . ".<br>$sys_admin";
          CleanUp();
        }
        if ($result2->ntuples > 1)
        {
          print "<h1>Error: Wrong number of records returned!</h1>\n";
          print "Error 1003<br>\n";
          print $result2->ntuples . " records were returned.  There should be only one.<br>$sys_admin";
          CleanUp();
        }
        if ($result2->ntuples == 0)
        {
          $last_check = -1;
        }
        else
        {
          $last_check = $result2->getvalue(0, 0);
          if ($last_check eq "")
          {
            $last_check = -1;
          }
        }
        # increment last_deposit and last_check and check for duplicates in database
        do {
          $last_deposit++;
          $result2 = $conn->exec("select parent_num from debitcredit_tb where account_num = $account_nums[$count] and dorc = true and sub_account_num = $last_deposit AND ledger_code = '$ledger_code'");
        } while ($result2->resultStatus == PGRES_TUPLES_OK && $result2->ntuples > 0);
        if ($result2->resultStatus != PGRES_TUPLES_OK)
        {
          PrintErrorHeader();
          print "<h1>Error: Accessing database failed!</h1>\n";
          print $conn->errorMessage . "<br>1004.  Tried to see if the incremented deposit exists in the database.<br>$sys_admin";
          CleanUp();
        }
        do {
          $last_check++;
          $result2 = $conn->exec("select parent_num from debitcredit_tb where account_num = $account_nums[$count] and dorc = false and sub_account_num = $last_check AND ledger_code = '$ledger_code'");
        } while ($result2->resultStatus == PGRES_TUPLES_OK && $result2->ntuples > 0);
        if ($result2->resultStatus != PGRES_TUPLES_OK)
        {
          PrintErrorHeader();
          print "<h1>Error: Accessing database failed!</h1>\n";
          print $conn->errorMessage . "<br>1005.  Tried to see if the incremented check exists in the database.<br>$sys_admin";
          CleanUp();
        }
        if ($dorcs[$count] eq "t")
        {
          if ($last_deposit == 0)
          {
            $sub_account_nums[$count] = -1;
          }
          else
          {
            $sub_account_nums[$count] = $last_deposit;
          }
        }
        else
        {
          if ($last_check == 0)
          {
            $sub_account_nums[$count] = -1;
          }
          else
          {
            $sub_account_nums[$count] = $last_check;
          }
        }
      }
      else
      {
        $sub_account_nums[$count] = $result->getvalue($count, 3);
      }

      $amounts[$count] = $result->getvalue($count, 4);
      # remove ($)s and (,)s from amount; database doesn't like these
      $amounts[$count] =~ s/\$//g;
      $amounts[$count] =~ s/\,//g;
      $cleareds[$count] = $result->getvalue($count, 6);
      $counters[$count] = $result->getvalue($count, 7);
    }
    $result = $conn->exec("select parent_num, sub_e_code, account_num, sub_account_num, amount, dorc, cleared, counter from debitcredit_tb where parent_num = $payee_payer_id and dorc = false AND ledger_code = '$ledger_code'");
    if ($result->resultStatus != PGRES_TUPLES_OK)
    {
      print "<h1>Error: Accessing database <font color=\"blue\">$ledger_db</font> failed!</h1>\n";
      print $conn->errorMessage . "<br>Tried to retrieve Journal Entry rows data for ref_num = <font color=\"blue\">$ref_num</font>.<br>$sys_admin";
      CleanUp();
    }
    for ($count2=0; $count2 < $result->ntuples; $count++, $count2++)
    {
      # load the arrays with the row data from the transaction
      $sub_e_codes[$count] = $result->getvalue($count2, 1);
      $account_nums[$count] = $result->getvalue($count2, 2);
      $dorcs[$count] = $result->getvalue($count2, 5);
      # if account is bank account (cash), then sub-account is check/deposit number; put into sub_account_text field
      $result2 = $conn->exec("select type from account_tb where number = $account_nums[$count]");
      if ($result2->resultStatus != PGRES_TUPLES_OK)
      {
        print "<h1>Error: Accessing database failed!</h1>\n";
        print $conn->errorMessage . "<br>Tried to lookup account type for $account_nums[$count].<br>$sys_admin";
        CleanUp();
      }
      if ($result2->ntuples != 1)
      {
        print "<h1>Error: Wrong number of records returned!</h1>\n";
        print $result2->ntuples . " records were returned. There should be only one.<br>$sys_admin";
        CleanUp();
      }
      if ($result2->getvalue(0, 0) == 0)
      {
        # this is a bank (cash) account; mark it
        $sub_account_bank{$account_nums[$count]} = 1;
        # get last used check/deposit #'s
        $result2 = $conn->exec("select max(sub_account_num) from debitcredit_tb where dorc = true and parent_num = (select max(parent_num) from debitcredit_tb where account_num = $account_nums[$count] and dorc = true and sub_account_num > -1 AND ledger_code = '$ledger_code') AND ledger_code = '$ledger_code'");
        if ($result2->resultStatus != PGRES_TUPLES_OK)
        {
          print "<h1>Error: Accessing database failed!</h1>\n";
          print "Error 1000<br>\n";
          print $conn->errorMessage . "<br>Tried to get the last used deposit# for account " . $account_nums[$count] . ".<br>$sys_admin";
          CleanUp();
        }
        if ($result2->ntuples > 1)
        {
          print "<h1>Error: Wrong number of records returned!</h1>\n";
          print "Error 1001<br>\n";
          print $result2->ntuples . " records were returned.  There should be only one.<br>$sys_admin";
          CleanUp();
        }
        if ($result2->ntuples == 0)
        {
          $last_deposit = -1;
        }
        else
        {
          $last_deposit = $result2->getvalue(0, 0);
          if ($last_deposit eq "")
          {
            $last_deposit = -1;
          }
        }
        $result2 = $conn->exec("select max(sub_account_num) from debitcredit_tb where dorc = false and parent_num = (select max(parent_num) from debitcredit_tb where account_num = $account_nums[$count] and dorc = false and sub_account_num > -1 AND ledger_code = '$ledger_code') AND ledger_code = '$ledger_code'");
        if ($result2->resultStatus != PGRES_TUPLES_OK)
        {
          print "<h1>Error: Accessing database failed!</h1>\n";
          print "Error 1002<br>\n";
          print $conn->errorMessage . "<br>Tried to get the last used check# for account " . $account_nums[$count] . ".<br>$sys_admin";
          CleanUp();
        }
        if ($result2->ntuples > 1)
        {
          print "<h1>Error: Wrong number of records returned!</h1>\n";
          print "Error 1003<br>\n";
          print $result2->ntuples . " records were returned.  There should be only one.<br>$sys_admin";
          CleanUp();
        }
        if ($result2->ntuples == 0)
        {
          $last_check = -1;
        }
        else
        {
          $last_check = $result2->getvalue(0, 0);
          if ($last_check eq "")
          {
            $last_check = -1;
          }
        }
        # increment last_deposit and last_check and check for duplicates in database
        do {
          $last_deposit++;
          $result2 = $conn->exec("select parent_num from debitcredit_tb where account_num = $account_nums[$count] and dorc = true and sub_account_num = $last_deposit AND ledger_code = '$ledger_code'");
        } while ($result2->resultStatus == PGRES_TUPLES_OK && $result2->ntuples > 0);
        if ($result2->resultStatus != PGRES_TUPLES_OK)
        {
          PrintErrorHeader();
          print "<h1>Error: Accessing database failed!</h1>\n";
          print $conn->errorMessage . "<br>1004.  Tried to see if the incremented deposit exists in the database.<br>$sys_admin";
          CleanUp();
        }
        do {
          $last_check++;
          $result2 = $conn->exec("select parent_num from debitcredit_tb where account_num = $account_nums[$count] and dorc = false and sub_account_num = $last_check AND ledger_code = '$ledger_code'");
        } while ($result2->resultStatus == PGRES_TUPLES_OK && $result2->ntuples > 0);
        if ($result2->resultStatus != PGRES_TUPLES_OK)
        {
          PrintErrorHeader();
          print "<h1>Error: Accessing database failed!</h1>\n";
          print $conn->errorMessage . "<br>1005.  Tried to see if the incremented check exists in the database.<br>$sys_admin";
          CleanUp();
        }
        if ($dorcs[$count] eq "t")
        {
          if ($last_deposit == 0)
          {
            $sub_account_nums[$count] = -1;
          }
          else
          {
            $sub_account_nums[$count] = $last_deposit;
          }
        }
        else
        {
          if ($last_check == 0)
          {
            $sub_account_nums[$count] = -1;
          }
          else
          {
            $sub_account_nums[$count] = $last_check;
          }
        }
      }
      else
      {
        $sub_account_nums[$count] = $result->getvalue($count2, 3);
      }

      $amounts[$count] = $result->getvalue($count2, 4);
      # remove ($)s and (,)s from amount; database doesn't like these
      $amounts[$count] =~ s/\$//g;
      $amounts[$count] =~ s/\,//g;
      $cleareds[$count] = $result->getvalue($count2, 6);
      $counters[$count] = $result->getvalue($count2, 7);
    }
    $num_rows = $count;
  }
  else
  {
    $num_rows = $num_extra_rows;
    $payee_payer = $input{'payee_payer_text'};
    $error_string = IsValidString($payee_payer);
    if (length $error_string > 0)
    {
      PrintErrorHeader();
      print "<h1>Error:  Invalid Payee-Payer!</h1>\n";
      print "<b>$error_string</b> is invalid!<br>$back_button";
      CleanUp();
    }
  }
  # run through all accounts that are cash accounts (type == 0) and get the next available check/deposit #'s
  $result = $conn->exec("select acct_num from local_accounts_tb WHERE ledger_code = '$ledger_code'");
  if ($result->resultStatus != PGRES_TUPLES_OK)
  {
    PrintErrorHeader();
    print "<h1>Error: Accessing database failed!</h1>\n";
    print $conn->errorMessage . "<br>1006: Tried to get the list of local accounts assigned to this ledger.<br>$sys_admin";
    CleanUp();
  }
  # build a string with the list of local account numbers in it
  $local_accounts_string = "";
  for ($count=0; $count < $result->ntuples; $count++)
  {
    $local_accounts_string .= $result->getvalue($count, 0);
    if ($count < $result->ntuples - 1)
    {
      $local_accounts_string .= ", ";
    }
  }
  if ($local_accounts_string eq "")
  {
    PrintErrorHeader();
    print "<h1>Error: No Accounts Found!</h1>\n";
    print "It appears that there are no accounts assigned to this ledger.  You must assign some accounts to continue.<br>$sys_admin";
    CleanUp();
  }
  $result = $conn->exec("select number from account_tb where type = 0 and number in ($local_accounts_string)");
  if ($result->resultStatus != PGRES_TUPLES_OK)
  {
    PrintErrorHeader();
    print "<h1>Error: Accessing database failed!</h1>\n";
    print $conn->errorMessage . "<br>1007: Tried to get all accounts from the main database with type = 0.<br>$sys_admin";
    CleanUp();
  }
  for ($count=0; $count < $result->ntuples; $count++)
  {
    # get last used check/deposit #'s
    $result2 = $conn->exec("select max(sub_account_num) from debitcredit_tb where dorc = true and parent_num = (select max(parent_num) from debitcredit_tb where account_num = " . $result->getvalue($count, 0) . " and dorc = true and sub_account_num > -1 AND ledger_code = '$ledger_code') AND ledger_code = '$ledger_code'");
    if ($result2->resultStatus != PGRES_TUPLES_OK)
    {
      print "<h1>Error: Accessing database failed!</h1>\n";
      print "Error 1000<br>\n";
      print $conn->errorMessage . "<br>Tried to get the last used deposit# for account " . $result->getvalue($count, 0) . ".<br>$sys_admin";
      CleanUp();
    }
    if ($result2->ntuples > 1)
    {
      print "<h1>Error: Wrong number of records returned!</h1>\n";
      print "Error 1001<br>\n";
      print $result2->ntuples . " records were returned.  There should be only one.<br>$sys_admin";
      CleanUp();
    }
    if ($result2->ntuples == 0)
    {
      $last_deposit = -1;
    }
    else
    {
      $last_deposit = $result2->getvalue(0, 0);
      if ($last_deposit eq "")
      {
        $last_deposit = -1;
      }
    }
    $result2 = $conn->exec("select max(sub_account_num) from debitcredit_tb where dorc = false and parent_num = (select max(parent_num) from debitcredit_tb where account_num = " . $result->getvalue($count, 0) . " and dorc = false and sub_account_num > -1 AND ledger_code = '$ledger_code') AND ledger_code = '$ledger_code'");
    if ($result2->resultStatus != PGRES_TUPLES_OK)
    {
      print "<h1>Error: Accessing database failed!</h1>\n";
      print "Error 1002<br>\n";
      print $conn->errorMessage . "<br>Tried to get the last used check# for account " . $result->getvalue($count, 0) . ".<br>$sys_admin";
      CleanUp();
    }
    if ($result2->ntuples > 1)
    {
      print "<h1>Error: Wrong number of records returned!</h1>\n";
      print "Error 1003<br>\n";
      print $result2->ntuples . " records were returned.  There should be only one.<br>$sys_admin";
      CleanUp();
    }
    if ($result2->ntuples == 0)
    {
      $last_check = -1;
    }
    else
    {
      $last_check = $result2->getvalue(0, 0);
      if ($last_check eq "")
      {
        $last_check = -1;
      }
    }
    # increment last_deposit and last_check and check for duplicates in database
    do {
      $last_deposit++;
      $result2 = $conn->exec("select parent_num from debitcredit_tb where account_num = " . $result->getvalue($count, 0) . " and dorc = true and sub_account_num = $last_deposit AND ledger_code = '$ledger_code'");
    } while ($result2->resultStatus == PGRES_TUPLES_OK && $result2->ntuples > 0);
    if ($result2->resultStatus != PGRES_TUPLES_OK)
    {
      PrintErrorHeader();
      print "<h1>Error: Accessing database failed!</h1>\n";
      print $conn->errorMessage . "<br>1004:  Tried to see if the incremented deposit exists in the database.<br>$sys_admin";
      CleanUp();
    }
    do {
      $last_check++;
      $result2 = $conn->exec("select parent_num from debitcredit_tb where account_num = " . $result->getvalue($count, 0) . " and dorc = false and sub_account_num = $last_check AND ledger_code = '$ledger_code'");
    } while ($result2->resultStatus == PGRES_TUPLES_OK && $result2->ntuples > 0);
    if ($result2->resultStatus != PGRES_TUPLES_OK)
    {
      PrintErrorHeader();
      print "<h1>Error: Accessing database failed!</h1>\n";
      print $conn->errorMessage . "<br>1005:  Tried to see if the incremented check exists in the database.<br>$sys_admin";
      CleanUp();
    }

    $temp = $result->getvalue($count, 0);
    $deposit_hash{$temp} = $last_deposit;

    $temp = $result->getvalue($count, 0);
    $check_hash{$temp} = $last_check;
  }
}
elsif ($mode eq "refresh")
{
  $fewer_rows_available = 0;
  $num_rows = $input{'num_rows'};
  # if there are not more than num_extra_refresh_rows available for input, increase the number of rows to regenerate
  for ($count=$num_rows-1; $count>$num_rows-1-$num_extra_refresh_rows; $count--)
  {
    if ($input{"account_select_$count"} ne "-1" && $fewer_rows_available == 0)
    {
      $fewer_rows_available = $count;
    }
  }
  if ($fewer_rows_available)
  {
    # increase the number of rows by fewer_rows_available + num_extra_refresh_rows
    $num_rows = $fewer_rows_available+1+$num_extra_refresh_rows;
  }
  $error_string = IsValidUInteger($num_rows);
  if (length $error_string > 0)
  {
    PrintErrorHeader();
    print "<h1>Error:  Invalid Num Rows Value!</h1>\n";
    print "<b>$error_string</b> is invalid!<br>$back_button";
    CleanUp();
  }
  $journal_code = $input{'journal_code'};
  $error_string = IsValidString($journal_code);
  if (length $error_string > 0)
  {
    PrintErrorHeader();
    print "<h1>Error:  Invalid Journal Code!</h1>\n";
    print "<b>$error_string</b> is invalid!<br>$back_button";
    CleanUp();
  }
  $trans_date = $input{'trans_date'};
  if (not IsValidDateSyntax($trans_date))
  {
    PrintErrorHeader();
    print "<h1>Error:  Invalid Transaction Date!</h1>\n";
    print "$back_button";
    CleanUp();
  }
  $payee_payer = $input{'payee_payer_text'};
  $error_string = IsValidString($payee_payer);
  if (length $error_string > 0)
  {
    PrintErrorHeader();
    print "<h1>Error:  Invalid Payee-Payer!</h1>\n";
    print "<b>$error_string</b> is invalid!<br>$back_button";
    CleanUp();
  }
  $memo = $input{'memo'};
  $error_string = IsValidString($memo);
  if (length $error_string > 0)
  {
    PrintErrorHeader();
    print "<h1>Error:  Invalid Memo!</h1>\n";
    print "<b>$error_string</b> is invalid!<br>$back_button";
    CleanUp();
  }
  $remember = $input{'remember'};
  # run through all accounts that are cash accounts (type == 0) and get the next available check/deposit #'s
  $result = $conn->exec("select acct_num from local_accounts_tb WHERE ledger_code = '$ledger_code'");
  if ($result->resultStatus != PGRES_TUPLES_OK)
  {
    PrintErrorHeader();
    print "<h1>Error: Accessing database failed!</h1>\n";
    print $conn->errorMessage . "<br>1006: Tried to get the list of local accounts assigned to this ledger.<br>$sys_admin";
    CleanUp();
  }
  # build a string with the list of local account numbers in it
  $local_accounts_string = "";
  for ($count=0; $count < $result->ntuples; $count++)
  {
    $local_accounts_string .= $result->getvalue($count, 0);
    if ($count < $result->ntuples - 1)
    {
      $local_accounts_string .= ", ";
    }
  }
  if ($local_accounts_string eq "")
  {
    PrintErrorHeader();
    print "<h1>Error: No Accounts Found!</h1>\n";
    print "It appears that there are no accounts assigned to this ledger.  You must assign some accounts to continue.<br>$sys_admin";
    CleanUp();
  }
  $result = $conn->exec("select number from account_tb where type = 0 and number in ($local_accounts_string)");
  if ($result->resultStatus != PGRES_TUPLES_OK)
  {
    PrintErrorHeader();
    print "<h1>Error: Accessing database failed!</h1>\n";
    print $conn->errorMessage . "<br>1007: Tried to get all accounts from the main database with type = 0.<br>$sys_admin";
    CleanUp();
  }
  for ($count=0; $count < $result->ntuples; $count++)
  {
    # get last used check/deposit #'s
    $result2 = $conn->exec("select max(sub_account_num) from debitcredit_tb where dorc = true and parent_num = (select max(parent_num) from debitcredit_tb where account_num = " . $result->getvalue($count, 0) . " and dorc = true and sub_account_num > -1 AND ledger_code = '$ledger_code') AND ledger_code = '$ledger_code'");
    if ($result2->resultStatus != PGRES_TUPLES_OK)
    {
      print "<h1>Error: Accessing database failed!</h1>\n";
      print "Error 1000<br>\n";
      print $conn->errorMessage . "<br>Tried to get the last used deposit# for account " . $result->getvalue($count, 0) . ".<br>$sys_admin";
      CleanUp();
    }
    if ($result2->ntuples > 1)
    {
      print "<h1>Error: Wrong number of records returned!</h1>\n";
      print "Error 1001<br>\n";
      print $result2->ntuples . " records were returned.  There should be only one.<br>$sys_admin";
      CleanUp();
    }
    if ($result2->ntuples == 0)
    {
      $last_deposit = -1;
    }
    else
    {
      $last_deposit = $result2->getvalue(0, 0);
      if ($last_deposit eq "")
      {
        $last_deposit = -1;
      }
    }
    $result2 = $conn->exec("select max(sub_account_num) from debitcredit_tb where dorc = false and parent_num = (select max(parent_num) from debitcredit_tb where account_num = " . $result->getvalue($count, 0) . " and dorc = false and sub_account_num > -1 AND ledger_code = '$ledger_code') AND ledger_code = '$ledger_code'");
    if ($result2->resultStatus != PGRES_TUPLES_OK)
    {
      print "<h1>Error: Accessing database failed!</h1>\n";
      print "Error 1002<br>\n";
      print $conn->errorMessage . "<br>Tried to get the last used check# for account " . $result->getvalue($count, 0) . ".<br>$sys_admin";
      CleanUp();
    }
    if ($result2->ntuples > 1)
    {
      print "<h1>Error: Wrong number of records returned!</h1>\n";
      print "Error 1003<br>\n";
      print $result2->ntuples . " records were returned.  There should be only one.<br>$sys_admin";
      CleanUp();
    }
    if ($result2->ntuples == 0)
    {
      $last_check = -1;
    }
    else
    {
      $last_check = $result2->getvalue(0, 0);
      if ($last_check eq "")
      {
        $last_check = -1;
      }
    }
    # increment last_deposit and last_check and check for duplicates in database
    do {
      $last_deposit++;
      $result2 = $conn->exec("select parent_num from debitcredit_tb where account_num = " . $result->getvalue($count, 0) . " and dorc = true and sub_account_num = $last_deposit AND ledger_code = '$ledger_code'");
    } while ($result2->resultStatus == PGRES_TUPLES_OK && $result2->ntuples > 0);
    if ($result2->resultStatus != PGRES_TUPLES_OK)
    {
      PrintErrorHeader();
      print "<h1>Error: Accessing database failed!</h1>\n";
      print $conn->errorMessage . "<br>1004:  Tried to see if the incremented deposit exists in the database.<br>$sys_admin";
      CleanUp();
    }
    do {
      $last_check++;
      $result2 = $conn->exec("select parent_num from debitcredit_tb where account_num = " . $result->getvalue($count, 0) . " and dorc = false and sub_account_num = $last_check AND ledger_code = '$ledger_code'");
    } while ($result2->resultStatus == PGRES_TUPLES_OK && $result2->ntuples > 0);
    if ($result2->resultStatus != PGRES_TUPLES_OK)
    {
      PrintErrorHeader();
      print "<h1>Error: Accessing database failed!</h1>\n";
      print $conn->errorMessage . "<br>1005:  Tried to see if the incremented check exists in the database.<br>$sys_admin";
      CleanUp();
    }

    $temp = $result->getvalue($count, 0);
    $deposit_hash{$temp} = $last_deposit;

    $temp = $result->getvalue($count, 0);
    $check_hash{$temp} = $last_check;
  }
}

print "<head><title>$prog_name $prog_version Journals Activity</title></head>\n";
print "<body bgcolor=$body_bgcolor onLoad=\"do_load();\">\n";
print <<"END_OF_STYLE";
<style type="text/css"><!--
  a:hover   { color: red }
  a:link    { text-decoration: none; color: blue }
  a:visited { text-decoration: none; color: blue }
  a:active  { text-decoration: none; color: blue }-->
</style>
<script language="Javascript1.2" src="../js/common.js"></script>
<script language=\"Javascript1.2\">
  <!--
  var sub_entities = new Array();
  var accounts = new Array();
  var sub_accounts = new Array();
  var sub_accounts_bank = new Array();

//  function create_sub_entity(name, value)
//  {
//    this.name = name;
//    this.value = value;
//  }

//  function create_account(name, value)
//  {
//    this.name = name;
//    this.value = value;
//  }

  function create_sub_account(name, value)
  {
    this.name = name;
    this.value = value;
  }

END_OF_STYLE
#/
# get the sub entities from the database and fill in the array
$result = $conn->exec("select code from sub_entity_tb WHERE ledger_code = '$ledger_code'");
if ($result->resultStatus != PGRES_TUPLES_OK)
{
  print "</script></head><body>\n";
  print "<h1>Error: Accessing database <font color=\"blue\">$ledger_db</font> failed!</h1>\n";
  print $conn->errorMessage . "<br>Tried to retrieve all sub entities from $ledger_db.<br>$sys_admin";
  CleanUp();
}
for ($count=0; $count < $result->ntuples; $count++)
{
  $sub_entity_value = $result->getvalue($count, 0);
#  print "  sub_entities[$count] = new create_sub_entity(\"$sub_entity_value\", \"$sub_entity_value\");\n";
  $sub_entity_array[$count] = $sub_entity_value;
}
# get the accounts from the database and fill in the array
$result = $conn->exec("select acct_num from local_accounts_tb WHERE ledger_code = '$ledger_code'");
if ($result->resultStatus != PGRES_TUPLES_OK)
{
  print "</script></head><body>\n";
  print "<h1>Error: Accessing database <font color=\"blue\">$ledger_db</font> failed!</h1>\n";
  print $conn->errorMessage . "<br>Tried to retrieve all local accounts from $ledger_db.<br>$sys_admin";
  CleanUp();
}
for ($count=0; $count < $result->ntuples; $count++)
{
  $local_account_id = $result->getvalue($count, 0);
  # build a comma separated string from the account numbers returned
  $account_numbers_string .= $local_account_id;
  if ($count < $result->ntuples - 1)
  {
    $account_numbers_string .= ",";
  }
}
# create a sub account array entry for a value of "-1"
print "  sub_accounts[\"-1\"] = new Array();\n";
print "  sub_accounts[\"-1\"][0] = new create_sub_account(\"               \", \"-1\");\n";
$result2 = $conn->exec("select name, number, type from account_tb where number in ($account_numbers_string) order by name");
for ($count=0; $count < $result2->ntuples; $count++)
{
  $local_account_name = $result2->getvalue($count, 0);
  $local_account_id = $result2->getvalue($count, 1);
  $local_account_type = $result2->getvalue($count, 2);
  $account_array[$count][0] = "$local_account_id";
  $account_array[$count][1] = "$local_account_name - $local_account_id";
#  print "  accounts[$count] = new create_account(\"$local_account_name - $local_account_id\", $local_account_id);\n";
  # get the sub accounts from the database and associate them with the accounts array
  $result3 = $conn->exec("select sub_acc_name, sub_acc_number from sub_acc_tb where parent = $local_account_id order by sub_acc_name");
  if ($result3->resultStatus != PGRES_TUPLES_OK)
  {
    print "</script></head><body>\n";
    print "<h1>Error: Accessing database failed!</h1>\n";
    print $conn->errorMessage . "<br>Tried to retrieve name and id information for sub accounts associated with account = $local_account_id.<br>$sys_admin";
    CleanUp();
  }
  print "  sub_accounts[\"$local_account_name - $local_account_id\"] = new Array();\n";
  print "  sub_accounts[\"$local_account_name - $local_account_id\"][0] = new create_sub_account(\"               \", \"-1\");\n";
  if ($local_account_type == 0)
  {
    # use the existing deposit_hash and check_hash to fill in the sub_account array
    # put a "C" and a "D" as options in the sub_accounts array
    print "  sub_accounts[\"$local_account_name - $local_account_id\"][1] = new create_sub_account(\"Check #\", \"C\");\n";
    print "  sub_accounts[\"$local_account_name - $local_account_id\"][2] = new create_sub_account(\"Deposit #\", \"D\");\n";
    print "  sub_accounts_bank[\"$local_account_name - $local_account_id\"] = new Array();\n";
    print "  sub_accounts_bank[\"$local_account_name - $local_account_id\"][0] = ";
    if (not exists $deposit_hash{$local_account_id})
    {
      print "0; // hash entry did not exist; hash value = $deposit_hash{$local_account_id}";
    }
    else
    {
      print "$deposit_hash{$local_account_id}";
    }
    print ";\n";
    print "  sub_accounts_bank[\"$local_account_name - $local_account_id\"][1] = ";
    if (not exists $check_hash{$local_account_id})
    {
      print "0; // hash entry did not exist; hash value = $check_hash{$local_account_id}";
    }
    else
    {
      print "$check_hash{$local_account_id}";
    }
    print ";\n";
  }
  else
  {
    for ($count2=0; $count2 < $result3->ntuples; $count2++)
    {
      $sub_account_name = $result3->getvalue($count2, 0);
      $sub_account_id = $result3->getvalue($count2, 1);
      $temp_count = $count2+1;
      print "  sub_accounts[\"$local_account_name - $local_account_id\"][$temp_count] = new create_sub_account(\"$sub_account_name - $sub_account_id\", $sub_account_id);\n";
    }
  }
}
if ($mode eq "edit" || $payee_payer_exists eq "true")
{
  $max_rows = $num_rows + $num_extra_rows;
}
else
{
  $max_rows = $num_rows;
}
print "\n  var num_rows = $max_rows;\n";
for ($count=0; $count < $max_rows; $count++)
{
  print "  var reset_sub_account_$count=0, reset_sub_account_text_$count='', reset_debit_$count='', reset_credit_$count='', reset_cleared_$count=' ';\n";
}
print <<"END_OF_STYLE";

  function do_load()
  {
    // add the contents of the arrays to the subentity, account, and subaccount selects; set the initial values to the data for the journal entry if in edit mode
    // clear all subaccount selects
END_OF_STYLE
for ($count=0; $count<$num_rows; $count++)
{
  if ($mode eq "edit" || $payee_payer_exists eq "true")
  {
    # print the default data for each select value into the JavaScript for it to check and select the option that corresponds to the data
#    print "    var sub_entity_$count = \"$sub_e_codes[$count]\";\n";
#    print "    var account_$count = \"$account_nums[$count]\";\n";
    print "    var sub_account_$count = \"$sub_account_nums[$count]\";\n";
  }
  elsif ($mode eq "refresh")
  {
#    print "    var sub_entity_$count = \"" . $input{"sub_entity_select_$count"} . "\";\n";
    print "    var account_$count = \"" . $input{"account_select_$count"} . "\";\n";
    if ($input{"sub_account_select_$count"} eq "C" || $input{"sub_account_select_$count"} eq "D")
    {
      print "    var sub_account_$count = \"" . $input{"sub_account_text_$count"} . "\";\n";
    }
    else
    {
      print "    var sub_account_$count = \"" . $input{"sub_account_select_$count"} . "\";\n";
    }
  }

  $sub_entity_reset_array[$count] = 0;
  for ($count2=0; $count2 < @sub_entity_array; $count2++)
  {
    if ($sub_entity_array[$count2] eq $sub_e_codes[$count] || ($mode eq "refresh" && $sub_entity_array[$count2] eq $input{"sub_entity_select_$count"}))
    {
      $sub_entity_reset_array[$count] = $count2 + 1;
    }
  }
#  print "    for (var count_sub_entity=0; count_sub_entity < sub_entities.length; count_sub_entity++)\n";
#  print "    {\n";
#  print "      document.edit_rows_form.sub_entity_select_$count.options[count_sub_entity+1] = new Option(sub_entities[count_sub_entity].name, sub_entities[count_sub_entity].value);\n";
#  if ($mode eq "edit" || $payee_payer_exists eq "true" || $mode eq "refresh")
#  {
#    print "      if (sub_entity_$count == sub_entities[count_sub_entity].value)\n";
#    print "      {\n";
#    print "        document.edit_rows_form.sub_entity_select_$count.selectedIndex = count_sub_entity+1;\n";
#    print "        reset_sub_entity_$count = document.edit_rows_form.sub_entity_select_$count.selectedIndex;\n";
#    print "      }\n";
#  }
#  else
#  {
#    print "      reset_sub_entity_$count = 0;\n";
#  }
#  print "    }\n";
#  print "    for (var count_account=0; count_account < accounts.length; count_account++)\n";
#  print "    {\n";
#  print "      document.edit_rows_form.account_select_$count.options[count_account+1] = new Option(accounts[count_account].name, accounts[count_account].value);\n";
#  if ($mode eq "edit" || $payee_payer_exists eq "true" || $mode eq "refresh")
#  {
#    print "      if (account_$count == accounts[count_account].value)\n";
#    print "      {\n";
#    print "        document.edit_rows_form.account_select_$count.selectedIndex = count_account+1;\n";
#    print "        account_s_$count = document.edit_rows_form.account_select_$count;\n";
#    print "        reset_account_$count = document.edit_rows_form.account_select_$count.selectedIndex;\n";
#    print "      }\n";
#  }
#  else
#  {
#    print "      reset_account_$count = 0;\n";
#  }
#  print "    }\n";
  $account_reset_array[$count] = 0;
  if ($mode eq "edit" || $payee_payer_exists eq "true" || ($mode eq "refresh" && $input{"account_select_$count"} ne "-1"))
  {
    for ($count2=0; $count2 < @account_array; $count2++)
    {
      if ($account_array[$count2][0] eq $account_nums[$count] || ($mode eq "refresh" && $account_array[$count2][0] eq $input{"account_select_$count"}))
      {
        print "    var account_value = \"$account_array[$count2][1]\";\n";
        print "    document.edit_rows_form.account_select_$count.selectedIndex = " . ($count2 + 1) . ";\n";
        $account_reset_array[$count] = $count2 + 1;
      }
    }
    if ($account_reset_array[$count] == 0 && $mode eq "refresh")
    {
      print "    // account_value not set! setting to default\n";
      print "    account_value = '-1';\n";
    }
    print "    document.edit_rows_form.sub_account_select_$count.options.length = 0;\n";
    print "    for (var count_sub_account=0; count_sub_account < sub_accounts[account_value].length; count_sub_account++)\n";
    print "    {\n";
    print "      document.edit_rows_form.sub_account_select_$count.options[count_sub_account] = new Option(sub_accounts[account_value][count_sub_account].name, sub_accounts[account_value][count_sub_account].value);\n";
    if (exists $sub_account_bank{$account_nums[$count]} || ($mode eq "refresh" && $input{"sub_account_select_$count"} eq "C" || $input{"sub_account_select_$count"} eq "D"))
    {
      if ($dorcs[$count] eq "t" || $input{"debit_$count"} ne "")
      {
        print "      if (sub_account_$count != \"-1\")\n";
        print "      {\n";
        print "        document.edit_rows_form.sub_account_select_$count.selectedIndex = 2;\n";
        print "        reset_sub_account_$count = 2;\n";
        print "      }\n";
      }
      elsif ($dorcs[$count] eq "f" || $input{"credit_$count"} ne "")
      {
        print "      if (sub_account_$count != \"-1\")\n";
        print "      {\n";
        print "        document.edit_rows_form.sub_account_select_$count.selectedIndex = 1;\n";
        print "        reset_sub_account_$count = 1;\n";
        print "      }\n";
      }
      print "      if (sub_account_$count == \"-1\")\n";
      print "      {\n";
      print "        document.edit_rows_form.sub_account_text_$count.value = \"\";\n";
      print "        reset_sub_account_text_$count = \"\";\n";
      print "      }\n";
      print "      else\n";
      print "      {\n";
      print "        document.edit_rows_form.sub_account_text_$count.value = sub_account_$count;\n";
      print "        reset_sub_account_text_$count = sub_account_$count;\n";
      print "      }\n";
    }
    else
    {
      print "      if (sub_account_$count.toString() == sub_accounts[account_value][count_sub_account].value.toString())\n";
      print "      {\n";
      print "        document.edit_rows_form.sub_account_select_$count.selectedIndex = count_sub_account;\n";
      print "        document.edit_rows_form.sub_account_text_$count.value = sub_accounts[account_value][count_sub_account].name;\n";
      print "        reset_sub_account_$count = count_sub_account;\n";
      print "        reset_sub_account_text_$count = sub_accounts[account_value][count_sub_account].name;\n";
      print "      }\n";
    }
    print "    }\n";
  }
  else
  {
    print "    reset_sub_account_$count = 0;\n";
    print "    reset_sub_account_text_$count = \"\";\n";
  }

  print "    reset_debit_$count = document.edit_rows_form.debit_$count.value;\n";
  print "    reset_credit_$count = document.edit_rows_form.credit_$count.value;\n";
  print "    reset_cleared_$count = document.edit_rows_form.cleared_$count.value;\n";
}
# add num_extra_rows rows to the end of the form if editing or recall/remembered data
if ($mode eq "edit" || $payee_payer_exists eq "true")
{
  for ($count2=0; $count2<$num_extra_rows; $count2++, $count++)
  {
#    print "    for (count_sub_entity=0; count_sub_entity < sub_entities.length; count_sub_entity++)\n";
#    print "    {\n";
#    print "      document.edit_rows_form.sub_entity_select_$count.options[count_sub_entity+1] = new Option(sub_entities[count_sub_entity].name, sub_entities[count_sub_entity].value);\n";
#    print "      document.edit_rows_form.sub_entity_select_$count.selectedIndex = 0;\n";
#    print "    }\n";
#    print "    for (count_account=0; count_account < accounts.length; count_account++)\n";
#    print "    {\n";
#    print "      document.edit_rows_form.account_select_$count.options[count_account+1] = new Option(accounts[count_account].name, accounts[count_account].value);\n";
#    print "      document.edit_rows_form.account_select_$count.selectedIndex = 0;\n";
#    print "    }\n";
#    print "    reset_sub_entity_$count = 0;\n";
#    print "    reset_account_$count = 0;\n";
    $sub_entity_reset_array[$count] = 0;
    $account_reset_array[$count] = 0;
    print "    reset_sub_account_$count = 0;\n";
    print "    reset_sub_account_text_$count = \"\";\n";
    print "    reset_debit_$count = document.edit_rows_form.debit_$count.value;\n";
    print "    reset_credit_$count = document.edit_rows_form.credit_$count.value;\n";
    print "    reset_cleared_$count = document.edit_rows_form.cleared_$count.value;\n";
  }
}
print <<"END_OF_STYLE";
  }

  function account_select_change(sub_entity, account, sub_account, sub_account_text, cleared)
  {
    // clear the sub entity field if the account is set to nothing
    if (account.selectedIndex == 0)
    {
      sub_entity.selectedIndex = 0;
    }
    // clear the sub-account select and refill with data associated with selected account
    sub_account.options.length = 0;
    account_value = account.options[account.selectedIndex].text;
    if (typeof sub_accounts[account_value] == "undefined")
    {
      sub_account.options[0] = new Option("               ", "-1");
    }
    else
    {
      for (count=0; count<sub_accounts[account_value].length; count++)
      {
        sub_account.options[count] = new Option(sub_accounts[account_value][count].name, sub_accounts[account_value][count].value);
      }
    }
    sub_account.selectedIndex = 0;
    sub_account_text.value = "";
    if (typeof cleared != "undefined")
    {
      // set the cleared field to " "
      cleared.value = " ";
    }
  }

  function sub_account_select_change(account, sub_account, sub_account_text, debit, credit)
  {
    if (sub_account.options[sub_account.selectedIndex].value != "C" && sub_account.options[sub_account.selectedIndex].value != "D")
    {
      if (sub_account.options[sub_account.selectedIndex].text[0] == " ")
      {
        // an empty value was selected
        sub_account_text.value = "";
      }
      else
      {
        sub_account_text.value = sub_account.options[sub_account.selectedIndex].text;
      }
    }
    else
    {
      if (sub_account.options[sub_account.selectedIndex].value == "C")
      {
        account_value = account.options[account.selectedIndex].text;
        sub_account_text.value = sub_accounts_bank[account_value][1];
        if (debit.value != "")
        {
          // move debit to credit field
          credit.value = debit.value;
          debit.value = "";
          credit_change(credit, debit, sub_account);
        }
      }
      else if (sub_account.options[sub_account.selectedIndex].value == "D")
      {
        account_value = account.options[account.selectedIndex].text;
        sub_account_text.value = sub_accounts_bank[account_value][0];
        if (credit.value != "")
        {
          // move credit to debit field
          debit.value = credit.value;
          credit.value = "";
          debit_change(debit, credit, sub_account);
        }
      }
    }
  }

  function sub_account_text_change(sub_account_text, sub_account)
  {
    var count;
    var regexp;

    if (sub_account.options[sub_account.selectedIndex].value != "C" && sub_account.options[sub_account.selectedIndex].value != "D")
    {
      regexp = eval("/^" + sub_account_text.value + "+/i");
      // search for match in sub_account select and set selectedIndex to the found item
      for (count=0; count < sub_account.options.length; count++)
      {
        if (sub_account.options[count].text.search(regexp) != -1)
        {
          sub_account.selectedIndex = count;
          sub_account_text.value = sub_account.options[count].text;
        }
      }
    }
  }

  function debit_change(debit, credit, sub_account)
  {
    var count;
    var row_value;
    var debit_sum;
    var credit_sum;
    var debit_credit_diff;
    var exit_loop;
    var temp_value;

    if (parseFloat(debit.value) < 0)
    {
      debit.value = parseFloat(debit.value) * -1;
      credit.value = debit.value;
      debit.value = "";
      credit_change(credit, debit, sub_account);
      return;
    }

    if (sub_account.options[sub_account.selectedIndex].value == "C")
    {
      if (debit.value != "")
      {
        alert("You selected a Check # which can only be associated with a credit.\\\nYou are attempting to enter a debit.\\\nSwapping values...");
      }
      credit.value = debit.value;
      debit.value = "";
      credit_change(credit, debit, sub_account);
      return;
    }

    var temp_debit = parseFloat(debit.value) + 0.005;
    // truncate temp_debit to 2 decimal places
    temp_debit = temp_debit.toString();
    if (temp_debit.indexOf(".") != -1)
    {
      debit.value = temp_debit.substring(0, temp_debit.indexOf(".")+3);
    }

    // clear credit field
    credit.value = "";
    // clear all rows that have debit/credit values but no account assigned to them
    for (count=0; count<num_rows; count++)
    {
      if (eval("document.edit_rows_form.account_select_" + count + ".selectedIndex") <= 0)
      {
        // clear debit and credit text fields
        eval("document.edit_rows_form.debit_" + count + ".value = \\"\\"");
        eval("document.edit_rows_form.credit_" + count + ".value = \\"\\"");
        // clear sub entity selects
        eval("document.edit_rows_form.sub_entity_select_" + count + ".selectedIndex = 0");
      }
    }

    // search backward from last row in table for the first occurrence of a row that does not have a sub entity, account, or sub account
    // assigned; store in row_value
    count = num_rows - 1;
    exit_loop = false;
    while (count >= 0 && !exit_loop)
    {
      if (eval("document.edit_rows_form.account_select_" + count + ".selectedIndex") > 0)
      {
        exit_loop = true;
      }
      if (!exit_loop)
      {
        count--;
      }
    }
    row_value = count + 1;

    // determine if the row_value is the third row (meaning there are only two entries so far) and the row being edited is the first
    // row; instead of creating a difference of debits and credits, match the second row to be the opposite of the first rows debit
    // or credit
    if (row_value == 2)
    {
      if (document.edit_rows_form.debit_0 == debit)
      {
        document.edit_rows_form.credit_1.value = debit.value;
        document.edit_rows_form.debit_1.value = "";
        // if the value being swapped exists in a cash type account, make sure the sub account changes to match the debit/credit,
        // deposit/check #
        if (document.edit_rows_form.sub_account_select_1.options[document.edit_rows_form.sub_account_select_1.selectedIndex].value == "D")
        {
          // set sub account select to Check #
          document.edit_rows_form.sub_account_select_1.selectedIndex = 1;
        }
        return;
      }
    }

    // if the next row (row_value + 1) does not exceed the number of rows in the table, it will be used for difference of the sums of the
    // debits and credits; otherwise, display an error message
    if (row_value >= num_rows)
    {
      alert("There are no more rows available to enter data!");
      return;
    }

    debit_sum = 0;
    credit_sum = 0;
    // run through rows from 0..row_value; keep a running sum of debits and credits whenever a debit or credit is encountered in a row
    for (count=0; count < row_value; count++)
    {
      if ((eval("document.edit_rows_form.debit_" + count + ".value") != "") && (eval("document.edit_rows_form.account_select_" + count + ".selectedIndex") > 0))
      {
        temp_value = parseFloat(eval("document.edit_rows_form.debit_" + count + ".value"));
        if (temp_value != NaN)
        {
          debit_sum += temp_value;
        }
      }
      if ((eval("document.edit_rows_form.credit_" + count + ".value") != "") && (eval("document.edit_rows_form.account_select_" + count + ".selectedIndex") > 0))
      {
        temp_value = parseFloat(eval("document.edit_rows_form.credit_" + count + ".value"));
        if (temp_value != NaN)
        {
          credit_sum += temp_value;
        }
      }
    }

    // calculate difference of sum of debits and credits
    if (parseFloat(debit_sum) > parseFloat(credit_sum))
    {
      debit_credit_diff = parseFloat(debit_sum) - parseFloat(credit_sum);
    }
    else
    {
      debit_credit_diff = parseFloat(credit_sum) - parseFloat(debit_sum);
    }
    var temp_diff = parseFloat(debit_credit_diff) + 0.005;
    // truncate temp_diff to 2 decimal places
    temp_diff = temp_diff.toString();
    if (temp_diff.indexOf(".") != -1)
    {
      debit_credit_diff = temp_diff.substring(0, temp_diff.indexOf(".")+3);
    }

    // make sure debit_credit_diff != 0.00
    if (debit_credit_diff != 0.00)
    {
      // determine which column needs the difference, debits or credits
      // set debit/credit text field to calculated value; if 0, do not set value
      if (parseFloat(debit_sum) < parseFloat(credit_sum))
      {
        eval("document.edit_rows_form.debit_" + row_value + ".value = debit_credit_diff");
        eval("document.edit_rows_form.credit_" + row_value + ".value = \\"\\";");
      }
      else if (parseFloat(debit_sum) > parseFloat(credit_sum))
      {
        eval("document.edit_rows_form.debit_" + row_value + ".value = \\"\\";");
        eval("document.edit_rows_form.credit_" + row_value + ".value = debit_credit_diff");
      }
      // set the sub entity of row_value to match the sub entity of row_value - 1 if row_value != 0 (which it never should)
      if (row_value != 0)
      {
        eval("document.edit_rows_form.sub_entity_select_" + row_value + ".selectedIndex = document.edit_rows_form.sub_entity_select_" + (row_value - 1) + ".selectedIndex");
      }
    }
  }

  function credit_change(credit, debit, sub_account)
  {
    var count;
    var row_value;
    var debit_sum;
    var credit_sum;
    var debit_credit_diff;
    var exit_loop;
    var temp_value;

    if (parseFloat(credit.value) < 0)
    {
      credit.value = parseFloat(credit.value) * -1;
      debit.value = credit.value;
      credit.value = "";
      debit_change(debit, credit, sub_account);
      return;
    }

    if (sub_account.options[sub_account.selectedIndex].value == "D")
    {
      if (credit.value != "")
      {
        alert("You selected a Deposit # which can only be associated with a debit.\\\nYou are attempting to enter a credit.\\\nSwapping value...");
      }
      debit.value = credit.value;
      credit.value = "";
      debit_change(debit, credit, sub_account);
      return;
    }

    var temp_credit = parseFloat(credit.value) + 0.005;
    // truncate temp_credit to 2 decimal places
    temp_credit = temp_credit.toString();
    if (temp_credit.indexOf(".") != -1)
    {
      credit.value = temp_credit.substring(0, temp_credit.indexOf(".")+3);
    }

    // clear debit field
    debit.value = "";
    // clear all rows that have debit/credit values but no account assigned to them
    for (count=0; count<num_rows; count++)
    {
      if (eval("document.edit_rows_form.account_select_" + count + ".selectedIndex") <= 0)
      {
        // clear debit and credit text fields
        eval("document.edit_rows_form.debit_" + count + ".value = \\"\\"");
        eval("document.edit_rows_form.credit_" + count + ".value = \\"\\"");
        // clear sub entity selects
        eval("document.edit_rows_form.sub_entity_select_" + count + ".selectedIndex = 0");
      }
    }

    // search backward from last row in table for the first occurrence of a row that does not have a sub entity, account, or sub account
    // assigned; store in row_value
    count = num_rows - 1;
    exit_loop = false;
    while (count >= 0 && !exit_loop)
    {
      if (eval("document.edit_rows_form.account_select_" + count + ".selectedIndex") > 0)
      {
        exit_loop = true;
      }
      if (!exit_loop)
      {
        count--;
      }
    }
    row_value = count + 1;

    // determine if the row_value is the third row (meaning there are only two entries so far) and the row being edited is the first
    // row; instead of creating a difference of debits and credits, match the second row to be the opposite of the first rows debit
    // or credit
    if (row_value == 2)
    {
      if (document.edit_rows_form.credit_0 == credit)
      {
        document.edit_rows_form.debit_1.value = credit.value;
        document.edit_rows_form.credit_1.value = "";
        // if the value being swapped exists in a cash type account, make sure the sub account changes to match the debit/credit,
        // deposit/check #
        if (document.edit_rows_form.sub_account_select_1.options[document.edit_rows_form.sub_account_select_1.selectedIndex].value == "C")
        {
          // set sub account select to Deposit #
          document.edit_rows_form.sub_account_select_1.selectedIndex = 2;
        }
        return;
      }
    }

    // if the next row (row_value + 1) does not exceed the number of rows in the table, it will be used for difference of the sums of the
    // debits and credits; otherwise, display an error message
    if (row_value >= num_rows)
    {
      alert("There are no more rows available to enter data!");
      return;
    }

    debit_sum = 0;
    credit_sum = 0;
    // run through rows from 0..row_value; keep a running sum of debits and credits whenever a debit or credit is encountered in a row
    for (count=0; count < row_value; count++)
    {
      if ((eval("document.edit_rows_form.debit_" + count + ".value") != "") && (eval("document.edit_rows_form.account_select_" + count + ".selectedIndex") > 0))
      {
        temp_value = parseFloat(eval("document.edit_rows_form.debit_" + count + ".value"));
        if (temp_value != NaN)
        {
          debit_sum += temp_value;
        }
      }
      if ((eval("document.edit_rows_form.credit_" + count + ".value") != "") && (eval("document.edit_rows_form.account_select_" + count + ".selectedIndex") > 0))
      {
        temp_value = parseFloat(eval("document.edit_rows_form.credit_" + count + ".value"));
        if (temp_value != NaN)
        {
          credit_sum += temp_value;
        }
      }
    }

    // calculate difference of sum of debits and credits
    if (parseFloat(debit_sum) > parseFloat(credit_sum))
    {
      debit_credit_diff = parseFloat(debit_sum) - parseFloat(credit_sum);
    }
    else
    {
      debit_credit_diff = parseFloat(credit_sum) - parseFloat(debit_sum);
    }
    var temp_diff = parseFloat(debit_credit_diff) + 0.005;
    // truncate temp_diff to 2 decimal places
    temp_diff = temp_diff.toString();
    if (temp_diff.indexOf(".") != -1)
    {
      debit_credit_diff = temp_diff.substring(0, temp_diff.indexOf(".")+3);
    }

    // make sure debit_credit_diff != 0.00
    if (debit_credit_diff != 0.00)
    {
      // determine which column needs the difference, debits or credits
      // set debit/credit text field to calculated value; if 0, do not set value
      if (parseFloat(debit_sum) < parseFloat(credit_sum))
      {
        eval("document.edit_rows_form.debit_" + row_value + ".value = debit_credit_diff");
        eval("document.edit_rows_form.credit_" + row_value + ".value = \\"\\";");
      }
      else if (parseFloat(debit_sum) > parseFloat(credit_sum))
      {
        eval("document.edit_rows_form.debit_" + row_value + ".value = \\"\\";");
        eval("document.edit_rows_form.credit_" + row_value + ".value = debit_credit_diff");
      }
      // set the sub entity of row_value to match the sub entity of row_value - 1 if row_value != 0 (which it never should)
      if (row_value != 0)
      {
        eval("document.edit_rows_form.sub_entity_select_" + row_value + ".selectedIndex = document.edit_rows_form.sub_entity_select_" + (row_value - 1) + ".selectedIndex");
      }
    }
  }

  function validate_form()
  {
    var sum_debits = 0.0;
    var sum_credits = 0.0;
    var temp_value = 0.0;
    var temp_sum_debits;
    var temp_sum_credits;
    var sum_rows = 0;
    var count;
    var count2;
    var same_check = new Array();
    var same_deposit = new Array();

    // run through rows from 0..num_rows; keep a running sum of debits and credits whenever a debit or credit is encountered in a row
    for (count=0; count < num_rows; count++)
    {
      if ((eval("document.edit_rows_form.debit_" + count + ".value") != "") && (eval("document.edit_rows_form.account_select_" + count + ".selectedIndex") > 0))
      {
        temp_value = parseFloat(eval("document.edit_rows_form.debit_" + count + ".value"));
        if (temp_value != NaN)
        {
          sum_debits += temp_value;
          sum_rows++;
        }
      }
      if ((eval("document.edit_rows_form.credit_" + count + ".value") != "") && (eval("document.edit_rows_form.account_select_" + count + ".selectedIndex") > 0))
      {
        temp_value = parseFloat(eval("document.edit_rows_form.credit_" + count + ".value"));
        if (temp_value != NaN)
        {
          sum_credits += temp_value;
          sum_rows++;
        }
      }
      if ((eval("document.edit_rows_form.account_select_" + count + ".selectedIndex") > 0) && (eval("document.edit_rows_form.sub_account_select_" + count + ".selectedIndex") > 0))
      {
        if ((eval("document.edit_rows_form.sub_account_select_" + count + ".options[document.edit_rows_form.sub_account_select_" + count + ".selectedIndex].value") == "C"))
        {
          same_check[count] = eval("document.edit_rows_form.sub_account_text_" + count + ".value");
          same_deposit[count] = "-1";
        }
        else
        {
          same_check[count] = "-1";
          same_deposit[count] = eval("document.edit_rows_form.sub_account_text_" + count + ".value");
        }
      }
      else
      {
        same_check[count] = "-1";
        same_deposit[count] = "-1";
      }
    }
    // check to make sure that there are at least two entries of row data
    if (sum_rows < 2)
    {
      alert("You must enter at least two rows of data!");
      return false;
    }
    // truncate temp_sum_debits to 2 decimal places
    temp_sum_debits = parseFloat(sum_debits) + 0.005;
    temp_sum_debits = temp_sum_debits.toString();
    if (temp_sum_debits.indexOf(".") != -1)
    {
      sum_debits = temp_sum_debits.substring(0, temp_sum_debits.indexOf(".")+3);
    }
    // truncate temp_sum_credits to 2 decimal places
    temp_sum_credits = parseFloat(sum_credits) + 0.005;
    temp_sum_credits = temp_sum_credits.toString();
    if (temp_sum_credits.indexOf(".") != -1)
    {
      sum_credits = temp_sum_credits.substring(0, temp_sum_credits.indexOf(".")+3);
    }
    // check that debits == credits
    if (sum_debits != sum_credits)
    {
      // error, cannot continue because debits do not equal credits
      alert("Debits do not equal credits!\\\nDebits:" + sum_debits + ", Credits:" + sum_credits);
      return false;
    }
    // check to make sure that the same check and/or deposit numbers are not being used multiple times on the same form
    for (count=0; count < num_rows; count++)
    {
      if ((eval("document.edit_rows_form.account_select_" + count + ".selectedIndex") > 0) && (eval("document.edit_rows_form.sub_account_select_" + count + ".selectedIndex") > 0) && (eval("document.edit_rows_form.sub_account_select_" + count + ".options[document.edit_rows_form.sub_account_select_" + count + ".selectedIndex].value") == "C"))
      {
        // run through the same_check array to see if exists in a location that is different than the current "count" variable
        for (count2=0; count2 < same_check.length; count2++)
        {
          if (count2 != count && same_check[count2] == eval("document.edit_rows_form.sub_account_text_" + count + ".value"))
          {
            alert("Check# " + same_check[count2] + " was used in multiple locations!");
            return false;
          }
        }
      }
      else if ((eval("document.edit_rows_form.account_select_" + count + ".selectedIndex") > 0) && (eval("document.edit_rows_form.sub_account_select_" + count + ".selectedIndex") > 0) && (eval("document.edit_rows_form.sub_account_select_" + count + ".options[document.edit_rows_form.sub_account_select_" + count + ".selectedIndex].value") == "D"))
      {
        // run through the same_deposit array to see if exists in a location that is different than the current "count" variable
        for (count2=0; count2 < same_deposit.length; count2++)
        {
          if (count2 != count && same_deposit[count2] == eval("document.edit_rows_form.sub_account_text_" + count + ".value"))
          {
            alert("Deposit# " + same_deposit[count2] + " was used in multiple locations!");
            return false;
          }
        }
      }
    }

    return true;
  }

  function blank_click()
  {
    var count;

    for (count=0; count < num_rows; count++)
    {
      eval("document.edit_rows_form.sub_entity_select_" + count + ".selectedIndex = 0");
      eval("document.edit_rows_form.account_select_" + count + ".selectedIndex = 0");
      eval("document.edit_rows_form.sub_account_select_" + count + ".selectedIndex = 0");
      account_select_change(eval("document.edit_rows_form.sub_entity_select_" + count), eval("document.edit_rows_form.account_select_" + count), eval("document.edit_rows_form.sub_account_select_" + count), eval("document.edit_rows_form.sub_account_text_" + count), "");
      eval("document.edit_rows_form.sub_account_text_" + count + ".value = ''");
      eval("document.edit_rows_form.debit_" + count + ".value = ''");
      eval("document.edit_rows_form.credit_" + count + ".value = ''");
      eval("document.edit_rows_form.cleared_" + count + ".value = ' '");
    }
  }

  function reset_click()
  {
    blank_click();
END_OF_STYLE
for ($count=0; $count < $max_rows; $count++)
{
  print "    document.edit_rows_form.sub_entity_select_$count.selectedIndex = $sub_entity_reset_array[$count];\n";
  print "    document.edit_rows_form.account_select_$count.selectedIndex = $account_reset_array[$count];\n";
  print "    account_select_change(document.edit_rows_form.sub_entity_select_$count, document.edit_rows_form.account_select_$count, document.edit_rows_form.sub_account_select_$count, document.edit_rows_form.sub_account_text_$count, document.edit_rows_form.cleared_$count);\n";
  print "    document.edit_rows_form.sub_account_select_$count.selectedIndex = reset_sub_account_$count;\n";
  print "    document.edit_rows_form.sub_account_text_$count.value = reset_sub_account_text_$count;\n";
  print "    document.edit_rows_form.debit_$count.value = reset_debit_$count;\n";
  print "    document.edit_rows_form.credit_$count.value = reset_credit_$count;\n";
  print "    document.edit_rows_form.cleared_$count.value = reset_cleared_$count;\n";
}
print <<"END_OF_STYLE";
  }

  //-->
</script>
END_OF_STYLE
#/ get current date
$date = `/bin/date +%m-%d-%Y`;
chomp $date;

print "<center>\n";
print "<table border=0 width=100% cellspacing=0 cellpadding=2 bgcolor=\"$body_bgcolor\">\n";
print "<tr>\n";
if ($mode eq "edit" or $other_mode eq "edit")
{
  print "<td align=left width=47%><font color=\"red\">";
  print "Editing Journal Entry in Journal <font color=\"blue\">$journal_name</font>";
}
elsif ($mode eq "new" or $other_mode eq "new")
{
  print "<td align=left width=47%><font color=\"red\">";
  print "Creating Journal Entry in Journal <font color=\"blue\">$journal_name</font>";
}
print " in Ledger <font color=\"$ledger_color\">$ledger_name</font></font></td>\n";
print "<td align=left><a href=\"$site_dir/help.html#journal\" target=\"docs\"><img border=0 src=\"$site_dir/images/help.jpg\" alt=\"Help\"></a></td>\n";
print "<td align=right>$date</td></tr></table>\n<hr><br>\n";
print PrintStandardLedgerMainMenu($ledger_db);

if ($mode eq "edit") # find the Journal Entry to edit and display our own edit code
{
  # get the first half of the transaction information
  $journal_code = $input{'journal_code_select'};
  $error_string = IsValidString($journal_code);
  if (length $error_string > 0)
  {
    print "<h1>Error:  Invalid Journal Code!</h1>\n";
    print "<b>$error_string</b> is invalid!<br>$back_button";
    CleanUp();
  }
  $trans_date = $input{'trans_date'};  # this will need to be changed to constructing the date from the month, day1, day2, and year selects
  if (not IsValidDateSyntax($trans_date))
  {
    print "<h1>Error:  Invalid Transaction Date!</h1>\n";
    print "$back_button";
    CleanUp();
  }
  $memo = $input{'memo_text'};
  $error_string = IsValidString($memo);
  if (length $error_string > 0)
  {
    print "<h1>Error:  Invalid Memo!</h1>\n";
    print "<b>$error_string</b> is invalid!<br>$back_button";
    CleanUp();
  }
  if (exists $input{'remembered_check'})
  {
    $remember = "true";
  }
  else
  {
    $remember = "false";
  }

  # start form
  print "<form method=post name=\"edit_rows_form\" action=\"$site_dir/cgi-bin/journal_activity_update.cgi\">\n";
  # hidden ref_num value
  print "<input type=hidden name=\"ref_num\" value=\"$ref_num\">\n";
  # hidden ledger_name value
  print "<input type=hidden name=\"ledger_db\" value=\"$ledger_db\">\n";
  # hidden journal_code value
  print "<input type=hidden name=\"journal_code\" value=\"$journal_code\">\n";
  # hidden transaction date value
  print "<input type=hidden name=\"trans_date\" value=\"$trans_date\">\n";
  # hidden payee_payer value
  print "<input type=hidden name=\"payee_payer\" value=\"$payee_payer\">\n";
  # hidden memo value
  print "<input type=hidden name=\"memo\" value=\"$memo\">\n";
  # hidden remember value
  print "<input type=hidden name=\"remember\" value=\"$remember\">\n";
  # hidden mode for row script (edit or new)
  print "<input type=hidden name=\"mode\" value=\"edit\">\n";
  # hidden number of rows in table
  $temp_rows = $num_rows + $num_extra_rows;
  print "<input type=hidden name=\"num_rows\" value=\"$temp_rows\">\n";

  print "</center>\n";
  print "Reference Number: $ref_num<br><br>\n";
  print "<center>\n";
  # build table out of the data
  print "<table border=1 cellspacing=1 cellpadding=2 bgcolor=\"$body_bgcolor\">\n";
  print "<tr>\n";
  print "<th valign=top>Journal</th><th valign=top align=left>Date</th><th valign=top align=left>Payee-Payer</th>";
  print "</tr>\n";
  print "<tr>\n";
  # journal code
  print "<td>$journal_code</td>\n";
  # date
  print "<td>$trans_date</td>\n";
  # payee/payer
  if ($payee_payer eq "")
  {
    print "<td><br></td>\n";
  }
  else
  {
    print "<td>$payee_payer</td>\n";
  }
  print "</tr>\n";
  print "<tr>\n";
  print "<th align=left>Remembered</th><th colspan=2 align=left>Memo</th>\n";
  print "</tr>\n";
  print "<tr>\n";
  # remembered
  print "<td align=center>";
  if ($remember eq "true")
  {
    print "<b>Yes</b>";
  }
  else
  {
    print "No";
  }
  print "</td>\n";
  # memo text field
  if ($memo eq "")
  {
    print "<td colspan=2><br></td>\n";
  }
  else
  {
    print "<td colspan=2>" . substr($memo, 0, 75) . "</td>\n";
  }
  print "</tr>\n";
  print "</table>\n";
  print "<hr>\n";
  print "<table border=0 width=\"100%\" cellspacing=1 cellpadding=2 bgcolor=\"$body_bgcolor\">\n";
  print "<tr>\n";
  print "<td align=left><input type=submit name=\"edit_submit\" value=\"Submit Journal Entry\" onClick=\"return validate_form();\"></td>\n";
  print "<td align=right><input type=submit name=\"refresh1\" value=\"Refresh\" onClick=\"submit_my_form(document.edit_rows_form, '$site_dir/cgi-bin/journal_activity_rows.cgi');\"> <input type=button name=\"blank1\" value=\"Blank\" onClick=\"blank_click();\"> <input type=button name=\"reset1\" value=\"Default\" onClick=\"reset_click();\"></td>\n";
  print "</tr>\n";
  print "</table>\n";
  print "<table border=1 width=\"100%\" cellspacing=1 cellpadding=2 bgcolor=\"$body_bgcolor\">\n";
  print "<tr>\n";
  print "<th width=\"1%\">SbE</th><th>Account</th><th width=\"25%\">Sub Account</th><th width=\"1%\">Debit</th><th width=\"1%\">Credit</th>\n";
  print "</tr>\n";
  # get all records for this journal entry from debitcredit_tb and add num_extra_rows to the end
  for ($count=0; $count<$num_rows; $count++)
  {
    print "<input type=hidden name=\"cleared_$count\" value=\"$cleareds[$count]\">\n";
    print "<tr>\n";
    # sub-entity
    print "<td align=center><select name=\"sub_entity_select_$count\">\n";
    print "<option value=\"\">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;\n";
    for ($count2=0; $count2 < @sub_entity_array; $count2++)
    {
      print "<option";
      if ($sub_entity_array[$count2] eq $sub_e_codes[$count])
      {
        print " selected";
      }
      print ">$sub_entity_array[$count2]\n";
    }
    print "</select></td>\n";
    # account
    print "<td align=center><select name=\"account_select_$count\" onChange=\"account_select_change(document.edit_rows_form.sub_entity_select_$count, document.edit_rows_form.account_select_$count, document.edit_rows_form.sub_account_select_$count, document.edit_rows_form.sub_account_text_$count, document.edit_rows_form.cleared_$count);\">\n";
    print "<option value=\"-1\">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;\n";
    for ($count2=0; $count2 < @account_array; $count2++)
    {
      print "<option";
      if ($account_array[$count2][0] eq $account_nums[$count] || ($mode eq "refresh" && $account_array[$count2][0] eq $input{"accounting_select_$count"}))
      {
        print " selected";
      }
      print " value=\"$account_array[$count2][0]\">$account_array[$count2][1]\n";
    }
    print "</select></td>\n";
    # sub-account
    print "<td align=center><select name=\"sub_account_select_$count\" onChange=\"sub_account_select_change(document.edit_rows_form.account_select_$count, document.edit_rows_form.sub_account_select_$count, document.edit_rows_form.sub_account_text_$count, document.edit_rows_form.debit_$count, document.edit_rows_form.credit_$count);\">\n";
    print "<option value=\"-1\">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;\n";
    print "</select><input type=text name=\"sub_account_text_$count\" size=10 onChange=\"sub_account_text_change(document.edit_rows_form.sub_account_text_$count, document.edit_rows_form.sub_account_select_$count);\"></td>\n";
    # debit/credit
    if ($dorcs[$count] eq "t")
    {
      # debit
      print "<td align=center><input type=text name=\"debit_$count\" value=\"$amounts[$count]\" size=12 onChange=\"debit_change(document.edit_rows_form.debit_$count, document.edit_rows_form.credit_$count, document.edit_rows_form.sub_account_select_$count);\"></td>\n";
      # credit
      print "<td align=center><input type=text name=\"credit_$count\" size=12 onChange=\"credit_change(document.edit_rows_form.credit_$count, document.edit_rows_form.debit_$count, document.edit_rows_form.sub_account_select_$count);\"></td>\n";
    }
    else
    {
      # debit
      print "<td align=center><input type=text name=\"debit_$count\" size=12 onChange=\"debit_change(document.edit_rows_form.debit_$count, document.edit_rows_form.credit_$count, document.edit_rows_form.sub_account_select_$count);\"></td>\n";
      # credit
      print "<td align=center><input type=text name=\"credit_$count\" value=\"$amounts[$count]\" size=12 onChange=\"credit_change(document.edit_rows_form.credit_$count, document.edit_rows_form.debit_$count, document.edit_rows_form.sub_account_select_$count);\"></td>\n";
    }
    print "</tr>\n";
  }
  for ($count2=0; $count2<$num_extra_rows; $count2++, $count++)
  {
    print "<input type=hidden name=\"cleared_$count\" value=\" \">\n";
    print "<tr>\n";
    # sub_entity
    print "<td align=center><select name=\"sub_entity_select_$count\">\n";
    print "<option value=\"\">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;\n";
    for ($count3=0; $count3 < @sub_entity_array; $count3++)
    {
      print "<option";
      if ($sub_entity_array[$count3] eq $sub_e_codes[$count])
      {
        print " selected";
      }
      print ">$sub_entity_array[$count3]\n";
    }
    print "</select></td>\n";
    # account
    print "<td align=center><select name=\"account_select_$count\" onChange=\"account_select_change(document.edit_rows_form.sub_entity_select_$count, document.edit_rows_form.account_select_$count, document.edit_rows_form.sub_account_select_$count, document.edit_rows_form.sub_account_text_$count, '');\">\n";
    print "<option value=\"-1\">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;\n";
    for ($count3=0; $count3 < @account_array; $count3++)
    {
      print "<option";
      if ($account_array[$count3][0] eq $account_nums[$count] || ($mode eq "refresh" && $account_array[$count3][0] eq $input{"accounting_select_$count"}))
      {
        print " selected";
      }
      print " value=\"$account_array[$count3][0]\">$account_array[$count3][1]\n";
    }
    print "</select></td>\n";
    # sub-account
    print "<td align=center><select name=\"sub_account_select_$count\" onChange=\"sub_account_select_change(document.edit_rows_form.account_select_$count, document.edit_rows_form.sub_account_select_$count, document.edit_rows_form.sub_account_text_$count, document.edit_rows_form.debit_$count, document.edit_rows_form.credit_$count);\">\n";
    print "<option value=\"-1\">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;\n";
    print "</select><input type=text name=\"sub_account_text_$count\" size=10 onChange=\"sub_account_text_change(document.edit_rows_form.sub_account_text_$count, document.edit_rows_form.sub_account_select_$count);\"></td>\n";
    # debit
    print "<td align=center><input type=text name=\"debit_$count\" size=12 onChange=\"debit_change(document.edit_rows_form.debit_$count, document.edit_rows_form.credit_$count, document.edit_rows_form.sub_account_select_$count);\"></td>\n";
    # credit
    print "<td align=center><input type=text name=\"credit_$count\" size=12 onChange=\"credit_change(document.edit_rows_form.credit_$count, document.edit_rows_form.debit_$count, document.edit_rows_form.sub_account_select_$count);\"></td>\n";
    print "</tr>\n";
  }
  print "</table>\n";
  print "<table border=0 width=\"100%\" cellspacing=1 cellpadding=2 bgcolor=\"$body_bgcolor\">\n";
  print "<tr>\n";
  print "<td align=left><input type=submit name=\"edit_submit\" value=\"Submit Journal Entry\" onClick=\"return validate_form();\"></td>\n";
  print "<td align=right><input type=submit name=\"refresh2\" value=\"Refresh\" onClick=\"submit_my_form(document.edit_rows_form, '$site_dir/cgi-bin/journal_activity_rows.cgi');\"> <input type=button name=\"blank2\" value=\"Blank\" onClick=\"blank_click();\"> <input type=button name=\"reset2\" value=\"Default\" onClick=\"reset_click();\"></td>\n";
  print "</tr>\n";
  print "</table>\n";
  my $temp_str;
  $temp_str = GetJournalViewInput();
  if (length $temp_str > 0)
  {
    print "$temp_str";
  }
  print "</form>\n";
  $temp_str = GetJournalViewInput();
  if (length $temp_str > 0)
  {
    print "<form name=\"journal_view_form\" method=post action=\"$site_dir/cgi-bin/journal_mod1.cgi\">\n";
    print "$temp_str";
    print "<br><div align=left><a href=\"$site_dir/cgi-bin/journal_mod1.cgi\" onClick=\"document.journal_view_form.submit(); return false;\">To return to the Journal View, click <u>here</u>.</a></div>\n";
    print "</form>\n";
  }
}
elsif ($mode eq "new") # create the new journal entry
{
  # get the first half of the transaction information
  $journal_code = $input{'journal_code_select'};
  $error_string = IsValidString($journal_code);
  if (length $error_string > 0)
  {
    print "<h1>Error:  Invalid Journal Code!</h1>\n";
    print "<b>$error_string</b> is invalid!<br>$back_button";
    CleanUp();
  }
  $trans_date = $input{'trans_date'};  # this will need to be changed to constructing the date from the month, day1, day2, and year selects
  if (not IsValidDateSyntax($trans_date))
  {
    print "<h1>Error:  Invalid Transaction Date!</h1>\n";
    print "$back_button";
    CleanUp();
  }
  $memo = $input{'memo_text'};
  $error_string = IsValidString($memo);
  if (length $error_string > 0)
  {
    print "<h1>Error:  Invalid Memo!</h1>\n";
    print "<b>$error_string</b> is invalid!<br>$back_button";
    CleanUp();
  }
  if (exists $input{'remembered_check'})
  {
    $remember = "true";
  }
  else
  {
    $remember = "false";
  }

  # start form
  print "<form method=post name=\"edit_rows_form\" action=\"$site_dir/cgi-bin/journal_activity_update.cgi\">\n";
  # hidden ledger_name value
  print "<input type=hidden name=\"ledger_db\" value=\"$ledger_db\">\n";
  # hidden journal_code value
  print "<input type=hidden name=\"journal_code\" value=\"$journal_code\">\n";
  # hidden transaction date value
  print "<input type=hidden name=\"trans_date\" value=\"$trans_date\">\n";
  # hidden payee_payer value
  print "<input type=hidden name=\"payee_payer\" value=\"$payee_payer\">\n";
  # hidden memo value
  print "<input type=hidden name=\"memo\" value=\"$memo\">\n";
  # hidden remember value
  print "<input type=hidden name=\"remember\" value=\"$remember\">\n";
  # hidden mode for row script (edit or new)
  print "<input type=hidden name=\"mode\" value=\"new\">\n";
  # hidden number of rows in table
  if ($payee_payer_exists eq "true")
  {
    $temp_rows = $num_rows + $num_extra_rows;
  }
  else
  {
    $temp_rows = $num_rows;
  }
  print "<input type=hidden name=\"num_rows\" value=\"$temp_rows\">\n";

  # build table out of the data
  print "<table border=1 cellspacing=1 cellpadding=2 bgcolor=\"$body_bgcolor\">\n";
  print "<tr>\n";
  print "<th valign=top>Journal</th><th valign=top align=left>Date</th><th valign=top align=left>Payee-Payer</th>";
  print "</tr>\n";
  print "<tr>\n";
  # journal code
  print "<td>$journal_code</td>\n";
  # date
  print "<td>$trans_date</td>\n";
  # payee/payer
  if ($payee_payer eq "")
  {
    print "<td><br></td>\n";
  }
  else
  {
    print "<td>$payee_payer</td>\n";
  }
  print "</tr>\n";
  print "<tr>\n";
  print "<th align=left>Remembered</th><th colspan=2 align=left>Memo</th>\n";
  print "</tr>\n";
  print "<tr>\n";
  # remembered
  print "<td align=center>";
  if ($remember eq "true")
  {
    print "<b>Yes</b>";
  }
  else
  {
    print "No";
  }
  print "</td>\n";
  # memo text field
  if ($memo eq "")
  {
    print "<td colspan=2><br></td>\n";
  }
  else
  {
    print "<td colspan=2>" . substr($memo, 0, 75) . "</td>\n";
  }
  print "</tr>\n";
  print "</table>\n";
  print "<hr>\n";
  print "<table border=0 width=\"100%\" cellspacing=1 cellpadding=2 bgcolor=\"$body_bgcolor\">\n";
  print "<tr>\n";
  print "<td align=left><input type=submit name=\"new_submit\" value=\"Submit Journal Entry\" onClick=\"return validate_form();\"></td>\n";
  print "<td align=right><input type=submit name=\"refresh1\" value=\"Refresh\" onClick=\"submit_my_form(document.edit_rows_form, '$site_dir/cgi-bin/journal_activity_rows.cgi');\"> <input type=button name=\"blank1\" value=\"Blank\" onClick=\"blank_click();\"> <input type=button name=\"reset1\" value=\"Default\" onClick=\"reset_click();\"></td>\n";
  print "</tr>\n";
  print "</table>\n";
  print "<table border=1 width=\"100%\" cellspacing=1 cellpadding=2 bgcolor=\"$body_bgcolor\">\n";
  print "<tr>\n";
  print "<th width=\"1%\">SbE</th><th>Account</th><th width=\"25%\">Sub Account</th><th width=\"1%\">Debit</th><th width=\"1%\">Credit</th>\n";
  print "</tr>\n";
  if ($payee_payer_exists eq "true")
  {
    # get all records for this journal entry from debitcredit_tb and add num_extra_rows to the end
    for ($count=0; $count<$num_rows; $count++)
    {
      print "<input type=hidden name=\"cleared_$count\" value=\" \">\n";
      print "<tr>\n";
      # sub-entity
      print "<td align=center><select name=\"sub_entity_select_$count\">\n";
      print "<option value=\"\">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;\n";
      for ($count3=0; $count3 < @sub_entity_array; $count3++)
      {
        print "<option";
        if ($sub_entity_array[$count3] eq $sub_e_codes[$count])
        {
          print " selected";
        }
        print ">$sub_entity_array[$count3]\n";
      }
      print "</select></td>\n";
      # account
      print "<td align=center><select name=\"account_select_$count\" onChange=\"account_select_change(document.edit_rows_form.sub_entity_select_$count, document.edit_rows_form.account_select_$count, document.edit_rows_form.sub_account_select_$count, document.edit_rows_form.sub_account_text_$count, '');\">\n";
      print "<option value=\"-1\">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;\n";
      for ($count3=0; $count3 < @account_array; $count3++)
      {
        print "<option";
        if ($account_array[$count3][0] eq $account_nums[$count] || ($mode eq "refresh" && $account_array[$count3][0] eq $input{"accounting_select_$count"}))
        {
          print " selected";
        }
        print " value=\"$account_array[$count3][0]\">$account_array[$count3][1]\n";
      }
      print "</select></td>\n";
      # sub-account
      print "<td align=center><select name=\"sub_account_select_$count\" onChange=\"sub_account_select_change(document.edit_rows_form.account_select_$count, document.edit_rows_form.sub_account_select_$count, document.edit_rows_form.sub_account_text_$count, document.edit_rows_form.debit_$count, document.edit_rows_form.credit_$count);\">\n";
      print "<option value=\"-1\">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;\n";
      print "</select><input type=text name=\"sub_account_text_$count\" size=10 onChange=\"sub_account_text_change(document.edit_rows_form.sub_account_text_$count, document.edit_rows_form.sub_account_select_$count);\"></td>\n";
      # debit/credit
      if ($dorcs[$count] eq "t")
      {
        # debit
        print "<td align=center><input type=text name=\"debit_$count\" value=\"$amounts[$count]\" size=12 onChange=\"debit_change(document.edit_rows_form.debit_$count, document.edit_rows_form.credit_$count, document.edit_rows_form.sub_account_select_$count);\"></td>\n";
        # credit
        print "<td align=center><input type=text name=\"credit_$count\" size=12 onChange=\"credit_change(document.edit_rows_form.credit_$count, document.edit_rows_form.debit_$count, document.edit_rows_form.sub_account_select_$count);\"></td>\n";
      }
      else
      {
        # debit
        print "<td align=center><input type=text name=\"debit_$count\" size=12 onChange=\"debit_change(document.edit_rows_form.debit_$count, document.edit_rows_form.credit_$count, document.edit_rows_form.sub_account_select_$count);\"></td>\n";
        # credit
        print "<td align=center><input type=text name=\"credit_$count\" value=\"$amounts[$count]\" size=12 onChange=\"credit_change(document.edit_rows_form.credit_$count, document.edit_rows_form.debit_$count, document.edit_rows_form.sub_account_select_$count);\"></td>\n";
      }
      print "</tr>\n";
    }
    for ($count2=0; $count2<$num_extra_rows; $count2++, $count++)
    {
      print "<input type=hidden name=\"cleared_$count\" value=\" \">\n";
      print "<tr>\n";
      # sub_entity
      print "<td align=center><select name=\"sub_entity_select_$count\">\n";
      print "<option value=\"\">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;\n";
      for ($count3=0; $count3 < @sub_entity_array; $count3++)
      {
        print "<option";
        if ($sub_entity_array[$count3] eq $sub_e_codes[$count])
        {
          print " selected";
        }
        print ">$sub_entity_array[$count3]\n";
      }
      print "</select></td>\n";
      # account
      print "<td align=center><select name=\"account_select_$count\" onChange=\"account_select_change(document.edit_rows_form.sub_entity_select_$count, document.edit_rows_form.account_select_$count, document.edit_rows_form.sub_account_select_$count, document.edit_rows_form.sub_account_text_$count, '');\">\n";
      print "<option value=\"-1\">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;\n";
      for ($count3=0; $count3 < @account_array; $count3++)
      {
        print "<option";
        if ($account_array[$count3][0] eq $account_nums[$count] || ($mode eq "refresh" && $account_array[$count3][0] eq $input{"accounting_select_$count"}))
        {
          print " selected";
        }
        print " value=\"$account_array[$count3][0]\">$account_array[$count3][1]\n";
      }
      print "</select></td>\n";
      # sub-account
      print "<td align=center><select name=\"sub_account_select_$count\" onChange=\"sub_account_select_change(document.edit_rows_form.account_select_$count, document.edit_rows_form.sub_account_select_$count, document.edit_rows_form.sub_account_text_$count, document.edit_rows_form.debit_$count, document.edit_rows_form.credit_$count);\">\n";
      print "<option value=\"-1\">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;\n";
      print "</select><input type=text name=\"sub_account_text_$count\" size=10 onChange=\"sub_account_text_change(document.edit_rows_form.sub_account_text_$count, document.edit_rows_form.sub_account_select_$count);\"></td>\n";
      # debit
      print "<td align=center><input type=text name=\"debit_$count\" size=12 onChange=\"debit_change(document.edit_rows_form.debit_$count, document.edit_rows_form.credit_$count, document.edit_rows_form.sub_account_select_$count);\"></td>\n";
      # credit
      print "<td align=center><input type=text name=\"credit_$count\" size=12 onChange=\"credit_change(document.edit_rows_form.credit_$count, document.edit_rows_form.debit_$count, document.edit_rows_form.sub_account_select_$count);\"></td>\n";
      print "</tr>\n";
    }
  }
  else
  {
    for ($count=0; $count<$num_rows; $count++)
    {
      print "<input type=hidden name=\"cleared_$count\" value=\" \">\n";
      print "<tr>\n";
      # sub_entity
      print "<td align=center><select name=\"sub_entity_select_$count\">\n";
      print "<option value=\"\">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;\n";
      for ($count3=0; $count3 < @sub_entity_array; $count3++)
      {
        print "<option";
        if ($sub_entity_array[$count3] eq $sub_e_codes[$count])
        {
          print " selected";
        }
        print ">$sub_entity_array[$count3]\n";
      }
      print "</select></td>\n";
      # account
      print "<td align=center><select name=\"account_select_$count\" onChange=\"account_select_change(document.edit_rows_form.sub_entity_select_$count, document.edit_rows_form.account_select_$count, document.edit_rows_form.sub_account_select_$count, document.edit_rows_form.sub_account_text_$count, '');\">\n";
      print "<option value=\"-1\">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;\n";
      for ($count3=0; $count3 < @account_array; $count3++)
      {
        print "<option";
        if ($account_array[$count3][0] eq $account_nums[$count] || ($mode eq "refresh" && $account_array[$count3][0] eq $input{"accounting_select_$count"}))
        {
          print " selected";
        }
        print " value=\"$account_array[$count3][0]\">$account_array[$count3][1]\n";
      }
      print "</select></td>\n";
      # sub-account
      print "<td align=center><select name=\"sub_account_select_$count\" onChange=\"sub_account_select_change(document.edit_rows_form.account_select_$count, document.edit_rows_form.sub_account_select_$count, document.edit_rows_form.sub_account_text_$count, document.edit_rows_form.debit_$count, document.edit_rows_form.credit_$count);\">\n";
      print "<option value=\"-1\">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;\n";
      print "</select><input type=text name=\"sub_account_text_$count\" size=10 onChange=\"sub_account_text_change(document.edit_rows_form.sub_account_text_$count, document.edit_rows_form.sub_account_select_$count);\"></td>\n";
      # debit
      print "<td align=center><input type=text name=\"debit_$count\" size=12 onChange=\"debit_change(document.edit_rows_form.debit_$count, document.edit_rows_form.credit_$count, document.edit_rows_form.sub_account_select_$count);\"></td>\n";
      # credit
      print "<td align=center><input type=text name=\"credit_$count\" size=12 onChange=\"credit_change(document.edit_rows_form.credit_$count, document.edit_rows_form.debit_$count, document.edit_rows_form.sub_account_select_$count);\"></td>\n";
      print "</tr>\n";
    }
  }
  print "</table>\n";
  print "<table border=0 width=\"100%\" cellspacing=1 cellpadding=2 bgcolor=\"$body_bgcolor\">\n";
  print "<tr>\n";
  print "<td align=left><input type=submit name=\"new_submit\" value=\"Submit Journal Entry\" onClick=\"return validate_form();\"></td>\n";
  print "<td align=right><input type=submit name=\"refresh2\" value=\"Refresh\" onClick=\"submit_my_form(document.edit_rows_form, '$site_dir/cgi-bin/journal_activity_rows.cgi');\"> <input type=button name=\"blank2\" value=\"Blank\" onClick=\"blank_click();\"> <input type=button name=\"reset2\" value=\"Default\" onClick=\"reset_click();\"></td>\n";
  print "</tr>\n";
  print "</table>\n";
  my $temp_str = GetJournalViewInput();
  if (length $temp_str > 0)
  {
    print "$temp_str";
  }
  print "</form>\n";
  my $temp_str = GetJournalViewInput();
  if (length $temp_str > 0)
  {
    print "<form name=\"journal_view_form\" method=post action=\"$site_dir/cgi-bin/journal_mod1.cgi\">\n";
    print "$temp_str";
    print "<br><div align=left><a href=\"$site_dir/cgi-bin/journal_mod1.cgi\" onClick=\"document.journal_view_form.submit(); return false;\">To return to the Journal View, click <u>here</u>.</a></div>\n";
    print "</form>\n";
  }
}
elsif ($mode eq "refresh")
{
  # start form
  print "<form method=post name=\"edit_rows_form\" action=\"$site_dir/cgi-bin/journal_activity_update.cgi\">\n";
  # hidden ledger_name value
  print "<input type=hidden name=\"ledger_db\" value=\"$ledger_db\">\n";
  if ($other_mode eq "edit")
  {
    # hidden ref_num value
    print "<input type=hidden name=\"ref_num\" value=\"$ref_num\">\n";
  }
  # hidden journal_code value
  print "<input type=hidden name=\"journal_code\" value=\"$journal_code\">\n";
  # hidden transaction date value
  print "<input type=hidden name=\"trans_date\" value=\"$trans_date\">\n";
  # hidden payee_payer value
  $payee_payer = $input{'payee_payer'};
  print "<input type=hidden name=\"payee_payer\" value=\"$payee_payer\">\n";
  # hidden memo value
  print "<input type=hidden name=\"memo\" value=\"$memo\">\n";
  # hidden remember value
  print "<input type=hidden name=\"remember\" value=\"$remember\">\n";
  # hidden mode for row script (edit or new)
  print "<input type=hidden name=\"mode\" value=\"$other_mode\">\n";
  # hidden number of rows in table
  print "<input type=hidden name=\"num_rows\" value=\"$num_rows\">\n";

  # build table out of the data
  print "<table border=1 cellspacing=1 cellpadding=2 bgcolor=\"$body_bgcolor\">\n";
  print "<tr>\n";
  print "<th valign=top>Journal</th><th valign=top align=left>Date</th><th valign=top align=left>Payee-Payer</th>";
  print "</tr>\n";
  print "<tr>\n";
  # journal code
  print "<td>$journal_code</td>\n";
  # date
  print "<td>$trans_date</td>\n";
  # payee/payer
  if ($payee_payer eq "")
  {
    print "<td><br></td>\n";
  }
  else
  {
    print "<td>$payee_payer</td>\n";
  }
  print "</tr>\n";
  print "<tr>\n";
  print "<th align=left>Remembered</th><th colspan=2 align=left>Memo</th>\n";
  print "</tr>\n";
  print "<tr>\n";
  # remembered
  print "<td align=center>";
  if ($remember eq "true")
  {
    print "<b>Yes</b>";
  }
  else
  {
    print "No";
  }
  print "</td>\n";
  # memo text field
  if ($memo eq "")
  {
    print "<td colspan=2><br></td>\n";
  }
  else
  {
    print "<td colspan=2>" . substr($memo, 0, 75) . "</td>\n";
  }
  print "</tr>\n";
  print "</table>\n";
  print "<hr>\n";
  print "<table border=0 width=\"100%\" cellspacing=1 cellpadding=2 bgcolor=\"$body_bgcolor\">\n";
  print "<tr>\n";
  print "<td align=left><input type=submit name=\"" . $other_mode . "_submit\" value=\"Submit Journal Entry\" onClick=\"return validate_form();\"></td>\n";
  print "<td align=right><input type=submit name=\"refresh1\" value=\"Refresh\" onClick=\"submit_my_form(document.edit_rows_form, '$site_dir/cgi-bin/journal_activity_rows.cgi');\"> <input type=button name=\"blank1\" value=\"Blank\" onClick=\"blank_click();\"> <input type=button name=\"reset1\" value=\"Default\" onClick=\"reset_click();\"></td>\n";
  print "</tr>\n";
  print "</table>\n";
  print "<table border=1 width=\"100%\" cellspacing=1 cellpadding=2 bgcolor=\"$body_bgcolor\">\n";
  print "<tr>\n";
  print "<th width=\"1%\">SbE</th><th>Account</th><th width=\"25%\">Sub Account</th><th width=\"1%\">Debit</th><th width=\"1%\">Credit</th>\n";
  print "</tr>\n";
  for ($count=0; $count<$num_rows; $count++)
  {
    print "<input type=hidden name=\"cleared_$count\" value=\"" . $input{"cleared_$count"} . "\">\n";
    print "<tr>\n";
    # sub_entity
    print "<td align=center><select name=\"sub_entity_select_$count\">\n";
    print "<option value=\"\">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;\n";
    for ($count3=0; $count3 < @sub_entity_array; $count3++)
    {
      print "<option";
      if ($sub_entity_array[$count3] eq $sub_e_codes[$count] || $sub_entity_array[$count3] eq $input{"sub_entity_select_$count"})
      {
        print " selected";
      }
      print ">$sub_entity_array[$count3]\n";
    }
    print "</select></td>\n";
    # account
    print "<td align=center><select name=\"account_select_$count\" onChange=\"account_select_change(document.edit_rows_form.sub_entity_select_$count, document.edit_rows_form.account_select_$count, document.edit_rows_form.sub_account_select_$count, document.edit_rows_form.sub_account_text_$count, '');\">\n";
    print "<option value=\"-1\">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;\n";
    for ($count3=0; $count3 < @account_array; $count3++)
    {
      print "<option";
      if ($account_array[$count3][0] eq $account_nums[$count] || ($mode eq "refresh" && $account_array[$count3][0] eq $input{"accounting_select_$count"}))
      {
        print " selected";
      }
      print " value=\"$account_array[$count3][0]\">$account_array[$count3][1]\n";
    }
    print "</select></td>\n";
    # sub-account
    print "<td align=center><select name=\"sub_account_select_$count\" onChange=\"sub_account_select_change(document.edit_rows_form.account_select_$count, document.edit_rows_form.sub_account_select_$count, document.edit_rows_form.sub_account_text_$count, document.edit_rows_form.debit_$count, document.edit_rows_form.credit_$count);\">\n";
    print "<option value=\"-1\">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;\n";
    print "</select><input type=text name=\"sub_account_text_$count\" value=\"" . $input{"sub_account_text_$count"} . "\" size=10 onChange=\"sub_account_text_change(document.edit_rows_form.sub_account_text_$count, document.edit_rows_form.sub_account_select_$count);\"></td>\n";
    # debit
    print "<td align=center><input type=text name=\"debit_$count\" value=\"" . $input{"debit_$count"} . "\" size=12 onChange=\"debit_change(document.edit_rows_form.debit_$count, document.edit_rows_form.credit_$count, document.edit_rows_form.sub_account_select_$count);\"></td>\n";
    # credit
    print "<td align=center><input type=text name=\"credit_$count\" value=\"" . $input{"credit_$count"} . "\" size=12 onChange=\"credit_change(document.edit_rows_form.credit_$count, document.edit_rows_form.debit_$count, document.edit_rows_form.sub_account_select_$count);\"></td>\n";
    print "</tr>\n";
  }
  print "</table>\n";
  print "<table border=0 width=\"100%\" cellspacing=1 cellpadding=2 bgcolor=\"$body_bgcolor\">\n";
  print "<tr>\n";
  print "<td align=left><input type=submit name=\"" . $other_mode . "_submit\" value=\"Submit Journal Entry\" onClick=\"return validate_form();\"></td>\n";
  print "<td align=right><input type=submit name=\"refresh2\" value=\"Refresh\" onClick=\"submit_my_form(document.edit_rows_form, '$site_dir/cgi-bin/journal_activity_rows.cgi');\"> <input type=button name=\"blank2\" value=\"Blank\" onClick=\"blank_click();\"> <input type=button name=\"reset2\" value=\"Default\" onClick=\"reset_click();\"></td>\n";
  print "</tr>\n";
  print "</table>\n";
  my $temp_str = GetJournalViewInput();
  if (length $temp_str > 0)
  {
    print "$temp_str";
  }
  print "</form>\n";
  my $temp_str = GetJournalViewInput();
  if (length $temp_str > 0)
  {
    print "<form name=\"journal_view_form\" method=post action=\"$site_dir/cgi-bin/journal_mod1.cgi\">\n";
    print "$temp_str";
    print "<br><div align=left><a href=\"$site_dir/cgi-bin/journal_mod1.cgi\" onClick=\"document.journal_view_form.submit(); return false;\">To return to the Journal View, click <u>here</u>.</a></div>\n";
    print "</form>\n";
  }
}

# print a horizontal rule to break the menu from the behind the scenes links
#print "<br><hr>\n";
print "</center>\n";

print "</body>\n";
print "</html>\n";
exit 0;

sub GetJournalViewInput
{
  my ($mode, $date_type, $date_from, $date_to, $redisplay_string, $journal_name, $journal_code, $ref_num, $error_string, $payee_payer, $memo, $account_name, $account_num, $sub_acct_name, $sub_acct_num, $sub_acct_parent);
  my ($money_type, $money_search, $money1, $money2, $sort_by, $sort_journal, $num_entries_to_display, $start_index, $ledger_db, $check_num, $deposit_num, $sort_operator);
  my %valid_entries_to_display = ( 5 => "5", 10 => "10", 15 => "15", 20 => "20", 25 => "25", 30 => "30", 35 => "35", 40 => "40", 45 => "45", 50 => "50" );
  my %valid_options = ( "open" => "open", "delete" => "delete", "add" => "add", "search" => "search", "search2" => "search2" );

  if (not exists $input{'journal_view_command'})
  {
    return "";  # nothing to do.
  }
  if (not exists $valid_options{$input{'journal_view_command'}})
  {
    PrintErrorHeader();
    print "<h1>(Journal View Re-display Code) Error:  Access Denied!</h1>\n";
    print "Invalid option given.  Option = '$input{'journal_view_command'}'.<br>$sys_admin";
    CleanUp();
  }

  $ledger_db = $input{'ledger'};
  if (length $ledger_db == 0)
  {
    PrintErrorHeader();
    print "<h1>(Journal View Re-display Code) Error: You must specify a ledger to work with!</h1>\n";
    print "$back_button";
    CleanUp();
  }
  $error_string = IsValidString($ledger_db);
  if (length $error_string > 0)
  {
    PrintErrorHeader();
    print "<h1>(Journal View Re-display Code) Error:  Invalid Database Name!</h1>\n";
    print "<b>$error_string</b> is invalid!<br>$back_button";
    CleanUp();
  }
  $redisplay_string .= "<input type=hidden name=\"ledger\" value=\"$ledger_db\">\n";

  # validate we got valid input from the user.
  if ($input{'journal_view_command'} eq "open")
  {
    $mode = 1;
    $redisplay_string .= "<input type=hidden name=\"journal_view_command\" value=\"open\">\n";
    if (not exists $input{'journal'})
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error: You must specify a Journal to work with!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    $redisplay_string .= "<input type=hidden name=\"journal\" value=\"" . $input{'journal'} . "\">\n";
    $date_from = $input{'date_from'};
    if (length $date_from == 0)
    {
      PrintErrorHeader();
      print "<h1>Error:  You must specify a From date!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    $date_to = $input{'date_to'};
    if (length $date_to == 0)
    {
      PrintErrorHeader();
      print "<h1>Error:  You must specify a To date!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    $sort_by = $input{'sort_by'};
    if (length $sort_by == 0)
    {
      PrintErrorHeader();
      print "<h1>Error:  You must specify a SortBy Option!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    if (not ($sort_by eq "date" || $sort_by eq "ref_num" || $sort_by eq "payee_payer"))
    {
      PrintErrorHeader();
      print "<h1>Error:  Invalid SortBy Option!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    if ($sort_by eq "date")
    {
      $sort_by = "trans_date";
    }
    if (exists $input{'sort_journal'})
    {
      $sort_journal = 1;
      $redisplay_string .= "<input type=hidden name=\"sort_journal\" value=\"1\">\n";
    }
    else
    {
      $sort_journal = 0;
    }
    $redisplay_string .= "<input type=hidden name=\"date_from\" value=\"$date_from\">\n<input type=hidden name=\"date_to\" value=\"$date_to\">\n<input type=hidden name=\"sort_by\" value=\"" . $input{'sort_by'} . "\">\n";
  }
  elsif ($input{'journal_view_command'} eq "search")
  {
    $mode = 4;
    # first make sure all the correct variables are being passed in.
    if (not exists $input{'date_type'})
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error: Date Qualifier must be given!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    $date_type = $input{'date_type'};
    if (not exists $input{'date_from_search'})
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error: Date to search from must be given!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    if (not ($date_type eq "equal" || $date_type eq "betweeni" || $date_type eq "betweene" || $date_type eq "afteri" || $date_type eq "aftere" || $date_type eq "beforei" || $date_type eq "beforee"))
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error:  Invalid Date Qualifier Option!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    $date_from = $input{'date_from_search'};
    if (not exists $input{'date_to_search'})
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error: Date to search to must be given!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    if (length $date_from > 0 && (not IsValidDateSyntax($date_from)))
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error:  Invalid Date given!</h1>\n";
      print "The From date is invalid.<br>$back_button";
      CleanUp();
    }
    $date_to = $input{'date_to_search'};
    if (length $date_to > 0 && (not IsValidDateSyntax($date_to)))
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error:  Invalid Date given!</h1>\n";
      print "The To date is invalid.<br>$back_button";
      CleanUp();
    }
    $redisplay_string .= "<input type=hidden name=\"journal_view_command\" value=\"search\">\n";
    $redisplay_string .= "<input type=hidden name=\"date_type\" value=\"$date_type\">\n<input type=hidden name=\"date_from_search\" value=\"$date_from\">\n<input type=hidden name=\"date_to_search\" value=\"$date_to\">\n";
    if (not exists $input{'journal2'})
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error: Journal selection must be given!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    ($journal_name, $journal_code) = split /\|/, $input{'journal2'};
    if (not exists $input{'ref_num2'})
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error: Reference Number field must be given!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    $ref_num = $input{'ref_num2'};
    $error_string = IsValidUInteger($ref_num);
    if (length $ref_num > 0 && length $error_string > 0)
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error:  Invalid Ref Number!</h1>\n";
      print "<b>$error_string</b> is invalid!<br>$back_button";
      CleanUp();
    }
    if (not exists $input{'check_num'})
    {
      PrintErrorHeader();
      print "<h1>Error: Check Number field must be given!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    $check_num = $input{'check_num'};
    $error_string = IsValidUInteger($check_num);
    if (length $check_num > 0 && length $error_string > 0)
    {
      PrintErrorHeader();
      print "<h1>Error:  Invalid Check Number!</h1>\n";
      print "<b>$error_string</b> is invalid!<br>$back_button";
      CleanUp();
    }
    if (not exists $input{'deposit_num'})
    {
      PrintErrorHeader();
      print "<h1>Error: Deposit Number field must be given!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    $deposit_num = $input{'deposit_num'};
    $error_string = IsValidUInteger($deposit_num);
    if (length $deposit_num > 0 && length $error_string > 0)
    {
      PrintErrorHeader();
      print "<h1>Error:  Invalid Deposit Number!</h1>\n";
      print "<b>$error_string</b> is invalid!<br>$back_button";
      CleanUp();
    }
    if (not exists $input{'payee_payer2'})
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error: Payee-Payer selection must be given!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    $payee_payer = $input{'payee_payer2'};
    $error_string = IsValidString($payee_payer);
    if (length $payee_payer > 0 && length $error_string > 0 && (not $error_string eq "_"))
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error:  Invalid Payee-Payer!</h1>\n";
      print "<b>$error_string</b> is invalid!<br>$back_button";
      CleanUp();
    }
    $redisplay_string .= "<input type=hidden name=\"journal2\" value=\"" . $input{'journal2'} . "\">\n<input type=hidden name=\"ref_num2\" value=\"$ref_num\">\n<input type=hidden name=\"check_num\" value=\"$check_num\">\n<input type=hidden name=\"deposit_num\" value=\"$deposit_num\">\n<input type=hidden name=\"payee_payer2\" value=\"$payee_payer\">\n";
    if (not exists $input{'memo2'})
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error: Memo field must be given!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    $memo = $input{'memo2'};
    $error_string = IsValidString($memo);
    if (length $memo > 0 && length $error_string > 0 && (not ($error_string eq "*" || $error_string eq "?")))
    {
      PrintErrorHeader();
      print "<h1(Journal View Re-display Code) >Error:  Invalid Memo!</h1>\n";
      print "<b>$error_string</b> is invalid!<br>$back_button";
      CleanUp();
    }
    if (not exists $input{'account'})
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error: Account selection must be given!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    ($account_name, $account_num) = split /\|/, $input{'account'};
    if (not exists $input{'sub_account'})
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error: Sub Account selection must be given!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    ($sub_acct_name, $sub_acct_num, $sub_acct_parent) = split /\|/, $input{'sub_account'};
    if (not exists $input{'dorc'})
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error: Debit or Credit Selection must be given!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    $money_type = $input{'dorc'};
    if (not ($money_type eq "select_dorc" || $money_type eq "debit" || $money_type eq "credit" || $money_type eq "both"))
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error:  Invalid Debit or Credit Selection type!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    $redisplay_string .= "<input type=hidden name=\"memo2\" value=\"$memo\">\n<input type=hidden name=\"account\" value=\"" . $input{'account'} . "\">\n<input type=hidden name=\"sub_account\" value=\"" . $input{'sub_account'} . "\">\n";
    $redisplay_string .= "<input type=hidden name=\"dorc\" value=\"$money_type\">\n";
    if (not exists $input{'dorc_search'})
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error: Debit or Credit Search Type Selection must be given!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    $money_search = $input{'dorc_search'};
    if (not ($money_search eq "all" || $money_search eq "equal" || $money_search eq "less_than" || $money_search eq "less_than_equal" || $money_search eq "greater_than" || $money_search eq "greater_than_equal" || $money_search eq "betweene" || $money_search eq "betweeni"))
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error:  Invalid Debit or Credit Search type!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    $money1 = $input{'money1'};
    $error_string = IsValidInteger($money1);
    my $error_string2 = IsValidFloat($money1);
    if (length $money1 > 0)
    {
      if (length $error_string > 0 && (not $error_string eq "."))
      {
        PrintErrorHeader();
        print "<h1>(Journal View Re-display Code) Error:  Invalid First Money Field!</h1>\n";
        print "<b>$error_string</b> is invalid!<br>$back_button";
        CleanUp();
      }
      elsif (length $error_string > 0 && $error_string eq "." && length $error_string2 > 0)
      {
        PrintErrorHeader();
        print "<h1>(Journal View Re-display Code) Error:  Invalid First Money Field!</h1>\n";
        print "<b>$error_string</b> is invalid!<br>$back_button";
        CleanUp();
      }
    }
    $redisplay_string .= "<input type=hidden name=\"dorc_search\" value=\"$money_search\">\n<input type=hidden name=\"money1\" value=\"$money1\">\n<input type=hidden name=\"money2\" value=\"" . $input{'money2'} . "\">\n";
    $money2 = $input{'money2'};
    $error_string = IsValidInteger($money2);
    $error_string2 = IsValidFloat($money2);
    if (length $money2 > 0)
    {
      if (length $error_string > 0 && (not $error_string eq "."))
      {
        PrintErrorHeader();
        print "<h1>(Journal View Re-display Code) Error:  Invalid Second Money Field!</h1>\n";
        print "<b>$error_string</b> is invalid!<br>$back_button";
        CleanUp();
      }
      elsif (length $error_string > 0 && $error_string eq "." && length $error_string2 > 0)
      {
        PrintErrorHeader();
        print "<h1>(Journal View Re-display Code) Error:  Invalid Second Money Field!</h1>\n";
        print "<b>$error_string</b> is invalid!<br>$back_button";
        CleanUp();
      }
    }
    $sort_by = $input{'sort_by2'};
    if (length $sort_by == 0)
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error:  You must specify a SortBy Option!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    #print "\"$sort_by\"<br>";
    if (not ($sort_by eq "date" || $sort_by eq "ref_num" || $sort_by eq "payee_payer"))
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error:  Invalid SortBy Option!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    if ($sort_by eq "date")
    {
      $sort_by = "trans_date";
    }
    if (exists $input{'sort_journal'})
    {
      $sort_journal = 1;
      $redisplay_string .= "<input type=hidden name=\"sort_journal\" value=\"1\">\n";
    }
    else
    {
      $sort_journal = 0;
    }
    $sort_operator = $input{'sort_operator'};
    if (length $sort_operator == 0)
    {
      PrintErrorHeader();
      print "<h1>Error:  You must specify a Search Operator!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    if (not ($sort_operator eq "AND" || $sort_operator eq "OR"))
    {
      PrintErrorHeader();
      print "<h1>Error:  Invalid Search Operator!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    $redisplay_string .= "<input type=hidden name=\"sort_by2\" value=\"" . $input{'sort_by2'} . "\">\n<input type=hidden name=\"sort_operator\" value=\"$sort_operator\">\n";

    # make sure they entered something in at least one field, but not something in both the debit and credit fields.
    if ((length $input{'date_from_search'} == 0) && (length $input{'date_to_search'} == 0) && ($input{'journal2'} eq "select_journal") && (length $input{'ref_num2'} == 0) && (length $input{'check_num'} == 0) && (length $input{'deposit_num'} == 0) && ($input{'payee_payer2'} eq "select_payee_payer") && (length $input{'memo2'} == 0) && ($input{'account'} eq "select_account") && ($input{'sub_account'} eq "select_sub_acct") && ($input{'dorc'} eq "select_dorc") && ($input{'dorc_search'} eq "all") && (length $input{'money1'} == 0) && (length $input{'money2'} == 0))
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error: You must specify something for your search!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    # make sure that the date_to_search field is given only if the date_type is "Between".
    if ((length $input{'date_from_search'} > 0) && (length $input{'date_to_search'} > 0) && ((not $input{'date_type'} eq "betweeni") && (not $input{'date_type'} eq "betweene")))
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error:  You must specify <b>Between</b> to use the second Date field!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    # make sure that both money fields are not both filled in if they are not doing a between search or no Dorc value selected.
    if ((length $input{'money1'} > 0) && (length $input{'money2'} > 0) && ((not $input{'dorc'} eq "select_dorc") && (not $input{'dorc_search'} eq "betweene") && (not $input{'dorc_search'} eq "betweeni")))
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error:  You can not specify both money fields when not searching with between!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    if (($input{'dorc_search'} eq "betweene" || $input{'dorc_search'} eq "betweeni") && (length $input{'money1'} == 0 || length $input{'money2'} == 0))
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error:  You must specify both money fields when searching with between!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    if (((not $input{'dorc'} eq "select_dorc") && (not $input{'dorc_search'} eq "all")) && ((length $input{'money1'} == 0) && (length $input{'money2'} == 0)))
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error:  You must specify an amount to search for!</h1>\n";
      print "Error: 1007<br>$back_button";
      CleanUp();
    }
    # make sure that if they enter a Ref-Num that they don't select anything else.
    if ((length $input{'ref_num2'} > 0) && ((length $input{'date_from_search'} > 0) || (length $input{'date_to_search'} > 0) || (length $input{'check_num'} > 0) || (length $input{'deposit_num'} > 0) || (not $input{'payee_payer2'} eq "select_payee_payer") || (not $input{'journal2'} eq "select_journal") || (not $input{'account'} eq "select_account") || (not $input{'sub_account'} eq "select_sub_acct") || (not $input{'dorc'} eq "select_dorc") || (not $input{'dorc_search'} eq "all") || (length $input{'money1'} > 0) || (length $input{'money2'} > 0) || (length $input{'memo2'} > 0)))
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error:  You can not specify anything else when specifying the Reference Number!</h1>\n";
      print "$back_button";
      CleanUp();
    }
  }
  elsif ($input{'journal_view_command'} eq "search2")
  {
    $mode = 5;
    # first make sure all the correct variables are being passed in.
    if (not exists $input{'ref_num2'})
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error: Reference Number field must be given!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    $ref_num = $input{'ref_num2'};
    $error_string = IsValidUInteger($ref_num);
    if (length $ref_num > 0 && length $error_string > 0)
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error:  Invalid Ref Number!</h1>\n";
      print "<b>$error_string</b> is invalid!<br>$back_button";
      CleanUp();
    }
    $redisplay_string .= "<input type=hidden name=\"journal_view_command\" value=\"search2\">\n<input type=hidden name=\"ref_num2\" value=\"$ref_num\">\n";
  }

  if ($mode == 1 || $mode == 4 || $mode == 5)
  {
    $num_entries_to_display = $input{'num_entries_to_display'};
    if (length $num_entries_to_display == 0)
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error: You must specify the number of Journal entries to display!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    $error_string = IsValidInteger($num_entries_to_display);
    if (length $error_string > 0)
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error:  Invalid Value for Number of Entries to Display!</h1>\n";
      print "<b>$error_string</b> is invalid!<br>$back_button";
      CleanUp();
    }

    # verify it is a valid value
    if (not exists $valid_entries_to_display{$num_entries_to_display})
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error:  Invalid Value for Number of Entries to Display!</h1>\n";
      print "<b>$num_entries_to_display</b> is not valid!<br>$back_button";
      CleanUp();
    }

    $start_index = $input{'start_index'};
    if (length $start_index == 0)
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error: You must specify the Starting Index to work from!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    $error_string = IsValidInteger($start_index);
    if (length $error_string > 0)
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error:  Invalid Value for Start Index to display from!</h1>\n";
      print "<b>$error_string</b> is invalid!<br>$back_button";
      CleanUp();
    }
    if ($start_index < 1)
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error:  The Start Index can not be less than 1!</h1>\n";
      print "$sys_admin";
      CleanUp();
    }
    $redisplay_string .= "<input type=hidden name=\"num_entries_to_display\" value=\"$num_entries_to_display\">\n<input type=hidden name=\"start_index\" value=\"$start_index\">\n";
  }

  return $redisplay_string;  # return the string that will contain everything necessary to re-display the journal like how the person just left it.
}