#!/usr/bin/perl
#$Id: journal_mod1.cgi,v 1.10 2004/02/18 00:05:03 james Exp $
#This package is released under the GPL.  You should have recieved the GPL with it.
# Copyright (c) 2000 HLR http://www.pcxperience.org  All rights reserved.
# journal_mod1.cgi  -  Created by James Pattie, 06/05/1999
# This script allows the user to either open a journal, delete
# a specified journal or create a new journal.
use strict;

use Pg;  # PostgreSQL Database Module
use cgi_lib;  # CGI Library routines
use custom;  # our customizable features
use reports;
use HTMLObject::Base;

use vars '$date';

# this is needed for URI encoding.
my $doc = HTMLObject::Base->new();

# get the values being passed in from the client
%input = ();  # make sure it is empty!
cgi_lib::ReadParse(*input);

# begin the HTML Output
print cgi_lib::PrintHeader();
print "<html>\n";

my $mode;  # modes are 1=open, 2=delete, 3=add, 4=search
my $ledger_name;  # name of ledger to work with
my $ledger_db;
my $journal_name;
my $journal_code;
my $date_from;
my $date_to;
my $date_type;
my $ref_num;
my $check_num;
my $deposit_num;
my $payee_payer;
my $account_num;
my $account_name;
my $sub_acct_name;
my $sub_acct_num;
my $sub_acct_parent;
my $sub_entity;
my $money_type;  # debit or credit
my $money_search; # =, <=, <, >, >=
my $money1;
my $money2;
my $memo;
my $sort_journal;
my $sort_by;
my $sort_operator;
my $journal_bgcolor;
my $search_string;
#my $use_java;
my $bank_color;
$bank_color="blue";
my $bank_deposit_color;
$bank_deposit_color="teal";
my $bank_credit_color;
$bank_credit_color="magenta";
my $name_first;
$name_first=0;	# set to 0 to have number first for Account and Sub Account.  Will eventually be set via Database.
my $edit_invalid;
$edit_invalid=1;	# set to 0 have it only allow you to delete invalid entries.  This will eventually come from the Database.
my $error_string;
my $report_obj;
my $ledger_color;
my $ledger_code;
my $num_entries_to_display;
my $start_index;
my $redisplay_string;
my $redisplayStringGET;
my $printing;
$printing = 0;
my $custom_title;
$custom_title = "";
my %valid_options;
%valid_options = ( "open" => "open", "delete" => "delete", "add" => "add", "search" => "search", "search2" => "search2", "print" => "print" );
$ledger_db = "";

use PortalWrapper; # The Portal Wrapper library.

my $portalObj;
$portalObj = PortalWrapper->new;
if ($portalObj->didErrorOccur)
{
  # begin the HTML Output
  print cgi_lib::PrintHeader();
  print "<html>\n";

  PrintErrorHeader();
  print $portalObj->errorMessage;
  CleanUp();
}
my $dbObj;
$dbObj = $portalObj->getDBInfo;
if (!defined $dbObj)
{
  if ($portalObj->didErrorOccur)
  {
    # begin the HTML Output
    print cgi_lib::PrintHeader();
    print "<html>\n";

    PrintErrorHeader();
    print $portalObj->errorMessage;
    CleanUp();
  }
}
else
{
  if ($dbObj->didErrorOccur)
  {
    # begin the HTML Output
    print cgi_lib::PrintHeader();
    print "<html>\n";
  
    PrintErrorHeader();
    print $dbObj->errorMessage;
    CleanUp();
  }
}
$db_host = $dbObj->dbHost;
$db_name = $dbObj->dbName;
$db_user = $dbObj->dbUser;
$db_passwd = $dbObj->dbPasswd;

my $database_connected;
$database_connected = 0;

if (not exists $input{'journal_view_command'})
{
  PrintErrorHeader();
  print "<h1>Error:  Access Denied!</h1>\n";
  print "Invalid command parameter.<br>$sys_admin";
  CleanUp();
}
if (not exists $valid_options{$input{'journal_view_command'}})
{
  PrintErrorHeader();
  print "<h1>Error:  Access Denied!</h1>\n";
  print "Invalid option given.  Option = '$input{'journal_view_command'}'.<br>$sys_admin";
  CleanUp();
}

$ledger_db = $input{'ledger'};
if (length $ledger_db == 0)
{
  PrintErrorHeader();
  print "<h1>Error: You must specify a ledger to work with!</h1>\n";
  print "$back_button";
  CleanUp();
}
$error_string = IsValidString($ledger_db);
if (length $error_string > 0)
{
  PrintErrorHeader();
  print "<h1>Error:  Invalid Database Name!</h1>\n";
  print "<b>$error_string</b> is invalid!<br>$back_button";
  CleanUp();
}

# validate we got valid input from the user.
if ($input{'journal_view_command'} eq "open")
{
  $mode = 1;
  $redisplay_string .= "<input type=hidden name=\"journal_view_command\" value=\"open\">\n";
  $redisplayStringGET .= "&journal_view_command=open";
  if (exists $input{'printable'} && $input{'printable'} eq "true")
  {
    $printing = 1;
  }
}
elsif ($input{'journal_view_command'} eq "delete")
{
  $mode = 2;
}
elsif ($input{'journal_view_command'} eq "add")
{
  $mode = 3;
}
elsif ($input{'journal_view_command'} eq "search")
{
  $mode = 4;
  # first make sure all the correct variables are being passed in.
  if (not exists $input{'date_type'})
  {
    PrintErrorHeader();
    print "<h1>Error: Date Qualifier must be given!</h1>\n";
    print "$back_button";
    CleanUp();
  }
  $date_type = $input{'date_type'};
  if (not exists $input{'date_from_search'})
  {
    PrintErrorHeader();
    print "<h1>Error: Date to search from must be given!</h1>\n";
    print "$back_button";
    CleanUp();
  }
  if (not ($date_type eq "equal" || $date_type eq "betweeni" || $date_type eq "betweene" || $date_type eq "afteri" || $date_type eq "aftere" || $date_type eq "beforei" || $date_type eq "beforee"))
  {
    PrintErrorHeader();
    print "<h1>Error:  Invalid Date Qualifier Option!</h1>\n";
    print "$back_button";
    CleanUp();
  }
  $date_from = $input{'date_from_search'};
  if (not exists $input{'date_to_search'})
  {
    PrintErrorHeader();
    print "<h1>Error: Date to search to must be given!</h1>\n";
    print "$back_button";
    CleanUp();
  }
  if (length $date_from > 0 && (not IsValidDateSyntax($date_from)))
  {
    PrintErrorHeader();
    print "<h1>Error:  Invalid Date given!</h1>\n";
    print "The From date is invalid.<br>$back_button";
    CleanUp();
  }
  $date_to = $input{'date_to_search'};
  if (length $date_to > 0 && (not IsValidDateSyntax($date_to)))
  {
    PrintErrorHeader();
    print "<h1>Error:  Invalid Date given!</h1>\n";
    print "The To date is invalid.<br>$back_button";
    CleanUp();
  }
  $redisplay_string .= "<input type=hidden name=\"journal_view_command\" value=\"search\">\n";
  $redisplayStringGET .= "&journal_view_command=search";
  $redisplay_string .= "<input type=hidden name=\"date_type\" value=\"$date_type\">\n<input type=hidden name=\"date_from_search\" value=\"$date_from\">\n<input type=hidden name=\"date_to_search\" value=\"$date_to\">\n";
  $redisplayStringGET .= "&date_type=" . $doc->encodeString(string => $date_type) . "&date_from_search=" . $doc->encodeString(string => $date_from) . "&date_to_search=" . $doc->encodeString(string => $date_to);
  if (not exists $input{'journal2'})
  {
    PrintErrorHeader();
    print "<h1>Error: Journal selection must be given!</h1>\n";
    print "$back_button";
    CleanUp();
  }
  ($journal_name, $journal_code) = split /\|/, $input{'journal2'};
  if (not exists $input{'ref_num2'})
  {
    PrintErrorHeader();
    print "<h1>Error: Reference Number field must be given!</h1>\n";
    print "$back_button";
    CleanUp();
  }
  $ref_num = $input{'ref_num2'};
  $error_string = IsValidUInteger($ref_num);
  if (length $ref_num > 0 && length $error_string > 0)
  {
    PrintErrorHeader();
    print "<h1>Error:  Invalid Ref Number!</h1>\n";
    print "<b>$error_string</b> is invalid!<br>$back_button";
    CleanUp();
  }
  if (not exists $input{'check_num'})
  {
    PrintErrorHeader();
    print "<h1>Error: Check Number field must be given!</h1>\n";
    print "$back_button";
    CleanUp();
  }
  $check_num = $input{'check_num'};
  $error_string = IsValidUInteger($check_num);
  if (length $check_num > 0 && length $error_string > 0)
  {
    PrintErrorHeader();
    print "<h1>Error:  Invalid Check Number!</h1>\n";
    print "<b>$error_string</b> is invalid!<br>$back_button";
    CleanUp();
  }
  if (not exists $input{'deposit_num'})
  {
    PrintErrorHeader();
    print "<h1>Error: Deposit Number field must be given!</h1>\n";
    print "$back_button";
    CleanUp();
  }
  $deposit_num = $input{'deposit_num'};
  $error_string = IsValidUInteger($deposit_num);
  if (length $deposit_num > 0 && length $error_string > 0)
  {
    PrintErrorHeader();
    print "<h1>Error:  Invalid Deposit Number!</h1>\n";
    print "<b>$error_string</b> is invalid!<br>$back_button";
    CleanUp();
  }
  if (not exists $input{'payee_payer2'})
  {
    PrintErrorHeader();
    print "<h1>Error: Payee-Payer selection must be given!</h1>\n";
    print "$back_button";
    CleanUp();
  }
  $payee_payer = $input{'payee_payer2'};
  $error_string = IsValidString($payee_payer);
  if (length $payee_payer > 0 && length $error_string > 0 && (not $error_string eq "_"))
  {
    PrintErrorHeader();
    print "<h1>Error:  Invalid Payee-Payer!</h1>\n";
    print "<b>$error_string</b> is invalid!<br>$back_button";
    CleanUp();
  }
  $redisplay_string .= "<input type=hidden name=\"journal2\" value=\"" . $input{'journal2'} . "\">\n<input type=hidden name=\"ref_num2\" value=\"$ref_num\">\n<input type=hidden name=\"check_num\" value=\"$check_num\">\n<input type=hidden name=\"deposit_num\" value=\"$deposit_num\">\n<input type=hidden name=\"payee_payer2\" value=\"$payee_payer\">\n";
  $redisplayStringGET .= "&journal2=" . $doc->encodeString(string => $input{journal2}) . "&ref_num2=" . $doc->encodeString(string => $ref_num) . "&check_num=" . $doc->encodeString(string => $check_num) . "&deposit_num=" . $doc->encodeString(string => $deposit_num) . "&payee_payer2=" . $doc->encodeString(string => $payee_payer);
  if (not exists $input{'memo2'})
  {
    PrintErrorHeader();
    print "<h1>Error: Memo field must be given!</h1>\n";
    print "$back_button";
    CleanUp();
  }
  $memo = $input{'memo2'};
  $error_string = IsValidString($memo);
  if (length $memo > 0 && length $error_string > 0 && (not ($error_string eq "*" || $error_string eq "?")))
  {
    PrintErrorHeader();
    print "<h1>Error:  Invalid Memo!</h1>\n";
    print "<b>$error_string</b> is invalid!<br>$back_button";
    CleanUp();
  }
  if (not exists $input{'sub_entity'})
  {
    PrintErrorHeader();
    print "<h1>Error: Sub Entity selection must be given!</h1>\n";
    print "$back_button";
    CleanUp();
  }
  $sub_entity = $input{'sub_entity'};
  if (not exists $input{'account'})
  {
    PrintErrorHeader();
    print "<h1>Error: Account selection must be given!</h1>\n";
    print "$back_button";
    CleanUp();
  }
  ($account_name, $account_num) = split /\|/, $input{'account'};
  if (not exists $input{'sub_account'})
  {
    PrintErrorHeader();
    print "<h1>Error: Sub Account selection must be given!</h1>\n";
    print "$back_button";
    CleanUp();
  }
  ($sub_acct_name, $sub_acct_num) = split /\|/, $input{'sub_account'};
  if (not exists $input{'dorc'})
  {
    PrintErrorHeader();
    print "<h1>Error: Debit or Credit Selection must be given!</h1>\n";
    print "$back_button";
    CleanUp();
  }
  $money_type = $input{'dorc'};
  if (not ($money_type eq "select_dorc" || $money_type eq "debit" || $money_type eq "credit" || $money_type eq "both"))
  {
    PrintErrorHeader();
    print "<h1>Error:  Invalid Debit or Credit Selection type!</h1>\n";
    print "$back_button";
    CleanUp();
  }
  $redisplay_string .= "<input type=hidden name=\"memo2\" value=\"$memo\">\n<input type=hidden name=\"account\" value=\"" . $input{'account'} . "\">\n<input type=hidden name=\"sub_account\" value=\"" . $input{'sub_account'} . "\">\n";
  $redisplayStringGET .= "&memo2=" . $doc->encodeString(string => $memo) . "&account=" . $doc->encodeString(string => $input{account}) . "&sub_account=" . $doc->encodeString(string => $input{sub_account});
  $redisplay_string .= "<input type=hidden name=\"dorc\" value=\"$money_type\">\n<input type=hidden name=\"sub_entity\" value=\"$input{sub_entity}\">\n";
  $redisplayStringGET .= "&dorc=" . $doc->encodeString(string => $money_type) . "&sub_entity=" . $doc->encodeString(string => $input{sub_entity});
  if (not exists $input{'dorc_search'})
  {
    PrintErrorHeader();
    print "<h1>Error: Debit or Credit Search Type Selection must be given!</h1>\n";
    print "$back_button";
    CleanUp();
  }
  $money_search = $input{'dorc_search'};
  if (not ($money_search eq "all" || $money_search eq "equal" || $money_search eq "less_than" || $money_search eq "less_than_equal" || $money_search eq "greater_than" || $money_search eq "greater_than_equal" || $money_search eq "betweene" || $money_search eq "betweeni"))
  {
    PrintErrorHeader();
    print "<h1>Error:  Invalid Debit or Credit Search type!</h1>\n";
    print "$back_button";
    CleanUp();
  }
  $money1 = $input{'money1'};
  $error_string = IsValidInteger($money1);
  my $error_string2 = IsValidFloat($money1);
  if (length $money1 > 0)
  {
    if (length $error_string > 0 && (not $error_string eq "."))
    {
      PrintErrorHeader();
      print "<h1>Error:  Invalid First Money Field!</h1>\n";
      print "<b>$error_string</b> is invalid!<br>$back_button";
      CleanUp();
    }
    elsif (length $error_string > 0 && $error_string eq "." && length $error_string2 > 0)
    {
      PrintErrorHeader();
      print "<h1>Error:  Invalid First Money Field!</h1>\n";
      print "<b>$error_string</b> is invalid!<br>$back_button";
      CleanUp();
    }
  }
  $redisplay_string .= "<input type=hidden name=\"dorc_search\" value=\"$money_search\">\n<input type=hidden name=\"money1\" value=\"$money1\">\n<input type=hidden name=\"money2\" value=\"" . $input{'money2'} . "\">\n";
  $redisplayStringGET .= "&dorc_search=" . $doc->encodeString(string => $money_search) . "&money1=" . $doc->encodeString(string => $money1) . "&money2=" . $doc->encodeString(string => $input{money2});
  $money2 = $input{'money2'};
  $error_string = IsValidInteger($money2);
  $error_string2 = IsValidFloat($money2);
  if (length $money2 > 0)
  {
    if (length $error_string > 0 && (not $error_string eq "."))
    {
      PrintErrorHeader();
      print "<h1>Error:  Invalid Second Money Field!</h1>\n";
      print "<b>$error_string</b> is invalid!<br>$back_button";
      CleanUp();
    }
    elsif (length $error_string > 0 && $error_string eq "." && length $error_string2 > 0)
    {
      PrintErrorHeader();
      print "<h1>Error:  Invalid Second Money Field!</h1>\n";
      print "<b>$error_string</b> is invalid!<br>$back_button";
      CleanUp();
    }
  }
  $sort_by = $input{'sort_by2'};
  if (length $sort_by == 0)
  {
    PrintErrorHeader();
    print "<h1>Error:  You must specify a SortBy Option!</h1>\n";
    print "$back_button";
    CleanUp();
  }
  #print "\"$sort_by\"<br>";
  if (not ($sort_by eq "date" || $sort_by eq "ref_num" || $sort_by eq "payee_payer"))
  {
    PrintErrorHeader();
    print "<h1>Error:  Invalid SortBy Option!</h1>\n";
    print "$back_button";
    CleanUp();
  }
  if ($sort_by eq "date")
  {
    $sort_by = "trans_date";
  }
  $sort_operator = $input{'sort_operator'};
  if (length $sort_operator == 0)
  {
    PrintErrorHeader();
    print "<h1>Error:  You must specify a Search Operator!</h1>\n";
    print "$back_button";
    CleanUp();
  }
  if (not ($sort_operator eq "AND" || $sort_operator eq "OR"))
  {
    PrintErrorHeader();
    print "<h1>Error:  Invalid Search Operator!</h1>\n";
    print "$back_button";
    CleanUp();
  }

  if (exists $input{'sort_journal'})
  {
    $sort_journal = 1;
    $redisplay_string .= "<input type=hidden name=\"sort_journal\" value=\"1\">\n";
    $redisplayStringGET .= "&sort_journal=1";
  }
  else
  {
    $sort_journal = 0;
  }
  $redisplay_string .= "<input type=hidden name=\"sort_by2\" value=\"" . $input{'sort_by2'} . "\">\n<input type=hidden name=\"sort_operator\" value=\"$sort_operator\">\n";
  $redisplayStringGET .= "&sort_by2=" . $doc->encodeString(string => $input{sort_by2}) . "&sort_operator=" . $doc->encodeString(string => $sort_operator);

  # make sure they entered something in at least one field, but not something in both the debit and credit fields.
  if ((length $input{'date_from_search'} == 0) && (length $input{'date_to_search'} == 0) && ($input{'journal2'} eq "select_journal") && (length $input{'ref_num2'} == 0) && (length $input{'check_num'} == 0) && (length $input{'deposit_num'} == 0) && ($input{'payee_payer2'} eq "select_payee_payer") && (length $input{'memo2'} == 0) && ($input{'sub_entity'} eq "select_sub_entity") && ($input{'account'} eq "select_account") && ($input{'sub_account'} eq "select_sub_acct") && ($input{'dorc'} eq "select_dorc") && ($input{'dorc_search'} eq "all") && (length $input{'money1'} == 0) && (length $input{'money2'} == 0))
  {
    PrintErrorHeader();
    print "<h1>Error: You must specify something for your search!</h1>\n";
    print "$back_button";
    CleanUp();
  }
  # make sure that the date_to_search field is given only if the date_type is "Between".
  if ((length $input{'date_from_search'} > 0) && (length $input{'date_to_search'} > 0) && ((not $input{'date_type'} eq "betweeni") && (not $input{'date_type'} eq "betweene")))
  {
    PrintErrorHeader();
    print "<h1>Error:  You must specify <b>Between</b> to use the second Date field!</h1>\n";
    print "$back_button";
    CleanUp();
  }
  # make sure that both money fields are not both filled in if they are not doing a between search or no Dorc value selected.
  if ((length $input{'money1'} > 0) && (length $input{'money2'} > 0) && ((not $input{'dorc'} eq "select_dorc") && (not $input{'dorc_search'} eq "betweene") && (not $input{'dorc_search'} eq "betweeni")))
  {
    PrintErrorHeader();
    print "<h1>Error:  You can not specify both money fields when not searching with between!</h1>\n";
    print "$back_button";
    CleanUp();
  }
  if (($input{'dorc_search'} eq "betweene" || $input{'dorc_search'} eq "betweeni") && (length $input{'money1'} == 0 || length $input{'money2'} == 0))
  {
    PrintErrorHeader();
    print "<h1>Error:  You must specify both money fields when searching with between!</h1>\n";
    print "$back_button";
    CleanUp();
  }
  if (((not $input{'dorc'} eq "select_dorc") && (not $input{'dorc_search'} eq "all")) && ((length $input{'money1'} == 0) && (length $input{'money2'} == 0)))
  {
    PrintErrorHeader();
    print "<h1>Error:  You must specify an amount to search for!</h1>\n";
    print "Error: 1007<br>$back_button";
    CleanUp();
  }
  # make sure that if they enter a Ref-Num that they don't select anything else.
  if ((length $input{'ref_num2'} > 0) && ((length $input{'date_from_search'} > 0) || (length $input{'date_to_search'} > 0) || (length $input{'check_num'} > 0) || (length $input{'deposit_num'} > 0) || (not $input{'payee_payer2'} eq "select_payee_payer") || (not $input{'journal2'} eq "select_journal") || (not $input{'account'} eq "select_account") || (not $input{'sub_account'} eq "select_sub_acct") || (not $input{'dorc'} eq "select_dorc") || (not $input{'dorc_search'} eq "all") || (length $input{'money1'} > 0) || (length $input{'money2'} > 0) || (length $input{'memo2'} > 0)))
  {
    PrintErrorHeader();
    print "<h1>Error:  You can not specify anything else when specifying the Reference Number!</h1>\n";
    print "$back_button";
    CleanUp();
  }
  if (exists $input{'printable'} && $input{'printable'} eq "true")
  {
    $printing = 1;
  }
}
elsif ($input{'journal_view_command'} eq "search2")
{
  $mode = 5;
  # first make sure all the correct variables are being passed in.
  if (not exists $input{'ref_num2'})
  {
    PrintErrorHeader();
    print "<h1>Error: Reference Number field must be given!</h1>\n";
    print "$back_button";
    CleanUp();
  }
  $ref_num = $input{'ref_num2'};
  $error_string = IsValidUInteger($ref_num);
  if (length $ref_num > 0 && length $error_string > 0)
  {
    PrintErrorHeader();
    print "<h1>Error:  Invalid Ref Number!</h1>\n";
    print "<b>$error_string</b> is invalid!<br>$back_button";
    CleanUp();
  }
  $redisplay_string .= "<input type=hidden name=\"journal_view_command\" value=\"search2\">\n<input type=hidden name=\"ref_num2\" value=\"$ref_num\">\n";
  $redisplayStringGET .= "&journal_view_comman=search2&ref_num2=" . $doc->encodeString(string => $ref_num);
  if (exists $input{'printable'} && $input{'printable'} eq "true")
  {
    $printing = 1;
  }
}
elsif ($input{'journal_view_command'} eq "print")
{
  $mode = 6;
  $printing = 1;  # signal we are printing.
  $date_from = $input{'start_date'};
  if (length $date_from == 0)
  {
    PrintErrorHeader();
    print "<h1>Error:  You must specify a Start date!</h1>\n";
    print "$back_button";
    CleanUp();
  }
  else
  {
    if (!IsValidDateSyntax($date_from))
    {
      PrintErrorHeader();
      print "<h1>Error:  The Start Date is Invalid!</h1>\n";
      print "$back_button";
      CleanUp();
    }
  }
  $date_to = $input{'end_date'};
  if (length $date_to == 0)
  {
    PrintErrorHeader();
    print "<h1>Error:  You must specify a End date!</h1>\n";
    print "$back_button";
    CleanUp();
  }
  else
  {
    if (!IsValidDateSyntax($date_to))
    {
      PrintErrorHeader();
      print "<h1>Error:  The End Date is Invalid!</h1>\n";
      print "$back_button";
      CleanUp();
    }
  }
  $custom_title = $input{'title'};

  my $journals = $input{'journals'};
  if (length $journals == 0)
  {
    PrintErrorHeader();
    print "<h1>Error:  You must select a journal to work with!</h1>\n";
    print "$back_button";
    CleanUp();
  }
  my @journals = split /\0/, $journals;
  my @journal_codes = ();
  foreach my $temp (@journals)
  {
    my ($temp_name, $temp_code) = split /\|/, $temp;
    push @journal_codes, $temp_code;
  }
  $journal_code = join ',', @journal_codes;  # now contains a comma seperated list of all journals to work with.
  # now make every entry have single quotes around it.
  $journal_code =~ s/([^,]+),/'$1',/g;
  # catch the case where it is at the end.
  $journal_code =~ s/',([^,]+)$/','$1'/;
  # see if it is by itself
  $journal_code =~ s/^([^,]+)$/'$1'/;
  # now go through and replace any ',' with ', '
  $journal_code =~ s/','/', '/g;

  $sort_by = $input{'sort_by'};
  if (length $sort_by == 0)
  {
    PrintErrorHeader();
    print "<h1>Error:  You must specify a SortBy Option!</h1>\n";
    print "$back_button";
    CleanUp();
  }
  if (not ($sort_by eq "date" || $sort_by eq "ref_num" || $sort_by eq "payee_payer"))
  {
    PrintErrorHeader();
    print "<h1>Error:  Invalid SortBy Option!</h1>\n";
    print "$back_button";
    CleanUp();
  }
  if ($sort_by eq "date")
  {
    $sort_by = "trans_date";
  }
  if (exists $input{'sort_journal'})
  {
    $sort_journal = 1;
  }
  else
  {
    $sort_journal = 0;
  }
}

if ($mode == 1 || $mode == 4 || $mode == 5)
{
  $num_entries_to_display = $input{'num_entries_to_display'};
  if (length $num_entries_to_display == 0)
  {
    PrintErrorHeader();
    print "<h1>Error: You must specify the number of Journal entries to display!</h1>\n";
    print "$back_button";
    CleanUp();
  }
  $error_string = IsValidInteger($num_entries_to_display);
  if (length $error_string > 0)
  {
    PrintErrorHeader();
    print "<h1>Error:  Invalid Value for Number of Entries to Display!</h1>\n";
    print "<b>$error_string</b> is invalid!<br>$back_button";
    CleanUp();
  }

  # verify it is a valid value
  if ($num_entries_to_display < 0)
  {
    PrintErrorHeader();
    print "<h1>Error:  Invalid Value for Number of Entries to Display!</h1>\n";
    print "<b>$num_entries_to_display</b> is not valid!<br>$back_button";
    CleanUp();
  }

  $start_index = $input{'start_index'};
  if (length $start_index == 0)
  {
    PrintErrorHeader();
    print "<h1>Error: You must specify the Starting Index to work from!</h1>\n";
    print "$back_button";
    CleanUp();
  }
  $error_string = IsValidInteger($start_index);
  if (length $error_string > 0)
  {
    PrintErrorHeader();
    print "<h1>Error:  Invalid Value for Start Index to display from!</h1>\n";
    print "<b>$error_string</b> is invalid!<br>$back_button";
    CleanUp();
  }
  if ($start_index < 1)
  {
    PrintErrorHeader();
    print "<h1>Error:  The Start Index can not be less than 1!</h1>\n";
    print "$sys_admin";
    CleanUp();
  }
}
elsif ($mode == 6)
{
  $num_entries_to_display = -1;
  $start_index = 1;
}

# check to see if we are running under mod_perl
if (exists $ENV{MOD_PERL})
{
  # check to see if the database is still connected
  if (defined $conn)
  {
    # check the status of the connection
    if ($conn->status != PGRES_CONNECTION_OK)
    {
      $database_connected = 0;
    }
    else
    {
      # connection still good!
      $database_connected = 1;
    }
  }
  else
  {
    $database_connected = 0;
  }
}

if (not $database_connected)
{
  # connect to the database.
  $conn = Pg::connectdb("host = $db_host dbname = $db_name user = $db_user password = $db_passwd");
  if ($conn->status == PGRES_CONNECTION_BAD)
  {
    PrintErrorHeader();
    print "<h1>Error:  Couldn't connect to the database!</h1><br>\n";
    print $conn->errorMessage . "<br>$sys_admin";
    CleanUp();
  }
}

# set the DateStyle for the Database.
$result = setDBDateStyle($conn);
if ($result->resultStatus != PGRES_COMMAND_OK)
{
  PrintErrorHeader();
  print "<h1>Error:  Setting Date Style failed!</h1>\n";
  print $conn->errorMessage . "<br>$sys_admin";
  CleanUp();
}

# now validate that the ledger they specified is valid

$result = $conn->exec("select name from entity_tb where database_name = '$ledger_db'");
if ($result->resultStatus != PGRES_TUPLES_OK)
{
  PrintErrorHeader();
  print "<h1>Error: Accessing database failed!</h1>\n";
  print "Trying to check entity table.<br>$sys_admin";
  CleanUp();
}
if ($result->ntuples == 0)
{
  PrintErrorHeader();
  print "<h1>Error: Ledger <font color=\"blue\">$ledger_db</font> does not exist!</h1>\n";
  print "$sys_admin";
  CleanUp();
}
else
{
  $ledger_name = $result->getvalue(0, 0);
}

# create the reports object
$report_obj = reports->new($conn, $ledger_db);
if ($report_obj->didErrorOccur())
{
  PrintErrorHeader();
  print $report_obj->getErrorMessage();
  CleanUp();
}
$ledger_code = $report_obj->getLedgerCode();
if ($report_obj->didErrorOccur())
{
  PrintErrorHeader();
  print $report_obj->getErrorMessage();
  CleanUp();
}
$ledger_color = $report_obj->getLedgerColor();
if ($report_obj->didErrorOccur())
{
  PrintErrorHeader();
  print $report_obj->getErrorMessage();
  CleanUp();
}
$journal_bgcolor = $ledger_color;

if ($mode == 1 or $mode == 2)
{
  $redisplay_string .= "<input type=hidden name=\"journal\" value=\"" . $input{'journal'} . "\">\n";
  $redisplayStringGET .= "&journal=" . $doc->encodeString(string => $input{journal});
  ($journal_name, $journal_code) = split /\|/, $input{'journal'};
  if (length $journal_code == 0 && length $journal_name > 0 && $journal_name eq "all_journals")
  {
    $journal_code = "all_journals";
    $journal_name = "All Journals";
  }
  if (length $journal_code == 0)
  {
    PrintErrorHeader();
    print "<h1>Error:  You must select a journal to work with!</h1>\n";
    print "$back_button";
    CleanUp();
  }
  if ($mode == 2) # they want to delete so make sure they are not trying to delete "All Journals"
  {
    if ($journal_code eq "all_journals")
    {
      PrintErrorHeader();
      print "<h1>Error:  You can not delete <font color=\"blue\">All Journals</font>!</h1>\n";
      print "If you really want to delete all Journals you will have to select each one indivdually.<br>\n";
      print "$back_button";
      CleanUp();
    }
    if ($journal_code eq "IS")
    {
      PrintErrorHeader();
      print "<h1>Error:  You can not delete the <font color=\"blue\">Investment Journal</font>!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    if ($journal_code eq "G")
    {
      PrintErrorHeader();
      print "<h1>Error:  You can not delete the <font color=\"blue\">General Journal</font>!</h1>\n";
      print "$back_button";
      CleanUp();
    }
  }
  if (not $journal_code eq "all_journals")
  {
    if (length $journal_name == 0)
    {
      PrintErrorHeader();
      print "<h1>Error:  You must select a journal to work with!</h1>\n";
      print "Journal Name not specified.<br>$back_button";
      CleanUp();
    }
  }
  if ($mode == 1)
  {
    $date_from = $input{'date_from'};
    if (length $date_from == 0)
    {
      PrintErrorHeader();
      print "<h1>Error:  You must specify a From date!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    $date_to = $input{'date_to'};
    if (length $date_to == 0)
    {
      PrintErrorHeader();
      print "<h1>Error:  You must specify a To date!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    $sort_by = $input{'sort_by'};
    if (length $sort_by == 0)
    {
      PrintErrorHeader();
      print "<h1>Error:  You must specify a SortBy Option!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    if (not ($sort_by eq "date" || $sort_by eq "ref_num" || $sort_by eq "payee_payer"))
    {
      PrintErrorHeader();
      print "<h1>Error:  Invalid SortBy Option!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    if ($sort_by eq "date")
    {
      $sort_by = "trans_date";
    }
    if (exists $input{'sort_journal'})
    {
      $sort_journal = 1;
      $redisplay_string .= "<input type=hidden name=\"sort_journal\" value=\"1\">\n";
      $redisplayStringGET .= "&sort_journal=1";
    }
    else
    {
      $sort_journal = 0;
    }
    $redisplay_string .= "<input type=hidden name=\"date_from\" value=\"$date_from\">\n<input type=hidden name=\"date_to\" value=\"$date_to\">\n<input type=hidden name=\"sort_by\" value=\"" . $input{'sort_by'} . "\">\n";
    $redisplayStringGET .= "&date_from=" . $doc->encodeString(string => $date_from) . "&date_to=" . $doc->encodeString(string => $date_to) . "&sort_by=" . $doc->encodeString(string => $input{sort_by});
  }
}
elsif ($mode == 3)
{
  $journal_name = $input{'name'};
  if (length $journal_name == 0)
  {
    PrintErrorHeader();
    print "<h1>Error:  You must specify a journal name to create!</h1>\n";
    print "$back_button";
    CleanUp();
  }
  $error_string = IsValidString($journal_name);
  if (length $error_string > 0)
  {
    PrintErrorHeader();
    print "<h1>Error:  Invalid Journal Name!</h1>\n";
    print "<b>$error_string</b> is invalid!<br>$back_button";
    CleanUp();
  }
  if ($journal_name eq "All Journals")
  {
    PrintErrorHeader();
    print "<h1>Error:  You cannot create an <font color=\"blue\">All Journals</font> Journal!</h1>\n";
    print "$back_button";
    CleanUp();
  }
  $journal_code = $input{'code'};
  if (length $journal_code == 0)
  {
    PrintErrorHeader();
    print "<h1>Error:  You must specify a journal code to create!</h1>\n";
    print "$back_button";
    CleanUp();
  }
  $error_string = IsValidString($journal_code);
  if (length $error_string > 0)
  {
    PrintErrorHeader();
    print "<h1>Error:  Invalid Journal_Code!</h1>\n";
    print "<b>$error_string</b> is invalid!<br>$back_button";
    CleanUp();
  }
}
elsif ($mode == 4) # search
{
  # generate the search string to search for.
  $search_string = "SELECT DISTINCT(ref_num), journal_code, trans_date, payee_payer, memo, remember from journal_entry_tb WHERE ledger_code = '$ledger_code' AND ";
  my $and_needed = 0;

  # are they searching by a ref_num (simplest case)
  if (length $ref_num > 0)
  {
    $search_string .= "ref_num = $ref_num";
  }
  else
  {
    # are they searching by date
    if (length $date_from > 0)
    {
      # see what type of search we are doing, =, <, >, between
      if ($date_type eq "betweeni")
      {
        $search_string .= "(trans_date BETWEEN '$date_from' AND '$date_to')";
        $and_needed = 1;
      }
      elsif ($date_type eq "betweene")
      {
        $search_string .= "(trans_date > '$date_from' AND trans_date < '$date_to')";
        $and_needed = 1;
      }
      elsif ($date_type eq "equal")
      {
        $search_string .= "trans_date = '$date_from'";
        $and_needed = 1;
      }
      elsif ($date_type eq "beforei")
      {
        $search_string .= "trans_date <= '$date_from'";
        $and_needed = 1;
      }
      elsif ($date_type eq "beforee")
      {
        $search_string .= "trans_date < '$date_from'";
        $and_needed = 1;
      }
      elsif ($date_type eq "afteri")
      {
        $search_string .= "trans_date >= '$date_from'";
        $and_needed = 1;
      }
      elsif ($date_type eq "aftere")
      {
        $search_string .= "trans_date > '$date_from'";
        $and_needed = 1;
      }
    }

    # are they searching by journal
    if (not $journal_name eq "select_journal")
    {
      if ($and_needed)
      {
        $search_string .= " $sort_operator ";
      }
      $search_string .= "journal_code = '$journal_code'";
      $and_needed = 1;
    }

    # are they searching by payee-payer
    if (not $payee_payer eq "select_payee_payer")
    {
      if ($and_needed)
      {
        $search_string .= " $sort_operator ";
      }
      $search_string .= "payee_payer = '$payee_payer'";
      $and_needed = 1;
    }

    # are they searching by check-number
    if (length $check_num > 0)
    {
      if ($and_needed)
      {
        $search_string .= " $sort_operator ";
      }
      $search_string .= "ref_num IN (SELECT parent_num FROM debitcredit_tb WHERE dorc = false AND sub_account_num = $check_num AND ledger_code = '$ledger_code' AND account_num IN (SELECT number FROM account_tb WHERE type = 0))";
      $and_needed = 1;
    }

    # are they searching by deposit-number
    if (length $deposit_num > 0)
    {
      if ($and_needed)
      {
        $search_string .= " $sort_operator ";
      }
      $search_string .= "ref_num IN (SELECT parent_num FROM debitcredit_tb WHERE dorc = true AND sub_account_num = $deposit_num AND ledger_code = '$ledger_code' AND account_num IN (SELECT number FROM account_tb WHERE type = 0))";
      $and_needed = 1;
    }

    # are they searching by memo
    if (length $memo > 0)
    {
      if ($and_needed)
      {
        $search_string .= " $sort_operator ";
      }
      # see if they are using any SQL wild cards (% and _)
      if ($memo =~ /(%|_|\*|\?)/)
      {
        $memo =~ s/\*/%/g;  # globally replace all *'s with %'s.
        $memo =~ s/\?/_/g;   # globally replace all ?'s with _'s.
        $search_string .= "memo LIKE '$memo'";
        $and_needed = 1;
      }
      else # they are not
      {
        $search_string .= "memo = '$memo'";
        $and_needed = 1;
      }
    }

    # are they searching by sub entity
    if (not $sub_entity eq "select_sub_entity")
    {
      if ($and_needed)
      {
        $search_string .= " $sort_operator ";
      }
      $search_string .= "ref_num IN (SELECT parent_num FROM debitcredit_tb WHERE sub_e_code = '$sub_entity' AND ledger_code = '$ledger_code')";
      $and_needed = 1;
    }

    # are they searching by account
    if (not $account_name eq "select_account")
    {
      if ($and_needed)
      {
        $search_string .= " $sort_operator ";
      }
      $search_string .= "ref_num IN (SELECT parent_num FROM debitcredit_tb WHERE account_num = $account_num AND ledger_code = '$ledger_code')";
      $and_needed = 1;
    }

    # are they searching by sub-account
    if (not $sub_acct_name eq "select_sub_acct")
    {
      if ($and_needed)
      {
        $search_string .= " $sort_operator ";
      }
      $search_string .= "ref_num IN (SELECT parent_num FROM debitcredit_tb WHERE sub_account_num = $sub_acct_num and account_num IN (SELECT number FROM account_tb WHERE type <> 0) AND ledger_code = '$ledger_code')";
      $and_needed = 1;
    }

    # Determine if they have selected a Debit, Credit or Both value to search for.
    if (not $money_type eq "select_dorc")
    {
      my $search_type;
      # see what type of comparison we are doing.
      if ($money_search eq "equal")
      {
        $search_type = "=";
      }
      elsif ($money_search eq "less_than")
      {
        $search_type = "<";
      }
      elsif ($money_search eq "less_than_equal")
      {
        $search_type = "<=";
      }
      elsif ($money_search eq "greater_than")
      {
        $search_type = ">";
      }
      elsif ($money_search eq "greater_than_equal")
      {
        $search_type = ">=";
      }
      elsif ($money_search eq "betweene")
      {
        $search_type = "!";
      }
      elsif ($money_search eq "betweeni")
      {
        $search_type = "!";
      }

      if ($and_needed)
      {
        $search_string .= " $sort_operator ";
      }

      # now see if we are searching against just Debit, Credit or Both types.
      if ($money_type eq "debit")
      {
        if ($money_search eq "all")
        {
          $search_string .= "ref_num IN (SELECT parent_num FROM debitcredit_tb WHERE dorc = true AND ledger_code = '$ledger_code')";
        }
        else
        {
          $search_string .= "ref_num IN (SELECT parent_num FROM debitcredit_tb WHERE dorc = true AND ledger_code = '$ledger_code' and";
          if ($search_type eq "!" && ($money_search eq "betweene" || $money_search eq "betweeni"))
          {  # handle this case specially
            if ($money_search eq "betweeni")
            {
              $search_string .= " (amount BETWEEN '$money1' and '$money2')";
            }
            else
            {
              $search_string .= " amount > '$money1' AND amount < '$money2'";
            }
          }
          else
          {
            $search_string .= " amount $search_type '$money1'";
          }
          $search_string .= ")";
        }
      }
      elsif ($money_type eq "credit")
      {
        if ($money_search eq "all")
        {
          $search_string .= "ref_num IN (SELECT parent_num FROM debitcredit_tb WHERE dorc = false AND ledger_code = '$ledger_code')";
        }
        else
        {
          $search_string .= "ref_num IN (SELECT parent_num FROM debitcredit_tb WHERE dorc = false AND ledger_code = '$ledger_code' and";
          if ($search_type eq "!" && ($money_search eq "betweene" || $money_search eq "betweeni"))
          {  # handle this case specially
            if ($money_search eq "betweeni")
            {
              $search_string .= " (amount BETWEEN '$money1' and '$money2')";
            }
            else
            {
              $search_string .= " amount > '$money1' AND amount < '$money2'";
            }
          }
          else
          {
            $search_string .= " amount $search_type '$money1'";
          }
          $search_string .= ")";
        }
      }
      elsif ($money_type eq "both")
      {
        if ($money_search eq "all")
        {
          $search_string .= "ref_num IN (SELECT parent_num FROM debitcredit_tb WHERE ledger_code = '$ledger_code')";
        }
        else
        {
          $search_string .= "ref_num IN (SELECT parent_num FROM debitcredit_tb WHERE ledger_code = '$ledger_code' AND";
          if ($search_type eq "!" && ($money_search eq "betweene" || $money_search eq "betweeni"))
          {  # handle this case specially
            if ($money_search eq "betweeni")
            {
              $search_string .= " (amount BETWEEN '$money1' and '$money2')";
            }
            else
            {
              $search_string .= " amount > '$money1' AND amount < '$money2'";
            }
          }
          else
          {
            $search_string .= " amount $search_type '$money1'";
          }
          $search_string .= ")";
        }
      }
    }
  }

  # now we need to apply any Ordering specified.
  my $tmp_sortby = $sort_by;

  if ($sort_by ne "ref_num")
  {
    $tmp_sortby .= ", ref_num";
  }

  if ($sort_journal)
  {
    $search_string .= " ORDER BY journal_code, $tmp_sortby";
  }
  else
  {
    $search_string .= " ORDER BY $tmp_sortby, journal_code";
  }
}
elsif ($mode == 5)
{
  # generate the search string to search for.
  $search_string = "SELECT DISTINCT(ref_num), journal_code, trans_date, payee_payer, memo, remember from journal_entry_tb WHERE ref_num = $ref_num AND ledger_code = '$ledger_code'";
}

# now make sure that the journal exists if we are going to open or delete it or make sure that the
# journal doesn't exist if they are wanting to create one.
if ($mode == 1 or $mode == 2)
{
  if ($journal_code eq "all_journals")
  {
    $result = $conn->exec("select name from journal_tb");
  }
  else
  {
    $result = $conn->exec("select name from journal_tb where code = '$journal_code'");
  }
  if ($result->resultStatus != PGRES_TUPLES_OK)
  {
    PrintErrorHeader();
    print "<h1>Error:  Accessing database <font color=\"blue\">$ledger_db</font> failed!</h1>\n";
    if ($journal_code eq "all_journals")
    {
      print $conn->errorMessage . "<br>Tried to check for any Journals.<br>$sys_admin";
    }
    else
    {
      print $conn->errorMessage . "<br>Tried to validate Journal with code <font color=\"blue\">$journal_code</font>.<br>$sys_admin";
    }
    CleanUp();
  }
  if ($result->ntuples == 0)
  {
    PrintErrorHeader();
    if ($journal_code eq "all_journals")
    {
      print "<h1>Error:  There are no Journals defined in the Ledger!</h1>\n";
      print "Tried to check for Journals in Ledger <font color=\"blue\">$ledger_name</font><br>$sys_admin";
    }
    else
    {
      print "<h1>Error:  Journal with code <font color=\"blue\">$journal_code</font> does not exist!</h1>\n";
      print "It may have been deleted!<br>$sys_admin";
    }
    CleanUp();
  }
}
elsif ($mode == 3)
{
  $result = $conn->exec("select code from journal_tb where name = '$journal_name'");
  if ($result->resultStatus != PGRES_TUPLES_OK)
  {
    PrintErrorHeader();
    print "<h1>Error:  Accessing database <font color=\"blue\">$ledger_db</font> failed!</h1>\n";
    print $conn->errorMessage . "<br>Tried to validate Journal <font color=\"blue\">$journal_name</font>.<br>$sys_admin";
    CleanUp();
  }
  if ($result->ntuples != 0)
  {
    PrintErrorHeader();
    print "<h1>Error:  Journal <font color=\"blue\">$journal_name</font> already exists!</h1>\n";
    print "$back_button";
    CleanUp();
  }
}


print "<head><title>$prog_name $prog_version Journals - Ledger '$ledger_db'</title>\n";

my $onLoad;
$onLoad="";
if ($mode == 2 || $mode == 3)
{
  print <<"END_OF_CODE";
  <script language="Javascript1.2" src="../js/common.js"></script>
  <script language="Javascript1.2">
  <!--
  var ErrorOccurred = false;
  function doTimeout()
  {
    if (!ErrorOccurred)
    {
      setTimeout("javascript: document.journal_delete_create_form.submit();", 3000); // 3 seconds
    }
  }
  //-->
  </script>
END_OF_CODE
  $onLoad = " onLoad=doTimeout()";
}
elsif ($mode != 6)
{
  # create the JavaScript code that will resubmit the data so that the Journal View can either be
  # refreshed (start_index = same value) or go forwards or backwards in the View.
  print <<"END_OF_CODE";
  <script language="Javascript1.2" src="../js/common.js"></script>
  <script language="Javascript1.2">
  <!--
  function SubmitJournalView(StartIndex)
  {
    document.journal_view.start_index.value = StartIndex;
    document.journal_view.action = "$site_dir/cgi-bin/journal_mod1.cgi";
    document.journal_view.submit();

    return false;
  }

  function SubmitJournalViewPrintable(StartIndex)
  {
    document.journal_view.start_index.value = StartIndex;
    document.journal_view.printable.value = "true";
    document.journal_view.action = "$site_dir/cgi-bin/journal_mod1.cgi";
    document.journal_view.submit();

    return false;
  }

  function DoYouReallyWantToDelete(RefNum)
  {
    var msg = "Do you Really want to delete the Transaction with Reference Number = '" + RefNum + "'?\\\n\\\nClick 'OK' to Delete";
    if (confirm(msg))
    {
      document.journal_view.journal_command.value = "delete";
      document.journal_view.journal_entry.value = RefNum;
      document.journal_view.submit();
    }

    return false;
  }
  //-->
  </script>
END_OF_CODE
}#/

if ($printing)
{
  $onLoad = " onLoad=\"window.print();\"";
}

print "</head>\n";
print "<body bgcolor=$body_bgcolor$onLoad>\n";
print <<"END_OF_STYLE";
<style type="text/css"><!--
  a:hover   { color: red }
  a:link    { text-decoration: none; color: blue }
  a:visited { text-decoration: none; color: blue }
  a:active  { text-decoration: none; color: blue }
 
  td { font-size: xx-small; }
  table { font-size: xx-small;
-->
</style>
<script language="Javascript1.2" src="../js/common.js"></script>
END_OF_STYLE
#/ get the date
$date = `/bin/date +%m-%d-%Y`;
chomp $date;

print "<center>\n";
print "<table border=0 width=100% cellspacing=0 cellpadding=2 bgcolor=\"$body_bgcolor\">\n";
print "<tr>\n";
print "<td align=left width=47%><font color=\"red\">";
if ($mode == 1)
{
  if ($journal_code eq "all_journals")
  {
    my $string = "";
    $string .= "<a href=\"$site_dir/cgi-bin/journal_mod1.cgi\" onClick=\"javascript:SubmitJournalView($start_index); return false;\">" if ($printing);
    $string .= "Working with <font color=\"blue\">$journal_name</font> in Ledger <font color=\"$journal_bgcolor\">$ledger_name</font>";
    $string .= "</a>" if ($printing);
    print $string;
  }
  else
  {
    my $string = "";
    $string .= "<a href=\"$site_dir/cgi-bin/journal_mod1.cgi\" onClick=\"javascript:SubmitJournalView($start_index); return false;\">" if ($printing);
    $string .= "Working with Journal <font color=\"blue\">$journal_name</font> in Ledger <font color=\"$journal_bgcolor\">$ledger_name</font>";
    $string .= "</a>" if ($printing);
    print $string;
  }
}
elsif ($mode == 2)
{
  print "Deleting Journal <font color=\"blue\">$journal_name</font> in Ledger <font color=\"$journal_bgcolor\">$ledger_name</font>";
}
elsif ($mode == 3)
{
  print "Creating Journal <font color=\"blue\">$journal_name</font> in Ledger <font color=\"$journal_bgcolor\">$ledger_name</font>";
}
elsif ($mode == 4 || $mode == 5)
{
  my $string = "";
  $string .= "<a href=\"$site_dir/cgi-bin/journal_mod1.cgi\" onClick=\"javascript:SubmitJournalView($start_index); return false;\">" if ($printing);
  $string .= "Searching... in Ledger <font color=\"$journal_bgcolor\">$ledger_name</font>";
  $string .= "</a>" if ($printing);
  print $string;
}
elsif ($mode == 6)
{
  print "Displaying Journals in Ledger <font color=\"$journal_bgcolor\">$ledger_name</font> for Printing.";
}
print "</font></td>\n";
if (!$printing)
{
  print "<td align=left><a href=\"$site_dir/help.html#journal\" target=\"docs\"><img border=0 src=\"$site_dir/images/help.jpg\" alt=\"Help\"></a></td>\n";
}
else
{
  print "<td align=left><h3>$custom_title</h3></td>\n";
}
print "<td align=right>$date</td></tr></table>\n";
if (!$printing)
{
  print "<hr>\n";
  print PrintStandardLedgerMainMenu($ledger_db);
}
else
{
  print "<br>\n";
}
if ($mode == 1)
{
  my $tmp_sortby = $sort_by;

  if ($sort_by ne "ref_num")
  {
    $tmp_sortby .= ", ref_num";
  }

  # Figure out how many entries we will be displaying and display that figure at the top of the screen.
  if ($journal_code eq "all_journals")
  {
    if ($sort_journal)
    {
      $search_string = "select ref_num, journal_code, trans_date, payee_payer, memo, remember from journal_entry_tb where (trans_date between '$date_from' and '$date_to') AND ledger_code = '$ledger_code' order by journal_code, $tmp_sortby"; # removed ' AND journal_code <> 'IS''
    }
    else
    {
      $search_string = "select ref_num, journal_code, trans_date, payee_payer, memo, remember from journal_entry_tb where (trans_date between '$date_from' and '$date_to') AND ledger_code = '$ledger_code' order by $tmp_sortby, journal_code"; # removed ' AND journal_code <> 'IS''
    }
  }
  else
  {
    $search_string = "select ref_num, journal_code, trans_date, payee_payer, memo, remember from journal_entry_tb where journal_code = '$journal_code' and (trans_date between '$date_from' and '$date_to') AND ledger_code = '$ledger_code' order by $tmp_sortby";
  }
  DisplayJournal($search_string, $redisplay_string, $redisplayStringGET);
}
elsif ($mode == 2) # display the delete this journal page
{
  # check and make sure that the Journal is not being used.
  $result = $conn->exec("select ref_num from journal_entry_tb where journal_code = '$journal_code' AND ledger_code = '$ledger_code'");
  if ($result->resultStatus != PGRES_TUPLES_OK)
  {
    print "<script language=\"Javascript1.2\">\nErrorOccurred = true;\n</script>\n";
    print "<h1>Error:  Accessing database failed!</h1>\n";
    print $conn->errorMessage . "<br>Tried to see if Journal <font color=\"blue\">$journal_name</font> is in use.<br>$sys_admin";
    CleanUp();
  }
  if ($result->ntuples != 0)
  {
    print "<form name=\"journal_delete_create_form\" method=post action=\"$site_dir/cgi-bin/journals.cgi\">\n";
    print "<input type=hidden name=\"ledger\" value=\"$ledger_db\">\n";
    print "<input type=hidden name=\"open\" value=\"\">\n";
    print "<h1>Error:  Journal <font color=\"blue\">$journal_name</font> is in use!</h1>\n";
    print "<br>You can not delete a Journal while it is being used in entries.<br>$back_button";
    print "</form>\n";
    CleanUp();
  }

  # make sure they are not trying to delete the last journal.
  $result = $conn->exec("SELECT COUNT(code) FROM journal_tb");
  if ($result->resultStatus != PGRES_TUPLES_OK)
  {
    print "<script language=\"Javascript1.2\">\nErrorOccurred = true;\n</script>\n";
    print "<h1>Error:  Accessing database failed!</h1>\n";
    print $conn->errorMessage . "<br>Tried to get count of Journals in this ledger.<br>$sys_admin";
    CleanUp();
  }
  if ($result->getvalue(0, 0) == 1)
  {
    print "<script language=\"Javascript1.2\">\nErrorOccurred = true;\n</script>\n";
    print "<h1>Error:  You can not Delete the Last Journal!</h1>\n$back_button";
    CleanUp();
  }

  # start a transaction
  $result = $conn->exec("begin work");
  if ($result->resultStatus != PGRES_COMMAND_OK)
  {
    print "<script language=\"Javascript1.2\">\nErrorOccurred = true;\n</script>\n";
    print "<h1>Error:  Accessing database <font color=\"blue\">$ledger_db</font> failed!</h1>\n";
    print $conn->errorMessage . "<br>Tried to start transaction.<br>$sys_admin";
    CleanUp();
  }

  # delete the Journal entry.
  $result = $conn->exec("delete from journal_tb where name = '$journal_name' and code = '$journal_code'");
  if ($result->resultStatus != PGRES_COMMAND_OK)
  {
    print "<script language=\"Javascript1.2\">\nErrorOccurred = true;\n</script>\n";
    print "<h1>Error:  Accessing database <font color=\"blue\">$ledger_db</font> failed!</h1>\n";
    print $conn->errorMessage . "<br>Tried to delete journal <font color=\"blue\">$journal_name</font>.<br>$sys_admin";
    CleanUp();
  }

  # commit work
  $result = $conn->exec("commit work");
  if ($result->resultStatus != PGRES_COMMAND_OK)
  {
    print "<script language=\"Javascript1.2\">\nErrorOccurred = true;\n</script>\n";
    print "<h1>Error:  Accessing database <font color=\"blue\">$ledger_db</font> failed!</h1>\n";
    print $conn->errorMessage . "<br>Tried to commit Transaction.<br>$sys_admin";
    CleanUp();
  }

  # end transaction
  $result = $conn->exec("end work");
  if ($result->resultStatus != PGRES_COMMAND_OK)
  {
    print "<script language=\"Javascript1.2\">\nErrorOccurred = true;\n</script>\n";
    print "<h1>Error:  Accessing database <font color=\"blue\">$ledger_db</font> failed!</h1>\n";
    print $conn->errorMessage . "<br>Tried to end transaction.<br>$sys_admin";
    CleanUp();
  }

  print "<h1>Journal <font color=\"blue\">$journal_name</font> Successfully Deleted!</h1>\n";
  print "<br><br>\n";

  print "<form name=\"journal_delete_create_form\" method=post action=\"$site_dir/cgi-bin/journals.cgi\">\n";
  print "<input type=hidden name=\"ledger\" value=\"$ledger_db\">\n";
  print "<input type=hidden name=\"open\" value=\"\">\n";
  print "You will be returned to the Journal Screen in <b>3</b> seconds.<br>\n";
  print "</form>\n";
}
elsif ($mode == 3) # create the new journal
{
  # first verify that the journal name and journal code are not being used by anyone else
  $result = $conn->exec("select code from journal_tb where name = '$journal_name'");
  if ($result->resultStatus != PGRES_TUPLES_OK)
  {
    print "<script language=\"Javascript1.2\">\nErrorOccurred = true;\n</script>\n";
    print "<h1>Error:  Accessing database <font color=\"blue\">$ledger_db</font> failed!</h1>\n";
    print $conn->errorMessage . "<br>Tried to check for duplicate Journal Names.<br>$sys_admin";
    CleanUp();
  }
  if ($result->ntuples != 0)
  {
    print "<script language=\"Javascript1.2\">\nErrorOccurred = true;\n</script>\n";
    print "<h1>Error:  Journal Name <font color=\"blue\">$journal_name</font> is already being used!</h1>\n";
    print "$back_button";
    CleanUp();
  }

  $result = $conn->exec("select name from journal_tb where code = '$journal_code'");
  if ($result->resultStatus != PGRES_TUPLES_OK)
  {
    print "<script language=\"Javascript1.2\">\nErrorOccurred = true;\n</script>\n";
    print "<h1>Error:  Accessing database <font color=\"blue\">$ledger_db</font> failed!</h1>\n";
    print $conn->errorMessage . "<br>Tried to check for duplicate Journal Codes.<br>$sys_admin";
    CleanUp();
  }
  if ($result->ntuples != 0)
  {
    print "<script language=\"Javascript1.2\">\nErrorOccurred = true;\n</script>\n";
    print "<h1>Error:  Journal Code <font color=\"blue\">$journal_code</font> is already being used!</h1>\n";
    print "$back_button";
    CleanUp();
  }

  # start a transaction
  $result = $conn->exec("begin work");
  if ($result->resultStatus != PGRES_COMMAND_OK)
  {
    print "<script language=\"Javascript1.2\">\nErrorOccurred = true;\n</script>\n";
    print "<h1>Error:  Accessing database <font color=\"blue\">$ledger_db</font> failed!</h1>\n";
    print $conn->errorMessage . "<br>Tried to start a transaction.<br>$sys_admin";
    CleanUp();
  }

  # create the journal entry
  $result = $conn->exec("insert into journal_tb (name, code) values ('$journal_name', '$journal_code')");
  if ($result->resultStatus != PGRES_COMMAND_OK)
  {
    print "<script language=\"Javascript1.2\">\nErrorOccurred = true;\n</script>\n";
    print "<h1>Error:  Creating Journal data in database <font color=\"blue\">$ledger_db</font> failed!</h1>\n";
    print $conn->errorMessage . "<br>Tried to create Journal record (name=<font color=\"blue\">$journal_name</font>, code=<font color=\"blue\">$journal_code</font>).<br>$sys_admin";
    CleanUp();
  }

  # commit the transaction
  $result = $conn->exec("commit work");
  if ($result->resultStatus != PGRES_COMMAND_OK)
  {
    print "<script language=\"Javascript1.2\">\nErrorOccurred = true;\n</script>\n";
    print "<h1>Error:  Committing transaction to database <font color=\"blue\">$ledger_db</font> failed!</h1>\n";
    print $conn->errorMessage . "<br>Tried to commit work after inserting Journal data.<br>$sys_admin";
    CleanUp();
  }

  # end the transaction
  $result = $conn->exec("end work");
  if ($result->resultStatus != PGRES_COMMAND_OK)
  {
    print "<script language=\"Javascript1.2\">\nErrorOccurred = true;\n</script>\n";
    print "<h1>Error:  Ending transaction with database <font color=\"blue\">$ledger_db</font> failed!</h1>\n";
    print $conn->errorMessage . "<br>Tried to end transaction after committing work.<br>$sys_admin";
    CleanUp();
  }

  print "<h1>Journal <font color=\"blue\">$journal_name</font> Successfully Created!</h1>\n";
  print "<br><br>\n";

  print "<form name=\"journal_delete_create_form\" method=post action=\"$site_dir/cgi-bin/journals.cgi\">\n";
  print "<input type=hidden name=\"ledger\" value=\"$ledger_db\">\n";
  print "<input type=hidden name=\"open\" value=\"\">\n";
  print "You will be returned to the Journal Screen in <b>3</b> seconds.<br>\n";
  print "</form>\n";
}
elsif ($mode == 4 || $mode == 5) # search
{
  DisplayJournal($search_string, $redisplay_string, $redisplayStringGET);
}
elsif ($mode == 6)
{
  if ($sort_journal)
  {
    $search_string = "select ref_num, journal_code, trans_date, payee_payer, memo, remember from journal_entry_tb where journal_code in ($journal_code) AND (trans_date between '$date_from' and '$date_to') AND ledger_code = '$ledger_code' order by journal_code, $sort_by";
  }
  else
  {
    $search_string = "select ref_num, journal_code, trans_date, payee_payer, memo, remember from journal_entry_tb where journal_code in ($journal_code) AND (trans_date between '$date_from' and '$date_to') AND ledger_code = '$ledger_code' order by $sort_by, journal_code";
  }
  DisplayJournal($search_string, $redisplay_string, $redisplayStringGET);
}

# print a horizontal rule to break the menu from the behind the scenes links
#print "<hr>\n";
print "</center>\n";

print "</body>\n";
print "</html>\n";
exit 0;


sub IsDateAfterClose
{
  my $fiscal_start = $_[0];
  my $temp_date = $_[1];

  # convert the dates to the ISO standard YYYYMMDD for comparison purposes.
  my ($start_month, $start_day, $start_year) = split /-/, $fiscal_start;
  $fiscal_start = $start_year . $start_month . $start_day;
  my ($temp_month, $temp_day, $temp_year);
  ($temp_month, $temp_day, $temp_year) = split /-/, $temp_date;
  $temp_date = $temp_year . $temp_month . $temp_day;

  if ($fiscal_start > $temp_date)
  {
    return 0;
  }
  return 1; #yes
}

sub IsDateInFiscalYear
{
  my $fiscal_start = $_[0];
  my $fiscal_end = $_[1];
  my $temp_date = $_[2];
  # split the dates into their month, day, year parts.
  my ($start_month, $start_day, $start_year) = split /-/, $fiscal_start;
  my ($end_month, $end_day, $end_year) = split /-/, $fiscal_end;
  #print "Fiscal Start (Month=$start_month, Day=$start_day, Year=$start_year)<br>\n";
  #print "Fiscal End (Month=$end_month, Day=$end_day, Year=$end_year)<br>\n";
  my ($temp_month, $temp_day, $temp_year);
  ($temp_month, $temp_day, $temp_year) = split /-/, $temp_date;
  #print "Tuple #$i: (Month=$temp_month, Day=$temp_day, Year=$temp_year)<br>\n";

  # first see if the year falls within the start and end values of the fiscal year
  if ($start_year == $end_year) # simple case, I know that the start month and end month are in the same year.
  {
    if ($temp_year == $start_year)
    {
      # next see if the month falls within the start and end values of the fiscal year
      if (($temp_month >= $start_month) && ($temp_month <= $end_month))
      {
        # next see if the day falls within the start and end values of the fiscal year
        if (($temp_day >= $start_day) && $temp_month == $start_month)
        {
          #$data_fixed = 0;
          return 1;
        }
        elsif (($temp_day <= $end_day) && $temp_month == $end_month)
        {
          #$data_fixed = 0;
          return 1;
        }
        elsif (($temp_month != $start_month) && ($temp_month != $end_month))
        {
          #$data_fixed = 0;
          return 1;
        }
      }
    }
  }
  else
  {
    if ($temp_year == $start_year)
    {
      if ($temp_month >= $start_month)
      {
        if (($temp_day >= $start_day) && ($temp_month == $start_month))
        {
          #$data_fixed = 0;
          return 1;
        }
        elsif ($temp_month != $start_month)
        {
          #$data_fixed = 0;
          return 1;
        }
      }
    }
    elsif ($temp_year == $end_year)
    {
      if ($temp_month <= $end_month)
      {
        if (($temp_day <= $end_day) && ($temp_month == $end_month))
        {
          #$data_fixed = 0;
          return 1;
        }
        elsif ($temp_month != $end_month)
        {
          #$data_fixed = 0;
          return 1;
        }
      }
    }
  }
  return 0;  # signal it is not within this fiscal year.
}

sub DisplayJournal
{
  my $search_string = shift;
  my $custom_hidden_fields_string = shift;
  my $customGETString = shift;
  my $entries_working_with = 0;
  my $editEntryURL = "";

  # first we get the current fiscal year's date info.
  my ($result2, $fiscal_start, $fiscal_end, $working_year, $data_fixed, $start_month, $start_day, $start_year, $end_month, $end_day, $end_year, $result);
  $result2 = $conn->exec("select year, start_date, end_date from known_years_tb where year in (select working_year from variables_tb WHERE ledger_code = '$ledger_code') AND ledger_code = '$ledger_code'");
  if ($result2->resultStatus != PGRES_TUPLES_OK)
  {
    print "<h1>Error:  Accessing database failed!</h1>\n";
    print $conn->errorMessage . "<br>Tried to get working year and fiscal year dates from ledger <font color=\"blue\">$ledger_db</font>.<br>$sys_admin";
    CleanUp();
  }
  if ($result2->ntuples == 0)
  {
    print "<h1>Error:  Program not configured!</h1>\n";
    print "Working Year is not set!<br>$sys_admin";
    CleanUp();
  }
  $working_year = $result2->getvalue(0, 0);
  $fiscal_start = $result2->getvalue(0, 1);
  $fiscal_end = $result2->getvalue(0, 2);

  # run the query and find out if there are any entries that will fall in the current fiscal year and only if there are do we display the Edit, Delete and New buttons, etc.
  # get count of total rows we have to work with
  (my $search_string2 = $search_string) =~ s/^(select) (.+) (from journal_entry_tb .+)(order by)( .+)$/$1 COUNT(*) $3/i;
  if ($search_string2 ne $search_string)
  {
    $result = $conn->exec($search_string2);
    if ($result->resultStatus != PGRES_TUPLES_OK)
    {
      print "<h1>Error:  Accessing database failed!</h1>\n";
      print $conn->errorMessage . "<br>Tried to execute Custom Search (<i>$search_string2</i>) in ledger <font color=\"blue\">$ledger_db</font>.<br>$sys_admin";
      CleanUp();
    }
    $entries_working_with = $result->getvalue(0, 0);

    # now gather the actual data to display for this page.
    if ($num_entries_to_display > 0)
    {
      $search_string .= " LIMIT $num_entries_to_display OFFSET " . ($start_index-1);
    }
    $result = $conn->exec($search_string);
    if ($result->resultStatus != PGRES_TUPLES_OK)
    {
      print "<h1>Error:  Accessing database failed!</h1>\n";
      print $conn->errorMessage . "<br>Tried to execute Custom Search (<i>$search_string</i>) in ledger <font color=\"blue\">$ledger_db</font>.<br>$sys_admin";
      CleanUp();
    }
  }
  else
  {
    $result = $conn->exec($search_string);
    if ($result->resultStatus != PGRES_TUPLES_OK)
    {
      print "<h1>Error:  Accessing database failed!</h1>\n";
      print $conn->errorMessage . "<br>Tried to execute Custom Search (<i>$search_string</i>) in ledger <font color=\"blue\">$ledger_db</font>.<br>$sys_admin";
      CleanUp();
    }
    $entries_working_with = $result->ntuples;
  }

  if (!$printing)
  {
    print "<table border=0 cellpadding=0 cellspacing=0 width=100%>\n";

    print "<tr><td align=left width=40%>Displaying ";
    if ($num_entries_to_display == 0)
    {
      print "<b>all</b> entries.";
    }
    else
    {
      print "<b>$num_entries_to_display</b> entries at a time.";
    }
    print "&nbsp;&nbsp;<a href=\"$site_dir/cgi-bin/journal_mod1.cgi\" onClick=\"javascript:SubmitJournalViewPrintable(" . ($start_index) . "); return false;\"><b>Print</b></a> screen.</td><td align=center width=20% valign=bottom>";
    print "<form method=post action=\"$site_dir/cgi-bin/journal_activity.cgi\" name=\"journal_trans_create\">\n";
    print "<input type=hidden name=\"ledger\" value=\"$ledger_db\">\n";
    print "<input type=hidden name=\"journal_code\" value=\"G\">\n";
    print "<input type=hidden name=\"journal_bgcolor\" value=\"\">\n";
    print "<input type=hidden name=\"start_index\" value=\"$start_index\">\n";
    print "<input type=hidden name=\"journal_command\" value=\"\">\n";  # used to tell the journal create, delete, edit scripts what to do.
    print "<input type=hidden name=\"num_entries_to_display\" value=\"$num_entries_to_display\">\n";
    print "$custom_hidden_fields_string";
    print "<input type=button name=\"create\" value=\"New Transaction\" onClick=\"document.journal_trans_create.journal_command.value='create';document.journal_trans_create.submit();\">";
    print "</form></td>\n<td align=right width=40%>";
    if ($entries_working_with > 0)
    {
      if ($num_entries_to_display > 0)
      {
        if ($start_index > $entries_working_with)
        {
          print "</td></tr></table>\n";
          print "<h1>Error:  The Index into the Journal is out of bounds!</h1>\n";
          print "<form name=\"journal_form\" method=post action=\"$site_dir/cgi-bin/journal_mod1.cgi\">\n";
          print "<input type=hidden name=\"ledger\" value=\"$ledger_db\">\n";
          print "<input type=hidden name=\"journal_code\" value=\"G\">\n";
          print "<input type=hidden name=\"journal_bgcolor\" value=\"\">\n";
          print "<input type=hidden name=\"start_index\" value=\"" . ($entries_working_with - $start_index < 1 ? 1 : $entries_working_with - $start_index) . "\">\n";
          print "<input type=hidden name=\"num_entries_to_display\" value=\"$num_entries_to_display\">\n";
          print "$custom_hidden_fields_string";
          print "<a href=\"$site_dir/cgi-bin/journal_mod1.cgi\" onClick=\"document.journal_form.submit(); return false;\">Click here to go to the last page of the Journal View</a>\n";
          print "</form>\n";
          CleanUp();
        }
        if ($start_index >= $num_entries_to_display)
        {
          print "<a href=\"$site_dir/cgi-bin/journal_mod1.cgi\" onClick=\"javascript:SubmitJournalView(" . ($start_index - $num_entries_to_display) . "); return false;\">Previous <b>$num_entries_to_display</b> Entries</a>&nbsp;&nbsp;|&nbsp;&nbsp;";
        }
        if ($start_index + $num_entries_to_display <= $entries_working_with)
        {
          print "<a href=\"$site_dir/cgi-bin/journal_mod1.cgi\" onClick=\"javascript:SubmitJournalView(" . ($start_index) . "); return false;\">Entries <b>$start_index</b> to <b>" . ($start_index + $num_entries_to_display - 1) . "</b></a>&nbsp;&nbsp;|&nbsp;&nbsp;";
          print "<a href=\"$site_dir/cgi-bin/journal_mod1.cgi\" onClick=\"javascript:SubmitJournalView(" . ($start_index + $num_entries_to_display) . "); return false;\">Next ";
          if ($start_index + (2 * $num_entries_to_display) <= $entries_working_with)
          {
            print "<b>$num_entries_to_display</b>";
          }
          else
          {
            print "<b>" . ($entries_working_with - ($start_index + $num_entries_to_display - 1)) . "</b>";
          }
          print " Entries</a>&nbsp;&nbsp;";
        }
        else
        {
          print "<a href=\"$site_dir/cgi-bin/journal_mod1.cgi\" onClick=\"javascript:SubmitJournalView($start_index); return false;\">Entries <b>$start_index</b> to <b>" . $entries_working_with . "</b></a>&nbsp;&nbsp;";
        }
        print "|&nbsp;&nbsp;Out of <b>" . $entries_working_with . "</b> Entries returned.";
      }
      else
      {
        print "<a href=\"$site_dir/cgi-bin/journal_mod1.cgi\" onClick=\"javascript:SubmitJournalView($start_index); return false;\"><b>" . $entries_working_with . "</b></a> Entries returned.";
      }
    }
    else
    {
      print "<b>0</b> Entries returned.";
    }
    print "</td></tr></table>\n";
    print "<br>\n";


    $data_fixed = 0;	# signal that initially the data is editable, etc.
    my ($i, $temp_date);
    for ($i=0; $i < $result->ntuples; $i++)
    {
      $temp_date = $result->getvalue($i, 2);
      my $journal_code = $result->getvalue($i, 1);
      # call the check date routine to see if this date is within the current fiscal year.
      if (IsDateInFiscalYear($fiscal_start, $fiscal_end, $temp_date) || IsDateAfterClose($fiscal_end, $temp_date) && $journal_code ne "IS")
#      if (IsDateAfterClose($fiscal_start, $temp_date))
      {
        $data_fixed = 0;
      }
    }

    # create the form
    print "<form method=post action=\"$site_dir/cgi-bin/journal_activity.cgi\" name=\"journal_view\">\n";
    print "<input type=hidden name=\"ledger\" value=\"$ledger_db\">\n";
    print "<input type=hidden name=\"journal_code\" value=\"G\">\n";
    print "<input type=hidden name=\"journal_bgcolor\" value=\"\">\n";
    print "<input type=hidden name=\"start_index\" value=\"$start_index\">\n";
    print "<input type=hidden name=\"printable\" value=\"false\">\n";
    print "<input type=hidden name=\"journal_command\" value=\"\">\n";  # used to tell the journal create, delete, edit scripts what to do.
    print "<input type=hidden name=\"num_entries_to_display\" value=\"$num_entries_to_display\">\n";
    print "<input type=\"hidden\" name=\"edit_entries\" value=\"\">\n";
    print "$custom_hidden_fields_string";

    $editEntryURL = "$site_dir/cgi-bin/journal_activity.cgi?ledger=" . $doc->encodeString(string => $ledger_db);
    $editEntryURL .= "&journal_code=G&journal_bgcolor=&start_index=$start_index&printable=false";
    $editEntryURL .= "&num_entries_to_display=$num_entries_to_display$customGETString";
  }
  else
  {
    # create the form
    print "<form method=post action=\"$site_dir/cgi-bin/journal_activity.cgi\" name=\"journal_view\">\n";
    print "<input type=hidden name=\"ledger\" value=\"$ledger_db\">\n";
    print "<input type=hidden name=\"journal_code\" value=\"G\">\n";
    print "<input type=hidden name=\"journal_bgcolor\" value=\"\">\n";
    print "<input type=hidden name=\"start_index\" value=\"$start_index\">\n";
    print "<input type=hidden name=\"printable\" value=\"false\">\n";
    print "<input type=hidden name=\"journal_command\" value=\"\">\n";  # used to tell the journal create, delete, edit scripts what to do.
    print "<input type=hidden name=\"num_entries_to_display\" value=\"$num_entries_to_display\">\n";
    print "$custom_hidden_fields_string";

    $data_fixed = 1;  # the data is not editable at all.
    $journal_bgcolor = "white";  # don't hilight the first line.
    $start_index = 1;
    $num_entries_to_display = $result->ntuples;
    $bank_color = "black";
    $bank_credit_color = "black";
    $bank_deposit_color = "black";
  }
  #--------------------------------#################### Start of Display Code ###################3------------------------------------
  # start the table to display the results in.
  print "<table border=1 width=100% cellspacing=1 cellpadding=2 bgcolor=\"$body_bgcolor\">\n";
  if ($data_fixed)
  {
    print "<tr><th align=left width=8%>J / R</th><th align=left width=10%>Date</th><th align=left width=20%>Payee-Payer</th><th align=left width=2%>SE</th><th align=left width=24%>Account</th><th align=left width=16%>Sub Account</th><th align=center width=10%>Debit</th><th align=center width=10%>Credit</th></tr>\n";
  }
  else
  {
    print "<tr><th align=left width=8%>J / R</th><th align=left width=10%>Date</th><th align=left width=19%>Payee-Payer</th><th align=left width=2%>SE</th><th align=left width=24%>Account</th><th align=left width=16%>Sub Account</th><th align=center width=10%>Debit</th><th align=center width=10%>Credit</th><th align=center width=1%>Del</th></tr>\n";
  }
  if ($result->ntuples == 0)
  {
    if ($data_fixed)
    {
      print "<tr bgcolor=\"$journal_bgcolor\"><td align=left colspan=8>No entries exist.</td></tr>\n";
    }
    else
    {
      print "<tr bgcolor=\"$journal_bgcolor\"><td align=left colspan=8>No entries exist.</td><td><br></td></tr>\n";
      print "<input type=hidden name=\"num_entries\" value=\"0\">\n";
    }
  }
  else # everything else gets done inside this loop.
  {
    # loop through these entries and get their transactions from the debitcredit_tb.
    my ($result3, $result4, $ref_num, $my_journal_code, $trans_date, $payee_payer, $memo, $i, $temp, $temp_num, $remembered, $result5, $result6);
    if (!$data_fixed)
    {
      # let the next script know how many entries we are working with.
      print "<input type=hidden name=\"journal_entry\" value=\"\">\n";
    }
    #for ($i=$start_index-1; $i < ($start_index + $num_entries_to_display - 1) && $i < $result->ntuples; $i++)
    for ($i=0; $i < $result->ntuples; $i++)
    {
      $ref_num = $result->getvalue($i, 0);
      $my_journal_code = $result->getvalue($i, 1);
      $trans_date = $result->getvalue($i, 2);
      $payee_payer = $result->getvalue($i, 3);
      $remembered = $result->getvalue($i, 5);
      if (length $payee_payer == 0)
      {
        $payee_payer = "<br>";
      }
      $memo = $result->getvalue($i, 4);
      if (length $memo == 0)
      {
        $memo = "<br>";
      }

      # now we need to get all the debit and credit transactions for this journal entry.
      $result3 = $conn->exec("select sub_e_code, account_num, sub_account_num, amount from debitcredit_tb where parent_num = $ref_num and dorc = true AND ledger_code = '$ledger_code'");
      if ($result3->resultStatus != PGRES_TUPLES_OK) #debit
      {
        print "<tr><td colspan=8>\n";
        print "<h1>Error:  Accessing Database <font color=\"blue\">$ledger_db</font> failed!</h1>\n";
        print $conn->errorMessage . "<br>Tried to get debit entries for Journal Entry <font color=\"blue\">$ref_num</font>.<br>$sys_admin";
        print "</td></tr></table></form>\n";
        CleanUp();
      }

      $result4 = $conn->exec("select sub_e_code, account_num, sub_account_num, amount from debitcredit_tb where parent_num = $ref_num and dorc = false AND ledger_code = '$ledger_code'");
      if ($result4->resultStatus != PGRES_TUPLES_OK) #credit
      {
        print "<tr><td colspan=8>\n";
        print "<h1>Error:  Accessing Database <font color=\"blue\">$ledger_db</font> failed!</h1>\n";
        print $conn->errorMessage . "<br>Tried to get credit entries for Journal Entry <font color=\"blue\">$ref_num</font>.<br>$sys_admin";
        print "</td></tr></table></form>\n";
        CleanUp();
      }
      my $num_rows = $result3->ntuples + $result4->ntuples;
      my $tmp;

      # do a quick check and make sure that the Debits = Credits
      $result5 = $conn->exec("select sum(amount) from debitcredit_tb where parent_num = $ref_num and dorc = true AND ledger_code = '$ledger_code'");
      if ($result5->resultStatus != PGRES_TUPLES_OK) # debit
      {
        print "<tr><td colspan=8>\n";
        print "<h1>Error:  Accessing Database <font color=\"blue\">$ledger_db</font> failed!</h1>\n";
        print $conn->errorMessage . "<br>Tried to get debit Debit Total for Journal Entry <font color=\"blue\">$ref_num</font>.<br>$sys_admin";
        print "</td></tr></table></form>\n";
        CleanUp();
      }

      $result6 = $conn->exec("select sum(amount) from debitcredit_tb where parent_num = $ref_num and dorc = false AND ledger_code = '$ledger_code'");
      if ($result6->resultStatus != PGRES_TUPLES_OK) # credit
      {
        print "<tr><td colspan=8>\n";
        print "<h1>Error:  Accessing Database <font color=\"blue\">$ledger_db</font> failed!</h1>\n";
        print $conn->errorMessage . "<br>Tried to get Credit Total for Journal Entry <font color=\"blue\">$ref_num</font>.<br>$sys_admin";
        print "</td></tr></table></form>\n";
        CleanUp();
      }

      my ($debit_total, $credit_total);
      $debit_total = $result5->getvalue(0, 0);
      $credit_total = $result6->getvalue(0, 0);

      # now we make sure that we have at least 1 credit and 1 debit!
      if (($result3->ntuples < 1 || $result4->ntuples < 1) || ($debit_total != $credit_total))
      { # error!
        if (!$data_fixed)
        {
          my $tmp2 = 3;  # number of rows to span for edit and delete columns
          if ($num_rows > 2 && $result4->ntuples == 0)
          {
            $tmp2 += $num_rows - 2;
          }
          elsif ($result3->ntuples == 0 && $result4->ntuples > 1)
          {
            $tmp2 += $num_rows - 1;
          }
          elsif ($result3->ntuples > 0 && $result4->ntuples > 0)
          {
            $tmp2 += $num_rows - 2;
          }
          print "<tr bgcolor=\"red\"><td align=left colspan=8>\n";
          my $tmp = "journal_delete_" . ($i+$start_index-1);
          my $tmp_str;
          if ($debit_total != $credit_total)
          {
            $tmp_str = "&nbsp;&nbsp;&nbsp;&nbsp;Debits and Credits do not Equal!";
          }
          else
          {
            $tmp_str = "&nbsp;&nbsp;&nbsp;&nbsp;Not enough Debits or Credits in this transaction!";
          }
          if ($my_journal_code ne "IS")
          {
            print "<font color=\"white\">Invalid Entry!$tmp_str</font></td><td rowspan=$tmp2 align=center valign=top bgcolor=\"$body_bgcolor\"><input type=checkbox name=\"$tmp\" value=\"ON\" checked onClick=\"DoYouReallyWantToDelete($ref_num);\"></td></tr>\n";
          }
          else
          {
            print "<font color=\"white\">Invalid Entry!$tmp_str</font></td><td rowspan=$tmp2 align=center valign=top bgcolor=\"$body_bgcolor\"><br></td></tr>\n";
          }
        }
        else
        {
          print "<tr bgcolor=\"red\"><td align=left colspan=8><font color=\"white\">Invalid Entry!</font></td></tr>\n";
        }
        print "<tr bgcolor=\"$journal_bgcolor\">\n";
        # now we print what data we have and leave the rest blank

        print "<td align=left>";
        if ($remembered eq "t")
        {
          print "R> ";
        }
        print "$my_journal_code";
        print "</td>\n";
        print "<td align=left>$trans_date</td>\n";
        print "<td align=left>$payee_payer</td>\n";
        # since we display debits first, see if there are any debit entries to display and if so display the first record, else display nothing
        if ($result3->ntuples > 0)
        {
          my $sub_e_code = $result3->getvalue(0, 0);
          if (length $sub_e_code == 0)
          {
            $sub_e_code = "<br>";
          }
          my $account_num = $result3->getvalue(0, 1);
          my $sub_account_num = $result3->getvalue(0, 2);
          my $amount = $result3->getvalue(0, 3);
          $amount =~ s/^\$//;  # remove the leading $

          # now I have to lookup the Account Name and Sub Account Name and display them.
          my $result5 = $conn->exec("select name, type from account_tb where number = $account_num");
          if ($result5->resultStatus != PGRES_TUPLES_OK)
          {
            print "</tr><tr><td colspan=8>\n";
            print "<h1>Error:  Accessing Database failed!</h1>\n";
            print $conn->errorMessage . "<br>Tried to lookup Account name for <font color=\"blue\">$account_num</font>.<br>$sys_admin";
            print "</td></tr></table></form>\n";
            CleanUp();
          }
          if ($result5->ntuples == 0)
          {
            print "</tr><tr><td colspan=8>\n";
            print "<h1>Error:  No Account Info returned!</h1>\n";
            print "Tried to lookup Account name for <font color=\"blue\">$account_num</font>.<br>$sys_admin";
            print "</td></tr></table></form>\n";
            CleanUp();
          }
          my $account_name = $result5->getvalue(0, 0);
          my $account_type = $result5->getvalue(0, 1);

          print "<td align=center>$sub_e_code</td>\n";
          if ($name_first)
          {
            print "<td align=left>$account_name - ";
            if ($account_type == 0)
            {
              print "<font color=\"$bank_color\">$account_num</font>";
            }
            else
            {
              print "$account_num";
            }
          }
          else # print number first
          {
            print "<td align=left>";
            if ($account_type == 0)
            {
              print "<font color=\"$bank_color\">$account_num</font>";
            }
            else
            {
              print "$account_num";
            }
            print " - $account_name";
          }

   #added by JT 9/15/00
          #lookup acct_num in local_accts_tb to get tax status and place an * by taxable accts
          #only if rev or exp
          statusflag($account_num, $conn);
          print "</td>\n";

          # get the sub_account name if appropriate
          my $sub_account_name = "";
          if ($sub_account_num >= 0 && $account_type != 0)  # only display sub account name if account is not a bank account
          {
            $result5 = $conn->exec("select sub_acc_name from sub_acc_tb where sub_acc_number = $sub_account_num");
            if ($result5->resultStatus != PGRES_TUPLES_OK)
            {
              print "</tr><tr><td colspan=8>\n";
              print "<h1>Error:  Accessing Database failed!</h1>\n";
              print $conn->errorMessage . "<br>Tried to lookup Sub Account name for <font color=\"blue\">$sub_account_num</font>.<br>$sys_admin";
              print "</td></tr></table></form>\n";
              CleanUp();
            }
            if ($result5->ntuples == 0)
            {
              print "</tr><tr><td colspan=8>\n";
              print "<h1>Error:  No Sub Account Info returned!</h1>\n";
              print "Tried to lookup Sub Account name for <font color=\"blue\">$sub_account_num</font>.<br>$sys_admin";
              print "</td></tr></table></form>\n";
              CleanUp();
            }
            $sub_account_name = $result5->getvalue(0, 0);
          }
          if ($sub_account_num >= 0)
          {
            if ($name_first)
            {
              print "<td align=left>$sub_account_name";
              if ($account_type == 0)
              {
                print "<font color=\"$bank_deposit_color\">$sub_account_num</font>";
              }
              else
              {
                print " - " . $sub_account_num;
              }
              print "</td>\n";
            }
            else  # print number first
            {
              print "<td align=left>";
              if ($account_type == 0)
              {
                print "<font color=\"$bank_deposit_color\">$sub_account_num</font>";
              }
              else
              {
                print $sub_account_num . " - ";
              }
              print "$sub_account_name";
              print "</td>\n";
            }
          }
          else
          {
            print "<td><br></td>\n";
          }

          print "<td align=right>" . commify($amount) . "</td>\n";
          print "<td><br></td>\n"; # Credit is nothing
          $num_rows--; # decrement the number of items we are working with.
        }
        else
        {
          print "<td><br></td>\n";  # Sub Entity code
          print "<td><br></td>\n";  # Account Code
          print "<td><br></td>\n";  # Account Name
          print "<td><br></td>\n";  # Debit
          print "<td><br></td>\n";  # Credit
        }
        # determine how many rows of debits and credits we need to span.
        if ($num_rows > 0)
        {
          print "</tr><tr><td rowspan=$num_rows align=left valign=top>";
          if ($edit_invalid && $my_journal_code ne "IS" && !$printing)
          {
            $tmp = "journal_edit_" . ($i+$start_index-1);
            my $tmpURL = $editEntryURL;
            $tmpURL .= "&edit_entries=$tmp&journal_command=edit&journal_entry=$ref_num";
            #print "<a href=\"#\" onClick=\"document.journal_view.edit_entries.value='$tmp';document.journal_view.journal_command.value='edit';document.journal_view.journal_entry.value='$ref_num';document.journal_view.submit();return false;\">";
            print "<a href=\"$tmpURL\">";
          }
          print "$ref_num";
          if ($edit_invalid && $my_journal_code ne "IS" && !$printing)
          {
            print "</a>";
          }
          print "</td><td rowspan=$num_rows valign=top align=right><b>Memo</b></td><td align=left rowspan=$num_rows valign=top>$memo</td>";
          # now we print any debits or credits remaining
          if ($result3->ntuples > 1)
          { # display the rest of the debits
            my $i;
            for ($i=1; $i < $result3->ntuples; $i++)
            {
              print "<tr>\n" if ($i > 2); # only start a new row if past memo line
              my $sub_e_code = $result3->getvalue($i, 0);
              if (length $sub_e_code == 0)
              {
                $sub_e_code = "<br>";
              }
              my $account_num = $result3->getvalue($i, 1);
              my $sub_account_num = $result3->getvalue($i, 2);
              my $amount = $result3->getvalue($i, 3);
              $amount =~ s/^\$//;  # remove the leading $

              # now I have to lookup the Account Name and Sub Account Name and display them.
              my $result5 = $conn->exec("select name, type from account_tb where number = $account_num");
              if ($result5->resultStatus != PGRES_TUPLES_OK)
              {
                print "</tr><tr><td colspan=8>\n";
                print "<h1>Error:  Accessing Database failed!</h1>\n";
                print $conn->errorMessage . "<br>Tried to lookup Account name for <font color=\"blue\">$account_num</font>.<br>$sys_admin";
                print "</td></tr></table></form>\n";
                CleanUp();
              }
              if ($result5->ntuples == 0)
              {
                print "</tr><tr><td colspan=8>\n";
                print "<h1>Error:  No Account Info returned!</h1>\n";
                print "Tried to lookup Account name for <font color=\"blue\">$account_num</font>.<br>$sys_admin";
                print "</td></tr></table></form>\n";
                CleanUp();
              }
              my $account_name = $result5->getvalue(0, 0);
              my $account_type = $result5->getvalue(0, 1);

              print "<td align=center>$sub_e_code</td>\n";
              if ($name_first)
              {
                print "<td align=left>$account_name - ";
                if ($account_type == 0)
                {
                  print "<font color=\"$bank_color\">$account_num</font>";
                }
                else
                {
                  print "$account_num";
                }
              }
              else # print number first
              {
                print "<td align=left>";
                if ($account_type == 0)
                {
                  print "<font color=\"$bank_color\">$account_num</font>";
                }
                else
                {
                  print "$account_num";
                }
                print " - $account_name";
              }

   #added by JT 9/15/00
          #lookup acct_num in local_accts_tb to get tax status and place an * by taxable accts
          #only if rev or exp
              statusflag($account_num, $conn);
              print "</td>\n";

              # get the sub_account name if appropriate
              my $sub_account_name = "";
              if ($sub_account_num >= 0 && $account_type != 0)  # only display sub account name if account is not a bank account
              {
                $result5 = $conn->exec("select sub_acc_name from sub_acc_tb where sub_acc_number = $sub_account_num");
                if ($result5->resultStatus != PGRES_TUPLES_OK)
                {
                  print "</tr><tr><td colspan=8>\n";
                  print "<h1>Error:  Accessing Database failed!</h1>\n";
                  print $conn->errorMessage . "<br>Tried to lookup Sub Account name for <font color=\"blue\">$sub_account_num</font>.<br>$sys_admin";
                  print "</td></tr></table></form>\n";
                  CleanUp();
                }
                if ($result5->ntuples == 0)
                {
                  print "</tr><tr><td colspan=8>\n";
                  print "<h1>Error:  No Sub Account Info returned!</h1>\n";
                  print "Tried to lookup Sub Account name for <font color=\"blue\">$sub_account_num</font>.<br>$sys_admin";
                  print "</td></tr></table></form>\n";
                  CleanUp();
                }
                $sub_account_name = $result5->getvalue(0, 0);
              }
              if ($sub_account_num >= 0)
              {
                if ($name_first)
                {
                  print "<td align=left>$sub_account_name";
                  if ($account_type == 0)
                  {
                    print "<font color=\"$bank_deposit_color\">$sub_account_num</font>";
                  }
                  else
                  {
                    print " - " . $sub_account_num;
                  }
                  print "</td>\n";
                }
                else  # print number first
                {
                  print "<td align=left>";
                  if ($account_type == 0)
                  {
                    print "<font color=\"$bank_deposit_color\">$sub_account_num</font>";
                  }
                  else
                  {
                    print $sub_account_num . " - ";
                  }
                  print "$sub_account_name";
                  print "</td>\n";
                }
              }
              else
              {
                print "<td><br></td>\n";
              }

              print "<td align=right>". commify($amount) . "</td>\n";
              print "<td><br></td>\n"; # Credit is nothing
              print "</tr>\n";
            }
          }
          if ($result4->ntuples > 0)
          { # display the credits
            my $i;
            for ($i=0; $i < $result4->ntuples; $i++)
            {
              print "<tr>\n" if ($i > 0); # only start a new row if more rows to display
              my $sub_e_code = $result4->getvalue($i, 0);
              if (length $sub_e_code == 0)
              {
                $sub_e_code = "<br>";
              }
              my $account_num = $result4->getvalue($i, 1);
              my $sub_account_num = $result4->getvalue($i, 2);
              my $amount = $result4->getvalue($i, 3);
              $amount =~ s/^\$//;  # remove the leading $

              # now I have to lookup the Account Name and Sub Account Name and display them.
              my $result5 = $conn->exec("select name, type from account_tb where number = $account_num");
              if ($result5->resultStatus != PGRES_TUPLES_OK)
              {
                print "</tr><tr><td colspan=8>\n";
                print "<h1>Error:  Accessing Database failed!</h1>\n";
                print $conn->errorMessage . "<br>Tried to lookup Account name for <font color=\"blue\">$account_num</font>.<br>$sys_admin";
                print "</td></tr></table></form>\n";
                CleanUp();
              }
              if ($result5->ntuples == 0)
              {
                print "</tr><tr><td colspan=8>\n";
                print "<h1>Error:  No Account Info returned!</h1>\n";
                print "Tried to lookup Account name for <font color=\"blue\">$account_num</font>.<br>$sys_admin";
                print "</td></tr></table></form>\n";
                CleanUp();
              }
              my $account_name = $result5->getvalue(0, 0);
              my $account_type = $result5->getvalue(0, 1);

              print "<td align=center>$sub_e_code</td>\n";
              if ($name_first)
              {
                print "<td align=left>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;$account_name - ";
                if ($account_type == 0)
                {
                  print "<font color=\"$bank_color\">$account_num</font>";
                }
                else
                {
                  print "$account_num";
                }
              }
              else # print number first
              {
                print "<td align=left>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
                if ($account_type == 0)
                {
                  print "<font color=\"$bank_color\">$account_num</font>";
                }
                else
                {
                  print "$account_num";
                }
                print " - $account_name";
              }

   #added by JT 9/15/00
          #lookup acct_num in local_accts_tb to get tax status and place an * by taxable accts
          #only if rev or exp
              statusflag($account_num, $conn);
              print "</td>\n";

              # get the sub_account name if appropriate
              my $sub_account_name = "";
              if ($sub_account_num >= 0 && $account_type != 0)  # only display sub account name if account is not a bank account
              {
                $result5 = $conn->exec("select sub_acc_name from sub_acc_tb where sub_acc_number = $sub_account_num");
                if ($result5->resultStatus != PGRES_TUPLES_OK)
                {
                  print "</tr><tr><td colspan=8>\n";
                  print "<h1>Error:  Accessing Database failed!</h1>\n";
                  print $conn->errorMessage . "<br>Tried to lookup Sub Account name for <font color=\"blue\">$sub_account_num</font>.<br>$sys_admin";
                  print "</td></tr></table></form>\n";
                  CleanUp();
                }
                if ($result5->ntuples == 0)
                {
                  print "</tr><tr><td colspan=8>\n";
                  print "<h1>Error:  No Sub Account Info returned!</h1>\n";
                  print "Tried to lookup Sub Account name for <font color=\"blue\">$sub_account_num</font>.<br>$sys_admin";
                  print "</td></tr></table></form>\n";
                  CleanUp();
                }
                $sub_account_name = $result5->getvalue(0, 0);
              }
              if ($sub_account_num >= 0)
              {
                if ($name_first)
                {
                  print "<td align=left>$sub_account_name"; # removed these '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;'
                  if ($account_type == 0)
                  {
                    print "<font color=\"$bank_credit_color\">$sub_account_num</font>";
                  }
                  else
                  {
                    print " - " . $sub_account_num;
                  }
                  print "</td>\n";
                }
                else  # print number first
                {
                  print "<td align=left>";  # removed these '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;'
                  if ($account_type == 0)
                  {
                    print "<font color=\"$bank_credit_color\">$sub_account_num</font>";
                  }
                  else
                  {
                    print $sub_account_num . " - ";
                  }
                  print "$sub_account_name";
                  print "</td>\n";
                }
              }
              else
              {
                print "<td><br></td>\n";
              }

              print "<td><br></td>\n";   # Debit is nothing
              print "<td align=right>" . commify($amount) . "</td>\n";
              print "</tr>\n";
            }
          }
        }
        else
        {
          print "</tr><tr><td align=right valign=top>";
          print "$ref_num\n";
          print "</td><td align=right><b>Memo</b></td><td align=left>$memo</td>";
          print "<td><br></td>"; # Sub Entity code
          print "<td><br></td>"; # Account Code
          print "<td><br></td>"; # Account Name
          print "<td><br></td>"; # Debit
          print "<td><br></td>"; # Credit
          print "</tr>\n";
        }
      }
      else # *******************************************************************************************************************************************
      { # at this point we should have a valid entry to display.
        my $tmp = "journal_edit_" . ($i+$start_index-1);
        print "<tr bgcolor=\"$journal_bgcolor\">";
        print "<td align=left>";
        if ($remembered eq "t")
        {
          print "R> ";
        }
        print "$my_journal_code";
        print "</td>\n";
        print "<td align=left>$trans_date</td>\n";
        print "<td align=left>$payee_payer</td>\n";
        # since we display debits first, display the first record

        my $sub_e_code = $result3->getvalue(0, 0);
        if (length $sub_e_code == 0)
        {
          $sub_e_code = "<br>";
        }
        my $account_num = $result3->getvalue(0, 1);
        my $sub_account_num = $result3->getvalue(0, 2);
        my $amount = $result3->getvalue(0, 3);
        $amount =~ s/^\$//;  # remove the leading $

        # now I have to lookup the Account Name and Sub Account Name and display them.
        my $result5 = $conn->exec("select name, type from account_tb where number = $account_num");
        if ($result5->resultStatus != PGRES_TUPLES_OK)
        {
          print "</tr><tr><td colspan=8>\n";
          print "<h1>Error:  Accessing Database failed!</h1>\n";
          print $conn->errorMessage . "<br>Tried to lookup Account name for <font color=\"blue\">$account_num</font>.<br>$sys_admin";
          print "</td></tr></table></form>\n";
          CleanUp();
        }
        if ($result5->ntuples == 0)
        {
          print "</tr><tr><td colspan=8>\n";
          print "<h1>Error:  No Account Info returned!</h1>\n";
          print "Tried to lookup Account name for <font color=\"blue\">$account_num</font>.<br>$sys_admin";
          print "</td></tr></table></form>\n";
          CleanUp();
        }
        my $account_name = $result5->getvalue(0, 0);
        my $account_type = $result5->getvalue(0, 1);

        print "<td align=center>$sub_e_code</td>\n";
        if ($name_first)
        {
          print "<td align=left>$account_name - ";
          if ($account_type == 0)
          {
            print "<font color=\"$bank_color\">$account_num</font>";
          }
          else
          {
            print "$account_num";
          }
        }
        else # print number first
        {
          print "<td align=left>";
          if ($account_type == 0)
          {
            print "<font color=\"$bank_color\">$account_num</font>";
          }
          else
          {
            print "$account_num";
          }
          print " - $account_name";
        }

   #added by JT 9/15/00
          #lookup acct_num in local_accts_tb to get tax status and place an * by taxable accts
          #only if rev or exp
        statusflag($account_num, $conn);
        print "</td>\n";

        # get the sub_account name if appropriate
        my $sub_account_name = "";
        if ($sub_account_num >= 0 && $account_type != 0)  # only display sub account name if account is not a bank account
        {
          $result5 = $conn->exec("select sub_acc_name from sub_acc_tb where sub_acc_number = $sub_account_num");
          if ($result5->resultStatus != PGRES_TUPLES_OK)
          {
            print "</tr><tr><td colspan=8>\n";
            print "<h1>Error:  Accessing Database failed!</h1>\n";
            print $conn->errorMessage . "<br>Tried to lookup Sub Account name for <font color=\"blue\">$sub_account_num</font>.<br>$sys_admin";
            print "</td></tr></table></form>\n";
            CleanUp();
          }
          if ($result5->ntuples == 0)
          {
            print "</tr><tr><td colspan=8>\n";
            print "<h1>Error:  No Sub Account Info returned!</h1>\n";
            print "Tried to lookup Sub Account name for <font color=\"blue\">$sub_account_num</font>.<br>$sys_admin";
            print "</td></tr></table></form>\n";
            CleanUp();
          }
          $sub_account_name = $result5->getvalue(0, 0);
        }
        if ($sub_account_num >= 0)
        {
          if ($name_first)
          {
            print "<td align=left>$sub_account_name";
            if ($account_type == 0)
            {
              print "<font color=\"$bank_deposit_color\">$sub_account_num</font>";
            }
            else
            {
              print " - " . $sub_account_num;
            }
            print "</td>\n";
          }
          else  # print number first
          {
            print "<td align=left>";
            if ($account_type == 0)
            {
              print "<font color=\"$bank_deposit_color\">$sub_account_num</font>";
            }
            else
            {
              print $sub_account_num . " - ";
            }
            print "$sub_account_name";
            print "</td>\n";
          }
        }
        else
        {
          print "<td><br></td>\n";
        }

        print "<td align=right>" . commify($amount) . "</td>\n";
        print "<td><br></td>\n"; # Credit is nothing

        if (!$data_fixed && $my_journal_code ne "IS")
        {
          # determine how many rows of debits and credits we need to span.
          $tmp = "journal_delete_" . ($i+$start_index-1);
          print "<td valign=top rowspan=$num_rows bgcolor=\"$body_bgcolor\" align=center><input type=checkbox name=\"$tmp\" value=\"ON\" onClick=\"DoYouReallyWantToDelete($ref_num);\"></td></tr>\n";
        }
        elsif (!$data_fixed)
        {
          print "<td valign=top rowspan=$num_rows bgcolor=\"$body_bgcolor\" align=center><br></td></tr>\n";
        }
        # end of first row, now we have some more debits and then credits to display
        my $tmp2 = $num_rows - 1;
        print "<tr><td rowspan=$tmp2 align=left valign=top>";
        if ($my_journal_code ne "IS" && !$printing)
        {
          my $tmpURL = $editEntryURL;
          $tmpURL .= "&edit_entries=$tmp&journal_command=edit&journal_entry=$ref_num";
          #rint "<a href=\"#\" onClick=\"document.journal_view.edit_entries.value='$tmp';document.journal_view.journal_command.value='edit';document.journal_view.journal_entry.value='$ref_num';document.journal_view.submit();return false;\">";
          print "<a href=\"$tmpURL\">";
        }
        print "$ref_num";
        if ($my_journal_code ne "IS" && !$printing)
        {
          print "</a>";
        }
        print "</td><td rowspan=$tmp2 valign=top align=right><b>Memo</b></td><td align=left rowspan=$tmp2 valign=top>$memo</td>";
        # now we print any debits or credits remaining
        if ($result3->ntuples > 1)
        { # display the rest of the debits
          my $i;
          for ($i=1; $i < $result3->ntuples; $i++)
          {
            if ($i > 2) # only start a new row when we are past the Memo line.
            {
              print "<tr>\n";
            }
            my $sub_e_code = $result3->getvalue($i, 0);
            if (length $sub_e_code == 0)
            {
              $sub_e_code = "<br>";
            }
            my $account_num = $result3->getvalue($i, 1);
            my $sub_account_num = $result3->getvalue($i, 2);
            my $amount = $result3->getvalue($i, 3);
            $amount =~ s/^\$//;  # remove the leading $

            # now I have to lookup the Account Name and Sub Account Name and display them.
            my $result5 = $conn->exec("select name, type from account_tb where number = $account_num");
            if ($result5->resultStatus != PGRES_TUPLES_OK)
            {
              print "</tr><tr><td colspan=8>\n";
              print "<h1>Error:  Accessing Database failed!</h1>\n";
              print $conn->errorMessage . "<br>Tried to lookup Account name for <font color=\"blue\">$account_num</font>.<br>$sys_admin";
              print "</td></tr></table></form>\n";
              CleanUp();
            }
            if ($result5->ntuples == 0)
            {
              print "</tr><tr><td colspan=8>\n";
              print "<h1>Error:  No Account Info returned!</h1>\n";
              print "Tried to lookup Account name for <font color=\"blue\">$account_num</font>.<br>$sys_admin";
              print "</td></tr></table></form>\n";
              CleanUp();
            }
            my $account_name = $result5->getvalue(0, 0);
            my $account_type = $result5->getvalue(0, 1);

            print "<td align=center>$sub_e_code</td>\n";
            if ($name_first)
            {
              print "<td align=left>$account_name - ";
              if ($account_type == 0)
              {
                print "<font color=\"$bank_color\">$account_num</font>";
              }
              else
              {
                print "$account_num";
              }
            }
            else # print number first
            {
              print "<td align=left>";
              if ($account_type == 0)
              {
                print "<font color=\"$bank_color\">$account_num</font>";
              }
              else
              {
                print "$account_num";
              }
              print " - $account_name";
            }
          #added by JT 9/15/00
          #lookup acct_num in local_accts_tb to get tax status and place an * by taxable accts
          #only if rev or exp
            statusflag($account_num, $conn);
            print "</td>\n";

            # get the sub_account name if appropriate
            my $sub_account_name = "";
            if ($sub_account_num >= 0 && $account_type != 0)  # only display sub account name if account is not a bank account
            {
              $result5 = $conn->exec("select sub_acc_name from sub_acc_tb where sub_acc_number = $sub_account_num");
              if ($result5->resultStatus != PGRES_TUPLES_OK)
              {
                print "</tr><tr><td colspan=8>\n";
                print "<h1>Error:  Accessing Database failed!</h1>\n";
                print $conn->errorMessage . "<br>Tried to lookup Sub Account name for <font color=\"blue\">$sub_account_num</font>.<br>$sys_admin";
                print "</td></tr></table></form>\n";
                CleanUp();
              }
              if ($result5->ntuples == 0)
              {
                print "</tr><tr><td colspan=8>\n";
                print "<h1>Error:  No Sub Account Info returned!</h1>\n";
                print "Tried to lookup Sub Account name for <font color=\"blue\">$sub_account_num</font>.<br>$sys_admin";
                print "</td></tr></table></form>\n";
                CleanUp();
              }
              $sub_account_name = $result5->getvalue(0, 0);
            }
            if ($sub_account_num >= 0)
            {
              if ($name_first)
              {
                print "<td align=left>$sub_account_name";
                if ($account_type == 0)
                {
                  print "<font color=\"$bank_deposit_color\">$sub_account_num</font>";
                }
                else
                {
                  print " - " . $sub_account_num;
                }
                print "</td>\n";
              }
              else  # print number first
              {
                print "<td align=left>";
                if ($account_type == 0)
                {
                  print "<font color=\"$bank_deposit_color\">$sub_account_num</font>";
                }
                else
                {
                  print $sub_account_num . " - ";
                }
                print "$sub_account_name";
                print "</td>\n";
              }
            }
            else
            {
              print "<td><br></td>\n";
            }

            print "<td align=right>" . commify($amount) . "</td>\n";
            print "<td><br></td>\n"; # Credit is nothing
            print "</tr>\n";
          }
        }
        if ($result4->ntuples > 0)
        { # display the credits
          my $i;
          for ($i=0; $i < $result4->ntuples; $i++)
          {
            if ($result3->ntuples > 1)
            {
              print "<tr>\n";
            }
            else
            {
              print "<tr>\n" if ($i > 0);
            }
            my $sub_e_code = $result4->getvalue($i, 0);
            if (length $sub_e_code == 0)
            {
              $sub_e_code = "<br>";
            }
            my $account_num = $result4->getvalue($i, 1);
            my $sub_account_num = $result4->getvalue($i, 2);
            my $amount = $result4->getvalue($i, 3);
            $amount =~ s/^\$//;  # remove the leading $

            # now I have to lookup the Account Name and Sub Account Name and display them.
            my $result5 = $conn->exec("select name, type from account_tb where number = $account_num");
            if ($result5->resultStatus != PGRES_TUPLES_OK)
            {
              print "</tr><tr><td colspan=8>\n";
              print "<h1>Error:  Accessing Database failed!</h1>\n";
              print $conn->errorMessage . "<br>Tried to lookup Account name for <font color=\"blue\">$account_num</font>.<br>$sys_admin";
              print "</td></tr></table></form>\n";
              CleanUp();
            }
            if ($result5->ntuples == 0)
            {
              print "</tr><tr><td colspan=8>\n";
              print "<h1>Error:  No Account Info returned!</h1>\n";
              print "Tried to lookup Account name for <font color=\"blue\">$account_num</font>.<br>$sys_admin";
              print "</td></tr></table></form>\n";
              CleanUp();
            }
            my $account_name = $result5->getvalue(0, 0);
            my $account_type = $result5->getvalue(0, 1);

            print "<td align=center>$sub_e_code</td>\n";
            if ($name_first)
            {
              print "<td align=left>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;$account_name - ";
              if ($account_type == 0)
              {
                print "<font color=\"$bank_color\">$account_num</font>";
              }
              else
              {
                print "$account_num";
              }
            }
            else # print number first
            {
              print "<td align=left>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
              if ($account_type == 0)
              {
                print "<font color=\"$bank_color\">$account_num</font>";
              }
              else
              {
                print "$account_num";
              }
              print " - $account_name";
            }
          #added by JT 9/15/00
          #lookup acct_num in local_accts_tb to get tax status and place an * by taxable accts
          #only if rev or exp
            statusflag($account_num, $conn);
            print "</td>\n";

            # get the sub_account name if appropriate
            my $sub_account_name = "";
            if ($sub_account_num >= 0 && $account_type != 0)  # only display sub account name if account is not a bank account
            {
              $result5 = $conn->exec("select sub_acc_name from sub_acc_tb where sub_acc_number = $sub_account_num");
              if ($result5->resultStatus != PGRES_TUPLES_OK)
              {
                print "</tr><tr><td colspan=8>\n";
                print "<h1>Error:  Accessing Database failed!</h1>\n";
                print $conn->errorMessage . "<br>Tried to lookup Sub Account name for <font color=\"blue\">$sub_account_num</font>.<br>$sys_admin";
                print "</td></tr></table></form>\n";
                CleanUp();
              }
              if ($result5->ntuples == 0)
              {
                print "</tr><tr><td colspan=8>\n";
                print "<h1>Error:  No Sub Account Info returned!</h1>\n";
                print "Tried to lookup Sub Account name for <font color=\"blue\">$sub_account_num</font>.<br>$sys_admin";
                if ($data_fixed)
                {
                  print "</td></tr></table></form>\n";
                }
                else
                {
                  print "</td><td><br></td></tr></table></form>\n";
                }
                CleanUp();
              }
              $sub_account_name = $result5->getvalue(0, 0);
            }
            if ($sub_account_num >= 0)
            {
              if ($name_first)
              {
                print "<td align=left>$sub_account_name";  # removed these '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;'
                if ($account_type == 0)
                {
                  print "<font color=\"$bank_credit_color\">$sub_account_num</font>";
                }
                else
                {
                  print " - " . $sub_account_num;
                }
                print "</td>\n";
              }
              else  # print number first
              {
                print "<td align=left>";  # removed these '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;'
                if ($account_type == 0)
                {
                  print "<font color=\"$bank_credit_color\">$sub_account_num</font>";
                }
                else
                {
                  print $sub_account_num . " - ";
                }
                print "$sub_account_name";
                print "</td>\n";
              }
            }
            else
            {
              print "<td><br></td>\n";
            }

            print "<td><br></td>\n";   # Debit is nothing
            print "<td align=right>" . commify($amount) . "</td>\n";
            print "</tr>\n";
          }
        }
      }
    }
  }
  print "</table>\n";
  print "</form>\n";

  if (!$printing)
  {
    # display the navigation bar at the bottom.
    print "<table border=0 cellpadding=0 cellspacing=0 width=100%>\n";
    print "<tr><td align=left width=40%>Displaying ";
    if ($num_entries_to_display == 0)
    {
      print "<b>all</b> entries.";
    }
    else
    {
      print "<b>$num_entries_to_display</b> entries at a time.";
    }
    print "&nbsp;&nbsp;<a href=\"$site_dir/cgi-bin/journal_mod1.cgi\" onClick=\"javascript:SubmitJournalViewPrintable(" . ($start_index) . "); return false;\"><b>Print</b></a> screen.</td><td align=center width=20% valign=bottom>";
    print "<form method=post action=\"$site_dir/cgi-bin/journal_activity.cgi\" name=\"journal_trans_create2\">\n";
    print "<input type=hidden name=\"ledger\" value=\"$ledger_db\">\n";
    print "<input type=hidden name=\"journal_code\" value=\"G\">\n";
    print "<input type=hidden name=\"journal_bgcolor\" value=\"\">\n";
    print "<input type=hidden name=\"start_index\" value=\"$start_index\">\n";
    print "<input type=hidden name=\"journal_command\" value=\"\">\n";  # used to tell the journal create, delete, edit scripts what to do.
    print "<input type=hidden name=\"num_entries_to_display\" value=\"$num_entries_to_display\">\n";
    print "$custom_hidden_fields_string";
    print "<input type=button name=\"create\" value=\"New Transaction\" onClick=\"document.journal_trans_create2.journal_command.value='create';document.journal_trans_create2.submit();\">";
    print "</form></td>\n<td align=right width=40%>";
    if ($entries_working_with > 0)
    {
      if ($num_entries_to_display > 0)
      {
        if ($start_index > $entries_working_with)
        {
          print "</td></tr></table>\n";
          print "<h1>Error:  The Index into the Journal is out of bounds!</h1>\n";
          print "<form name=\"journal_form2\" method=post action=\"$site_dir/cgi-bin/journal_mod1.cgi\">\n";
          print "<input type=hidden name=\"ledger\" value=\"$ledger_db\">\n";
          print "<input type=hidden name=\"journal_code\" value=\"G\">\n";
          print "<input type=hidden name=\"journal_bgcolor\" value=\"\">\n";
          print "<input type=hidden name=\"start_index\" value=\"" . ($entries_working_with - $start_index < 1 ? 1 : $entries_working_with - $start_index) . "\">\n";
          print "<input type=hidden name=\"num_entries_to_display\" value=\"$num_entries_to_display\">\n";
          print "$custom_hidden_fields_string";
          print "<a href=\"$site_dir/cgi-bin/journal_mod1.cgi\" onClick=\"document.journal_form2.submit(); return false;\">Click here to go to the last page of the Journal View</a>\n";
          print "</form>\n";
          CleanUp();
        }
        if ($start_index >= $num_entries_to_display)
        {
          print "<a href=\"$site_dir/cgi-bin/journal_mod1.cgi\" onClick=\"javascript:SubmitJournalView(" . ($start_index - $num_entries_to_display) . "); return false;\">Previous <b>$num_entries_to_display</b> Entries</a>&nbsp;&nbsp;|&nbsp;&nbsp;";
        }
        if ($start_index + $num_entries_to_display <= $entries_working_with)
        {
          print "<a href=\"$site_dir/cgi-bin/journal_mod1.cgi\" onClick=\"javascript:SubmitJournalView(" . ($start_index) . "); return false;\">Entries <b>$start_index</b> to <b>" . ($start_index + $num_entries_to_display - 1) . "</b></a>&nbsp;&nbsp;|&nbsp;&nbsp;";
          print "<a href=\"$site_dir/cgi-bin/journal_mod1.cgi\" onClick=\"javascript:SubmitJournalView(" . ($start_index + $num_entries_to_display) . "); return false;\">Next ";
          if ($start_index + (2 * $num_entries_to_display) <= $entries_working_with)
          {
            print "<b>$num_entries_to_display</b>";
          }
          else
          {
            print "<b>" . ($entries_working_with - ($start_index + $num_entries_to_display - 1)) . "</b>";
          }
          print " Entries</a>&nbsp;&nbsp;";
        }
        else
        {
          print "<a href=\"$site_dir/cgi-bin/journal_mod1.cgi\" onClick=\"javascript:SubmitJournalView($start_index); return false;\">Entries <b>$start_index</b> to <b>" . $entries_working_with . "</b></a>&nbsp;&nbsp;";
        }
        print "|&nbsp;&nbsp;Out of <b>" . $entries_working_with . "</b> Entries returned.";
      }
      else
      {
        print "<a href=\"$site_dir/cgi-bin/journal_mod1.cgi\" onClick=\"javascript:SubmitJournalView($start_index); return false;\"><b>" . $entries_working_with . "</b></a> Entries returned.";
      }
    }
    else
    {
      print "<b>0</b> Entries returned.";
    }
    print "</td></tr></table>\n";
  }
}

sub statusflag
{
  my $num = $_[0];
  my $conns = $_[1];

  if (($num =~ /^4/) || ($num =~ /^5/))
  {
    my $sqlquery = "select taxable from local_accounts_tb where ledger_code = '$ledger_code' and acct_num = $num";
    my $result67 = $conns->exec($sqlquery);
    if ($result67->resultStatus != PGRES_TUPLES_OK)
    {
      print "</td></tr><tr><td colspan=8>\n";
      print "Error while looking up tax status for account $account_num\n";
    print "$sqlquery";
      die;
    }
    if ($result67->ntuples ==1)
    {
      if ($result67->getvalue(0,0) eq "t")
      {
        print "*";
      }
    }
  }#end if

}
