#!/usr/bin/perl
#$Id: register_reconcile.cgi,v 1.2 2004/06/22 22:42:37 pattieja Exp $
#This package is released under the GPL.  You should have recieved the GPL with it.
# Copyright (c) 2000 HLR http://www.pcxperience.org  All rights reserved.
# register_reconcile.cgi  -  Created by Jason A. Pattie, 04/19/2000
# This script updates the journal entry(ies) that are affected by modifying the
# cleared/reconciled status flag to make the journal entry(ies) reconciled (r's).

use strict;

use Pg;  # PostgreSQL Database Module
use cgi_lib;  # CGI Library routines
use custom;  # our customizable features
use reports;

use vars '$date';
use vars '$count';
use vars '$count2';
use vars '$reconciled_count';
use vars '$temp_ref_num';
use vars '$temp_counter';
use vars '$temp';
use vars '$from_search_date';
use vars '$to_search_date';
my $account_name;
my $account_num;
my $account_type_name;
my $error_happened;
$error_happened = 0;

# get the values being passed in from the client
%input = ();  # make sure it is empty!
cgi_lib::ReadParse(*input);

# begin the HTML Output
print cgi_lib::PrintHeader();
print "<html>\n";

my $ledger_name;  # name of ledger to work with
my $ledger_db;
my $ledger_color;
my $result2;
my $error_string;
my $ledger_code;
my $report_obj;

use PortalWrapper; # The Portal Wrapper library.

my $portalObj;
$portalObj = PortalWrapper->new;
if ($portalObj->didErrorOccur)
{
  # begin the HTML Output
  print cgi_lib::PrintHeader();
  print "<html>\n";

  PrintErrorHeader();
  print $portalObj->errorMessage;
  CleanUp();
}
my $dbObj;
$dbObj = $portalObj->getDBInfo;
if (!defined $dbObj)
{
  if ($portalObj->didErrorOccur)
  {
    # begin the HTML Output
    print cgi_lib::PrintHeader();
    print "<html>\n";
  
    PrintErrorHeader();
    print $portalObj->errorMessage;
    CleanUp();
  }
}
else
{
  if ($dbObj->didErrorOccur)
  {
    # begin the HTML Output
    print cgi_lib::PrintHeader();
    print "<html>\n";
  
    PrintErrorHeader();
    print $dbObj->errorMessage;
    CleanUp();
  }
}
$db_host = $dbObj->dbHost;
$db_name = $dbObj->dbName;
$db_user = $dbObj->dbUser;
$db_passwd = $dbObj->dbPasswd;

my $database_connected;
$database_connected = 0;

$ledger_db = $input{'ledger_db'};
if (length $ledger_db == 0)
{
  PrintErrorHeader();
  print "<h1>Error: You must specify a ledger to work with!</h1>\n";
  print "$back_button";
  CleanUp();
}
$error_string = IsValidString($ledger_db);
if (length $error_string > 0)
{
  PrintErrorHeader();
  print "<h1>Error:  Invalid Database Name!</h1>\n";
  print "<b>$error_string</b> is invalid!<br>$back_button";
  CleanUp();
}

if (not exists $input{'finish_reconcile_submit'})
{
  PrintErrorHeader();
  print "<h1>Error:  Access Denied!</h1>\n";
  print "Invalid options.<br>$sys_admin";
  CleanUp();
}

if (not exists $input{'reconciled_count'})
{
  PrintErrorHeader();
  print "<h1>Error: Access Denied!</h1>\n";
  print "Invalid options.  Form value (reconciled count) missing.<br>$sys_admin";
  CleanUp();
}
$error_string = IsValidUInteger($input{'reconciled_count'});
if (length $error_string > 0)
{
  PrintErrorHeader();
  print "<h1>Error:  Invalid Num Rows Value!</h1>\n";
  print "<b>$error_string</b> is invalid!<br>$back_button";
  CleanUp();
}
$reconciled_count = $input{'reconciled_count'};

$account_name = $input{'account_name'};
if (length $account_name == 0)
{
  PrintErrorHeader();
  print "<h1>Error:  You must specify the Account Name!</h1>\n";
  print "$back_button";
  CleanUp();
}
$error_string = IsValidString($account_name);
if (length $error_string > 0)
{
  PrintErrorHeader();
  print "<h1>Error:  Invalid Account Name!</h1>\n";
  print "<b>$error_string</b> is invalid!<br>$back_button";
  CleanUp();
}

$account_type_name = $input{'account_type_name'};
if (length $account_type_name == 0)
{
  PrintErrorHeader();
  print "<h1>Error:  You must specify the Account Type Name!</h1>\n";
  print "$back_button";
  CleanUp();
}
$error_string = IsValidString($account_type_name);
if (length $error_string > 0)
{
  PrintErrorHeader();
  print "<h1>Error:  Invalid Account Type Name!</h1>\n";
  print "<b>$error_string</b> is invalid!<br>$back_button";
  CleanUp();
}

if (not exists $input{'from_search_date'})
{
  PrintErrorHeader();
  print "<h1>Error: Access Denied!</h1>\n";
  print "Invalid options.  Form value (from search date) missing.<br>$sys_admin";
  CleanUp();
}
$from_search_date = $input{'from_search_date'};
if (not IsValidDateSyntax($from_search_date))
{
  PrintErrorHeader();
  print "<h1>Error:  Invalid From Search Date!</h1>\n";
  print "$back_button";
  CleanUp();
}

if (not exists $input{'to_search_date'})
{
  PrintErrorHeader();
  print "<h1>Error: Access Denied!</h1>\n";
  print "Invalid options.  Form value (to search date) missing.<br>$sys_admin";
  CleanUp();
}
$to_search_date = $input{'to_search_date'};
if (not IsValidDateSyntax($to_search_date))
{
  PrintErrorHeader();
  print "<h1>Error:  Invalid To Search Date!</h1>\n";
  print "$back_button";
  CleanUp();
}

$account_num = $input{'account_num'};
if (length $account_num == 0)
{
  PrintErrorHeader();
  print "<h1>Error:  You must specify the Account Number!</h1>\n";
  print "$back_button";
  CleanUp();
}
$error_string = IsValidUInteger($account_num);
if (length $error_string > 0)
{
  PrintErrorHeader();
  print "<h1>Error:  Invalid Account Number!</h1>\n";
  print "<b>$error_string</b> is invalid!<br>$back_button";
  CleanUp();
}

# check to see if we are running under mod_perl
if (exists $ENV{MOD_PERL})
{
  # check to see if the database is still connected
  if (defined $conn)
  {
    # check the status of the connection
    if ($conn->status != PGRES_CONNECTION_OK)
    {
      $database_connected = 0;
    }
    else
    {
      # connection still good!
      $database_connected = 1;
    }
  }
  else
  {
    $database_connected = 0;
  }
}

if (not $database_connected)
{
  # connect to the database.
  $conn = Pg::connectdb("host = $db_host dbname = $db_name user = $db_user password = $db_passwd");
  if ($conn->status == PGRES_CONNECTION_BAD)
  {
    PrintErrorHeader();
    print "<h1>Error:  Couldn't connect to the database!</h1><br>\n";
    print $conn->errorMessage . "<br>$sys_admin";
    CleanUp();
  }
}

# set the DateStyle for the Database.
$result = setDBDateStyle($conn);
if ($result->resultStatus != PGRES_COMMAND_OK)
{
  PrintErrorHeader();
  print "<h1>Error:  Setting Date Style failed!</h1>\n";
  print $conn->errorMessage . "<br>$sys_admin";
  CleanUp();
}

# now validate that the ledger they specified is valid
$result = $conn->exec("select name from entity_tb where database_name = '$ledger_db'");
if ($result->resultStatus != PGRES_TUPLES_OK)
{
  PrintErrorHeader();
  print "<h1>Error: Accessing database failed!</h1>\n";
  print $conn->errorMessage . "<br>Trying to check entity table.<br>$sys_admin";
  CleanUp();
}
if ($result->ntuples == 0)
{
  PrintErrorHeader();
  print "<h1>Error: Ledger <font color=\"blue\">$ledger_db</font> does not exist!</h1>\n";
  print "$sys_admin";
  CleanUp();
}
else
{
  $ledger_name = $result->getvalue(0, 0);
}

# create the reports object
$report_obj = reports->new($conn, $ledger_db);
if ($report_obj->didErrorOccur())
{
  PrintErrorHeader();
  print $report_obj->getErrorMessage();
  CleanUp();
}
$ledger_code = $report_obj->getLedgerCode();
if ($report_obj->didErrorOccur())
{
  PrintErrorHeader();
  print $report_obj->getErrorMessage();
  CleanUp();
}
$ledger_color = $report_obj->getLedgerColor();
if ($report_obj->didErrorOccur())
{
  PrintErrorHeader();
  print $report_obj->getErrorMessage();
  CleanUp();
}

# figure out the beginning and ending date of the current working year
my ($working_year, $from_date, $to_date);

$result = $conn->exec("select year, start_date, end_date from known_years_tb where year in (select working_year from variables_tb WHERE ledger_code = '$ledger_code') AND ledger_code = '$ledger_code'");
if ($result->resultStatus != PGRES_TUPLES_OK)
{
  PrintErrorHeader();
  print "<h1>Error:  Accessing database failed!</h1>\n";
  print $conn->errorMessage . "<br>Tried to get working year and fiscal year dates from ledger <font color=\"blue\">$ledger_db</font>.<br>$sys_admin";
  CleanUp();
}
if ($result->ntuples == 0)
{
  PrintErrorHeader();
  print "<h1>Error: Program not configured!</h1>\n";
  print "Working Year is not set!<br>$sys_admin";
  CleanUp();
}
$working_year = $result->getvalue(0, 0);
$from_date    = $result->getvalue(0, 1);
$to_date      = $result->getvalue(0, 2);

print "<head><title>$prog_name $prog_version Account Registers</title></head>\n";
print "<body bgcolor=$body_bgcolor>\n";
print <<"END_OF_STYLE";
<style type="text/css"><!--
  a:hover   { color: red }
  a:link    { text-decoration: none; color: blue }
  a:visited { text-decoration: none; color: blue }
  a:active  { text-decoration: none; color: blue }-->
</style>
<script language="Javascript1.2" src="../js/common.js"></script>
END_OF_STYLE
# get the date
$date = `/bin/date +%m-%d-%Y`;
chomp $date;

print "<center>\n";
print "<table border=0 width=100% cellspacing=0 cellpadding=2 bgcolor=\"$body_bgcolor\">\n";
print "<tr>\n";
print "<td align=left width=47%><font color=\"red\">Reconciling/Updating Register <font color=blue>" . $input{'account_name'} . " (" . $input{'account_type_name'} . ")</font> in Ledger <font color=\"$ledger_color\">$ledger_name</font>. &nbsp;FY is <font color=\"black\">$working_year</font>.</font></td>\n";
print "<td align=left><a href=\"$site_dir/help.html#register\" target=\"docs\"><img border=0 src=\"$site_dir/images/help.jpg\" alt=\"Help\"></a></td>\n";
print "<td align=right>$date</td></tr></table>\n<hr><br>\n";
print PrintStandardLedgerMainMenu($ledger_db);

print "<br><br>\n";

# update the row data entries with the changes made to the cleared fields on the previous form
for ($count=0; $count < $reconciled_count; $count++)
{
  $temp = "reconcile_ref_num_" . $count;
  if (exists $input{$temp})
  {
    $temp_ref_num = $input{$temp};
    $temp = "reconcile_count_" . $count;
    if (exists $input{$temp})
    {
      $temp_counter = $input{$temp};
      $result = $conn->exec("update debitcredit_tb set cleared = 'r' where parent_num = $temp_ref_num and counter = $temp_counter AND ledger_code = '$ledger_code'");
      if ($result->resultStatus != PGRES_COMMAND_OK)
      {
        print "<font color=red>Error: Failed to update record (<font color=blue>ref_num=$temp_ref_num, counter=$temp_counter</font>)!</font><br>\n";
        print $conn->errorMessage . "<br>\n";
        $error_happened = 1;
      }
    }
  }
}

if (!$error_happened)
{
  print "<center><h2>Successfully finished reconciling <font color=\"blue\">$account_name - $account_num ($account_type_name)</font>.</h2></center>\n";
}

# print a horizontal rule to break the menu from the behind the scenes links
print "<br><hr>\n";
print "</center>\n";

print "<form method=post action=\"\" name=\"register_redo_form\">\n";
print "<input type=hidden name=\"ledger_db\" value=\"$ledger_db\">\n";
print "<input type=hidden name=\"account_select\" value=\"$account_name|$account_num\">\n";
print "<input type=hidden name=\"account_value\" value=\"$account_name|$account_num\">\n";
print "<input type=hidden name=\"from_search_date\" value=\"$from_search_date\">\n";
print "<input type=hidden name=\"to_search_date\" value=\"$to_search_date\">\n";
if (exists $input{'display_outstanding'})
{
  print "<input type=hidden name=\"display_outstanding\" value=\"\">\n";
}
print "<input type=submit name=\"register_select_submit\" value=\"Re-Edit this Register\" onClick=\"submit_my_form(document.register_redo_form, '$site_dir/cgi-bin/register_display.cgi')\">\n";
print "</form>\n";

print "</body>\n";
print "</html>\n";
exit 0;
