#!/usr/bin/perl
#$Id: reports4.cgi,v 1.2 2003/10/14 22:42:07 pattieja Exp $
#This package is released under the GPL.  You should have recieved the GPL with it.
# Copyright (c) 2000 HLR http://www.pcxperience.org  All rights reserved.
# reports4.cgi  -  Created by James Pattie, 07/21/1999
# This script actually does the report that the user selected.
use strict;
no strict 'refs';

use Pg;  # PostgreSQL Database Module
use cgi_lib;  # CGI Library routines
use custom;  # our customizable features
use reports;  # the Report Module

use vars '$date';
use vars '$ledger_db';
use vars '$ledger_name';
use vars '$report_group';
use vars '$group_name';
use vars '$report';
use vars '$report_name';
use vars '$report_type';  # The Income Statement report type or could be used in other reports also.
use vars '$report_obj';  # The report Object
use vars '$print_report';  # Boolean to specify if the report is to be printable or not.
use vars '$show_zero_balances'; # boolean to specify if we should show activity / balances that = 0.00
use vars '$show_accounts_as';  # boolean: 1 = Name - Number, 0 = Number - Name
use vars '$show_by_sub_entities'; # boolean: 1 = show by Sub-Entities, 0 = Normal report.
use vars '$show_non_tax_section'; # boolean: 1 = show Non-Tax sectionm, 0 = Don't show Non-Tax section.
use vars '$activity_start_point'; # value that tells me how many months to go back for each Date I'm working with to get the starting date.

use vars '$date1';
use vars '$date2'; # Bookeeping specific (Balance Sheet primarily)
use vars '$date3';
use vars '$date4';
use vars '$num_list_entries'; # keeps track of the number of dynamic elements that are created for a report.
$num_list_entries = 0;  # the initial value
use vars '$num_sub_lists';  # keeps track of the number of sub-lists that have been created.
$num_sub_lists = 0;  # the initial value
use vars '$list_height';
$list_height = 30;  # set the initial value
use vars '$date1_start';  # Income Statement specific
use vars '$date1_stop';
use vars '$date2_start';
use vars '$date2_stop';
use vars '$date3_start';
use vars '$date3_stop';
use vars '$date4_start';
use vars '$date4_stop';
use vars '$tos';	 # type of statement
use vars '$CoGS_location';
use vars '$lod';   # Level of detail
use vars '$all_accounts';
use vars '$accounts_selected';
use vars '$num_columns';
use vars '$years';
use vars '$data_precision';  # indicates what level of precision to display the data in.

use vars '$federal_from_date';  # 941 quarterly payroll report dates for federal and state
use vars '$federal_to_date';
use vars '$reverse_federal_to_date';
use vars '$state_from_date';
use vars '$state_to_date';

# 941 quarterly payroll report variables for both federal and state
use vars '$q1_sub_account_num';
use vars '$q2_sub_account_num';
use vars '$q3_sub_account_num';
use vars '$q4_sub_account_num';
# define default quarter sub account numbers
$q1_sub_account_num = 1;
$q2_sub_account_num = 2;
$q3_sub_account_num = 3;
$q4_sub_account_num = 4;
use vars '$federal_display_order';
use vars '$state_display_order';

use vars '$state_account_num';
use vars '$state_cdp_percent';  # state 941 variables
use vars '$state_cdp_amount';
use vars '$state_pop_amount';  # will be negative for overpayment, positive for underpayment
use vars '$state_att_amount';
use vars '$state_interest_amount';

use vars '%state_sub_account_balances';  # calculated values for state 941 report
use vars '$state_total_balances_amount';
use vars '$state_withholding';
use vars '$state_compensation_deduction';
use vars '$state_balance_due';
use vars '$state_total_due';

use vars '$FITW_account_nums'; # federal 941 variables
use vars '$FICA_account_nums';
use vars '$MEDICARE_account_nums';
use vars '$AEIC_account_nums';
use vars '$salary_expense_account_nums';
use vars '$FICA_rate';
use vars '$FICA_cap';
use vars '$MEDICARE_rate';
use vars '$MEDICARE_cap';
use vars '%employee_amounts';

use vars '$federal_year';
use vars '$federal_quarter';
use vars '$FITW_over_under_payment_amount';
use vars '$FITW_other_adjustments_amount';
use vars '$FICA_MEDICARE_sick_pay_amount';
use vars '$FICA_MEDICARE_other_adjustments_amount';

use vars '$number_of_employees'; # calculated values for federal 941 report
use vars '$total_wages_tips';
use vars '$total_income_tax_withheld';
use vars '$adjusted_total_income_tax_withheld';
use vars '$taxable_FICA_wages';
use vars '$taxable_FICA_tips';
use vars '$tax_FICA_wages';
use vars '$tax_FICA_tips';
use vars '$tax_MEDICARE_wages_tips';
use vars '$total_FICA_MEDICARE_taxes';
use vars '$fractions_of_cents';
use vars '$adjustment_FICA_MEDICARE_amount';
use vars '$adjusted_total_FICA_MEDICARE_taxes';
use vars '$total_taxes_amount';
use vars '$advance_EIC_payments';
use vars '$net_taxes_amount';
use vars '$total_deposits_for_quarter';
use vars '$balance_due_amount';
use vars '$overpayment_amount';
use vars '$month_1_liability_amount';
use vars '$month_2_liability_amount';
use vars '$month_3_liability_amount';
use vars '$quarter_liability_amount';

# trial balance report variables
use vars '$trial_balance_date';
use vars '$tb_display_order';
use vars '@tb_accounts_array';
use vars '@tb_accounts_balances';
use vars '$tb_debit_sum';
use vars '$tb_credit_sum';

use vars '$custom_title';
use vars '$error_message';  # global error message string
use vars '$ledger_color';
use vars '$ledger_code';
use vars '$date_range_string';
use vars '@Data';
use vars '@TaxData';        # Taxable Data array
use vars '@NonTaxData';     # NonTax Data array
use vars '$precision_table';
$precision_table = { '10' => 'tens', '100' => 'hundreds', '1000' => 'thousands', '10000' => 'ten-thousands', '100000' => 'hundred-thousands', '1000000' => 'millions' };
use vars qw($i $acct_num $result2 $result3);  # result2 will hold the account types, result3 will hold the other data.
use vars qw(@asset_total @liability_total @equity_total);
use vars qw(@revenue_total @expense_total @Dates @Start_Dates);
use vars qw($text_width $data_width $max_columns $font_size_text $font_size_data $uline_length);
$text_width = 30;  # width's in % of the text and data columns of printable / detailed view reports.
$data_width = 70;
$font_size_text = 3;  # the number of points to decrease the font for the text column.
$font_size_data = 1;  # the number of points to decrease the font for the data column.
$max_columns = 4;  # the maximum number of data columns to be displayed at any time.
$uline_length = 80;  # the number of pixels that will be displayed for a <hr> in the printable version.
use vars '$line_length';
$line_length = 12; # length of the line that should be generated under any text that needs it.
use vars '$font_str';
$font_str = "Helvetica";

my %BookKeepingValidateFunctions;
%BookKeepingValidateFunctions = ( "account_activity_sheet" => \&reports4AccountActivitySheetValidate,
			  "cash_flow" => \&reports4CashFlowValidate,
			  "balance_sheet" => \&reports4BalanceSheetValidate,
			  "account_balance_sheet" => \&reports4AccountBalanceSheetValidate,
			  "income_statement" => \&reports4IncomeStatementValidate,
			  "quarterly_income_statement" => \&reports4QuarterlyIncomeStatementValidate,
			  "missing_checks" => "Define",
			  "bank_reconciliation" => \&reports4BankReconciliationValidate,
			  "trial_balance" => \&reports4TrialBalanceValidate
);
my %PayrollValidateFunctions;
%PayrollValidateFunctions = ( "federal_941_quarterly_payroll" => \&reports4Federal941Validate,
			  "state_941_quarterly_payroll" => \&reports4State941Validate,
			  "fica_and_medicare" => "Define",
			  "payroll_record" => "Define"
);
my %WorkFunctions;
%WorkFunctions = ( "account_activity_sheet" => \&reports4AccountActivitySheetWork,
			  "cash_flow" => \&reports4CashFlowWork,
			  "balance_sheet" => \&reports4BalanceSheetWork,
			  "account_balance_sheet" => \&reports4AccountBalanceSheetWork,
			  "income_statement" => \&reports4IncomeStatementWork,
			  "quarterly_income_statement" => "Define",
			  "missing_checks" => "Define",
			  "bank_reconciliation" => \&reports4BankReconciliationWork,
			  "trial_balance" => \&reports4TrialBalanceWork,
			  "federal_941_quarterly_payroll" => \&reports4Federal941Work,
			  "state_941_quarterly_payroll" => \&reports4State941Work,
			  "fica_and_medicare" => "Define",
			  "payroll_record" => "Define"
);

my %JavaScriptFunctions;
%JavaScriptFunctions = ( "account_activity_sheet" => \&reports4AccountActivitySheetJavaScript,
			  "cash_flow" => \&reports4CashFlowJavaScript,
			  "balance_sheet" => \&reports4BalanceSheetJavaScript,
			  "account_balance_sheet" => \&reports4AccountBalanceSheetJavaScript,
			  "income_statement" => \&reports4IncomeStatementJavaScript,
			  "quarterly_income_statement" => \&reports4QuarterlyIncomeStatementJavaScript,
			  "missing_checks" => "Define",
			  "bank_reconciliation" => \&reports4BankReconciliationJavaScript,
			  "trial_balance" => "Define",
			  "federal_941_quarterly_payroll" => "Define",
			  "state_941_quarterly_payroll" => "Define",
			  "fica_and_medicare" => "Define",
			  "payroll_record" => "Define"
);
my %DisplayFormFunctions;
%DisplayFormFunctions = ( "account_activity_sheet" => \&reports4AccountActivitySheetDisplayForm,
			  "cash_flow" => \&reports4CashFlowDisplayForm,
			  "balance_sheet" => \&reports4BalanceSheetDisplayForm,
			  "account_balance_sheet" => \&reports4AccountBalanceSheetDisplayForm,
			  "income_statement" => \&reports4IncomeStatementDisplayForm,
			  "quarterly_income_statement" => \&reports4QuarterlyIncomeStatementDisplayForm,
			  "missing_checks" => "Define",
			  "bank_reconciliation" => \&reports4BankReconciliationDisplayForm,
			  "trial_balance" => \&reports4TrialBalanceDisplayForm,
			  "federal_941_quarterly_payroll" => \&reports4Federal941DisplayForm,
			  "state_941_quarterly_payroll" => \&reports4State941DisplayForm,
			  "fica_and_medicare" => "Define",
			  "payroll_record" => "Define"
);

use PortalWrapper; # The Portal Wrapper library.

my $portalObj;
$portalObj = PortalWrapper->new;
if ($portalObj->didErrorOccur)
{
  # begin the HTML Output
  print cgi_lib::PrintHeader();
  print "<html>\n";

  PrintErrorHeader();
  print $portalObj->errorMessage;
  CleanUp();
}
my $dbObj;
$dbObj = $portalObj->getDBInfo;
if (!defined $dbObj)
{
  if ($portalObj->didErrorOccur)
  {
    # begin the HTML Output
    print cgi_lib::PrintHeader();
    print "<html>\n";
  
    PrintErrorHeader();
    print $portalObj->errorMessage;
    CleanUp();
  }
}
else
{
  if ($dbObj->didErrorOccur)
  {
    # begin the HTML Output
    print cgi_lib::PrintHeader();
    print "<html>\n";
  
    PrintErrorHeader();
    print $dbObj->errorMessage;
    CleanUp();
  }
}
$db_host = $dbObj->dbHost;
$db_name = $dbObj->dbName;
$db_user = $dbObj->dbUser;
$db_passwd = $dbObj->dbPasswd;

my $database_connected;
$database_connected = 0;

# include all the helper files that do the work
require "./reports_account_balance_sheet.pm";
require "./reports_account_activity_sheet.pm";
require "./reports_accounts.pm";
require "./reports_balance_sheet.pm";
require "./reports_trial_balance.pm";
require "./reports_cash_flow.pm";
require "./reports_helpers.pm";
require "./reports_income_statement.pm";
require "./reports_quarterly_income_statement.pm";
require "./reports_federal_941.pm";
require "./reports_state_941.pm";
require "./reports_bank_reconciliation.pm";

# get the values being passed in from the client
%input = ();  # make sure it is empty!
cgi_lib::ReadParse(*input);

# begin the HTML Output
print cgi_lib::PrintHeader();
print "<html>\n";

if (not exists $input{'run'})
{
  PrintErrorHeader();
  print "<h1>Error:  Invalid Access!</h1>\n";
  print "$sys_admin";
  CleanUp();
}

$ledger_db = $input{'ledger'};
if (length $ledger_db == 0)
{
  PrintErrorHeader();
  print "<h1>Error: You must specify a ledger to work with!</h1>\n";
  print "$back_button";
  CleanUp();
}

$report_group = $input{'report_group'};
if (length $report_group == 0)
{
  PrintErrorHeader();
  print "<h1>Error: You must select a report group to work with!</h1>\n";
  print "$back_button";
  CleanUp();
}

if (not ($report_group eq "bookkeeping" || $report_group eq "payroll")) # || $report_group eq "asset" || $report_group eq "investment" || $report_group eq "analysis"))
{
  PrintErrorHeader();
  print "<h1>Error:  Invalid Report Group specified!</h1>\n";
  print "Value specified was '$report_group'.<br>$sys_admin";
  CleanUp();
}

$report = $input{'report'};
if (length $report == 0)
{
  PrintErrorHeader();
  print "<h1>Error: You must specify a report to run!</h1>\n";
  print "$back_button";
  CleanUp();
}

# Global Values set by every report
$custom_title = $input{'custom_report_name'};

# see what they specified for Show Activities/Balances = $0.00
if (not exists $input{'show_zero_balances'})
{
  PrintErrorHeader();
  print "<h1>Error:  Show Zero Activities/Balances must be set!</h1>\n";
  print "$sys_admin";
  CleanUp();
}
$show_zero_balances = $input{'show_zero_balances'};
if (not ($show_zero_balances eq "YES" || $show_zero_balances eq "NO"))
{
  PrintErrorHeader();
  print "<h1>Error:  Invalid value set for Show Zero Activities/Balances!</h1>\n";
  print "The value specified was '$show_zero_balances'.<br>$sys_admin";
  CleanUp();
}
$show_zero_balances = ($show_zero_balances eq "YES" ? 1:0);

# see what they specified for Show Account Names: Name - Number or Number - Name
if (not exists $input{'show_accounts_as'})
{
  PrintErrorHeader();
  print "<h1>Error:  Show Accounts as Name - Number or Number - Name must be set!</h1>\n";
  print "$sys_admin";
  CleanUp();
}
$show_accounts_as = $input{'show_accounts_as'};
if (not ($show_accounts_as eq "name-number" || $show_accounts_as eq "number-name"))
{
  PrintErrorHeader();
  print "<h1>Error:  Invalid value set for Show Accounts as!</h1>\n";
  print "The value specified was '$show_accounts_as'.<br>$sys_admin";
  CleanUp();
}
$show_accounts_as = ($show_accounts_as eq "name-number" ? 1:0);

# see what we got for the text and data font sizes
if (length $input{'font_size_text'} == 0)
{
  PrintErrorHeader();
  print "<h1>Error:  You must specify the font size to use for the text display!</h1>\n";
  print "$back_button";
  CleanUp();
}
$font_size_text = $input{'font_size_text'};
if (not ($font_size_text eq "+1" || $font_size_text eq "+2" || $font_size_text eq "+0" || $font_size_text eq "-1" || $font_size_text eq "-2"))
{
  PrintErrorHeader();
  print "<h1>Error:  Invalid value set for Text Font Size!</h1>\n";
  print "The value specified was '$font_size_text'.<br>$sys_admin";
  CleanUp();
}

if (length $input{'font_size_data'} == 0)
{
  PrintErrorHeader();
  print "<h1>Error:  You must specify the font size to use for the data display!</h1>\n";
  print "$back_button";
  CleanUp();
}
$font_size_data = $input{'font_size_data'};
if (not ($font_size_data eq "+1" || $font_size_data eq "+2" || $font_size_data eq "+0" || $font_size_data eq "-1" || $font_size_data eq "-2"))
{
  PrintErrorHeader();
  print "<h1>Error:  Invalid value set for Data Font Size!</h1>\n";
  print "The value specified was '$font_size_data'.<br>$sys_admin";
  CleanUp();
}

# see what value they specified for the data precision.
if (length $input{'data_precision'} == 0)
{
  PrintErrorHeader();
  print "<h1>Error:  You must specify the precision to use for the data!</h1>\n";
  print "$back_button";
  CleanUp();
}
$data_precision = $input{'data_precision'};
if (not ($data_precision == 1 || $data_precision == 10 || $data_precision == 100 || $data_precision == 1000 || $data_precision == 10000 || $data_precision == 100000 || $data_precision == 1000000))
{
  PrintErrorHeader();
  print "<h1>Error: <b>$data_precision</b> is an invalid value for the data precision!</h1>\n";
  print "$back_button";
  CleanUp();
}

if ($report_group eq "bookkeeping")
{
  if (not exists $BookKeepingValidateFunctions{$report})
  {
    PrintErrorHeader();
    print "<h1>Error:  Invalid option for Bookkeeping!</h1>\n";
    print "$sys_admin";
    CleanUp();
  }
  if (exists $BookKeepingValidateFunctions{$report} && $BookKeepingValidateFunctions{$report} ne "Define")
  {
    # execute the Validation Function for the selected report
    $BookKeepingValidateFunctions{$report}->();
  }
}
elsif ($report_group eq "payroll")
{
  if (not exists $PayrollValidateFunctions{$report})
  {
    PrintErrorHeader();
    print "<h1>Error:  Invalid option for Payroll!</h1>\n";
    print "$sys_admin";
    CleanUp();
  }
  if (exists $PayrollValidateFunctions{$report} && $PayrollValidateFunctions{$report} ne "Define")
  {
    # execute the Validation Function for the selected report
    $PayrollValidateFunctions{$report}->();
  }
}
#elsif ($report_group eq "asset")
#{
#  if (not ($report eq "asset_valuation" || $report eq "depreciation"))
#  {
#    PrintErrorHeader();
#    print "<h1>Error:  Invalid option for Asset!</h1>\n";
#    print "$sys_admin";
#    CleanUp();
#  }
#  if ($report eq "asset_valuation")
#  {
#    $report_name = "Asset Valuation";
#  }
#  elsif ($report eq "depreciation")
#  {
#    $report_name = "Depreciation";
#  }
#}
#elsif ($report_group eq "investment")
#{
#  if (not ($report eq "1099_reconciliation" || $report eq "investment_performance" || $report eq "capital_gains" || $report eq "investment_transactions" || $report eq "price_comparison" || $report eq "portfolio_value"))
#  {
#    PrintErrorHeader();
#    print "<h1>Error:  Invalid option for Investment!</h1>\n";
#    print "$sys_admin";
#    CleanUp();
#  }
#  if ($report eq "1099_reconciliation")
#  {
#    $report_name = "1099 Reconciliation";
#  }
#  elsif ($report eq "investment_performance")
#  {
#    $report_name = "Investment Performance";
#  }
#  elsif ($report eq "capital_gains")
#  {
#    $report_name = "Capital Gains";
#  }
#  elsif ($report eq "investment_transactions")
#  {
#    $report_name = "Investment Transactions";
#  }
#  elsif ($report eq "price_comparison")
#  {
#    $report_name = "Price Comparison";
#  }
#  elsif ($report eq "portfolio_value")
#  {
#    $report_name = "Portfolio Value";
#  }
#}
#elsif ($report_group eq "analysis")
#{
#  if (not ($report eq "quick_ratio" || $report eq "current_ratio" || $report eq "inventory_turnover" || $report eq "accounts_receivable_turnover" || $report eq "days_sales_in_receivables" || $report eq "debt_ratio" || $report eq "times_interest_earned_ratio" || $report eq "return_on_net_sales" || $report eq "return_on_total_assets" || $report eq "return_on_common_stockholders_equity" || $report eq "eps_common_stock" || $report eq "pe" || $report eq "dividend_yield" || $report eq "book_value"))
#  {
#    PrintErrorHeader();
#    print "<h1>Error:  Invalid option for Analysis!</h1>\n";
#    print "$sys_admin";
#    CleanUp();
#  }
#  if ($report eq "quick_ratio")
#  {
#    $report_name = "Quick Ratio";
#  }
#  elsif ($report eq "current_ratio")
#  {
#    $report_name = "Current Ratio";
#  }
#  elsif ($report eq "inventory_turnover")
#  {
#    $report_name = "Inventory Turnover";
#  }
#  elsif ($report eq "accounts_receivable_turnover")
#  {
#    $report_name = "Accounts Receivable Turnover";
#  }
#  elsif ($report eq "days_sales_in_receivables")
#  {
#    $report_name = "Days Sales in Receivables";
#  }
#  elsif ($report eq "debt_ratio")
#  {
#    $report_name = "Debt Ratio";
#  }
#  elsif ($report eq "times_interest_earned_ratio")
#  {
#    $report_name = "Times-Interest-Earned Ratio";
#  }
#  elsif ($report eq "return_on_net_sales")
#  {
#    $report_name = "Return on Net Sales";
#  }
#  elsif ($report eq "return_on_total_assets")
#  {
#    $report_name = "Return on Total Assets";
#  }
#  elsif ($report eq "return_on_common_stockholders_equity")
#  {
#    $report_name = "Return on Common Stockholders Equity";
#  }
#  elsif ($report eq "eps_common_stock")
#  {
#    $report_name = "EPS Common Stock";
#  }
#  elsif ($report eq "pe")
#  {
#    $report_name = "PE";
#  }
#  elsif ($report eq "dividend_yield")
#  {
#    $report_name = "Dividend Yield";
#  }
#  elsif ($report eq "book_value")
#  {
#    $report_name = "Book Value";
#  }
#}

if ($report_group eq "bookkeeping")
{
  $group_name = "Bookkeeping";
}
elsif ($report_group eq "payroll")
{
  $group_name = "Payroll";
}
#elsif ($report_group eq "asset")
#{
#  $group_name = "Asset";
#}
#elsif ($report_group eq "investment")
#{
#  $group_name = "Investment";
#}
#elsif ($report_group eq "analysis")
#{
#  $group_name = "Analysis";
#}

# check to see if we are running under mod_perl
if (exists $ENV{MOD_PERL})
{
  # check to see if the database is still connected
  if (defined $conn)
  {
    # check the status of the connection
    if ($conn->status != PGRES_CONNECTION_OK)
    {
      $database_connected = 0;
    }
    else
    {
      # connection still good!
      $database_connected = 1;
    }
  }
  else
  {
    $database_connected = 0;
  }
}

if (not $database_connected)
{
  # connect to the database.
  $conn = Pg::connectdb("host = $db_host dbname = $db_name user = $db_user password = $db_passwd");
  if ($conn->status == PGRES_CONNECTION_BAD)
  {
    PrintErrorHeader();
    print "<h1>Error:  Couldn't connect to the database!</h1><br>\n";
    print $conn->errorMessage . "<br>$sys_admin";
    CleanUp();
  }
}

# set the DateStyle for the Database.
$result = setDBDateStyle($conn);
if ($result->resultStatus != PGRES_COMMAND_OK)
{
  PrintErrorHeader();
  print "<h1>Error:  Setting Date Style failed!</h1>\n";
  print $conn->errorMessage . "<br>$sys_admin";
  CleanUp();
}

$result = $conn->exec("select name from entity_tb where database_name = '$ledger_db'");
if ($result->resultStatus != PGRES_TUPLES_OK)
{
  PrintErrorHeader();
  print "<h1>Error: Accessing database failed!</h1>\n";
  print "Trying to check entity table.<br>$sys_admin";
  CleanUp();
}
if ($result->ntuples == 0)
{
  PrintErrorHeader();
  print "<h1>Error: Ledger <font color=\"blue\">$ledger_db</font> does not exist!</h1>\n";
  print "$sys_admin";
  CleanUp();
}
$ledger_name = $result->getvalue(0, 0);

# create the reports object
$report_obj = reports->new($conn, $ledger_db);
if ($report_obj->didErrorOccur())
{
  PrintErrorHeader();
  print $report_obj->getErrorMessage();
  CleanUp();
}
$ledger_code = $report_obj->getLedgerCode();
if ($report_obj->didErrorOccur())
{
  PrintErrorHeader();
  print $report_obj->getErrorMessage();
  CleanUp();
}
$ledger_color = $report_obj->getLedgerColor();
if ($report_obj->didErrorOccur())
{
  PrintErrorHeader();
  print $report_obj->getErrorMessage();
  CleanUp();
}

# lookup the accounts needed for this report, if any.

if ($report_group eq "bookkeeping")
{
}
elsif ($report_group eq "payroll")
{
}
#elsif ($report_group eq "asset")
#{
#}
#elsif ($report_group eq "investment")
#{
#}
#elsif ($report_group eq "analysis")
#{
#}

# actually do the report without displaying anything yet.
if (exists $WorkFunctions{$report} && $WorkFunctions{$report} ne "Define")
{
  $WorkFunctions{$report}->();
}
#elsif ($report eq "asset_valuation")
#{
#}
#elsif ($report eq "depreciation")
#{
#}
#elsif ($report eq "1099_reconciliation")
#{
#}
#elsif ($report eq "investment_performance")
#{
#}
#elsif ($report eq "capital_gains")
#{
#}
#elsif ($report eq "investment_transactions")
#{
#}
#elsif ($report eq "price_comparison")
#{
#}
#elsif ($report eq "portfolio_value")
#{
#}
#elsif ($report eq "quick_ratio")
#{
#}
#elsif ($report eq "current_ratio")
#{
#}
#elsif ($report eq "inventory_turnover")
#{
#}
#elsif ($report eq "accounts_receivable_turnover")
#{
#}
#elsif ($report eq "days_sales_in_receivables")
#{
#}
#elsif ($report eq "debt_ratio")
#{
#}
#elsif ($report eq "times_interest_earned_ratio")
#{
#}
#elsif ($report eq "return_on_net_sales")
#{
#}
#elsif ($report eq "return_on_total_assets")
#{
#}
#elsif ($report eq "return_on_common_stockholders_equity")
#{
#}
#elsif ($report eq "eps_common_stock")
#{
#}
#elsif ($report eq "pe")
#{
#}
#elsif ($report eq "dividend_yield")
#{
#}
#elsif ($report eq "book_value")
#{
#}

my $print_str;
$print_str = "";
if ($print_report)
{
  $print_str = "- Printable Version";
}

print "<head><title>$prog_name $prog_version - '$report_name' Report in Ledger '$ledger_name' $print_str</title>\n";

# put in any JavaScript code here that any reports need.
if (exists $JavaScriptFunctions{$report} && $JavaScriptFunctions{$report} ne "Define")
{
  $JavaScriptFunctions{$report}->();

  # now display the style blocks that will cause the layers to display correctly (only if not printing)
  if (!$print_report)
  {
    print "<STYLE TYPE=\"text/css\">\n";
    print "#spacer { position: absolute; height: ". (($num_list_entries + 1) * $list_height) . "; }\n";
    print "</STYLE>\n";
    print "<STYLE TYPE=\"text/css\">\n";
    for (my $k=0; $k < $num_list_entries; $k++)
    {
      print "#lItem$k { position:absolute; }\n";
    }
    print "</STYLE>\n";
  }
}

if ($report eq "income_statement" || $report eq "cash_flow")
{
  reports4IncomeStatementCashFlowJavaScript();
}

print "</head>\n";
if (($report eq "income_statement" || $report eq "quarterly_income_statement" || $report eq "cash_flow" || $report eq "balance_sheet") && (not $print_report))
{
  print "<body bgcolor=$body_bgcolor onLoad=\"InitializeArray();\">\n";
}
else
{
  print "<body bgcolor=$body_bgcolor>\n";
}
print <<"END_OF_STYLE";
<style type="text/css"><!--
  a:hover   { color: blue }
  a:link    { text-decoration: none; color: blue }
  a:visited { text-decoration: none; color: blue }
  a:active  { text-decoration: none; color: blue }-->
</style>
<script language=\"Javascript1.2\" src=\"../js/common.js\"></script>
END_OF_STYLE
# get the date
$date = `/bin/date +%m-%d-%Y`;
chomp $date;

print "<center>\n";
print "<table border=0 width=100% cellspacing=0 cellpadding=2 bgcolor=\"$body_bgcolor\">\n";
print "<tr>\n";
print "<td width=35%>Ledger <font color=\"$ledger_color\">$ledger_name</font>";
if ($report eq "income_statement")
{ # indicate the type of Income Statement incase the user doesn't.
  if ($tos eq "tax")
  {
    print "&nbsp;(T)";
  }
  else
  {
    print "&nbsp;(G)";
  }
}
print "</td>\n";
print "<td align=center width=30%>";
if ($print_report)
{
  print "<font face='$font_str' size=$font_size_text>";
}
print "<h3>$custom_title</h3>";
if ($print_report)
{
  print "</font>";
}
print "</td>\n";
print "<td align=right>$date</td></tr>\n";
if (length $date_range_string > 0)
{
  print "<tr><td width=35%><br></td><td align=center width=30%>$date_range_string</td><td><br></td></tr>\n";
}
print "</table><br>\n";

# display the selected reports results
if (exists $DisplayFormFunctions{$report} && $DisplayFormFunctions{$report} ne "Define")
{
  $DisplayFormFunctions{$report}->();
  if (!$print_report)
  {
    # print the DIV blocks in the body to allow the layers to properly showup.
    print "<DIV ID=\"spacer\"></DIV>\n";
    for (my $k=0; $k < $num_list_entries; $k++)
    {
      print "<DIV ID=\"lItem$k\" NAME=\"lItem$k\"></DIV>\n";
    }
  }
}
#elsif ($report eq "asset_valuation")
#{
#}
#elsif ($report eq "depreciation")
#{
#}
#elsif ($report eq "1099_reconciliation")
#{
#}
#elsif ($report eq "investment_performance")
#{
#}
#elsif ($report eq "capital_gains")
#{
#}
#elsif ($report eq "investment_transactions")
#{
#}
#elsif ($report eq "price_comparison")
#{
#}
#elsif ($report eq "portfolio_value")
#{
#}
#elsif ($report eq "quick_ratio")
#{
#}
#elsif ($report eq "current_ratio")
#{
#}
#elsif ($report eq "inventory_turnover")
#{
#}
#elsif ($report eq "accounts_receivable_turnover")
#{
#}
#elsif ($report eq "days_sales_in_receivables")
#{
#}
#elsif ($report eq "debt_ratio")
#{
#}
#elsif ($report eq "times_interest_earned_ratio")
#{
#}
#elsif ($report eq "return_on_net_sales")
#{
#}
#elsif ($report eq "return_on_total_assets")
#{
#}
#elsif ($report eq "return_on_common_stockholders_equity")
#{
#}
#elsif ($report eq "eps_common_stock")
#{
#}
#elsif ($report eq "pe")
#{
#}
#elsif ($report eq "dividend_yield")
#{
#}
#elsif ($report eq "book_value")
#{
#}

print "</body>\n";
print "</html>\n";
exit 0;
