#$Id: reports_income_statement.pm,v 1.2 2004/08/31 20:55:29 moreejt Exp $
#This package is released under the GNU General Public License.
#You should have recieved a copy of the GPL with it.
# Copyright (c) 2000 HLR http://www.pcxperience.org  All rights reserved.
sub reports3IncomeStatementCustomizedFormItems
{
  print <<"END_OF_FORM";
  <tr><td align=center><font color=\"$menu_fgcolor\">Type of Income Statement:&nbsp;</font><select name=\"tos\">
  <option value=\"services\">Goods & Services
  <option value=\"investment\">Investment
  </select></td></tr>
  <input type=hidden name=\"tos\" value=\"tax\">
  <!-- <tr><td align=center><font color=\"$menu_fgcolor\">CoGS Goes in:&nbsp;</font><select name=\"cogs_location\">
  <option value=\"revenue\">Revenue
  <option value=\"expenses\">Expenses
  </select></td></tr> -->
  <tr><td align=center><select name=\"years\" multiple size=\"6\">
END_OF_FORM
  # walk through the list of known years and put them in a multi-select combo box.
  my ($i, $year, $closed);
  for ($i=0; $i < $known_years->ntuples; $i++)
  {
    $year = $known_years->getvalue($i, 0);
    $closed = $known_years->getvalue($i, 1);

    if ($closed eq "t")
    {
      print "<option value=\"$year\">$year\n";
    }
    else
    {
      print "<option value=\"$year\">$year (Open)\n";
    }
  }
  print "</select></td></tr>\n";
}

sub reports4IncomeStatementWork
{
  # @Data will have the following structure:
  # Account Type info:  name, num, debit_increases, first_digit, [balance], num_accounts, [accounts]
  # [balance] will have: balance1, balance2, balance3, balance4
  # [accounts] will have: name, num, sub_accts, [year1], [year2], [year3], [year4]
  # sub_accts is a string of | seperated names of the sub-accts that exist for each account.
  # [yearX] will have: f_year, balance, num_entries, [entries]
  # [entries] will have: ref_num, journal_code, payer_payee, memo, sub_entity_code, date, amount, dorc, sub-acct_name ("----" for none)

  my @Years = split /,/, $years;

  # get the Revenue data and the Expense data
  $result2 = $conn->exec("select name, num, debit_increases, first_digit from acct_type_tb where num >= 9 and num <= 16 order by num");
  if ($result2->resultStatus != PGRES_TUPLES_OK)
  {
    print "<h1>Error:  Accessing database failed!</h1>\n";
    print $conn->errorMessage . "<br>Tried to get Account Types.<br>$sys_admin";
    CleanUp();
  }
  if ($result2->ntuples == 0)
  {
    print "<h1>Error:  Program is not configured!</h1>\n";
    print "Account Types table is not filled in!<br>$sys_admin";
    CleanUp();
  }

  for ($i=0; $i < $result2->ntuples; $i++)  # loop through all Account Type entries returned and gather data for each.
  {
    my ($acct_type_name, $acct_type_num, $debit_increases, $first_digit);
    $acct_type_name  = $result2->getvalue($i, 0);
    $acct_type_num   = $result2->getvalue($i, 1);
    $debit_increases = $result2->getvalue($i, 2);
    $first_digit     = $result2->getvalue($i, 3);

    # store this Account Type's info in the Data structure
    my ($j, $result3, $result4, @running_balance, @Acct_data);
    for ($j=0; $j <= 3; $j++)
    {
      $Data[$i][$j] = $result2->getvalue($i, $j);
    }

    # Find all accounts for this account type in the Global Database
    $result3 = $conn->exec("select name, number from account_tb where type = $acct_type_num order by number");
    if ($result3->resultStatus != PGRES_TUPLES_OK)
    {
      print "<h1>Error:  Accessing database failed!</h1>\n";
      print $conn->errorMessage . "<br>Tried to get list of Accounts for Account Type <font color=\"blue\">$acct_type_name</font>.<br>$sys_admin";
      CleanUp();
    }

    if ($result3->ntuples == 0)
    {
      $Data[$i][4][0] = "0.00";
      $Data[$i][4][1] = "0.00";
      $Data[$i][4][2] = "0.00";
      $Data[$i][4][3] = "0.00";
      $Data[$i][5] = 0;
    }
    else
    {
      my ($acct_num_list, $acct_name_list, @acct_type_balance, $acct_name, $acct_number);
      for ($j=0; $j < $result3->ntuples; $j++)
      {
        $acct_name = $result3->getvalue($j, 0);
        $acct_number = $result3->getvalue($j, 1);

        $acct_num_list .= ", " if ($j > 0);
        $acct_name_list .= ", " if ($j > 0);
        $acct_num_list .= $acct_number;
        $acct_name_list .= $acct_name;
      }

      $acct_type_balance[0] = "0.00";
      $acct_type_balance[1] = "0.00";
      $acct_type_balance[2] = "0.00";
      $acct_type_balance[3] = "0.00";

      # now ask for any accounts that exist in the local_accounts_tb of the ledger that match.
      # do something special if we are doing a tax report.
      if ($tos eq "tax" && $acct_type_num != 15)
      {
        $result3 = $conn->exec("select acct_num from local_accounts_tb where taxable = true and acct_num in ($acct_num_list) and sub_entity_code is null AND ledger_code = '$ledger_code' order by acct_num");
      }
      else
      {
        $result3 = $conn->exec("select acct_num from local_accounts_tb where acct_num in ($acct_num_list) and sub_entity_code is null AND ledger_code = '$ledger_code' order by acct_num");
      }
      if ($result3->resultStatus != PGRES_TUPLES_OK)
      {
        print "<h1>Error:  Accessing database failed!</h1>\n";
        print $conn->errorMessage . "<br>Tried to get list of Accounts to work with based on the Local Accounts Table.<br>List = $acct_num_list<br>$acct_name_list<br>$sys_admin";
        CleanUp();
      }

      $Data[$i][5] = $result3->ntuples;
      if ($result3->ntuples == 0)
      {
        $Data[$i][4] = [ @acct_type_balance ];
      }
      else
      {
        # now we have a list of accounts to work with for this Account Type that exist in the Ledger and may also be taxable if so desired.
        for ($j=0; $j < $result3->ntuples; $j++)
        {
          $acct_number = $result3->getvalue($j, 0);

          # now we find the name of the account
          $result4 = $conn->exec("select name from account_tb where number = $acct_number");
          if ($result4->resultStatus != PGRES_TUPLES_OK)
          {
            print "<h1>Error:  Accessing database failed!</h1>\n";
            print $conn->errorMessage . "<br>Tried to get the name of the account with number = '$acct_number'.<br>$sys_admin";
            CleanUp();
          }
          if ($result4->ntuples == 0)
          {
            print "<h1>Error:  Program is not configured properly!</h1>\n";
            print "The Account with Number = '$acct_number' does not have a name!<br>$sys_admin";
            CleanUp();
          }
          $acct_name = $result4->getvalue(0, 0);

          # assign this accounts info to the Acct_data array.
          $Acct_data[$j][0] = $acct_name;
          $Acct_data[$j][1] = $acct_number;

          my %sub_accounts;  # the hash to hold the sub-accounts encountered for this account.

          # now we lookup all activity that this account had for each year specified.
          my ($k, $tmp_year);
          for ($k=0; $k < scalar @Years; $k++)
          {
            $tmp_year = $Years[$k];

            my ($balance, @Entries, @YearX, $start_date, $end_date);
            $balance = "0.00";

            # get the start and end dates for the fiscal year specified
            $result4 = $conn->exec("select start_date, end_date from known_years_tb where year = $tmp_year AND ledger_code = '$ledger_code'");
            if ($result4->resultStatus != PGRES_TUPLES_OK)
            {
              print "<h1>Error:  Accessing database failed!</h1>\n";
              print $conn->errorMessage . "<br>Tried to get the start and stop dates of fiscal year = '$tmp_year'.<br>$sys_admin";
              CleanUp();
            }
            if ($result4->ntuples == 0)
            {
              print "<h1>Error:  Program is not configured properly!</h1>\n";
              print "Fiscal Year = '$tmp_year' does not have start and stop dates specified!<br>$sys_admin";
              CleanUp();
            }
            $start_date = $result4->getvalue(0, 0);
            $end_date   = $result4->getvalue(0, 1);

            # record what year this YearX is working with
            $YearX[0] = $tmp_year;

            if ($acct_type_num == 15)
            {
              $result4 = $conn->exec("select amount, dorc, parent_num, sub_e_code, sub_account_num from debitcredit_tb where account_num = $acct_number and sub_account_num = $tmp_year AND ledger_code = '$ledger_code'");
            }
            else
            {
              $result4 = $conn->exec("select amount, dorc, parent_num, sub_e_code, sub_account_num from debitcredit_tb where account_num = $acct_number and parent_num in (select ref_num from journal_entry_tb where (trans_date >= '$start_date' and trans_date <= '$end_date') AND ledger_code = '$ledger_code') AND ledger_code = '$ledger_code' order by parent_num");
            }
            if ($result4->resultStatus != PGRES_TUPLES_OK)
            {
              print "<h1>Error:  Accessing database failed!</h1>\n";
              print $conn->errorMessage . "<br>Tried to get transactions for Account = '$acct_number', Fiscal Year = '$tmp_year'.<br>$sys_admin";
              CleanUp();
            }
            $YearX[2] = $result4->ntuples;  # number of entries to work with.
            if ($result4->ntuples > 0)
            {
              my ($l, $amount, $dorc, $ref_num, $sub_e_code, $sub_account_num, $sub_account_name, $journal_code, $payer_payee, $memo, $entry_date, $result5);
              for ($l=0; $l < $result4->ntuples; $l++)
              {
                $amount = $result4->getvalue($l, 0);
                # cut the $ off the front.
                $amount =~ s/^\$//;
                $amount =~ s/,//g; # remove any commas.
                $dorc = $result4->getvalue($l, 1);
                $ref_num = $result4->getvalue($l, 2);
                $sub_e_code = $result4->getvalue($l, 3);
                $sub_account_num = $result4->getvalue($l, 4);

                # get the info for this transaction from the journal_entry_tb
                $result5 = $conn->exec("select journal_code, trans_date, payee_payer, memo from journal_entry_tb where ref_num = $ref_num AND ledger_code = '$ledger_code'");
                if ($result5->resultStatus != PGRES_TUPLES_OK)
                {
                  print "<h1>Error:  Accessing database failed!</h1>\n";
                  print $conn->errorMessage . "<br>Tried to get Transaction info for Transaction with Ref_num = '$ref_num'.<br>$sys_admin";
                  CleanUp();
                }
                if ($result5->ntuples == 0)
                {
                  print "<h1>Error:  Program is not configured!</h1>\n";
                  print "Journal Entry is not created for Transaction with Ref_num = '$ref_num'!<br>$sys_admin";
                  CleanUp();
                }
                $journal_code = $result5->getvalue(0, 0);
                $entry_date = $result5->getvalue(0, 1);
                $payer_payee = $result5->getvalue(0, 2);
                $payer_payee =~ s/'/\\'/g;  # replace all ' with \'
                $memo = $result5->getvalue(0, 3);
                $memo =~ s/'/\\'/g;  # replace all ' with \'

                $sub_account_name = "----";

                # get the name of the sub-account if it isn't equal to -1
                if ($sub_account_num != -1)
                {
                  $result5 = $conn->exec("select sub_acc_name from sub_acc_tb where sub_acc_number = $sub_account_num and parent = $acct_number");
                  if ($result5->resultStatus != PGRES_TUPLES_OK)
                  {
                    print "<h1>Error:  Accessing database failed!</h1>\n";
                    print $conn->errorMessage . "<br>Tried to get Sub Account Name for Sub Account = '$sub_account_num'.<br>$sys_admin";
                    CleanUp();
                  }
                  if ($result5->ntuples == 0)
                  {
                    print "<h1>Error:  Program is not configured!</h1>\n";
                    print "Sub Account is not properly configured for Sub Account with Number = '$sub_account_num', Parent = '$acct_number'!<br>$sys_admin";
                    CleanUp();
                  }
                  $sub_account_name = $result5->getvalue(0, 0);
                }

                # add this transactions info to the array of Entries
                $Entries[$l][0] = $ref_num;
                $Entries[$l][1] = $journal_code;
                $Entries[$l][2] = $payer_payee;
                $Entries[$l][3] = $memo;
                $Entries[$l][4] = $sub_e_code;
                $Entries[$l][5] = $entry_date;
                $Entries[$l][6] = $amount;
                $Entries[$l][7] = $dorc;
                $Entries[$l][8] = $sub_account_name;

                # update the hash of sub-accounts encountered
                $sub_accounts{$sub_account_name} = $sub_account_name;

                # update the account balance and the Account Type balance.

                if ($debit_increases eq "t" && $dorc eq "t") # debit increases and amount is a debit
                {
                  $acct_type_balance[$k] += $amount;
                  $balance += $amount;
                }
                elsif ($debit_increases eq "t" && $dorc eq "f") # debit increases and amount is a credit
                {
                  $acct_type_balance[$k] -= $amount;
                  $balance -= $amount;
                }
                elsif ($debit_increases eq "f" && $dorc eq "t") # debit decreases and amount is a debit
                {
                  $acct_type_balance[$k] -= $amount;
                  $balance -= $amount;
                }
                elsif ($debit_increases eq "f" && $dorc eq "f") # debit decreases and amount is a credit
                {
                  $acct_type_balance[$k] += $amount;
                  $balance += $amount;
                }
              }
            }
            $acct_type_balance[$k] = sprintf "%.2f", $acct_type_balance[$k];
            $balance = sprintf "%.2f", $balance;

            # update the YearX array
            $YearX[1] = $balance;
            $YearX[3] = [ @Entries ];

            # now add this YearX array to the Acct_data array
            $Acct_data[$j][3+$k] = [ @YearX ];
          }
          # now we extract the list of all sub_accounts encountered and create the | seperated string
          my $tmp_string;
          $tmp_string = join '|', (sort keys %sub_accounts);

          $Acct_data[$j][2] = $tmp_string;
        }
        $Data[$i][6] = [ @Acct_data ];
        $Data[$i][4] = [ @acct_type_balance ];
      }
    }
  }
}

sub reports4IncomeStatementDisplayForm
{
  # @Data will have the following structure:
  # Account Type info:  name, num, debit_increases, first_digit, [balance], num_accounts, [accounts]
  # [balance] will have: balance1, balance2, balance3, balance4
  # [accounts] will have: name, num, sub_accts, [year1], [year2], [year3], [year4]
  # sub_accts is a string of | seperated names of the sub-accts that exist for each account.
  # [yearX] will have: f_year, balance, num_entries, [entries]
  # [entries] will have: ref_num, journal_code, payer_payee, memo, sub_entity_code, date, amount, dorc, sub-acct_name ("----" for none)

  # create the header string to be displayed in the printable version of the report.
  my $header_string = "<center><table border=0 width=100% cellspacing=0 cellpadding=2 bgcolor=\"$body_bgcolor\"><tr><td width=35%>Ledger <font color=\"$ledger_color\">$ledger_name</font>";
  if ($tos eq "services")
  {
    $header_string .= "&nbsp;(S)";
  }
  else
  {
    $header_string .= "&nbsp;(I)";
  }
  $header_string .= "</td><td align=center width=30%><h3>$custom_title</h3></td><td align=right>$date</td></tr>";
  if (length $date_range_string > 0)
  {
    $header_string .= "<tr><td width=35%><br></td><td align=center width=30%>$date_range_string</td><td><br></td></tr>";
  }
  $header_string .= "</table><br>";
  my $num_years = split /,/, $years;  # number of years to display.
  my (@total_revenue, @total_expenses);

  my $year_header_string = "<table border=0 width=90% cellspacing=0 cellpadding=2 bgcolor=\"$body_bgcolor\">";
  $year_header_string .= "<tr><td width=40% align=left><br></td>";
  for ($i=0; $i < $num_years; $i++)
  {
    my $width = int (60 / $num_years);
    my @Years = split /,/, $years;
    my $tmp_year = $Years[$i];
    $year_header_string .= "<td width=$width% align=right><b>$tmp_year</b>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>";
  }
  $year_header_string .= "</tr></table>";

  $result = $conn->exec("select working_year('$ledger_code')");
  if ($result->resultStatus != PGRES_TUPLES_OK)
  {
    print "<h1>Error:  Accessing database failed!</h1>\n";
    print $conn->errorMessage . "<br>Tried to get current fiscal year from database.<br>$sys_admin";
    CleanUp();
  }
  if ($result->ntuples == 0)
  {
    print "<h1>Error:  Current Fiscal Year not configured!</h1>\n";
    print "The Current Fiscal Year is not set!<br>$sys_admin";
    CleanUp();
  }
  my $curr_fiscal_year = $result->getvalue(0, 0);

  print "<script language=Javascript1.2>\n";
  print "  var header_string='$header_string';\n";
  print "  var year_header_string='$year_header_string';\n";
  print "  var body_bgcolor=\"$body_bgcolor\";\n";
  print "  var current_fiscal_year=$curr_fiscal_year;\n";
  print "</script>\n";

  # display the Print Button
  print "<form name=\"Dummy_form\">\n";
  print "<div align=right><input type=button name=\"Print\" value=\"Print View\" onClick=\"printReport('Income Statement Report', year_header_string);\"></div>\n";
  print "</form>\n";

  #print "<table border=0 height=" . (($num_list_entries + 1) * $list_height) . "><tr><td></td></tr></table>\n";
}

sub reports4IncomeStatementJavaScript
{
  my $time = `/bin/date +%s`;
  chomp $time;

  print "<script language=\"JavaScript1.2\" SRC=\"../js/resize.js\"></script>\n";
  print "<script language=\"JavaScript1.2\" SRC=\"../js/list.js\"></script>\n";
  print "<script language=JavaScript1.2>\n";
  print "var Data = new Array();\n";
  print "var Data_Strings = new Array();\n";
  print "// Other Global Variables\n";
  print "var Ledger = \"$ledger_db\";\n";
  print "var Site_Dir = \"$site_dir\";\n";
  my $num_years = split /,/, $years;  # get the number of years to really work with.
  print "var NumYears = $num_years;\n\n";
  print "// Data will have the following structure:\n";
  print "// Account Type info:  name, num, debit_increases, first_digit, [balance], num_accounts, [accounts]\n";
  print "// [balance] will have: balance1, balance2, balance3, balance4\n";
  print "// [accounts] will have: name, num, sub_accts, [year1], [year2], [year3], [year4]\n";
  print "// sub_accts is a string of | seperated names of the sub-accts that exist for each account.\n";
  print "// [yearX] will have: f_year, balance, num_entries, [entries]\n";
  print "// [entries] will have: ref_num, journal_code, payer_payee, memo, sub_entity_code, date, amount, dorc, sub-acct_name (\"----\" for none)\n\n";
  print "  function InitializeArray()\n";
  print "  {\n";

  # create the JavaScript Array of data from the Perl array.
  my ($i, $j, $k, $l);
  my $CoGSfound = 0;
  my $SalesRevfound = 0;
  LOOP: for ($i=0; $i < scalar @Data; $i++)
  {
    my ($temp_str);

    # if this is Sales Revenue (10) then we also need to do CoGS (14) and then later skip CoGS.

    if ($Data[$i][1] == 14)
    {
      $CoGSfound = 1;
      next LOOP;
    }

    $temp_str = "'" . $Data[$i][0] . "'," . $Data[$i][1] . ",'" . $Data[$i][2] . "'," . $Data[$i][3] . ",['" . $Data[$i][4][0] . "','" . $Data[$i][4][1] . "','" . $Data[$i][4][2] . "','" . $Data[$i][4][3] . "']," . $Data[$i][5] . ",[";
    # Generate the Account Array structure.
    my @Accounts = @{$Data[$i][6]};
    for ($j=0; $j < $Data[$i][5]; $j++)
    {
      $temp_str .= "['" . $Accounts[$j][0] . "'," . $Accounts[$j][1] . ",'" . $Accounts[$j][2] . "'";
      # Generate the Years.
      for ($k=3; $k <= 6; $k++)
      {
        my @YearX = @{$Accounts[$j][$k]};
        $temp_str .= ",[" . $YearX[0] . ",'" . $YearX[1] . "'," . $YearX[2] . ",[";
        my @Entries = @{$YearX[3]};
        for ($l=0; $l < $YearX[2]; $l++)
        {
          $temp_str .= "[" . $Entries[$l][0] . ",'" . $Entries[$l][1] . "','" . $Entries[$l][2] . "','" . $Entries[$l][3] . "','" . $Entries[$l][4] . "','" . $Entries[$l][5] . "','" . $Entries[$l][6] . "','" . $Entries[$l][7] . "','" . $Entries[$l][8] . "']";
          if ($l < $YearX[2] - 1)
          {
            $temp_str .= ",";
          }
        }
        $temp_str .= "]]";
      }
      $temp_str .= "]";
      if ($j < $Data[$i][5] - 1)
      {
        $temp_str .= ",";
      }
    }

    my $location = $i;
    $location++ if ($SalesRevfound);
    $location-- if ($CoGSfound);

    $temp_str .= "]";  # Close the Account Array structure.
    print "    Data[$location] = [$temp_str];\n";
    print "    Data_Strings[$location] = \"[$temp_str]\";\n";

    if ($Data[$i][1] == 10)
    {
      $SalesRevfound = 1;
      # find the CoGS entry and display it
      cogs: for ($j=$i; $j < scalar @Data; $j++)
      {
        last cogs if ($Data[$j][1] == 14);
      }
      my $location = $i + 1;
      my $i=$j;  # temporarily replace the value of $i with $j.
      $temp_str = "'" . $Data[$i][0] . "'," . $Data[$i][1] . ",'" . $Data[$i][2] . "'," . $Data[$i][3] . ",['" . $Data[$i][4][0] . "','" . $Data[$i][4][1] . "','" . $Data[$i][4][2] . "','" . $Data[$i][4][3] . "']," . $Data[$i][5] . ",[";
      # Generate the Account Array structure.
      my @Accounts = @{$Data[$i][6]};
      for ($j=0; $j < $Data[$i][5]; $j++)
      {
        $temp_str .= "['" . $Accounts[$j][0] . "'," . $Accounts[$j][1] . ",'" . $Accounts[$j][2] . "'";
        # Generate the Years.
        for ($k=3; $k <= 6; $k++)
        {
          my @YearX = @{$Accounts[$j][$k]};
          $temp_str .= ",[" . $YearX[0] . ",'" . $YearX[1] . "'," . $YearX[2] . ",[";
          my @Entries = @{$YearX[3]};
          for ($l=0; $l < $YearX[2]; $l++)
          {
            $temp_str .= "[" . $Entries[$l][0] . ",'" . $Entries[$l][1] . "','" . $Entries[$l][2] . "','" . $Entries[$l][3] . "','" . $Entries[$l][4] . "','" . $Entries[$l][5] . "','" . $Entries[$l][6] . "','" . $Entries[$l][7] . "','" . $Entries[$l][8] . "']";
            if ($l < $YearX[2] - 1)
            {
              $temp_str .= ",";
            }
          }
          $temp_str .= "]]";
        }
        $temp_str .= "]";
        if ($j < $Data[$i][5] - 1)
        {
          $temp_str .= ",";
        }
      }

      $temp_str .= "]";  # Close the Account Array structure.
      print "    Data[$location] = [$temp_str];\n";
      print "    Data_Strings[$location] = \"[$temp_str]\";\n";
    }
  }

  print "    // Call init() to start the Dynamic Lists\n";
  print "    init();\n";
  print "  }\n\n";
  print << "JAVA_CODE";
  function SubmitEditForm(w, ref_num)
  {
    win = window.open("", w);
    win.document.Detailed_View.action = Site_Dir + "/cgi-bin/journal_activity.cgi";
    win.document.Detailed_View.journal_entry_0.value = ref_num;
    //alert("Ref_Num = " + win.document.Detailed_View.journal_entry_0.value);
    win.document.Detailed_View.submit();
    return false;
  }
  function SubmitViewForm(w, ref_num)
  {
    win = window.open("", w);
    win.document.Detailed_View.action = Site_Dir + "/cgi-bin/journal_mod1.cgi";
    win.document.Detailed_View.ref_num.value = ref_num;
    //alert("Ref_Num = " + win.document.Detailed_View.ref_num.value);
    win.document.Detailed_View.submit();
    return false;
  }

  function display_entries(Acct_Type_num, Acct_Num, Year, Sub_Acct_Name)
  {
    var w = window.open("", "display_entries_$time", "status=yes,menubar=yes,resizeable=yes,toolbar=yes,location=yes,scrollbars=yes");
    var d = w.document;
    var i, j, k, found;

    d.open();

    d.writeln("<html>");
    d.writeln("<head><title>Income Statement Detailed View</title></head>");
    d.writeln("<body bgcolor=#ffffff>");
    // Display the Main Header
    d.writeln(header_string);

    // Now we need to lookup in the Data Array and find the Account Type entry that has num = Acct_Type_num.
    for (i=0, found=0; i < Data.length && !found; i++)
    {
      if (Data[i][1] == Acct_Type_num)
      {
        found = 1;  // Signal we found the item.
      }
    }
    i--;  // correct for the increment.

    if (!found)
    {
      alert("Error:  The Account Type could not be found with Number = " + Acct_Type_num + "! Notify Systems Administrator.");
      d.close();
      return;
    }

    // i now holds the index into Data of the Account Type specified.

    // Now we need to find the Account in Data[i][6] that has num = Acct_Num.
    for (j=0, found=0; j < Data[i][5] && !found; j++)
    {
      if (Data[i][6][j][1] == Acct_Num)
      {
        found = 1;  // Signal we found the Account.
      }
    }
    j--;  // correct for the increment.

    if (!found)
    {
      alert("Error:  The Account could not be found with Number = " + Acct_Num + "! Notify Systems Administrator.");
      d.close();
      return;
    }

    // j now holds the index into Data[i][6] of the Account specified.

    // Now we need to find the Year in Data[i][6][3-6] that has f_year = Year.
    for (k=0, found=0; k < NumYears; k++)
    {
      if (Data[i][6][j][3+k][0] == Year)
      {
        found = 1;  // Signal we found the Year.
      }
    }
    k--;  // correct for the increment.

    if (!found)
    {
      alert("Error:  The Year could not be found with f_year = " + Year + "! Notify Systems Administrator.");
      d.close();
      return;
    }

    // k now holds the index into Data[i][6][j][3+k] of the Year specified.

    // now we open a table and walk through the Year entry and display all lines that have sub-acct_name = Sub_Acct_Name.
    d.writeln("<table border=0 cellspacing=0 cellpadding=0 width=90%>");
    if (Sub_Acct_Name != "____")
    {
      d.writeln("<tr><td align=left><h3>Sub Account=<font color=red>", Sub_Acct_Name, "</font></h3></td></tr>");
    }
    else
    {
      Sub_Acct_Name = "----";
    }

    d.writeln("<tr><td align=left><h4>Account=", Data[i][6][j][0], "</h4></td></tr>");
    d.writeln("<tr><td align=left>Year=", Year, "<br></td></tr>");
    d.writeln("</table>");
    //d.writeln("<h4>Account Type=",Data[i][0],", Account=",Data[i][6][j][0],", Sub Account=<font color=red>",Sub_Acct_Name,"</font>, Year=",Year,"</h4>");
    //if (current_fiscal_year == Year)  // Editable
    //{
    //  d.writeln("<form method=post action=\\\"\", Site_Dir, \"/cgi-bin/journal_activity.cgi\\\" name=\\\"Detailed_View\\\">");
    //  d.writeln("<input type=hidden name=\\\"ledger\\\" value=\\\"", Ledger, "\\\">");
    //  d.writeln("<input type=hidden name=\\\"journal_code\\\" value=\\\"all_journals\\\">");
    //  d.writeln("<table border=1 cellspacing=1 cellpadding=2 width=90%>");
    //  d.writeln("<tr><th>Edit</th><th>Jnl</th><th>Ref Num</th><th>Date</th><th>Payee-Payer</th><th>Memo</th><th>SE</th><th>Debit</th><th>Credit</th></tr>");
    //}
    //else  // Viewable only
    //{
      d.writeln("<form method=post action=\\\"\", Site_Dir, \"/cgi-bin/journal_mod1.cgi\\\" name=\\\"Detailed_View\\\">");
      d.writeln("<input type=hidden name=\\\"ledger\\\" value=\\\"", Ledger, "\\\">");
      d.writeln("<input type=hidden name=\\\"search2\\\" value=\\\"search2\\\">");
      d.writeln("<input type=hidden name=\\\"ref_num\\\" value=\\\"refnum\\\">");
      d.writeln("<table border=1 cellspacing=1 cellpadding=2 width=90%>");
      d.writeln("<tr><th>Action</th><th>Jnl</th><th>Ref Num</th><th>Date</th><th>Payee-Payer</th><th>Memo</th><th>SE</th><th>Debit</th><th>Credit</th></tr>");
    //}

    var Num_Entries=0;
    for (var z=0; z < Data[i][6][j][3+k][2]; z++)
    {
      if (Data[i][6][j][3+k][3][z][8] == Sub_Acct_Name)
      {
        var Entry = Data[i][6][j][3+k][3][z];
        //if (current_fiscal_year == Year)
        //{
        //  d.write("<tr><td align=center><input type=radio name=\\\"edit_entries\\\" value=\\\"journal_edit_", Num_Entries, "\\\"></td>");
        //}
        //else
        //{
          d.write("<tr><td align=center><a href=\\\"\\\" onClick=\\\"opener.SubmitViewForm('" + w.name + "'," + Entry[0] + "); return false;\\\">View</a></td>");
        //}
        d.write("<td align=center>", Entry[1], "</td><td align=right>", Entry[0], "</td><td align=center>", Entry[5], "</td><td>");
        if (Entry[2] == "")
        {
          d.write("<br>");
        }
        else
        {
          d.write(Entry[2]);
        }
        d.write("</td><td>");
        if (Entry[3] == "")
        {
          d.write("<br>");
        }
        else
        {
          d.write(Entry[3]);
        }
        d.write("</td><td>", Entry[4], "</td>");
        if (Entry[7] == "t")  // Debit
        {
          d.write("<td align=right>", Entry[6], "</td><td><br></td>");
        }
        else  // Credit
        {
          d.write("<td><br></td><td align=right>", Entry[6], "</td>");
        }
        //if (current_fiscal_year == Year)
        //{
        //  d.writeln("<input type=hidden name=\\\"journal_entry_", Num_Entries, "\\\" value=\\\"", Entry[0], "\\\"></tr>");
        //}
        //else
        //{
          d.writeln("</tr>");
        //}
        Num_Entries++;
      }
    }

    d.writeln("</table>");
    //if (current_fiscal_year == Year)
    //{
    //  d.writeln("<input type=submit name=\\\"edit\\\" value=\\\"Edit Transaction\\\">");
    //  d.writeln("<input type=hidden name=\\\"num_entries\\\" value=\\\"", Num_Entries, "\\\">");
    //  d.writeln("</form>");
    //}
    //else
    //{
    //  d.writeln("<input type=submit name=\\\"search2\\\" value=\\\"View Transaction\\\">");
      d.writeln("</form>");
    //}
    d.writeln("</body>");
    d.writeln("</html>");

    d.close();	// Don't forget this!
  }

  function init()
  {
    if (parseInt(navigator.appVersion) < 4)
    {
      alert("Sorry, a 4.0+ browser is required to view this report.");
      return;
    }

    var width, height = 30;
    if (isNav4) width = 3 * window.innerWidth / 4;
    else width = 3 * document.body.clientWidth / 4;

    var bgColor = "$body_bgcolor";
    mylist = new List(true, width, height, bgColor);

JAVA_CODE

    # define the table header string that each list item will need.
    my $table_str = "<table border=0 width=100% cellspacing=0 cellpadding=2 bgcolor='$body_bgcolor'>";

    my (@total_revenue, @total_expenses, $temp_str);

    $num_list_entries = 0;
    $num_sub_lists = 0;
    $list_height = 30;  # make sure to syncronize with the JavaScript version also.

    # display the report header (dates)
    $temp_str = $table_str . "<tr><td width=40% align=left><br></td>";
    for ($i=0; $i < $num_years; $i++)
    {
      my $width = int (60 / $num_years);
      my @Years = split /,/, $years;
      my $tmp_year = $Years[$i];
      $temp_str .= "<td width=$width% align=right><b>$tmp_year</b>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>";
      $total_revenue[$i] = "0.00";
      $total_expenses[$i] = "0.00";
    }
    $temp_str .= "</tr></table>";

    print "    mylist.addItem(\"$temp_str\", -1);\n";
    $num_list_entries++;

    my $js_array_index = 0;

    # now we actually begin displaying the Revenue and Expense Entries with CoGS in Revenue.
    for ($i=0; $i < scalar @Data; $i++)
    {
      my $name = $Data[$i][0];
      my $number = $Data[$i][1];

      if ($Data[$i][1] == 10)
      {
        # Generate the Sales Revenue Data
        # This will either be a main List item or have a Sub List based upon if it has any items.

        $temp_str = $table_str . "<tr><td width=40% align=left>&nbsp;&nbsp;&nbsp;$name</td>";
        my $total_str = $table_str . "<tr><td width=40% align=left>&nbsp;&nbsp;&nbsp;$name Total</td>";
        my $z;
        for ($z=0; $z < $num_years; $z++)
        { # display data for all years working with
          my $width = int (60 / $num_years);
          my $balance = $Data[$i][4][$z];
          $total_str .= "<td width=$width% align=right>";
          if ($balance < 0)
          {
            $balance *= -1;
            $balance = sprintf "%.2f", $balance;
            $total_str .= "<code><font face='$font_str' color=red>(" . commify($balance) . ")</font></code>&nbsp;&nbsp;";
            $balance *= -1;
          }
          else
          {
            $total_str .= "<code><font face='$font_str'>" . commify($balance) . "</font></code>&nbsp;&nbsp;&nbsp;&nbsp;";
          }
          $total_str .= "</td>";
        }
        $temp_str .= "</tr></table>";
        $total_str .= "</tr></table>";

        # See if there are any items for this Account Type
        if ($Data[$i][5] > 0)
        {  # we have accounts to work with
          my $count = $num_sub_lists++;
          print "    sublist$count = new List(false, width, height, bgColor);\n"; # parent list for the Accounts

          # now we need to loop through all Accounts listed of this Account Type and create the sub-lists or sub-entries to represent them.
          my ($sub_count, @Acct_Data);
          @Acct_Data = @{$Data[$i][6]};  # get the list of Accounts to work with
          for ($sub_count=0; $sub_count < $Data[$i][5]; $sub_count++)
          {
            my $count2 = $num_sub_lists++;
            my $acct_name = $Acct_Data[$sub_count][0];
            my $acct_num  = $Acct_Data[$sub_count][1];
            my $sub_accts_str = $Acct_Data[$sub_count][2];
            print "      sublist$count2 = new List(false, width, height, bgColor);\n"; # parent list of the current Account
            # determine if this Account has any entries to list.  If so we will do a double line entry or a single line entry.
            my ($year_count, $acct_temp_str, $acct_total_str, $has_accts);
            $acct_temp_str = $table_str . "<tr><td width=40% align=left>&nbsp;$acct_name</td>";
            $acct_total_str = $table_str . "<tr><td width=40% align=left>&nbsp;$acct_name Total</td>";
            $has_accts = 0;
            for ($year_count=0; $year_count < $num_years; $year_count++)
            {
              my @sub_acct_data = @{$Acct_Data[$sub_count][3+$year_count]};
              my $width = int (60 / $num_years);
              my ($intro_str, $end_str);
              $acct_total_str .= "<td width=$width% align=right>";
              my $acct_total = $sub_acct_data[1];

              if ($sub_count == $Data[$i][5] - 1) # see if we need to underline this total figure.
              {
                my ($space_str, $y, $length);
                $length = length commify($acct_total);
                if ($acct_total < 0)
                {
                  $length++;  # take into account the () and no - sign.
                }
                for ($y=0; $y < $line_length - $length; $y++)
                {
                  $space_str .= "&nbsp;";
                }
                $intro_str = "<u>$space_str";
                $end_str = "</u>";
              }

              if ($acct_total < 0)
              {
                $acct_total *= -1;
                $acct_total = sprintf "%.2f", $acct_total;
                $acct_total_str .= "<code><font face='$font_str' color=red>$intro_str(" . commify($acct_total) . ")$end_str</font></code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
                $acct_total *= -1;
              }
              else
              {
                $acct_total = sprintf "%.2f", $acct_total;
                $acct_total_str .= "<code><font face='$font_str'>$intro_str" . commify($acct_total) . "$end_str</font></code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
              }
              $acct_total_str .= "</b></td>";
              $has_accts = 1 if ($sub_acct_data[2] > 0);
            }
            $acct_total_str .= "</tr></table>";
            $acct_temp_str .= "</tr></table>";

            if ($has_accts)
            { # we have to display the list of sub accounts now and the Total line
              # we need to loop through each of the Sub Accounts that this account has and determine what sub-accounts are listed for each year being displayed.
              # we have to do this before we add sublist$count2 to it's parent list.
              my (@sub_acct_names, $num_sub_accts);
              $num_sub_accts = 0;
              for ($year_count=0; $year_count < $num_years; $year_count++)
              {
                my (%local_sub_acct_names);
                my @sub_acct_data = @{$Acct_Data[$sub_count][3+$year_count]};
                my ($xx);
                for ($xx=0; $xx < $sub_acct_data[2]; $xx++)
                {
                  my @entry = @{$sub_acct_data[3][$xx]};
                  my $sub_acct_name = $entry[8];
                  $local_sub_acct_names{$sub_acct_name} = $sub_acct_name if (not exists $local_sub_acct_names{$sub_acct_name});
                }
                my @SubAccts;
                foreach (sort keys %local_sub_acct_names)
                {
                  push @SubAccts, $_;
                }
                $sub_acct_names[$year_count] = [ @SubAccts ];
                $num_sub_accts = keys %local_sub_acct_names if (keys %local_sub_acct_names > $num_sub_accts);
              }

              my ($sub_count2, $sub_acct_temp_str);
              for ($sub_count2=0; $sub_count2 < $num_sub_accts; $sub_count2++)
              {
                $sub_acct_temp_str = $table_str . "<tr><td width=40% align=left>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;$sub_acct_names[0][$sub_count2]</td>";
                for ($year_count=0; $year_count < $num_years; $year_count++)
                {
                  my $string = "<br>";
                  my $width = int (60 / $num_years);
                  my @Years = split /,/, $years;
                  my $tmp_year = $Years[$year_count];
                  my $sub_total = "0.00";

                  # find the total of all entries that this sub account had for the year in question.
                  my ($yy);
                  for ($yy=0; $yy < $Acct_Data[$sub_count][3+$year_count][2]; $yy++)
                  {
                    if ($Acct_Data[$sub_count][3+$year_count][3][$yy][8] eq $sub_acct_names[$year_count][$sub_count2])
                    {
                      my $debit_increases = $Data[$i][2];
                      my $dorc = $Acct_Data[$sub_count][3+$year_count][3][$yy][7];
                      if ($debit_increases eq "t" && $dorc eq "t") # debit increases and amount is a debit
                      {
                        $sub_total += $Acct_Data[$sub_count][3+$year_count][3][$yy][6];
                      }
                      elsif ($debit_increases eq "t" && $dorc eq "f") # debit increases and amount is a credit
                      {
                        $sub_total -= $Acct_Data[$sub_count][3+$year_count][3][$yy][6];
                      }
                      elsif ($debit_increases eq "f" && $dorc eq "t") # debit decreases and amount is a debit
                      {
                        $sub_total -= $Acct_Data[$sub_count][3+$year_count][3][$yy][6];
                      }
                      elsif ($debit_increases eq "f" && $dorc eq "f") # debit decreases and amount is a credit
                      {
                        $sub_total += $Acct_Data[$sub_count][3+$year_count][3][$yy][6];
                      }
                    }
                  }
                  $sub_total = sprintf "%.2f", $sub_total;
                  my ($intro_str, $end_str);
                  if ($sub_count2 == $num_sub_accts - 1)  # see if we need to underline this entry.
                  {
                    my ($space_str, $y, $length);
                    $length = length commify($sub_total);
                    if ($sub_total < 0)
                    {
                      $length++;  # take into account the () and no - sign.
                    }
                    for ($y=0; $y < $line_length - $length; $y++)
                    {
                      $space_str .= "&nbsp;";
                    }
                    $intro_str = "<u>$space_str";
                    $end_str = "</u>";
                  }
                  else
                  {
                    $intro_str = "";
                    $end_str = "";
                  }
                  $sub_acct_names[$year_count][$sub_count2] = "____" if ($sub_acct_names[$year_count][$sub_count2] eq "----");
                  $string = "<a href='javascript:display_entries($number,$acct_num,$tmp_year,\\\"$sub_acct_names[$year_count][$sub_count2]\\\");'>";
                  if ($sub_total < 0)
                  {
                    $sub_total *= -1;
                    $sub_total = sprintf "%.2f", $sub_total;
                    $sub_total = commify($sub_total);
                    $string .= "<font color=red>$intro_str(" . $sub_total . ")$end_str";
                    $sub_total *= -1;
                  }
                  else
                  {
                    $sub_total = commify($sub_total);
                    $string .= "$intro_str" . $sub_total . "&nbsp;&nbsp;$end_str";
                  }
                  $string .= "</a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;" if ($sub_count2 < scalar $sub_acct_names[$year_count]);
                  $sub_acct_temp_str .= "<td width=$width% align=right>&nbsp;$string</td>";
 		}
 		$sub_acct_temp_str .= "</tr></table>";
 		print "        sublist$count2.addItem(\"$sub_acct_temp_str\", -1);\n";
 		$num_list_entries++;
              }
              print "      sublist$count.addList(sublist$count2, \"$acct_temp_str\", $sub_count);\n";
              $num_list_entries++;
              print "      sublist$count.addItem(\"$acct_total_str\", -1);\n";
              $num_list_entries++;
            }
            else
            { # we just display the total line without the word Total
              $acct_total_str =~ s/Total//;
              print "      sublist$count.addItem(\"$acct_total_str\", $sub_count);\n";
              $num_list_entries++;
            }
          }
          print "    mylist.addList(sublist$count, \"$temp_str\", $js_array_index);\n";
          $js_array_index++;
          $num_list_entries++;
          print "    mylist.addItem(\"$total_str\", -1);\n";
          $num_list_entries++;
        }
        else
        {  # no accounts to work with
          $total_str =~ s/Total//;
          print "    mylist.addItem(\"$total_str\", $js_array_index);\n";
          $js_array_index++;
          $num_list_entries++;
        }

        # Now Generate the CoGS Data

        # first we have to find the CoGS entry in @Data
        my $j;
        LINE: for ($j=$i; $j < scalar @Data; $j++)
        {
          last LINE if ($Data[$j][1] == 14);
        }
        $name = $Data[$j][0];
        $number = $Data[$j][1];
        $temp_str = $table_str . "<tr><td width=40% align=left>&nbsp;&nbsp;&nbsp;$name</td>";
        $total_str = $table_str . "<tr><td width=40% align=left>&nbsp;&nbsp;&nbsp;$name Total</td>";
        for ($z=0; $z < $num_years; $z++)
        { # display all years working with.
          my $width = int (60 / $num_years);
          my $balance = $Data[$j][4][$z];
          $total_str .= "<td width=$width% align=right>";
          if ($balance < 0)
          {
            $balance *= -1;
            $balance = sprintf "%.2f", $balance;
            my ($space_str, $y, $length);
            $length = length commify($balance);
            if ($balance < 0)
            {
              $length++;  # take into account the () and no - sign.
            }
            for ($y=0; $y < $line_length - $length; $y++)
            {
              $space_str .= "&nbsp;";
            }
            $total_str .= "<code><font face='$font_str' color=red><u>$space_str(" . commify($balance) . ")</u></font></code>&nbsp;&nbsp;";
            $balance *= -1;
          }
          else
          {
            $balance = sprintf "%.2f", $balance;
            my ($space_str, $y, $length);
            $length = length commify($balance);
            if ($balance < 0)
            {
              $length++;  # take into account the () and no - sign.
            }
            for ($y=0; $y < $line_length - $length; $y++)
            {
              $space_str .= "&nbsp;";
            }
            $total_str .= "<code><font face='$font_str'><u>$space_str" . commify($balance) . "</u></font></code>&nbsp;&nbsp;&nbsp;&nbsp;";
          }
          $total_str .= "</td>";
        }
        $total_str .= "</tr></table>";
        $temp_str .= "</tr></table>";

        # See if there are any items for this Account Type
        if ($Data[$j][5] > 0)
        {  # we have accounts to work with
          my $count = $num_sub_lists++;
          print "    sublist$count = new List(false, width, height, bgColor);\n"; # parent list for the Accounts

          # now we need to loop through all Accounts listed of this Account Type and create the sub-lists or sub-entries to represent them.
          my ($sub_count, @Acct_Data);
          @Acct_Data = @{$Data[$j][6]};  # get the list of Accounts to work with
          for ($sub_count=0; $sub_count < $Data[$i][5]; $sub_count++)
          {
            my $count2 = $num_sub_lists++;
            my $acct_name = $Acct_Data[$sub_count][0];
            my $acct_num  = $Acct_Data[$sub_count][1];
            my $sub_accts_str = $Acct_Data[$sub_count][2];
            print "      sublist$count2 = new List(false, width, height, bgColor);\n"; # parent list of the current Account
            # determine if this Account has any entries to list.  If so we will do a double line entry or a single line entry.
            my ($year_count, $acct_temp_str, $acct_total_str, $has_accts);
            $acct_temp_str = $table_str . "<tr><td width=40% align=left>&nbsp;$acct_name</td>";
            $acct_total_str = $table_str . "<tr><td width=40% align=left>&nbsp;$acct_name Total</td>";
            $has_accts = 0;
            for ($year_count=0; $year_count < $num_years; $year_count++)
            {
              my @sub_acct_data = @{$Acct_Data[$sub_count][3+$year_count]};
              my $width = int (60 / $num_years);
              my ($intro_str, $end_str);
              $acct_total_str .= "<td width=$width% align=right>";
              my $acct_total = $sub_acct_data[1];

              if ($sub_count == $Data[$j][5] - 1) # see if we need to underline this total figure.
              {
                my ($space_str, $y, $length);
                $length = length commify($acct_total);
                if ($acct_total < 0)
                {
                  $length++;  # take into account the () and no - sign.
                }
                for ($y=0; $y < $line_length - $length; $y++)
                {
                  $space_str .= "&nbsp;";
                }
                $intro_str = "<u>$space_str";
                $end_str = "</u>";
              }

              if ($acct_total < 0)
              {
                $acct_total *= -1;
                $acct_total = sprintf "%.2f", $acct_total;
                $acct_total_str .= "<code><font face='$font_str' color=red>$intro_str(" . commify($acct_total) . ")$end_str</font></code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
                $acct_total *= -1;
              }
              else
              {
                $acct_total = sprintf "%.2f", $acct_total;
                $acct_total_str .= "<code><font face='$font_str'>$intro_str" . commify($acct_total) . "$end_str</font></code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
              }
              $acct_total_str .= "</b></td>";
              $has_accts = 1 if ($sub_acct_data[2] > 0);
            }
            $acct_total_str .= "</tr></table>";
            $acct_temp_str .= "</tr></table>";

            if ($has_accts)
            { # we have to display the list of sub accounts now and the Total line
              # we need to loop through each of the Sub Accounts that this account has and determine what sub-accounts are listed for each year being displayed.
              # we have to do this before we add sublist$count2 to it's parent list.
              my (@sub_acct_names, $num_sub_accts);
              $num_sub_accts = 0;
              for ($year_count=0; $year_count < $num_years; $year_count++)
              {
                my (%local_sub_acct_names);
                my @sub_acct_data = @{$Acct_Data[$sub_count][3+$year_count]};
                my ($xx);
                for ($xx=0; $xx < $sub_acct_data[2]; $xx++)
                {
                  my @entry = @{$sub_acct_data[3][$xx]};
                  my $sub_acct_name = $entry[8];
                  $local_sub_acct_names{$sub_acct_name} = $sub_acct_name if (not exists $local_sub_acct_names{$sub_acct_name});
                }
                my @SubAccts;
                foreach (sort keys %local_sub_acct_names)
                {
                  push @SubAccts, $_;
                }
                $sub_acct_names[$year_count] = [ @SubAccts ];
                $num_sub_accts = keys %local_sub_acct_names if (keys %local_sub_acct_names > $num_sub_accts);
              }

              my ($sub_count2, $sub_acct_temp_str);
              for ($sub_count2=0; $sub_count2 < $num_sub_accts; $sub_count2++)
              {
                $sub_acct_temp_str = $table_str . "<tr><td width=40% align=left>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;$sub_acct_names[0][$sub_count2]</td>";
                for ($year_count=0; $year_count < $num_years; $year_count++)
                {
                  my $string = "<br>";
                  my $width = int (60 / $num_years);
                  my @Years = split /,/, $years;
                  my $tmp_year = $Years[$year_count];
                  my $sub_total = "0.00";

                  # find the total of all entries that this sub account had for the year in question.
                  my ($yy);
                  for ($yy=0; $yy < $Acct_Data[$sub_count][3+$year_count][2]; $yy++)
                  {
                    if ($Acct_Data[$sub_count][3+$year_count][3][$yy][8] eq $sub_acct_names[$year_count][$sub_count2])
                    {
                      my $debit_increases = $Data[$j][2];
                      my $dorc = $Acct_Data[$sub_count][3+$year_count][3][$yy][7];
                      if ($debit_increases eq "t" && $dorc eq "t") # debit increases and amount is a debit
                      {
                        $sub_total += $Acct_Data[$sub_count][3+$year_count][3][$yy][6];
                      }
                      elsif ($debit_increases eq "t" && $dorc eq "f") # debit increases and amount is a credit
                      {
                        $sub_total -= $Acct_Data[$sub_count][3+$year_count][3][$yy][6];
                      }
                      elsif ($debit_increases eq "f" && $dorc eq "t") # debit decreases and amount is a debit
                      {
                        $sub_total -= $Acct_Data[$sub_count][3+$year_count][3][$yy][6];
                      }
                      elsif ($debit_increases eq "f" && $dorc eq "f") # debit decreases and amount is a credit
                      {
                        $sub_total += $Acct_Data[$sub_count][3+$year_count][3][$yy][6];
                      }
                    }
                  }
                  $sub_total = sprintf "%.2f", $sub_total;
                  my ($intro_str, $end_str);
                  if ($sub_count2 == $num_sub_accts - 1)  # see if we need to underline this entry.
                  {
                    my ($space_str, $y, $length);
                    $length = length commify($sub_total);
                    if ($sub_total < 0)
                    {
                      $length++;  # take into account the () and no - sign.
                    }
                    for ($y=0; $y < $line_length - $length; $y++)
                    {
                      $space_str .= "&nbsp;";
                    }
                    $intro_str = "<u>$space_str";
                    $end_str = "</u>";
                  }
                  else
                  {
                    $intro_str = "";
                    $end_str = "";
                  }
                  $sub_acct_names[$year_count][$sub_count2] = "____" if ($sub_acct_names[$year_count][$sub_count2] eq "----");
                  $string = "<a href='javascript:display_entries($number,$acct_num,$tmp_year,\\\"$sub_acct_names[$year_count][$sub_count2]\\\");'>";
                  if ($sub_total < 0)
                  {
                    $sub_total *= -1;
                    $sub_total = sprintf "%.2f", $sub_total;
                    $sub_total = commify($sub_total);
                    $string .= "<font color=red>$intro_str(" . $sub_total . ")$end_str";
                    $sub_total *= -1;
                  }
                  else
                  {
                    $sub_total = commify($sub_total);
                    $string .= "$intro_str" . $sub_total . "&nbsp;&nbsp;$end_str";
                  }
                  $string .= "</a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;" if ($sub_count2 < scalar $sub_acct_names[$year_count]);
                  $sub_acct_temp_str .= "<td width=$width% align=right>&nbsp;$string</td>";
 		}
 		$sub_acct_temp_str .= "</tr></table>";
 		print "        sublist$count2.addItem(\"$sub_acct_temp_str\", -1);\n";
 		$num_list_entries++;
              }
              print "      sublist$count.addList(sublist$count2, \"$acct_temp_str\", $sub_count);\n";
              $num_list_entries++;
              print "      sublist$count.addItem(\"$acct_total_str\", -1);\n";
              $num_list_entries++;
            }
            else
            { # we just display the total line without the word Total
              $acct_total_str =~ s/Total//;
              print "      sublist$count.addItem(\"$acct_total_str\", $sub_count);\n";
              $num_list_entries++;
            }
          }
          print "    mylist.addList(sublist$count, \"$temp_str\", $js_array_index);\n";
          $js_array_index++;
          $num_list_entries++;
          print "    mylist.addItem(\"$total_str\", -1);\n";
          $num_list_entries++;
        }
        else
        {  # no accounts to work with
          $total_str =~ s/Total//;
          print "    mylist.addItem(\"$total_str\", $js_array_index);\n";
          $js_array_index++;
          $num_list_entries++;
        }

        # now we display the Gross Margin Line
        $temp_str = $table_str . "<tr><td width=40% align=left>&nbsp;Gross Margin</td>";
        for ($z=0; $z < $num_years; $z++)
        {
          my $gross_margin = $Data[$i][4][$z] - $Data[$j][4][$z];
          $total_revenue[$z] += $gross_margin;
          my $width = int (60 / $num_years);
          $temp_str .= "<td width=$width% align=right>";
          if ($gross_margin < 0)
          {
            $gross_margin *= -1;
            $gross_margin = sprintf "%.2f", $gross_margin;
            $temp_str .= "<code><font face='$font_str' color=red>(" . commify($gross_margin) . ")</font></code>&nbsp;&nbsp;";
            $gross_margin *= -1;
          }
          else
          {
            $gross_margin = sprintf "%.2f", $gross_margin;
            $temp_str .= "<code><font face='$font_str'>" . commify($gross_margin) . "</font></code>&nbsp;&nbsp;&nbsp;&nbsp;";
          }
          $temp_str .= "</td>";
        }
        $temp_str .= "</tr></table>";

        print "    mylist.addItem(\"$temp_str\", -1);\n";
      }
      elsif ($Data[$i][1] != 14 && $Data[$i][1] != 15 && $Data[$i][1] != 16)
      {
        # see if we need to Subtotal the Revenue
        if ($Data[$i][1] == 13) # The Expenses type so Revenues are over
        {
          my $z;
          $temp_str = $table_str . "<tr><td width=40% align=left><b>&nbsp;Total Revenue</b></td>";
          for ($z=0; $z < $num_years; $z++)
          {
            my $width = int (60 / $num_years);
            $temp_str .= "<td width=$width% align=right><b>";
            if ($total_revenue[$z] < 0)
            {
              $total_revenue[$z] *= -1;
              $total_revenue[$z] = sprintf "%.2f", $total_revenue[$z];
              $temp_str .= "<code><font face='$font_str' color=red>(" . commify($total_revenue[$z]) . ")</font></code>&nbsp;&nbsp;";
              $total_revenue[$z] *= -1;
            }
            else
            {
              $total_revenue[$z] = sprintf "%.2f", $total_revenue[$z];
              $temp_str .= "<code><font face='$font_str'>" . commify($total_revenue[$z]) . "</font></code>&nbsp;&nbsp;&nbsp;&nbsp;";
            }
            $temp_str .= "</b></td>";
          }
          $temp_str .= "</tr></table>";

          print "    mylist.addItem(\"$temp_str\", -1);\n";
          $num_list_entries++;
        }

        # This will either be a main List item or have a Sub List based upon if it has any items.

        $temp_str = $table_str . "<tr><td width=40% align=left>&nbsp;$name</td>";
        my $z;
        my $total_str = $table_str . "<tr><td width=40% align=left>&nbsp;$name Total</td>";
        for ($z=0; $z < $num_years; $z++)
        { # display data for all years working with
          my $width = int (60 / $num_years);
          my $balance = $Data[$i][4][$z];
          $total_str .= "<td width=$width% align=right>";
          if ($balance < 0)
          {
            $balance *= -1;
            $balance = sprintf "%.2f", $balance;
            my ($intro_str, $end_str);
            if ($Data[$i][1] == 12 || $Data[$i][1] == 13) # end of Revenue or Expenses
            {
              my ($space_str, $y, $length);
              $length = length commify($balance);
              if ($balance < 0)
              {
                $length++;  # take into account the () and no - sign.
              }
              for ($y=0; $y < $line_length - $length; $y++)
              {
                $space_str .= "&nbsp;";
              }
              $intro_str = "<u>$space_str";
              $end_str = "</u>";
            }
            $total_str .= "<code><font face='$font_str' color=red>$intro_str(" . commify($balance) . ")$end_str</font></code>&nbsp;&nbsp;";
            $balance *= -1;
          }
          else
          {
            my ($intro_str, $end_str);
            if ($Data[$i][1] == 12 || $Data[$i][1] == 13) # end of Revenue or Expenses
            {
              my ($space_str, $y, $length);
              $length = length commify($balance);
              if ($balance < 0)
              {
                $length++;  # take into account the () and no - sign.
              }
              for ($y=0; $y < $line_length - $length; $y++)
              {
                $space_str .= "&nbsp;";
              }
              $intro_str = "<u>$space_str";
              $end_str = "</u>";
            }
            $total_str .= "<code><font face='$font_str'>$intro_str" . commify($balance) . "$end_str</font></code>&nbsp;&nbsp;&nbsp;&nbsp;";
          }
          $total_str .= "</td>";
          # keep a running total of the balances
          if ($Data[$i][1] < 13) # Revenue
          {
            $total_revenue[$z] += $balance;
          }
          else # Expenses
          {
            $total_expenses[$z] += $balance;
          }
        }
        $temp_str .= "</tr></table>";
        $total_str .= "</tr></table>";

        # See if there are any items for this Account Type
        if ($Data[$i][5] > 0)
        {  # we have accounts to work with
          my $count = $num_sub_lists++;
          print "    sublist$count = new List(false, width, height, bgColor);\n"; # parent list for the Accounts

          # now we need to loop through all Accounts listed of this Account Type and create the sub-lists or sub-entries to represent them.
          my ($sub_count, @Acct_Data);
          @Acct_Data = @{$Data[$i][6]};  # get the list of Accounts to work with
          for ($sub_count=0; $sub_count < $Data[$i][5]; $sub_count++)
          {
            my $count2 = $num_sub_lists++;
            my $acct_name = $Acct_Data[$sub_count][0];
            my $acct_num  = $Acct_Data[$sub_count][1];
            my $sub_accts_str = $Acct_Data[$sub_count][2];
            print "      sublist$count2 = new List(false, width, height, bgColor);\n"; # parent list of the current Account
            # determine if this Account has any entries to list.  If so we will do a double line entry or a single line entry.
            my ($year_count, $acct_temp_str, $acct_total_str, $has_accts);
            $acct_temp_str = $table_str . "<tr><td width=40% align=left>&nbsp;$acct_name</td>";
            $acct_total_str = $table_str . "<tr><td width=40% align=left>&nbsp;$acct_name Total</td>";
            $has_accts = 0;
            for ($year_count=0; $year_count < $num_years; $year_count++)
            {
              my @sub_acct_data = @{$Acct_Data[$sub_count][3+$year_count]};
              my $width = int (60 / $num_years);
              my ($intro_str, $end_str);
              $acct_total_str .= "<td width=$width% align=right>";
              my $acct_total = $sub_acct_data[1];

              if ($sub_count == $Data[$i][5] - 1) # see if we need to underline this total figure.
              {
                my ($space_str, $y, $length);
                $length = length commify($acct_total);
                if ($acct_total < 0)
                {
                  $length++;  # take into account the () and no - sign.
                }
                for ($y=0; $y < $line_length - $length; $y++)
                {
                  $space_str .= "&nbsp;";
                }
                $intro_str = "<u>$space_str";
                $end_str = "</u>";
              }

              if ($acct_total < 0)
              {
                $acct_total *= -1;
                $acct_total = sprintf "%.2f", $acct_total;
                $acct_total_str .= "<code><font face='$font_str' color=red>$intro_str(" . commify($acct_total) . ")$end_str</font></code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
                $acct_total *= -1;
              }
              else
              {
                $acct_total = sprintf "%.2f", $acct_total;
                $acct_total_str .= "<code><font face='$font_str'>$intro_str" . commify($acct_total) . "$end_str</font></code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
              }
              $acct_total_str .= "</b></td>";
              $has_accts = 1 if ($sub_acct_data[2] > 0);
            }
            $acct_total_str .= "</tr></table>";
            $acct_temp_str .= "</tr></table>";

            if ($has_accts)
            { # we have to display the list of sub accounts now and the Total line
              # we need to loop through each of the Sub Accounts that this account has and determine what sub-accounts are listed for each year being displayed.
              # we have to do this before we add sublist$count2 to it's parent list.
              my (@sub_acct_names, $num_sub_accts);
              $num_sub_accts = 0;
              for ($year_count=0; $year_count < $num_years; $year_count++)
              {
                my (%local_sub_acct_names);
                my @sub_acct_data = @{$Acct_Data[$sub_count][3+$year_count]};
                my ($xx);
                for ($xx=0; $xx < $sub_acct_data[2]; $xx++)
                {
                  my @entry = @{$sub_acct_data[3][$xx]};
                  my $sub_acct_name = $entry[8];
                  $local_sub_acct_names{$sub_acct_name} = $sub_acct_name if (not exists $local_sub_acct_names{$sub_acct_name});
                }
                my @SubAccts;
                foreach (sort keys %local_sub_acct_names)
                {
                  push @SubAccts, $_;
                }
                $sub_acct_names[$year_count] = [ @SubAccts ];
                $num_sub_accts = keys %local_sub_acct_names if (keys %local_sub_acct_names > $num_sub_accts);
              }

              my ($sub_count2, $sub_acct_temp_str);
              for ($sub_count2=0; $sub_count2 < $num_sub_accts; $sub_count2++)
              {
                $sub_acct_temp_str = $table_str . "<tr><td width=40% align=left>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;$sub_acct_names[0][$sub_count2]</td>";
                for ($year_count=0; $year_count < $num_years; $year_count++)
                {
                  my $string = "<br>";
                  my $width = int (60 / $num_years);
                  my @Years = split /,/, $years;
                  my $tmp_year = $Years[$year_count];
                  my $sub_total = "0.00";

                  # find the total of all entries that this sub account had for the year in question.
                  my ($yy);
                  for ($yy=0; $yy < $Acct_Data[$sub_count][3+$year_count][2]; $yy++)
                  {
                    if ($Acct_Data[$sub_count][3+$year_count][3][$yy][8] eq $sub_acct_names[$year_count][$sub_count2])
                    {
                      my $debit_increases = $Data[$i][2];
                      my $dorc = $Acct_Data[$sub_count][3+$year_count][3][$yy][7];
                      if ($debit_increases eq "t" && $dorc eq "t") # debit increases and amount is a debit
                      {
                        $sub_total += $Acct_Data[$sub_count][3+$year_count][3][$yy][6];
                      }
                      elsif ($debit_increases eq "t" && $dorc eq "f") # debit increases and amount is a credit
                      {
                        $sub_total -= $Acct_Data[$sub_count][3+$year_count][3][$yy][6];
                      }
                      elsif ($debit_increases eq "f" && $dorc eq "t") # debit decreases and amount is a debit
                      {
                        $sub_total -= $Acct_Data[$sub_count][3+$year_count][3][$yy][6];
                      }
                      elsif ($debit_increases eq "f" && $dorc eq "f") # debit decreases and amount is a credit
                      {
                        $sub_total += $Acct_Data[$sub_count][3+$year_count][3][$yy][6];
                      }
                    }
                  }
                  $sub_total = sprintf "%.2f", $sub_total;
                  my ($intro_str, $end_str);
                  if ($sub_count2 == $num_sub_accts - 1)  # see if we need to underline this entry.
                  {
                    my ($space_str, $y, $length);
                    $length = length commify($sub_total);
                    if ($sub_total < 0)
                    {
                      $length++;  # take into account the () and no - sign.
                    }
                    for ($y=0; $y < $line_length - $length; $y++)
                    {
                      $space_str .= "&nbsp;";
                    }
                    $intro_str = "<u>$space_str";
                    $end_str = "</u>";
                  }
                  else
                  {
                    $intro_str = "";
                    $end_str = "";
                  }
                  $sub_acct_names[$year_count][$sub_count2] = "____" if ($sub_acct_names[$year_count][$sub_count2] eq "----");
                  $string = "<a href='javascript:display_entries($number,$acct_num,$tmp_year,\\\"$sub_acct_names[$year_count][$sub_count2]\\\");'>";
                  if ($sub_total < 0)
                  {
                    $sub_total *= -1;
                    $sub_total = sprintf "%.2f", $sub_total;
                    $sub_total = commify($sub_total);
                    $string .= "<font color=red>$intro_str(" . $sub_total . ")$end_str";
                    $sub_total *= -1;
                  }
                  else
                  {
                    $sub_total = commify($sub_total);
                    $string .= "$intro_str" . $sub_total . "&nbsp;&nbsp;$end_str";
                  }
                  $string .= "</a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;" if ($sub_count2 < scalar $sub_acct_names[$year_count]);
                  $sub_acct_temp_str .= "<td width=$width% align=right>&nbsp;$string</td>";
 		}
 		$sub_acct_temp_str .= "</tr></table>";
 		print "        sublist$count2.addItem(\"$sub_acct_temp_str\", -1);\n";
 		$num_list_entries++;
              }
              print "      sublist$count.addList(sublist$count2, \"$acct_temp_str\", $sub_count);\n";
              $num_list_entries++;
              print "      sublist$count.addItem(\"$acct_total_str\", -1);\n";
              $num_list_entries++;
            }
            else
            { # we just display the total line without the word Total
              $acct_total_str =~ s/Total//;
              print "      sublist$count.addItem(\"$acct_total_str\", $sub_count);\n";
              $num_list_entries++;
            }
          }
          print "    mylist.addList(sublist$count, \"$temp_str\", $js_array_index);\n";
          $js_array_index++;
          $num_list_entries++;
          print "    mylist.addItem(\"$total_str\", -1);\n";
          $num_list_entries++;
        }
        else
        {  # no accounts to work with
          $total_str =~ s/Total//;
          print "    mylist.addItem(\"$total_str\", $js_array_index);\n";
          $js_array_index++;
          $num_list_entries++;
        }
      }
    }

    # now print the Total Expenses
    my $z;
    $temp_str = $table_str . "<tr><td width=40% align=left><b>&nbsp;Total Expenses</b></td>";
    for ($z=0; $z < $num_years; $z++)
    {
      my $width = int (60 / $num_years);
      $temp_str .= "<td width=$width% align=right><b>";
      if ($total_expenses[$z] < 0)
      {
        $total_expenses[$z] *= -1;
        $total_expenses[$z] = sprintf "%.2f", $total_expenses[$z];
        $temp_str .= "<code><font face='$font_str' color=red>(" . commify($total_expenses[$z]) . ")</font></code>&nbsp;&nbsp;";
        $total_expenses[$z] *= -1;
      }
      else
      {
        $total_expenses[$z] = sprintf "%.2f", $total_expenses[$z];
        $temp_str .= "<code><font face='$font_str'>" . commify($total_expenses[$z]) . "</font></code>&nbsp;&nbsp;&nbsp;&nbsp;";
      }
      $temp_str .= "</b></td>";
    }
    $temp_str .= "</tr></table>";
    print "    mylist.addItem(\"$temp_str\", -1);\n";
    $num_list_entries++;

    # now print the EBITDA
    # EBITDA = Total Revenues - Total Expenses
    $temp_str = $table_str . "<tr><td width=40% align=left>&nbsp;<b>EBITDA</b></td>";
    my @ebitda;
    for ($z=0; $z < $num_years; $z++)
    {
      my $width = int (60 / $num_years);
      $ebitda[$z] = $total_revenue[$z] - $total_expenses[$z];
      $temp_str .= "<td width=$width% align=right><b>";
      if ($ebitda[$z] < 0)
      {
        $ebitda[$z] *= -1;
        $ebitda[$z] = sprintf "%.2f", $ebitda[$z];
        $temp_str .= "<code><font face='$font_str' color=red>(" . commify($ebitda[$z]) . ")</font></code>&nbsp;&nbsp;";
        $ebitda[$z] *= -1;
        $ebitda[$z] = sprintf "%.2f", $ebitda[$z];
      }
      else
      {
        $ebitda[$z] = sprintf "%.2f", $ebitda[$z];
        $temp_str .= "<code><font face='$font_str'>" . commify($ebitda[$z]) . "</font></code>&nbsp;&nbsp;&nbsp;&nbsp;";
      }
      $temp_str .= "</b></td>";
    }
    $temp_str .= "</tr></table>";
    print "    mylist.addItem(\"$temp_str\", -1);\n";
    $num_list_entries++;

    # now print the Depreciation/Depletion
    my @depreciation;
    for ($i=0; $i < scalar @Data; $i++)
    {
      my $name = $Data[$i][0];
      my $number = $Data[$i][1];
      if ($Data[$i][1] == 16)
      {
        my $z;
        $temp_str = $table_str . "<tr><td width=40% align=left>&nbsp;$name</td>";
        my $total_str = $table_str . "<tr><td width=40% align=left>&nbsp;$name Total</td>";
        for ($z=0; $z < $num_years; $z++)
        { # display all years working with.
          my $width = int (60 / $num_years);
          my $balance = $Data[$i][4][$z];
          $depreciation[$z] = $balance;
          $total_str .= "<td width=$width% align=right>";
          if ($balance < 0)
          {
            $balance *= -1;
            $balance = sprintf "%.2f", $balance;
            my ($space_str, $y, $length);
            $length = length commify($balance);
            if ($balance < 0)
            {
              $length++;  # take into account the () and no - sign.
            }
            for ($y=0; $y < $line_length - $length; $y++)
            {
              $space_str .= "&nbsp;";
            }
            $total_str .= "<code><font face='$font_str' color=red><u>$space_str(" . commify($balance) . ")</u></font></code>&nbsp;&nbsp;";
            $balance *= -1;
          }
          else
          {
            $balance = sprintf "%.2f", $balance;
            my ($space_str, $y, $length);
            $length = length commify($balance);
            if ($balance < 0)
            {
              $length++;  # take into account the () and no - sign.
            }
            for ($y=0; $y < $line_length - $length; $y++)
            {
              $space_str .= "&nbsp;";
            }
            $total_str .= "<code><font face='$font_str'><u>$space_str" . commify($balance) . "</u></font></code>&nbsp;&nbsp;&nbsp;&nbsp;";
          }
          $total_str .= "</td>";
        }
        $total_str .= "</tr></table>";
        $temp_str .= "</tr></table>";

        # See if there are any items for this Account Type
        if ($Data[$i][5] > 0)
        {  # we have accounts to work with
          my $count = $num_sub_lists++;
          print "    sublist$count = new List(false, width, height, bgColor);\n"; # parent list for the Accounts

          # now we need to loop through all Accounts listed of this Account Type and create the sub-lists or sub-entries to represent them.
          my ($sub_count, @Acct_Data);
          @Acct_Data = @{$Data[$i][6]};  # get the list of Accounts to work with
          for ($sub_count=0; $sub_count < $Data[$i][5]; $sub_count++)
          {
            my $count2 = $num_sub_lists++;
            my $acct_name = $Acct_Data[$sub_count][0];
            my $acct_num  = $Acct_Data[$sub_count][1];
            my $sub_accts_str = $Acct_Data[$sub_count][2];
            print "      sublist$count2 = new List(false, width, height, bgColor);\n"; # parent list of the current Account
            # determine if this Account has any entries to list.  If so we will do a double line entry or a single line entry.
            my ($year_count, $acct_temp_str, $acct_total_str, $has_accts);
            $acct_temp_str = $table_str . "<tr><td width=40% align=left>&nbsp;$acct_name</td>";
            $acct_total_str = $table_str . "<tr><td width=40% align=left>&nbsp;$acct_name Total</td>";
            $has_accts = 0;
            for ($year_count=0; $year_count < $num_years; $year_count++)
            {
              my @sub_acct_data = @{$Acct_Data[$sub_count][3+$year_count]};
              my $width = int (60 / $num_years);
              my ($intro_str, $end_str);
              $acct_total_str .= "<td width=$width% align=right>";
              my $acct_total = $sub_acct_data[1];

              if ($sub_count == $Data[$i][5] - 1) # see if we need to underline this total figure.
              {
                my ($space_str, $y, $length);
                $length = length commify($acct_total);
                if ($acct_total < 0)
                {
                  $length++;  # take into account the () and no - sign.
                }
                for ($y=0; $y < $line_length - $length; $y++)
                {
                  $space_str .= "&nbsp;";
                }
                $intro_str = "<u>$space_str";
                $end_str = "</u>";
              }

              if ($acct_total < 0)
              {
                $acct_total *= -1;
                $acct_total = sprintf "%.2f", $acct_total;
                $acct_total_str .= "<code><font face='$font_str' color=red>$intro_str(" . commify($acct_total) . ")$end_str</font></code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
                $acct_total *= -1;
              }
              else
              {
                $acct_total = sprintf "%.2f", $acct_total;
                $acct_total_str .= "<code><font face='$font_str'>$intro_str" . commify($acct_total) . "$end_str</font></code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
              }
              $acct_total_str .= "</b></td>";
              $has_accts = 1 if ($sub_acct_data[2] > 0);
            }
            $acct_total_str .= "</tr></table>";
            $acct_temp_str .= "</tr></table>";

            if ($has_accts)
            { # we have to display the list of sub accounts now and the Total line
              # we need to loop through each of the Sub Accounts that this account has and determine what sub-accounts are listed for each year being displayed.
              # we have to do this before we add sublist$count2 to it's parent list.
              my (@sub_acct_names, $num_sub_accts);
              $num_sub_accts = 0;
              for ($year_count=0; $year_count < $num_years; $year_count++)
              {
                my (%local_sub_acct_names);
                my @sub_acct_data = @{$Acct_Data[$sub_count][3+$year_count]};
                my ($xx);
                for ($xx=0; $xx < $sub_acct_data[2]; $xx++)
                {
                  my @entry = @{$sub_acct_data[3][$xx]};
                  my $sub_acct_name = $entry[8];
                  $local_sub_acct_names{$sub_acct_name} = $sub_acct_name if (not exists $local_sub_acct_names{$sub_acct_name});
                }
                my @SubAccts;
                foreach (sort keys %local_sub_acct_names)
                {
                  push @SubAccts, $_;
                }
                $sub_acct_names[$year_count] = [ @SubAccts ];
                $num_sub_accts = keys %local_sub_acct_names if (keys %local_sub_acct_names > $num_sub_accts);
              }

              my ($sub_count2, $sub_acct_temp_str);
              for ($sub_count2=0; $sub_count2 < $num_sub_accts; $sub_count2++)
              {
                $sub_acct_temp_str = $table_str . "<tr><td width=40% align=left>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;$sub_acct_names[0][$sub_count2]</td>";
                for ($year_count=0; $year_count < $num_years; $year_count++)
                {
                  my $string = "<br>";
                  my $width = int (60 / $num_years);
                  my @Years = split /,/, $years;
                  my $tmp_year = $Years[$year_count];
                  my $sub_total = "0.00";

                  # find the total of all entries that this sub account had for the year in question.
                  my ($yy);
                  for ($yy=0; $yy < $Acct_Data[$sub_count][3+$year_count][2]; $yy++)
                  {
                    if ($Acct_Data[$sub_count][3+$year_count][3][$yy][8] eq $sub_acct_names[$year_count][$sub_count2])
                    {
                      my $debit_increases = $Data[$i][2];
                      my $dorc = $Acct_Data[$sub_count][3+$year_count][3][$yy][7];
                      if ($debit_increases eq "t" && $dorc eq "t") # debit increases and amount is a debit
                      {
                        $sub_total += $Acct_Data[$sub_count][3+$year_count][3][$yy][6];
                      }
                      elsif ($debit_increases eq "t" && $dorc eq "f") # debit increases and amount is a credit
                      {
                        $sub_total -= $Acct_Data[$sub_count][3+$year_count][3][$yy][6];
                      }
                      elsif ($debit_increases eq "f" && $dorc eq "t") # debit decreases and amount is a debit
                      {
                        $sub_total -= $Acct_Data[$sub_count][3+$year_count][3][$yy][6];
                      }
                      elsif ($debit_increases eq "f" && $dorc eq "f") # debit decreases and amount is a credit
                      {
                        $sub_total += $Acct_Data[$sub_count][3+$year_count][3][$yy][6];
                      }
                    }
                  }
                  $sub_total = sprintf "%.2f", $sub_total;
                  my ($intro_str, $end_str);
                  if ($sub_count2 == $num_sub_accts - 1)  # see if we need to underline this entry.
                  {
                    my ($space_str, $y, $length);
                    $length = length commify($sub_total);
                    if ($sub_total < 0)
                    {
                      $length++;  # take into account the () and no - sign.
                    }
                    for ($y=0; $y < $line_length - $length; $y++)
                    {
                      $space_str .= "&nbsp;";
                    }
                    $intro_str = "<u>$space_str";
                    $end_str = "</u>";
                  }
                  else
                  {
                    $intro_str = "";
                    $end_str = "";
                  }
                  $sub_acct_names[$year_count][$sub_count2] = "____" if ($sub_acct_names[$year_count][$sub_count2] eq "----");
                  $string = "<a href='javascript:display_entries($number,$acct_num,$tmp_year,\\\"$sub_acct_names[$year_count][$sub_count2]\\\");'>";
                  if ($sub_total < 0)
                  {
                    $sub_total *= -1;
                    $sub_total = sprintf "%.2f", $sub_total;
                    $sub_total = commify($sub_total);
                    $string .= "<font color=red>$intro_str(" . $sub_total . ")$end_str";
                    $sub_total *= -1;
                  }
                  else
                  {
                    $sub_total = commify($sub_total);
                    $string .= "$intro_str" . $sub_total . "&nbsp;&nbsp;$end_str";
                  }
                  $string .= "</a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;" if ($sub_count2 < scalar $sub_acct_names[$year_count]);
                  $sub_acct_temp_str .= "<td width=$width% align=right>&nbsp;$string</td>";
 		}
 		$sub_acct_temp_str .= "</tr></table>";
 		print "        sublist$count2.addItem(\"$sub_acct_temp_str\", -1);\n";
 		$num_list_entries++;
              }
              print "      sublist$count.addList(sublist$count2, \"$acct_temp_str\", $sub_count);\n";
              $num_list_entries++;
              print "      sublist$count.addItem(\"$acct_total_str\", -1);\n";
              $num_list_entries++;
            }
            else
            { # we just display the total line without the word Total
              $acct_total_str =~ s/Total//;
              print "      sublist$count.addItem(\"$acct_total_str\", $sub_count);\n";
              $num_list_entries++;
            }
          }
          print "    mylist.addList(sublist$count, \"$temp_str\", $js_array_index);\n";
          $js_array_index++;
          $num_list_entries++;
          print "    mylist.addItem(\"$total_str\", -1);\n";
          $num_list_entries++;
        }
        else
        {  # no accounts to work with
          $total_str =~ s/Total//;
          print "    mylist.addItem(\"$total_str\", $js_array_index);\n";
          $js_array_index++;
          $num_list_entries++;
        }
      }
    }

    # now print the Net Income Before Taxes
    # EBITDA - Depreciation / Depletion
    my @net_income_before_taxes;
    $temp_str = $table_str . "<tr><td width=40% align=left>&nbsp;<b>Net Income Before Taxes</b></td>";
    for ($z=0; $z < $num_years; $z++)
    {
      my $width = int (60 / $num_years);
      $net_income_before_taxes[$z] = $ebitda[$z] - $depreciation[$z];
      $temp_str .= "<td width=$width% align=right><b>";
      if ($net_income_before_taxes[$z] < 0)
      {
        $net_income_before_taxes[$z] *= -1;
        $net_income_before_taxes[$z] = sprintf "%.2f", $net_income_before_taxes[$z];
        $temp_str .= "<code><font face='$font_str' color=red>(" . commify($net_income_before_taxes[$z]) . ")</font></code>&nbsp;&nbsp;";
        $net_income_before_taxes[$z] *= -1;
        $net_income_before_taxes[$z] = sprintf "%.2f", $net_income_before_taxes[$z];
      }
      else
      {
        $net_income_before_taxes[$z] = sprintf "%.2f", $net_income_before_taxes[$z];
        $temp_str .= "<code><font face='$font_str'>" . commify($net_income_before_taxes[$z]) . "</font></code>&nbsp;&nbsp;&nbsp;&nbsp;";
      }
      $temp_str .= "</b></td>";
    }
    $temp_str .= "</tr></table>";
    print "    mylist.addItem(\"$temp_str\", -1);\n";
    $num_list_entries++;

    # now print the Income Tax Expense
    my @income_tax;
    for ($i=0; $i < scalar @Data; $i++)
    {
      my $name = $Data[$i][0];
      my $number = $Data[$i][1];
      if ($Data[$i][1] == 15)
      {
        my $z;
        $temp_str = $table_str . "<tr><td width=40% align=left><b>&nbsp;$name</b></td>";
        my $total_str = $table_str . "<tr><td width=40% align=left><b>&nbsp;$name Total</b></td>";
        for ($z=0; $z < $num_years; $z++)
        { # display all years working with.
          my $width = int (60 / $num_years);
          my $balance = $Data[$i][4][$z];
          $income_tax[$z] = $balance;
          $total_str .= "<td width=$width% align=right><b>";
          if ($balance < 0)
          {
            $balance *= -1;
            $balance = sprintf "%.2f", $balance;
            my ($space_str, $y, $length);
            $length = length commify($balance);
            if ($balance < 0)
            {
              $length++;  # take into account the () and no - sign.
            }
            for ($y=0; $y < $line_length - $length; $y++)
            {
              $space_str .= "&nbsp;";
            }
            $total_str .= "<code><font face='$font_str' color=red><u>$space_str(" . commify($balance) . ")</u></font></code>&nbsp;&nbsp;";
            $balance *= -1;
          }
          else
          {
            $balance = sprintf "%.2f", $balance;
            my ($space_str, $y, $length);
            $length = length commify($balance);
            if ($balance < 0)
            {
              $length++;  # take into account the () and no - sign.
            }
            for ($y=0; $y < $line_length - $length; $y++)
            {
              $space_str .= "&nbsp;";
            }
            $total_str .= "<code><font face='$font_str'><u>$space_str" . commify($balance) . "</u></font></code>&nbsp;&nbsp;&nbsp;&nbsp;";
          }
          $total_str .= "</b></td>";
        }
        $total_str .= "</tr></table>";
        $temp_str .= "</tr></table>";

        # See if there are any items for this Account Type
        if ($Data[$i][5] > 0)
        {  # we have accounts to work with
          my $count = $num_sub_lists++;
          print "    sublist$count = new List(false, width, height, bgColor);\n"; # parent list for the Accounts

          # now we need to loop through all Accounts listed of this Account Type and create the sub-lists or sub-entries to represent them.
          my ($sub_count, @Acct_Data);
          @Acct_Data = @{$Data[$i][6]};  # get the list of Accounts to work with
          for ($sub_count=0; $sub_count < $Data[$i][5]; $sub_count++)
          {
            my $count2 = $num_sub_lists++;
            my $acct_name = $Acct_Data[$sub_count][0];
            my $acct_num  = $Acct_Data[$sub_count][1];
            my $sub_accts_str = $Acct_Data[$sub_count][2];
            print "      sublist$count2 = new List(false, width, height, bgColor);\n"; # parent list of the current Account
            # determine if this Account has any entries to list.  If so we will do a double line entry or a single line entry.
            my ($year_count, $acct_temp_str, $acct_total_str, $has_accts);
            $acct_temp_str = $table_str . "<tr><td width=40% align=left>&nbsp;$acct_name</td>";
            $acct_total_str = $table_str . "<tr><td width=40% align=left>&nbsp;$acct_name Total</td>";
            $has_accts = 0;
            for ($year_count=0; $year_count < $num_years; $year_count++)
            {
              my @sub_acct_data = @{$Acct_Data[$sub_count][3+$year_count]};
              my $width = int (60 / $num_years);
              my ($intro_str, $end_str);
              $acct_total_str .= "<td width=$width% align=right>";
              my $acct_total = $sub_acct_data[1];

              if ($sub_count == $Data[$i][5] - 1) # see if we need to underline this total figure.
              {
                my ($space_str, $y, $length);
                $length = length commify($acct_total);
                if ($acct_total < 0)
                {
                  $length++;  # take into account the () and no - sign.
                }
                for ($y=0; $y < $line_length - $length; $y++)
                {
                  $space_str .= "&nbsp;";
                }
                $intro_str = "<u>$space_str";
                $end_str = "</u>";
              }

              if ($acct_total < 0)
              {
                $acct_total *= -1;
                $acct_total = sprintf "%.2f", $acct_total;
                $acct_total_str .= "<code><font face='$font_str' color=red>$intro_str(" . commify($acct_total) . ")$end_str</font></code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
                $acct_total *= -1;
              }
              else
              {
                $acct_total = sprintf "%.2f", $acct_total;
                $acct_total_str .= "<code><font face='$font_str'>$intro_str" . commify($acct_total) . "$end_str</font></code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
              }
              $acct_total_str .= "</td>";
              $has_accts = 1 if ($sub_acct_data[2] > 0);
            }
            $acct_total_str .= "</tr></table>";
            $acct_temp_str .= "</tr></table>";

            if ($has_accts)
            { # we have to display the list of sub accounts now and the Total line
              # we need to loop through each of the Sub Accounts that this account has and determine what sub-accounts are listed for each year being displayed.
              # we have to do this before we add sublist$count2 to it's parent list.
              my (@sub_acct_names, $num_sub_accts);
              $num_sub_accts = 0;
              for ($year_count=0; $year_count < $num_years; $year_count++)
              {
                my (%local_sub_acct_names);
                my @sub_acct_data = @{$Acct_Data[$sub_count][3+$year_count]};
                my ($xx);
                for ($xx=0; $xx < $sub_acct_data[2]; $xx++)
                {
                  my @entry = @{$sub_acct_data[3][$xx]};
                  my $sub_acct_name = $entry[8];
                  $local_sub_acct_names{$sub_acct_name} = $sub_acct_name if (not exists $local_sub_acct_names{$sub_acct_name});
                }
                my @SubAccts;
                foreach (sort keys %local_sub_acct_names)
                {
                  push @SubAccts, $_;
                }
                $sub_acct_names[$year_count] = [ @SubAccts ];
                $num_sub_accts = keys %local_sub_acct_names if (keys %local_sub_acct_names > $num_sub_accts);
              }

              my ($sub_count2, $sub_acct_temp_str);
              for ($sub_count2=0; $sub_count2 < $num_sub_accts; $sub_count2++)
              {
                $sub_acct_temp_str = $table_str . "<tr><td width=40% align=left>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;$sub_acct_names[0][$sub_count2]</td>";
                for ($year_count=0; $year_count < $num_years; $year_count++)
                {
                  my $string = "<br>";
                  my $width = int (60 / $num_years);
                  my @Years = split /,/, $years;
                  my $tmp_year = $Years[$year_count];
                  my $sub_total = "0.00";

                  # find the total of all entries that this sub account had for the year in question.
                  my ($yy);
                  for ($yy=0; $yy < $Acct_Data[$sub_count][3+$year_count][2]; $yy++)
                  {
                    if ($Acct_Data[$sub_count][3+$year_count][3][$yy][8] eq $sub_acct_names[$year_count][$sub_count2])
                    {
                      my $debit_increases = $Data[$i][2];
                      my $dorc = $Acct_Data[$sub_count][3+$year_count][3][$yy][7];
                      if ($debit_increases eq "t" && $dorc eq "t") # debit increases and amount is a debit
                      {
                        $sub_total += $Acct_Data[$sub_count][3+$year_count][3][$yy][6];
                      }
                      elsif ($debit_increases eq "t" && $dorc eq "f") # debit increases and amount is a credit
                      {
                        $sub_total -= $Acct_Data[$sub_count][3+$year_count][3][$yy][6];
                      }
                      elsif ($debit_increases eq "f" && $dorc eq "t") # debit decreases and amount is a debit
                      {
                        $sub_total -= $Acct_Data[$sub_count][3+$year_count][3][$yy][6];
                      }
                      elsif ($debit_increases eq "f" && $dorc eq "f") # debit decreases and amount is a credit
                      {
                        $sub_total += $Acct_Data[$sub_count][3+$year_count][3][$yy][6];
                      }
                    }
                  }
                  $sub_total = sprintf "%.2f", $sub_total;
                  my ($intro_str, $end_str);
                  if ($sub_count2 == $num_sub_accts - 1)  # see if we need to underline this entry.
                  {
                    my ($space_str, $y, $length);
                    $length = length commify($sub_total);
                    if ($sub_total < 0)
                    {
                      $length++;  # take into account the () and no - sign.
                    }
                    for ($y=0; $y < $line_length - $length; $y++)
                    {
                      $space_str .= "&nbsp;";
                    }
                    $intro_str = "<u>$space_str";
                    $end_str = "</u>";
                  }
                  else
                  {
                    $intro_str = "";
                    $end_str = "";
                  }
                  $sub_acct_names[$year_count][$sub_count2] = "____" if ($sub_acct_names[$year_count][$sub_count2] eq "----");
                  $string = "<a href='javascript:display_entries($number,$acct_num,$tmp_year,\\\"$sub_acct_names[$year_count][$sub_count2]\\\");'>";
                  if ($sub_total < 0)
                  {
                    $sub_total *= -1;
                    $sub_total = sprintf "%.2f", $sub_total;
                    $sub_total = commify($sub_total);
                    $string .= "<font color=red>$intro_str(" . $sub_total . ")$end_str";
                    $sub_total *= -1;
                  }
                  else
                  {
                    $sub_total = commify($sub_total);
                    $string .= "$intro_str" . $sub_total . "&nbsp;&nbsp;$end_str";
                  }
                  $string .= "</a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;" if ($sub_count2 < scalar $sub_acct_names[$year_count]);
                  $sub_acct_temp_str .= "<td width=$width% align=right>&nbsp;$string</td>";
 		}
 		$sub_acct_temp_str .= "</tr></table>";
 		print "        sublist$count2.addItem(\"$sub_acct_temp_str\", -1);\n";
 		$num_list_entries++;
              }
              print "      sublist$count.addList(sublist$count2, \"$acct_temp_str\", $sub_count);\n";
              $num_list_entries++;
              print "      sublist$count.addItem(\"$acct_total_str\", -1);\n";
              $num_list_entries++;
            }
            else
            { # we just display the total line without the word Total
              $acct_total_str =~ s/Total//;
              print "      sublist$count.addItem(\"$acct_total_str\", $sub_count);\n";
              $num_list_entries++;
            }
          }
          print "    mylist.addList(sublist$count, \"$temp_str\", $js_array_index);\n";
          $js_array_index++;
          $num_list_entries++;
          print "    mylist.addItem(\"$total_str\", -1);\n";
          $num_list_entries++;
        }
        else
        {  # no accounts to work with
          $total_str =~ s/Total//;
          print "    mylist.addItem(\"$total_str\", $js_array_index);\n";
          $js_array_index++;
          $num_list_entries++;
        }
      }
    }

    # now print the Net Income
    # Net Income Before Taxes - Income Tax
    my @net_income;
    $temp_str = $table_str . "<tr><td width=40% align=left>&nbsp;<b>Net Income</b></td>";
    for ($z=0; $z < $num_years; $z++)
    {
      my $width = int (60 / $num_years);
      $net_income[$z] = $net_income_before_taxes[$z] - $income_tax[$z];
      $temp_str .= "<td width=$width% align=right><b>";
      if ($net_income[$z] < 0)
     {
        $net_income[$z] *= -1;
        $net_income[$z] = sprintf "%.2f", $net_income[$z];
        $temp_str .= "<code><font face='$font_str' color=red>(" . commify($net_income[$z]) . ")</font></code>&nbsp;&nbsp;";
        $net_income[$z] *= -1;
        $net_income[$z] = sprintf "%.2f", $net_income[$z];
      }
      else
      {
        $net_income[$z] = sprintf "%.2f", $net_income[$z];
        $temp_str .= "<code><font face='$font_str'>" . commify($net_income[$z]) . "</font></code>&nbsp;&nbsp;&nbsp;&nbsp;";
      }
      $temp_str .= "</b></td>";
    }
    $temp_str .= "</tr></table>";
    print "    mylist.addItem(\"$temp_str\", -1);\n";
    $num_list_entries++;

    # l.addItem("<div align=right>This is a test.</div>");
    # subl = new List(false, width, height, bgColor);
    # subl.addItem("This is a sub-item.");
    # l.addList(subl, "Sub List");

    print << "JAVA_CODE";
    mylist.build(width/8,100);
  }

JAVA_CODE
  print "</script>\n";
}

sub reports4IncomeStatementCashFlowJavaScript
{
  my $time = `/bin/date +%s`;
  chomp $time;

  print "<script language=JavaScript1.2>\n";
  print << "JAVA_CODE";
  function printList(list, doc)
  {
    // list - holds the pointer to the list to walk through
    // doc  - holds the pointer to the document we are currently writing into.
    for (var i=0; i < list.types.length; i++)
    {
      if (list.strs[i].indexOf("Sub Accounts") != -1) continue;
      var str = "<table width=" + list.width + " nowrap border=0 cellpadding=0 cellspacing=0><tr><td width=15 nowrap>&nbsp;</td>";
      if (list.l > 0 && list.i > 0) str += "<td width=" + list.l*list.i + " nowrap>&nbsp;</td>";
      str += "<td height=" + (list.height - 9) + " width=" + (list.width-15-list.l*list.i) +" valign=middle align=left>";

      if (list.types[i] == "list" && list.lists[i].visible)
      {
        // if the items in this list have "Sub Accounts" in them, then we don't need to list it and we will do the following block instead.
        if (list.lists[i].strs[0].indexOf("Sub Accounts") == -1)
        {
          str += list.strs[i] + "</td></tr></table>";
          doc.writeln(str);

          printList(list.lists[i], doc);
        }
        //else
        //{  // See if there is an item below us that is our Total line.  If so, we will merge with it.
        //  re = /(.*<td.*>)(.+)(<\\/td>.*)/;
        //  tmp_str = list.strs[i].replace(re, "\$2");
        //  re = /(.+)(<\\/b>)(.*)/;
        //  if ((result = tmp_str.match(re)) != null)
        //  {  // remove the </b> tag from the end
        //    alert("</b> was in " + tmp_str);
        //    tmp_str = result[0] + result[2];
        //    alert("tmp_str now = " + tmp_str);
        //  }
        //  if (i+1 < list.types.length && list.types[i+1] == "item") // there is another item in the list
        //  {
        //    // See if we are it's parent.
        //    if (list.strs[i+1].indexOf(tmp_str + " Total") != -1)
        //    {  // we appear to be a parent!
        //      // create the string to display based upon this List Entry and ignore the entry we are currently on.
        //      re = / Total/;
        //      tmp_str = list.strs[i+1].replace(re, "");  // Get rid of Total from the String
        //      str += tmp_str + "</td></tr></table>";
        //      doc.writeln(str);
        //      i++;  // make sure we skip over this entry, so it is not displayed twice.
        //    }
        //    else  // we still have to display ourselves
        //    {
        //      str += list.strs[i] + "</td></tr></table>";
        //      doc.writeln(str);
        //    }
        //  }
        //  else  // we still have to display ourselves
        //  {
        //    str += list.strs[i] + "</td></tr></table>";
        //    doc.writeln(str);
        //  }
        //}
      }
      else
      {
        if(list.types[i] == "list" && !list.lists[i].visible)
        {  // See if there is an item below us that is our Total line.  If so, we will merge with it.
          re = /(.*<td.*>)(.+)(<\\/td>.*)/;
          tmp_str = list.strs[i].replace(re, "\$2");
          if (i+1 < list.types.length && list.types[i+1] == "item") // there is another item in the list
          {
            // See if we are it's parent.
            if (list.strs[i+1].indexOf(tmp_str + " Total") != -1)
            {  // we appear to be a parent!
              // create the string to display based upon this List Entry and ignore the entry we are currently on.
              re = / Total/;
              tmp_str = list.strs[i+1].replace(re, "");  // Get rid of Total from the String
              str += tmp_str + "</td></tr></table>";
              doc.writeln(str);
              i++;  // make sure we skip over this entry, so it is not displayed twice.
            }
            else  // we still have to display ourselves
            {
              str += list.strs[i] + "</td></tr></table>";
              doc.writeln(str);
            }
          }
          else  // we still have to display ourselves
          {
            str += list.strs[i] + "</td></tr></table>";
            doc.writeln(str);
          }
        }
        else  // we are not a list so display
        {
          str += list.strs[i] + "</td></tr></table>";
          doc.writeln(str);
        }
      }
    }
  }

  function printReport(title, column_header)
  {
    // title - has the title of the window
    // column_header - has the table entry to display the column headers.
    var win_title = "print_report_$time";
    var w = window.open("", win_title, "status=yes,menubar=yes,resizeable=yes,scrollbars=yes");
    var d = w.document;

    d.open();

    d.writeln("<html>");
    d.writeln("<head><title>", title, "</title></head>");
    d.writeln("<body bgcolor=#ffffff>");
    d.writeln("<style type=\\\"text/css\\\"><!--");
    d.writeln("  a:hover   { color: blue }");
    d.writeln("  a:link    { text-decoration: none; color: blue }");
    d.writeln("  a:visited { text-decoration: none; color: blue }");
    d.writeln("  a:active  { text-decoration: none; color: blue }-->");
    d.writeln("</style>");
    // Display the Main Header
    d.writeln(header_string);

    // Display the Column Headers - This is now the first entry in the List.
    //d.writeln(column_header);

    d.writeln("<table border=0 width=90% cellspacing=0 cellpadding=2 bgcolor=" + body_bgcolor + ">");

    // now we walk the main list and display all entries and lists that are visible except for Sub Accounts Lines
    printList(document.lists[0], d);  // Recursively walk through the main list and display all visible content.

    d.writeln("</table>");
    d.writeln("</body>");
    d.writeln("</html>");

    d.close();	// Don't forget this!
  }

JAVA_CODE
  print "</script>\n";
}

sub reports4IncomeStatementValidate
{
  $report_name = "Yearly Income Statement";
  $tos = $input{'tos'};
  if (length $tos == 0)
  {
    PrintErrorHeader();
    print "<h1>Error:  You must specify a Type of Statement!</h1>\n";
    print "Close this window to reselect.";
    CleanUp();
  }
  if (not ($tos eq "gross" || $tos eq "tax"))
  {
    PrintErrorHeader();
    print "<h1>Error:  Invalid value for Level of Detail!</h1>\n";
    print "Value given is '$lod'.<br>$sys_admin";
    CleanUp();
  }
#    # see where the user wants CoGS placed.
#    $CoGS_location = $input{'cogs_location'};
#    if (length $CoGS_location == 0)
#    {
#      PrintErrorHeader();
#      print "<h1>Error:  You must specify where you want the CoGS located!</h1>\n";
#      print "Close this window to reselect.";
#      CleanUp();
#    }
#    if (not ($CoGS_location eq "revenue" || $CoGS_location eq "expenses"))
#    {
#      PrintErrorHeader();
#      print "<h1>Error:  Invalid value for CoGS Location!</h1>\n";
#      print "Value given is '$CoGS_location'.<br>$sys_admin";
#      CleanUp();
#    }
  $years = $input{'years'};
  if (length $years == 0)
  {
    PrintErrorHeader();
    print "<h1>Error:  You must select a year(s) to work with!</h1>\n";
    print "Close this window to reselect.";
    CleanUp();
  }
  # now substitute any \0's with ,'s.
  $years =~ s/\0/,/g;
  my @tmp_years = split /,/, $years;
  if (scalar @tmp_years > 4)
  {
    PrintErrorHeader();
    print "<h1>Error:  You have selected too many years to work with!</h1>\n";
    print "There is currently a maximum of 4 years workable with.<br>Close this window to fix.";
    CleanUp();
  }

  # check and see if they want to display by Sub-Entities or not.
  if (not exists $input{'show_by_sub_entities'})
  {
    PrintErrorHeader();
    print "<h1>Error:  Show by Sub-Entities must be set!</h1>\n";
    print "$sys_admin";
    CleanUp();
  }
  $show_by_sub_entities = $input{'show_by_sub_entities'};
  if (not ($show_by_sub_entities eq "YES" || $show_by_sub_entities eq "NO"))
  {
    PrintErrorHeader();
    print "<h1>Error:  Invalid value set for Show by Sub-Entities!</h1>\n";
    print "Value set was '$show_by_sub_entities'.<br>$sys_admin";
    CleanUp();
  }
  $show_by_sub_entities = ($show_by_sub_entities eq "YES" ? 1:0);
}

return 1;