#$Id: reports_quarterly_income_statement.pm,v 1.1 2001/09/06 10:21:20 moreejt Exp $
#This package is released under the GNU General Public License.
#You should have recieved a copy of the GPL with it.
# Copyright (c) 2000 HLR http://www.pcxperience.org  All rights reserved.
sub reports3QuarterlyIncomeStatementJavaScriptValidation
{
  print <<"END_OF_SCRIPT";
  function reports3QuarterlyIncomeStatementJavaScriptValidation(doc)
  {
    var msg = "";
    var tmp = "";

    // verify that they have specified at least one complete date range
    var date1_start, date1_end, date2_start, date2_end, date3_start, date3_end, date4_start, date4_end;
    date1_start = doc.row1_start.value;
    date1_end   = doc.row1_end.value;
    date2_start = doc.row2_start.value;
    date2_end   = doc.row2_end.value;
    date3_start = doc.row3_start.value;
    date3_end   = doc.row3_end.value;
    date4_start = doc.row4_start.value;
    date4_end   = doc.row4_end.value;

    if (date1_start.length == 0 && date1_end.length == 0 && date2_start.length == 0 && date2_end.length == 0 && date3_start.length == 0 && date3_end.length == 0 && date4_start.length == 0 && date4_end.length == 0)
    {
      msg += "You must specify some dates to work with!\\n";
    }
    else  // something is filled in, now verify that it is a complete range
    {
      if ((date1_start.length > 0 && date1_end.length == 0) || (date1_start.length == 0 && date1_end.length > 0))
      {
        msg += "You must specify a complete range of dates for Row 1!\\n";
      }
      else
      {
        if (date1_start.length > 0 && date1_end.length > 0) // check and make sure the dates are valid.
        {
          tmp = IsValidDateSyntax(date1_start);
          if (tmp.length > 0)
          {
            msg += "Date 1 Start: " + tmp + "\\n";
          }
          tmp = IsValidDateSyntax(date1_end);
          if (tmp.length > 0)
          {
            msg += "Date 1 End: " + tmp + "\\n";
          }
        }
      }
      if ((date2_start.length > 0 && date2_end.length == 0) || (date2_start.length == 0 && date2_end.length > 0))
      {
        msg += "You must specify a complete range of dates for Row 2!\\n";
      }
      else
      {
        if (date2_start.length > 0 && date2_end.length > 0) // check and make sure the dates are valid.
        {
          tmp = IsValidDateSyntax(date2_start);
          if (tmp.length > 0)
          {
            msg += "Date 2 Start: " + tmp + "\\n";
          }
          tmp = IsValidDateSyntax(date2_end);
          if (tmp.length > 0)
          {
            msg += "Date 2 End: " + tmp + "\\n";
          }
        }
      }
      if ((date3_start.length > 0 && date3_end.length == 0) || (date3_start.length == 0 && date3_end.length > 0))
      {
        msg += "You must specify a complete range of dates for Row 3!\\n";
      }
      else
      {
        if (date3_start.length > 0 && date3_end.length > 0) // check and make sure the dates are valid.
        {
          tmp = IsValidDateSyntax(date3_start);
          if (tmp.length > 0)
          {
            msg += "Date 3 Start: " + tmp + "\\n";
          }
          tmp = IsValidDateSyntax(date3_end);
          if (tmp.length > 0)
          {
            msg += "Date 3 End: " + tmp + "\\n";
          }
        }
      }
      if ((date4_start.length > 0 && date4_end.length == 0) || (date4_start.length == 0 && date4_end.length > 0))
      {
        msg += "You must specify a complete range of dates for Row 4!\\n";
      }
      else
      {
        if (date4_start.length > 0 && date4_end.length > 0) // check and make sure the dates are valid.
        {
          tmp = IsValidDateSyntax(date4_start);
          if (tmp.length > 0)
          {
            msg += "Date 4 Start: " + tmp + "\\n";
          }
          tmp = IsValidDateSyntax(date4_end);
          if (tmp.length > 0)
          {
            msg += "Date 4 End: " + tmp + "\\n";
          }
        }
      }
    }

    return msg;
  }
END_OF_SCRIPT
}

sub reports3QuarterlyIncomeStatementCustomizedFormItems
{
  # display 4 rows of input fields for the dates and a select box that spans the 4 rows to display the values for the user to select from.
  print "<tr><td><table border=0 width=100% cellpadding=2 cellspacing=0 bgcolor=\"$menu_bgcolor\">\n";
  print "    <tr><th align=left>Start Date</th><th align=left>End Date</th><th align=left>Select Criteria</th><tr>\n";
  print "    <tr><td align=left><font color=\"$menu_fgcolor\">Column 1</font><input type=text name=\"row1_start\" value=\"\" size=10 maxlength=10></td>";
  print "        <td align=left><input type=text name=\"row1_end\" value=\"\" size=10 maxlength=10>&nbsp;<input type=button name=\"row1_clear\" value=\"Clear\" onClick=\"ClearRow(1);\"></td>";
  print "        <td align=left rowspan=4 valign=top><select name=\"date_select\" width=100 size=\"7\" onChange=\"FillNextRow();\"></select></td></tr>\n";
  print "    <tr><td align=left><font color=\"$menu_fgcolor\">Column 2</font><input type=text name=\"row2_start\" value=\"\" size=10 maxlength=10></td>";
  print "        <td align=left><input type=text name=\"row2_end\" value=\"\" size=10 maxlength=10>&nbsp;<input type=button name=\"row2_clear\" value=\"Clear\" onClick=\"ClearRow(2);\"></td></tr>\n";
  print "    <tr><td align=left><font color=\"$menu_fgcolor\">Column 3</font><input type=text name=\"row3_start\" value=\"\" size=10 maxlength=10></td>";
  print "        <td align=left><input type=text name=\"row3_end\" value=\"\" size=10 maxlength=10>&nbsp;<input type=button name=\"row3_clear\" value=\"Clear\" onClick=\"ClearRow(3);\"></td></tr>\n";
  print "    <tr><td align=left><font color=\"$menu_fgcolor\">Column 4</font><input type=text name=\"row4_start\" value=\"\" size=10 maxlength=10></td>";
  print "        <td align=left><input type=text name=\"row4_end\" value=\"\" size=10 maxlength=10>&nbsp;<input type=button name=\"row4_clear\" value=\"Clear\" onClick=\"ClearRow(4);\"></td></tr>\n";
  print "</table></td></tr>\n"; # end of input table.
  print "<tr><td align=center><font color=\"$menu_fgcolor\">Type of Report:&nbsp;</font><select name=\"report_type\">\n<option value=\"services\">Goods & Services\n<option value=\"investment\">Investment\n</select></td></tr>\n";
}

sub reports4QuarterlyIncomeStatementDisplayForm
{
  # create the header string to be displayed in the printable version of the report.
  my $header_string = "<center><table border=0 width=100% cellspacing=0 cellpadding=2 bgcolor='$body_bgcolor'><tr><td width=35%>Ledger <font color='$ledger_color'>$ledger_name</font>";
  $header_string .= "</td><td align=center width=30%><h3>$custom_title</h3></td><td align=right>$date</td></tr>";
  if (length $date_range_string > 0)
  {
    $header_string .= "<tr><td width=35%><br></td><td align=center width=30%>$date_range_string</td><td><br></td></tr>";
  }
  $header_string .= "</table><br>";
  #print "You entered $num_columns Row(s) to work with.<br>\n";
  if (not $print_report)
  {
    print "<script language=Javascript1.2>\n";
    print "  var body_bgcolor=\"$body_bgcolor\";\n";
    print "</script>\n";

    # display the Print Button
    my $time = `/bin/date +%s`;
    chomp $time;

    print "<form name=\"Dummy_form\" method=post action=\"\" target=\"income_statement_other_view\">\n";  # removed the _$time and added income_statement_ to the beginning.;
    print "<div align=right><input type=button name=\"Print\" value=\"Print View\" onClick=\"printReport();\"></div>\n";
    print "<input type=hidden name=\"ledger\" value=\"$ledger_db\">\n";
    print "<input type=hidden name=\"report_group\" value=\"$report_group\">\n";
    print "<input type=hidden name=\"report_type\" value=\"$report_type\">\n";
    print "<input type=hidden name=\"run\" value=\"\">\n";
    print "<input type=hidden name=\"report\" value=\"$report\">\n";
    print "<input type=hidden name=\"custom_report_name\" value=\"$custom_title\">\n";
    print "<input type=hidden name=\"show_zero_balances\" value=\"" . ($show_zero_balances ? "YES" : "NO") . "\">\n";
    print "<input type=hidden name=\"show_accounts_as\" value=\"" . ($show_accounts_as ? "name-number" : "number-name") . "\">\n";
    print "<input type=hidden name=\"data_precision\" value=\"$data_precision\">\n";
    print "<input type=hidden name=\"font_size_text\" value=\"$font_size_text\">\n";
    print "<input type=hidden name=\"font_size_data\" value=\"$font_size_data\">\n";
    my $z;
    for ($z=1; $z <= $max_columns; $z++)
    {
      my $temp = "row$z" . "_start";
      print "<input type=hidden name=\"$temp\" value=\"" . ($input{$temp}) . "\">";
      $temp = "row$z" . "_end";
      print "<input type=hidden name=\"$temp\" value=\"" . ($input{$temp}) . "\">\n";
    }
    print "<input type=hidden name=\"show_by_sub_entities\" value=\"" . ($show_by_sub_entities ? "YES" : "NO") . "\">\n";
    print "<input type=hidden name=\"show_non_tax_section\" value=\"" . ($show_non_tax_section ? "YES" : "NO") . "\">\n";
    print "<input type=hidden name=\"report_name\" value=\"$report_name\">\n";
    print "<input type=hidden name=\"print_report\" value=\"\">\n";
    print "<input type=hidden name=\"acct_type_num\" value=\"\">\n";
    print "<input type=hidden name=\"acct_num\" value=\"\">\n";
    print "<input type=hidden name=\"acct_name\" value=\"\">\n";
    print "<input type=hidden name=\"debit_increases\" value=\"\">\n";
    print "<input type=hidden name=\"sub_acct_name\" value=\"\">\n";
    print "<input type=hidden name=\"sub_entity_code\" value=\"\">\n";
    print "<input type=hidden name=\"sub_entity_name\" value=\"\">\n";
    print "<input type=hidden name=\"start_date\" value=\"\">\n";
    print "<input type=hidden name=\"end_date\" value=\"\">\n";
    print "<input type=hidden name=\"sub_acct_num\" value=\"\">\n";
    print "<input type=hidden name=\"header_string\" value=\"$header_string\">\n";
    print "<input type=hidden name=\"lists_opened\" value=\"\">\n";
    print "</form>\n";

    #print "There are '$num_list_entries' entries to be displayed at a list height of '$list_height'.<br>\n";

    #print "<table border=0 height=" . (($num_list_entries + 1) * $list_height) . "><tr><td>&nbsp;</td></tr></table>\n";
  }
  else
  {
    my $lists_opened = $input{'lists_opened'};
    #print "Lists Opened = '$lists_opened'<br>\n";
    # setup the initial table to display in.
    print "<table border=0 cellpadding=2 cellspacing=0 width=100% bgcolor=#ffffff>\n";
    $text_width = 20; # resize the proportions of the text to the data.
    $data_width = 80;

    # see if we need to display the In X's line
    if ($data_precision != 1)
    {
      my $temp_str = "<tr><td><table border=0 width=100% cellpadding=2 cellspacing=0><tr><td width=100% align=right><font face='$font_str' size=$font_size_text>(<i>In " . $$precision_table{$data_precision} . "</i>)</font></td></tr></table></td></tr>";
      print "$temp_str\n";
    }

    my (@Dates, $z, @SubEntity);
    for ($z=1; $z <= $num_columns; $z++)
    {
      my @Entry = ();
      my $temp_str = "row$z" . "_start";
      $Entry[0] = $input{$temp_str};
      $temp_str = "row$z" . "_end";
      $Entry[1] = $input{$temp_str};
      $Dates[$z-1] = [ @Entry ];
    }
    $SubEntity[0] = -2;
    $SubEntity[1] = '';
    print "<tr><td><table border=0 width=100% cellpadding=2 cellspacing=0><tr><td width=$text_width% align=left><br></td>";
    for ($z=0; $z < $max_columns; $z++) # removed the = from <= as the loop was doing 1 too many.
    {
      my $width = ($data_width / $max_columns);
      print "<td width=$width% align=right><font face='$font_str' size=$font_size_text>";
      if ($z < $num_columns)
      {
        my $temp = $Dates[$z][0];
        $temp =~ s/-/\//g;
        print "<code>$temp&nbsp;<br>-&nbsp;";
        $temp = $Dates[$z][1];
        $temp =~ s/-/\//g;
        print "$temp&nbsp;</code>";
      }
      else
      {
        print "<br>";
      }
      print "</font></td>";
    }
    print "</tr></table></td></tr>\n";
    # see if we need to do a SubEntity display or just display everything.
    if ($show_by_sub_entities)
    {
      my @NetIncomes = ("0.00", "0.00", "0.00", "0.00");  # Assuming only 4 columns max.
      my @SubEntities = $report_obj->GetSubEntities();
      if ($report_obj->didErrorOccur)
      {
        print $report_obj->getErrorMessage;
        CleanUp();
      }
      for ($z=0; $z < scalar @SubEntities; $z++)
      {
        @SubEntity = @{$SubEntities[$z]};
        my @netIncomes = doIncomeStatement(\@SubEntity, \@Dates, $num_columns, $lists_opened, 1, 1, 1, $report_type); # show tax, printable view, Income Tax Expense
        my $zz;
        for ($zz=0; $zz < $max_columns; $zz++)
        {
          $NetIncomes[$zz] += $netIncomes[$zz];
        }

        if ($show_non_tax_section)
        {
          @netIncomes = doIncomeStatement(\@SubEntity, \@Dates, $num_columns, $lists_opened, 0, 1, 1, $report_type); # don't show tax, printable view, Income Tax Expense
          for ($zz=0; $zz < $max_columns; $zz++)
          {
            $NetIncomes[$zz] += $netIncomes[$zz];
          }
        }

        print "<tr><td><table border=0 width=100% cellpadding=2 cellspacing=0><tr><td><font face='$font_str' size=$font_size_text><hr></font></td></tr></table></td></tr>\n";  # print the horizontal dividing line
      }
      # Display the total Net Income calculated
      my $temp_str = "<tr><td><table border=0 width=100% cellpadding=2 cellspacing=0><tr><td width=$text_width% align=left><font face='$font_str' size=$font_size_text><b>Total Net Income</b></font></td>";
      for ($z=0; $z < $max_columns; $z++)
      {
        my $width = ($data_width / $max_columns);
        $temp_str .= "<td width=$width% align=right><font face='$font_str' size=$font_size_data>";
        if ($z < $num_columns)
        {
          my $temp_value = $NetIncomes[$z];
          if ($data_precision == 1)
          {
            $temp_value = sprintf "%.2f", $temp_value;
          }
          else
          {
            $temp_value = sprintf "%.0f", $temp_value;
          }
          if ($temp_value < 0)
          {
            $temp_value *= -1;
            if ($data_precision == 1)
            {
              $temp_value = sprintf "%.2f", $temp_value;
            }
            else
            {
              $temp_value = sprintf "%.0f", $temp_value;
            }
          }
          if ($NetIncomes[$z] < 0)
          {
            $temp_str .= "<font color=red>(";
          }
          $temp_str .= "<b>" . (commify($temp_value)) . "</b>";
          if ($NetIncomes[$z] < 0)
          {
            $temp_str .= ")</font>&nbsp;&nbsp;";
          }
          else
          {
            $temp_str .= "&nbsp;&nbsp;&nbsp;&nbsp;";
          }
        }
        else
        {
          $temp_str .= "<br>";
        }
        $temp_str .= "</font></td>";
      }
      $temp_str .= "</tr></table></td></tr>\n";
      print "$temp_str";
    }
    else
    {
      doIncomeStatement(\@SubEntity, \@Dates, $num_columns, $lists_opened, 1, 1, 1, $report_type);  # show tax, printable view, Income Tax Expense

      if ($show_non_tax_section)
      {
        doIncomeStatement(\@SubEntity, \@Dates, $num_columns, $lists_opened, 0, 1, 1, $report_type); # don't show tax, printable view, Income Tax Expense
      }
    }

    print "</table>\n";
  }
}

sub reports3QuarterlyIncomeStatementJavaScript
{
  $OnLoadString = "onLoad=\"do_load();\"";
  $onResetString = "onClick=\"return do_Reset();\"";
  print <<"END_OF_HEADER";
  <script language=\"Javascript1.2\">
  <!--
    var report_name = "$report_name";
    var Curr_FYear = $working_year;

    function create_select_name(index, text, start, end)
    {
      this.value = index;
      this.text = text;
      this.start = start;
      this.end = end;
    }

    var date_names = new Array();

END_OF_HEADER
    # do the lookup in the known_years_tb for the past 5 years and
    # create the array entries that correspond to the ranges being
    # looked for: year, 1'st half, last half, 4 quarters

    #******************************************************************************************************************************
    #print "date_names[0] = new create_select_name(0, \"1999\", \"02/01/1999\", \"01/31/2000\");\n";

    $result = $conn->exec("SELECT year, start_date, end_date, q1_start, q1_end, q2_start, q2_end, q3_start, q3_end, q4_start, q4_end FROM known_years_tb where ledger_code = '$ledger_code' ORDER BY year DESC");
    if ($result->resultStatus != PGRES_TUPLES_OK)
    {
      print "</script></head><body bgcolor=#ffffff>\n";
      print "<h1>Error:  Accessing database failed!</h1>\n";
      print $conn->errorMessage . "<br>Tried to get list of known years to work with.<br>$sys_admin";
      CleanUp();
    }
    if ($result->ntuples == 0)
    {
      print "</script></head><body bgcolor=#ffffff>\n";
      print "<h1>Error:  There are no known years defined!</h1>\n";
      print "The Ledger does not appear to be configured!<br>$sys_admin";
      CleanUp();
    }

    my ($j, $k, $year, $year_start, $year_end, $q1_start, $q2_start, $q3_start, $q4_start, $q1_end, $q2_end, $q3_end, $q4_end);
    for ($j=0, $k=0; $j < $result->ntuples && $j < 5; $j++)
    {
      $year = $result->getvalue($j, 0);
      $year_start = $result->getvalue($j, 1);
      $year_end = $result->getvalue($j, 2);
      $q1_start = $result->getvalue($j, 3);
      $q1_end = $result->getvalue($j, 4);
      $q2_start = $result->getvalue($j, 5);
      $q2_end = $result->getvalue($j, 6);
      $q3_start = $result->getvalue($j, 7);
      $q3_end = $result->getvalue($j, 8);
      $q4_start = $result->getvalue($j, 9);
      $q4_end = $result->getvalue($j, 10);

      print "    date_names[" . $k++ . "] = new create_select_name($k, \"$year\", \"$year_start\", \"$year_end\");\n";
      print "    date_names[" . $k++ . "] = new create_select_name($k, \"first half $year\", \"$q1_start\", \"$q2_end\");\n";
      print "    date_names[" . $k++ . "] = new create_select_name($k, \"second half $year\", \"$q3_start\", \"$q4_end\");\n";
      print "    date_names[" . $k++ . "] = new create_select_name($k, \"1Q $year\", \"$q1_start\", \"$q1_end\");\n";
      print "    date_names[" . $k++ . "] = new create_select_name($k, \"2Q $year\", \"$q2_start\", \"$q2_end\");\n";
      print "    date_names[" . $k++ . "] = new create_select_name($k, \"3Q $year\", \"$q3_start\", \"$q3_end\");\n";
      print "    date_names[" . $k++ . "] = new create_select_name($k, \"4Q $year\", \"$q4_start\", \"$q4_end\");\n";
    }

    print <<"END_OF_HEADER";

    function do_load()
    {
      document.customize_form.date_select.selectedIndex = 0;
      date_select_fill();
    }

    function date_select_fill()
    {
      document.customize_form.date_select.options.length = 0;

      for (var count=0; count < date_names.length; count++)
      {
        document.customize_form.date_select.options[count] = new Option(date_names[count].text, date_names[count].value);
      }
    }

    function ClearRow(row)
    {
      switch (row)
      {
        case 1:
        	document.customize_form.row1_start.value = "";
        	document.customize_form.row1_end.value ="";
        	document.customize_form.row1_start.focus();
        	break;
        case 2:
        	document.customize_form.row2_start.value = "";
        	document.customize_form.row2_end.value ="";
        	document.customize_form.row2_start.focus();
        	break;
        case 3:
        	document.customize_form.row3_start.value = "";
        	document.customize_form.row3_end.value ="";
        	document.customize_form.row3_start.focus();
        	break;
        case 4:
        	document.customize_form.row4_start.value = "";
        	document.customize_form.row4_end.value ="";
        	document.customize_form.row4_start.focus();
        	break;
        default:
        	alert("Invalid Row Specified to clear!  Value = "+row);
        	break;
      }
    }

    function FillNextRow()
    {
      // get the index of the selected item and use it to lookup the start and end dates to fill into the next available row.
      // check to see if there are any empty rows.  I am assuming that if the start field is empty then the row is empty.
      // if no rows are empty then we should either, overwrite the last row or blow an error saying that no rows are empty.
      // possibly allow them to enter the number of the row they want the value placed in.
      var index = document.customize_form.date_select.selectedIndex;

      if (index == -1)
      {
        alert("No item selected from the Select Criteria combo box!");
        return;
      }

      if (index > date_names.length)
      {
        alert("The selected item is out of range!  Value = "+index);
        return;
      }

      // now see if we have any empty rows.
      var row_index=0;
      if (document.customize_form.row1_start.value.length == 0)
      {
        row_index = 1;
      }
      else
      {
        if (document.customize_form.row2_start.value.length == 0)
        {
          row_index = 2;
        }
        else
        {
          if (document.customize_form.row3_start.value.length == 0)
          {
            row_index = 3;
          }
          else
          {
            if (document.customize_form.row4_start.value.length == 0)
            {
              row_index = 4;
            }
          }
        }
      }

      switch (row_index)
      {
        case 0:
        	alert("There are no empty rows to fill in!  Please empty one and try again.");
        	break;
        case 1:
        	document.customize_form.row1_start.value = date_names[index].start;
        	document.customize_form.row1_end.value = date_names[index].end;
        	document.customize_form.row1_start.focus();
        	break;
        case 2:
        	document.customize_form.row2_start.value = date_names[index].start;
        	document.customize_form.row2_end.value = date_names[index].end;
        	document.customize_form.row2_start.focus();
        	break;
        case 3:
        	document.customize_form.row3_start.value = date_names[index].start;
        	document.customize_form.row3_end.value = date_names[index].end;
        	document.customize_form.row3_start.focus();
        	break;
        case 4:
        	document.customize_form.row4_start.value = date_names[index].start;
        	document.customize_form.row4_end.value = date_names[index].end;
        	document.customize_form.row4_start.focus();
        	break;
      }

      // unselect the item
      document.customize_form.date_select.selectedIndex = -1;
    }

    function do_Reset()
    {
      // Set all rows to empty
      for (var i=4; i >= 1; i--)
      {
        ClearRow(i);
      }

      // Set the report name to the default value.
      document.customize_form.custom_report_name.value = report_name;


      document.customize_form.row1_start.focus();  // return focus to row 1

      return false;
    }
  //-->
  </script>
END_OF_HEADER
}

sub reports4QuarterlyIncomeStatementJavaScript
{
  if (not $print_report)  # we are displaying a detailed view
  {
    # generate the Javascript code to display the detailed view lists, etc.
    print "<script language=\"JavaScript1.2\" SRC=\"../js/resize.js\"></script>\n";
    print "<script language=\"JavaScript1.2\" SRC=\"../js/list.js\"></script>\n";
    print "<script language=JavaScript1.2>\n";
    print "// Other Global Variables\n";
    print "var Ledger = \"$ledger_db\";\n";
    print "var Site_Dir = \"$site_dir\";\n";
    print "var NumColumns = $num_columns;\n\n";
    print "  function InitializeArray()\n";
    print "  {\n";
    print "    // Call init() to start the Dynamic Lists\n";
    print "    init();\n";
    print "  }\n\n";

    print << "JAVA_CODE";
  function display_entries(Acct_Type_num, Acct_Num, Acct_Name, Debit_Increases, Start_Date, End_Date, Sub_Acct_Num, Sub_Acct_Name, SubEntity_Code, SubEntity_Name)
  {
    // set the action of Dummy_form to point to report_detailed_view.cgi and submit the form
    document.Dummy_form.action = Site_Dir + "/cgi-bin/report_detailed_view.cgi";
    document.Dummy_form.acct_type_num.value = Acct_Type_num;
    document.Dummy_form.acct_num.value = Acct_Num;
    document.Dummy_form.acct_name.value = Acct_Name;
    document.Dummy_form.debit_increases.value = Debit_Increases;
    document.Dummy_form.sub_acct_name.value = Sub_Acct_Name;
    document.Dummy_form.sub_entity_code.value = SubEntity_Code;
    document.Dummy_form.sub_entity_name.value = SubEntity_Name;
    document.Dummy_form.start_date.value = Start_Date;
    document.Dummy_form.end_date.value = End_Date;
    document.Dummy_form.sub_acct_num.value = Sub_Acct_Num;
    document.Dummy_form.submit();

    return false;
  }

  function OpenedLists(list)
  {
    var value = "";  // The return value that indicates all opened lists encountered.

    for (var i=0; i < list.types.length; i++)
    {
      if (list.types[i] == "list" && list.lists[i].visible)
      {
        if (value.length > 0)
        {
          value += ",";
        }
        value += list.indexes[i];
        var temp = OpenedLists(list.lists[i]);
        if (temp.length > 0)
        {
          value += "," + temp;
        }
      }
    }

    return value;
  }

  function printReport()
  {
    // First we need to walk through the list and determine which sub-lists are open and mark them as being needed to be displayed on the print view.
    var lists_opened = document.Dummy_form.lists_opened; // point to the hidden variable we will use.
    lists_opened.value = ""; // clear it as it may have already been set and then re-run without the page being re-loaded.

    lists_opened.value = OpenedLists(mylist);
    //alert("The Lists currently open are: "+lists_opened.value);
    // set the action of Dummy_form to point to reports4.cgi and submit the form
    document.Dummy_form.action = Site_Dir + "/cgi-bin/reports4.cgi";
    document.Dummy_form.submit();

    return false;
  }

  function init()
  {
    if (parseInt(navigator.appVersion) < 4)
    {
      alert("Sorry, a 4.0+ browser is required to view this report.");
      return;
    }

    var width, height = 30;
    //if (isNav4) width = 3 * window.innerWidth / 4;
    //else width = 3 * document.body.clientWidth / 4;
    width = 800;

    //alert ("Window.innerWidth = " + window.innerWidth + ", width = " + width);

    var bgColor = "$body_bgcolor";
    mylist = new List(true, width, height, bgColor);

JAVA_CODE
    # See if we need to create the entry that says what the data precision is if not == 1
    if ($data_precision > 1)
    {
      my $temp_str = "<table border=0 width=100% cellpadding=2 cellspacing=0><tr><td width=100% align=right><font face='$font_str'>(<i>In " . $$precision_table{$data_precision} . "</i>)</font></td></tr></table>";
      print "    mylist.addItem(\"$temp_str\", -1);\n";
      $num_list_entries++;
    }

    # at this point call the doIncomeStatement function with the correct parameters to display the report.
    my (@Dates, $z, @SubEntity);
    for ($z=1; $z <= $num_columns; $z++)
    {
      my @Entry = ();
      my $temp_str = "row$z" . "_start";
      $Entry[0] = $input{$temp_str};
      $temp_str = "row$z" . "_end";
      $Entry[1] = $input{$temp_str};
      $Dates[$z-1] = [ @Entry ];
    }
    $SubEntity[0] = -2;
    $SubEntity[1] = '';
    my $temp_str = "<table border=0 width=100% cellpadding=2 cellspacing=0><tr><td width=$text_width% align=left><br></td>";
    for ($z=0; $z < $max_columns; $z++) # removed the = from <= because it would be doing 1 more loop than needed.
    {
      my $width = ($data_width / $max_columns);
      $temp_str .= "<td width=$width% align=right><font face='$font_str'>";
      if ($z < $num_columns)
      {
        my $temp = $Dates[$z][0];
        $temp =~ s/-/\//g;
        $temp_str .= "<code>$temp&nbsp;&nbsp;&nbsp;<br>-&nbsp;";
        $temp = $Dates[$z][1];
        $temp =~ s/-/\//g;
        $temp_str .= "$temp&nbsp;&nbsp;&nbsp;</code>";
      }
      else
      {
        $temp_str .= "<br>";
      }
      $temp_str .= "</font></td>";
    }
    $temp_str .= "</tr></table>";
    # add the Date header string to the list to display
    print "    mylist.addItem(\"$temp_str\", -1);\n";
    $num_list_entries++;

    # see if we need to do a SubEntity display or just display everything.
    if ($show_by_sub_entities)
    {
      my @NetIncomes = ("0.00", "0.00", "0.00", "0.00");  # Assuming only 4 columns max.
      my @SubEntities = $report_obj->GetSubEntities();
      if ($report_obj->didErrorOccur)
      {
        print "</script></head><body bgcolor=#ffffff>\n";
        print $report_obj->getErrorMessage;
        CleanUp();
      }
      for ($z=0; $z < scalar @SubEntities; $z++)
      {
        @SubEntity = @{$SubEntities[$z]};
        my @netIncomes = doIncomeStatement(\@SubEntity, \@Dates, $num_columns, "", 1, 0, 1, $report_type); # show tax, detailed view, Income Tax Expense
        my $zz;
        for ($zz=0; $zz < $max_columns; $zz++)
        {
          $NetIncomes[$zz] += $netIncomes[$zz];
        }

        if ($show_non_tax_section)
        {
          @netIncomes = doIncomeStatement(\@SubEntity, \@Dates, $num_columns, "", 0, 0, 1, $report_type); # don't show tax, detailed view, Income Tax Expense
          for ($zz=0; $zz < $max_columns; $zz++)
          {
            $NetIncomes[$zz] += $netIncomes[$zz];
          }
        }

        print "    mylist.addItem(\"<hr>\", -1);\n";  # print the horizontal dividing line
        $num_list_entries++;
      }
      # Display the total Net Income calculated
      my $temp_str = "<table border=0 width=100% cellpadding=2 cellspacing=0><tr><td width=$text_width% align=left><font face='$font_str'><b>Total Net Income</b></font></td>";
      for ($z=0; $z < $max_columns; $z++)
      {
        my $width = ($data_width / $max_columns);
        $temp_str .= "<td width=$width% align=right><font face='$font_str'>";
        if ($z < $num_columns)
        {
          my $temp_value = $NetIncomes[$z];
          if ($data_precision == 1)
          {
            $temp_value = sprintf "%.2f", $temp_value;
          }
          else
          {
            $temp_value = sprintf "%.0f", $temp_value;
          }
          if ($temp_value < 0)
          {
            $temp_value *= -1;
            if ($data_precision == 1)
            {
              $temp_value = sprintf "%.2f", $temp_value;
            }
            else
            {
              $temp_value = sprintf "%.0f", $temp_value;
            }
          }
          if ($NetIncomes[$z] < 0)
          {
            $temp_str .= "<font color=red>(";
          }
          $temp_str .= "<b>" . (commify($temp_value)) . "</b>";
          if ($NetIncomes[$z] < 0)
          {
            $temp_str .= ")</font>&nbsp;&nbsp;";
          }
          else
          {
            $temp_str .= "&nbsp;&nbsp;&nbsp;&nbsp;";
          }
        }
        else
        {
          $temp_str .= "<br>";
        }
        $temp_str .= "</font></td>";
      }
      $temp_str .= "</tr></table>";
      # add the Total Net Income string to the list to display
      print "      mylist.addItem(\"$temp_str\", -1);\n";
      $num_list_entries++;
    }
    else
    {
      doIncomeStatement(\@SubEntity, \@Dates, $num_columns, "", 1, 0, 1, $report_type);  # show tax, detailed view, Income Tax Expense

      if ($show_non_tax_section)
      {
        doIncomeStatement(\@SubEntity, \@Dates, $num_columns, "", 0, 0, 1, $report_type); # don't show tax, detailed view, Income Tax Expense
      }
    }

    print "    mylist.build(width/8, 100);\n";
    print "  }\n";  # end of the init() function.
    print "</script>\n";
  }
}

sub reports4QuarterlyIncomeStatementValidate
{
    $report_name = "Income Statement";  # removed Quarterly

    # make sure that they specified some dates to report on.
    if (length $input{'row1_start'} == 0 && length $input{'row1_end'} == 0 && length $input{'row2_start'} == 0 && length $input{'row2_end'} == 0 && length $input{'row3_start'} == 0 && length $input{'row3_end'} == 0 && length $input{'row4_start'} == 0 && length $input{'row4_end'} == 0)
    {
      PrintErrorHeader();
      print "<h1>Error:  You must specify some dates to report on!</h1>\n";
      print "Close this window to select the dates to search on.";
      CleanUp();
    }

    my @rows = (0,0,0,0);
    $num_columns = 0;
    # at this point, we appear to have something entered.  Now we just have to make sure that we have complete rows and no rows skipped.
    if (length $input{'row1_start'} != 0 && length $input{'row1_end'} != 0)
    {
      $rows[0] = 1;
      $num_columns++;
    }
    elsif (length $input{'row1_start'} != 0 || length $input{'row1_end'} != 0)
    {
      PrintErrorHeader();
      print "<h1>Error:  You must specify a complete Column for Row 1!</h1>\n";
      print "Close this window to fix the problem.";
      CleanUp();
    }
    if (length $input{'row2_start'} != 0 && length $input{'row2_end'} != 0)
    {
      $rows[1] = 1;
      $num_columns++;
    }
    elsif (length $input{'row2_start'} != 0 || length $input{'row2_end'} != 0)
    {
      PrintErrorHeader();
      print "<h1>Error:  You must specify a complete Column for Row 2!</h1>\n";
      print "Close this window to fix the problem.";
      CleanUp();
    }
    if (length $input{'row3_start'} != 0 && length $input{'row3_end'} != 0)
    {
      $rows[2] = 1;
      $num_columns++;
    }
    elsif (length $input{'row3_start'} != 0 || length $input{'row3_end'} != 0)
    {
      PrintErrorHeader();
      print "<h1>Error:  You must specify a complete Column for Row 3!</h1>\n";
      print "Close this window to fix the problem.";
      CleanUp();
    }
    if (length $input{'row4_start'} != 0 && length $input{'row4_end'} != 0)
    {
      $rows[3] = 1;
      $num_columns++;
    }
    elsif (length $input{'row4_start'} != 0 || length $input{'row4_end'} != 0)
    {
      PrintErrorHeader();
      print "<h1>Error:  You must specify a complete Column for Row 4!</h1>\n";
      print "Close this window to fix the problem.";
      CleanUp();
    }

    # at this point all rows that have something in them are complete rows, now
    # we just need to make sure that no rows are being skipped.
    if ($rows[0])
    {
      if ($rows[1])
      {
        if ($rows[2])
        {
        }
        elsif ($rows[3])
        {
          PrintErrorHeader();
          print "<h1>Error:  You must specify Columns in Sequential Order!</h1>\n";
          print "Close this window and specify a value for Row 3.";
          CleanUp();
        }
      }
      elsif ($rows[2] || $rows[3])
      {
        PrintErrorHeader();
        print "<h1>Error:  You must specify Columns in Sequential Order!</h1>\n";
        print "Close this window and specify a value for Row 2.";
        CleanUp();
      }
    }
    else
    {
      PrintErrorHeader();
      print "<h1>Error:  You must specify Columns in Sequential Order!</h1>\n";
      print "Close this window and specify a value for Row 1.";
      CleanUp();
    }

    # $num_columns holds the number of rows that were specified.
    # verify that all the dates are valid.
    for ($i=1; $i <= $num_columns; $i++)
    {
      my $temp = "row$i" . "_start";
      $$temp = $input{$temp};
      if (!IsValidDateSyntax($$temp))
      {
        PrintErrorHeader();
        print "<h1>Error:  Date '$$temp' in Column $i is invalid!</h1>\nClose this window to fix the problem.\n";
        CleanUp();
      }
      $temp = "row$i" . "_end";
      $$temp = $input{$temp};
      if (!IsValidDateSyntax($$temp))
      {
        PrintErrorHeader();
        print "<h1>Error:  Date '$$temp' in Column $i is invalid!</h1>\nClose this window to fix the problem.\n";
        CleanUp();
      }
    }

    if (exists $input{'print_report'})
    {
      $print_report = 1;
    }
    else
    {
      $print_report = 0;
    }

    # check and see if they want to display by Sub-Entities or not.
    if (not exists $input{'show_by_sub_entities'})
    {
      PrintErrorHeader();
      print "<h1>Error:  Show by Sub-Entities must be set!</h1>\n";
      print "$sys_admin";
      CleanUp();
    }
    $show_by_sub_entities = $input{'show_by_sub_entities'};
    if (not ($show_by_sub_entities eq "YES" || $show_by_sub_entities eq "NO"))
    {
      PrintErrorHeader();
      print "<h1>Error:  Invalid value set for Show by Sub-Entities!</h1>\n";
      print "Value set was '$show_by_sub_entities'.<br>$sys_admin";
      CleanUp();
    }
    $show_by_sub_entities = ($show_by_sub_entities eq "YES" ? 1:0);
    if (not exists $input{'show_non_tax_section'})
    {
      PrintErrorHeader();
      print "<h1>Error:  Show Non-Tax Section must be set!</h1>\n";
      print "$sys_admin";
      CleanUp();
    }
    $show_non_tax_section = $input{'show_non_tax_section'};
    if (not ($show_non_tax_section eq "YES" || $show_non_tax_section eq "NO"))
    {
      PrintErrorHeader();
      print "<h1>Error:  Invalid value set for Show Non-Tax Section!</h1>\n";
      print "Value set was '$show_non_tax_section'.<br>$sys_admin";
      CleanUp();
    }
    $show_non_tax_section = ($show_non_tax_section eq "YES" ? 1:0);
    if (not exists $input{'report_type'})
    {
      PrintErrorHeader();
      print "<h1>Error:  Report Type must be set!</h1>\n";
      print "$sys_admin";
      CleanUp();
    }
    $report_type = $input{'report_type'};
    if (not ($report_type eq "services" || $report_type eq "investment"))
    {
      PrintErrorHeader();
      print "<h1>Error:  Invalid value for Report Type!</h1>\n";
      print "Value given was '$report_type'.<br>$sys_admin";
      CleanUp();
    }
}

return 1;
