#!/usr/bin/perl
#$Id: sub_accounts_config4.cgi,v 1.5 2004/06/18 19:43:09 pattieja Exp $
#This package is released under the GPL.  You should have recieved the GPL with it.
# Copyright (c) 2000 HLR http://www.pcxperience.org  All rights reserved.
# sub_accounts_config4.cgi  -  Created by James Pattie, 06/26/1999
# This script creates or updates the sub account specified from
# the previous script.

use strict;

use Pg;  # PostgreSQL Database Module
use cgi_lib;  # CGI Library routines
use custom;  # our customizable features

use vars '$date';
my $error_string;
my $ledger_db;

use PortalWrapper; # The Portal Wrapper library.

my $portalObj;
$portalObj = PortalWrapper->new;
if ($portalObj->didErrorOccur)
{
  # begin the HTML Output
  print cgi_lib::PrintHeader();
  print "<html>\n";

  PrintErrorHeader();
  print $portalObj->errorMessage;
  CleanUp();
}
my $dbObj;
$dbObj = $portalObj->getDBInfo;
if (!defined $dbObj)
{
  if ($portalObj->didErrorOccur)
  {
    # begin the HTML Output
    print cgi_lib::PrintHeader();
    print "<html>\n";
  
    PrintErrorHeader();
    print $portalObj->errorMessage;
    CleanUp();
  }
}
else
{
  if ($dbObj->didErrorOccur)
  {
    # begin the HTML Output
    print cgi_lib::PrintHeader();
    print "<html>\n";
  
    PrintErrorHeader();
    print $dbObj->errorMessage;
    CleanUp();
  }
}
$db_host = $dbObj->dbHost;
$db_name = $dbObj->dbName;
$db_user = $dbObj->dbUser;
$db_passwd = $dbObj->dbPasswd;

my $database_connected;
$database_connected = 0;

# get the values being passed in from the client
%input = ();  # make sure it is empty!
cgi_lib::ReadParse(*input);

# begin the HTML Output
print cgi_lib::PrintHeader();
print "<html>\n";

$ledger_db = $input{'ledger'};

# check and make sure that we have either the create or update
# buttons being passed in.
if (not (exists $input{'update'} or exists $input{'create'} or exists $input{createStock} or exists $input{updateStock}))
{
  PrintErrorHeader();
  print "<h1>Error:  Access Denied!</h1>\n";
  print "Invalid calling option.<br>$sys_admin";
  CleanUp();
}

my ($mode, $sub_name, $sub_num, $sub_type, $old_sub_name, $ticker, $stockName, $market, $oldTicker, $oldStockName, $oldMarket);

if (exists $input{'update'} or exists $input{'create'} or exists $input{createStock} or exists $input{updateStock})
{
  $sub_name = $input{'sub_acct_name'};
  if (length $sub_name == 0)
  {
    PrintErrorHeader();
    print "<h1>Error:  Sub Account Name must be specified!</h1>\n$back_button";
    CleanUp();
  }
  $error_string = IsValidString($sub_name);
  if (length $error_string != 0)
  {
    PrintErrorHeader();
    print "<h1>Error:  Invalid Sub Account Name!</h1>\n";
    print "<b>$error_string</b> is invalid.<br>$back_button";
    CleanUp();
  }

  $sub_num = $input{'sub_acct_number'};
  if (length $sub_num == 0)
  {
    PrintErrorHeader();
    print "<h1>Error:  Sub Account Number must be specified!</h1>\n$back_button";
    CleanUp();
  }
  $error_string = IsValidInteger($sub_num);
  if (length $error_string != 0)
  {
    PrintErrorHeader();
    print "<h1>Error:  Invalid Sub Account Number!</h1>\n";
    print "<b>$error_string</b> is invalid.<br>$back_button";
    CleanUp();
  }
  if ($sub_num <= 0)
  {
    PrintErrorHeader();
    print "<h1>Error:  Invalid Sub Account Number!</h1>\n";
    print "The Sub Account Number can not be less than 1!<br><b>$sub_num</b> is invalid.<br>$back_button";
    CleanUp();
  }

  $sub_type = $input{'sub_acct_type'};
  if (length $sub_type == 0)
  {
    PrintErrorHeader();
    print "<h1>Error: Sub Account Type must be specified!</h1>\n$back_button";
    CleanUp();
  }
  $error_string = IsValidInteger($sub_type);
  if (length $error_string != 0)
  {
    PrintErrorHeader();
    print "<h1>Error: Invalid Sub Account Type!</h1>\n";
    print "<b>$error_string</b> is invalid.<br>$back_button";
    CleanUp();
  }
}

if (exists $input{'update'})
{
  $mode = 1;

  $old_sub_name = $input{'old_sub_acct_name'};
  if (length $old_sub_name == 0)
  {
    PrintErrorHeader();
    print "<h1>Error:  Old Sub Account Name must be specified!</h1>\n$sys_admin";
    CleanUp();
  }
  $error_string = IsValidString($old_sub_name);
  if (length $error_string != 0)
  {
    PrintErrorHeader();
    print "<h1>Error:  Invalid Old Sub Account Name!</h1>\n";
    print "<b>$error_string</b> is invalid.<br>$back_button";
    CleanUp();
  }
}
elsif (exists $input{'create'})
{
  $mode = 2;
}
elsif (exists $input{createStock})
{
  $mode = 3;
  
  # validate Stock specific data.
  $ticker = $input{ticker};
  if (length $ticker > 10)
  {
    PrintErrorHeader();
    print "<h1>Error:  ticker = '$ticker' is invalid!</h1><br>Length must be less than or equal to 10.<br>\n$back_button";
    CleanUp();
  }
  $stockName = $input{stockName};
  if (length $stockName == 0)
  {
    PrintErrorHeader();
    print "<h1>Error:  stockName = '$stockName' is invalid!</h1>\n$back_button";
    CleanUp();
  }
  $market = $input{market};
}
elsif (exists $input{updateStock})
{
  $mode = 4;
  
  #validate Stock specific data.
  $ticker = $input{ticker};
  if (length $ticker > 10)
  {
    PrintErrorHeader();
    print "<h1>Error:  ticker = '$ticker' is invalid!</h1><br>Length must be less than or equal to 10.<br>\n$back_button";
    CleanUp();
  }
  $stockName = $input{stockName};
  if (length $stockName == 0)
  {
    PrintErrorHeader();
    print "<h1>Error:  stockName = '$stockName' is invalid!</h1>\n$back_button";
    CleanUp();
  }
  $market = $input{market};

  $old_sub_name = $input{'old_sub_acct_name'};
  if (length $old_sub_name == 0)
  {
    PrintErrorHeader();
    print "<h1>Error:  Old Sub Account Name must be specified!</h1>\n$sys_admin";
    CleanUp();
  }
  $error_string = IsValidString($old_sub_name);
  if (length $error_string != 0)
  {
    PrintErrorHeader();
    print "<h1>Error:  Invalid Old Sub Account Name!</h1>\n";
    print "<b>$error_string</b> is invalid.<br>$back_button";
    CleanUp();
  }
  
  $oldTicker = $input{oldTicker};
  if (length $oldTicker > 10)
  {
    PrintErrorHeader();
    print "<h1>Error:  oldTicker = '$oldTicker' is invalid!</h1>\n$back_button";
    CleanUp();
  }
  $oldStockName = $input{oldStockName};
  if (length $oldStockName == 0)
  {
    PrintErrorHeader();
    print "<h1>Error:  oldStockName = '$oldStockName' is invalid!</h1>\n$back_button";
    CleanUp();
  }
  $oldMarket = $input{oldMarket};
}

# check to see if we are running under mod_perl
if (exists $ENV{MOD_PERL})
{
  # check to see if the database is still connected
  if (defined $conn)
  {
    # check the status of the connection
    if ($conn->status != PGRES_CONNECTION_OK)
    {
      $database_connected = 0;
    }
    else
    {
      # connection still good!
      $database_connected = 1;
    }
  }
  else
  {
    $database_connected = 0;
  }
}

if (not $database_connected)
{
  # connect to the database.
  $conn = Pg::connectdb("host = $db_host dbname = $db_name user = $db_user password = $db_passwd");
  if ($conn->status == PGRES_CONNECTION_BAD)
  {
    PrintErrorHeader();
    print "<h1>Error:  Couldn't connect to the database!</h1><br>\n";
    print $conn->errorMessage . "<br>$sys_admin";
    CleanUp();
  }
}

# set the DateStyle for the Database.
$result = setDBDateStyle($conn);
if ($result->resultStatus != PGRES_COMMAND_OK)
{
  PrintErrorHeader();
  print "<h1>Error:  Setting Date Style failed!</h1>\n";
  print $conn->errorMessage . "<br>$sys_admin";
  CleanUp();
}

# need to get the max length for a sub account number
$result = $conn->exec("select sub_acc_digits from version_tb");
if ($result->resultStatus != PGRES_TUPLES_OK)
{
  PrintErrorHeader();
  print "<h1>Error:  Accessing database failed!</h1>\n";
  print $conn->errorMessage . "<br>Tried to get length of a sub account from database.<br>$sys_admin";
  CleanUp();
}
if ($result->ntuples == 0)
{
  PrintErrorHeader();
  print "<h1>Error:  This software does not appear to be properly configured!</h1>\n";
  print "Tried to get length of a sub account from database.<br>$sys_admin";
  CleanUp();
}
my $sub_acct_length;
$sub_acct_length = $result->getvalue(0, 0);

# verify that the given account number is valid
if ((length $sub_num == 0 || length $sub_num > $sub_acct_length) && $mode != 4)
{
  PrintErrorHeader();
  print "<h1>Error:  The Sub Account Number is not valid.  It can not be longer than <font color=\"blue\">$sub_acct_length</font> digits!</h1>\n$back_button";
  CleanUp();
}

# get Markets to work with
my @markets;
@markets = getStockMarkets();

# validate the market given if working with a stock.
if ($mode == 3 || $mode == 4)
{
  my %markets = ();
  foreach my $tmpMarket (@markets)
  {
    $markets{$tmpMarket} = $tmpMarket;
  }
  if (length $market == 0 || $market =~ /^\s+$/)
  {
    PrintErrorHeader();
    print "<h1>Error:  market = '$market' is invalid!</h1>\n$back_button";
    CleanUp();
  }
  if ($mode == 4)  # check oldMarket and oldClass values.
  {
    if (length $oldMarket == 0 || $oldMarket =~ /^\s+$/ || not exists $markets{$oldMarket})
    {
      PrintErrorHeader();
      print "<h1>Error:  oldMarket = '$oldMarket' is invalid!</h1>\n$back_button";
      CleanUp();
    }
  }
}

print "<head><title>$prog_name $prog_version Working with Sub Accounts</title></head>\n";
print "<body bgcolor=$body_bgcolor>\n";
print <<"END_OF_STYLE";
<style type="text/css"><!--
  a:hover   { color: red }
  a:link    { text-decoration: none; color: blue }
  a:visited { text-decoration: none; color: blue }
  a:active  { text-decoration: none; color: blue }-->
</style>
<script language="Javascript1.2" src="../js/common.js"></script>
<script language=\"Javascript1.2\">
  <!--
  function SubmitForm()
  {
    document.sub_acct_admin.submit();
  }
  function SubmitForm2()
  {
    document.sub_acct_form.submit();
  }
  //-->
</script>
END_OF_STYLE
# get the date
$date = `/bin/date +%m-%d-%Y`;
chomp $date;

print "<center>\n";
print "<table border=0 width=100% cellspacing=0 cellpadding=2 bgcolor=\"$body_bgcolor\">\n";
print "<tr>\n";
print "<td width=47%>&nbsp;</td>\n";
print "<td align=left><a href=\"$site_dir/help.html#update_sub_accounts\" target=\"docs\"><img border=0 src=\"$site_dir/images/help.jpg\" alt=\"Help\"></a></td>\n";
print "<td align=right>$date</td></tr></table>\n<hr><br>\n";
print PrintStandardMainMenu($ledger_db);


if ($mode == 1)  # Edit
{
  # see if we need to actually update anything.
  if ($old_sub_name eq $sub_name)
  {
    print "<h1>No changes were made.</h1>\n";
    print "Not updating database.<br>\n";
  }
  else
  {
    # first verify that the Sub Account does exist.
    $result = $conn->exec("select type from sub_acc_tb where sub_acc_name = '$old_sub_name' and sub_acc_number = $sub_num and type = $sub_type");
    if ($result->resultStatus != PGRES_TUPLES_OK)
    {
      print "<h1>Error:  Accessing database failed!</h1>\n";
      print $conn->errorMessage . "<br>Tried to lookup Sub Account <font color=\"blue\">$old_sub_name - $sub_num</font> before updating.<br>$sys_admin";
      CleanUp();
    }
    if ($result->ntuples != 1)
    {
      print "<h1>Error:  Sub Account <font color=\"blue\">$old_sub_name - $sub_num</font> does not exist!</h1>\n";
      print "It may have already been deleted.<br>$sys_admin";
      CleanUp();
    }

    # make sure that they aren't using the same name or number in other Sub Account entries.
    if (not $old_sub_name eq $sub_name)
    {
      $result = $conn->exec("select sub_acc_number from sub_acc_tb where sub_acc_name = '$sub_name'");
      if ($result->resultStatus != PGRES_TUPLES_OK)
      {
        print "<h1>Error:  Accessing database failed!</h1>\n";
        print $conn->errorMessage . "<br>Tried to lookup Sub Account Name <font color=\"blue\">$sub_name</font> before updating.<br>$sys_admin";
        CleanUp();
      }
      if ($result->ntuples > 0)
      {
        print "<h1>Error:  Sub Account Name <font color=\"blue\">$sub_name</font> is already in use!<br>$back_button";
        CleanUp();
      }
    }

    # It is safe to update the Sub Account.

    # start a transaction
    $result = $conn->exec("begin work");
    if ($result->resultStatus != PGRES_COMMAND_OK)
    {
      print "<h1>Error:  Starting Transaction failed!</h1>\n";
      print $conn->errorMessage . "<br>Before updating of Sub Account <font color=\"blue\">$old_sub_name - $sub_num</font>.<br>$sys_admin";
      CleanUp();
    }

    # update the Sub Account
    $result = $conn->exec("update sub_acc_tb set sub_acc_name = '$sub_name' where sub_acc_name = '$old_sub_name' and sub_acc_number = $sub_num and type = $sub_type");
    if ($result->resultStatus != PGRES_COMMAND_OK)
    {
      print "<h1>Error:  Updating of Sub Account failed!</h1>\n";
      print $conn->errorMessage . "<br>Attempted updating of Sub Account <font color=\"blue\">$old_sub_name - $sub_num</font> to <font color=\"blue\">$sub_name - $sub_num</font> failed.<br>$sys_admin";
      CleanUp();
    }

    # commit the work
    $result = $conn->exec("commit work");
    if ($result->resultStatus != PGRES_COMMAND_OK)
    {
      print "<h1>Error:  Committing Transaction failed!</h1>\n";
      print $conn->errorMessage . "<br>After updating Sub Account <font color=\"blue\">$sub_name - $sub_num</font>.<br>$sys_admin";
      CleanUp();
    }

    print "Sub Account <font color=\"blue\">$sub_name - $sub_num</font> Successfully Updated!<br>\n";
  }
  print "<form name=\"sub_acct_form\" method=post action=\"$site_dir/cgi-bin/sub_accounts_config3.cgi\">\n";
  print "<input type=hidden name=\"submitted_by\" value=\"edit\">\n";
  print "<input type=hidden name=\"sub_acct\" value=\"$sub_num|$sub_name\">\n";
  if (length $ledger_db > 0)
  {
    print "<input type=hidden name=\"ledger\" value=\"$ledger_db\">\n";
  }
  print "<a href=\"\" onClick=\"SubmitForm2(); return false;\">To edit again, go <u>here</u>.</a>\n";
  print "</form>\n";
}
elsif ($mode == 2) # Create
{
  # first verify that the Sub Account doesn't already exist.
  $result = $conn->exec("select type from sub_acc_tb where sub_acc_name = '$sub_name' and sub_acc_number = $sub_num");
  if ($result->resultStatus != PGRES_TUPLES_OK)
  {
    print "<h1>Error:  Accessing database failed!</h1>\n";
    print $conn->errorMessage . "<br>Tried to lookup Sub Account <font color=\"blue\">$sub_name - $sub_num</font> before creating.<br>$sys_admin";
    CleanUp();
  }
  if ($result->ntuples != 0)
  {
    print "<h1>Error:  Sub Account <font color=\"blue\">$sub_name - $sub_num</font> already exists!</h1>\n$back_button";
    CleanUp();
  }

  # make sure that they aren't using the same name or number in other Sub Account entries.
  $result = $conn->exec("select sub_acc_name from sub_acc_tb where sub_acc_number = $sub_num");
  if ($result->resultStatus != PGRES_TUPLES_OK)
  {
    print "<h1>Error:  Accessing database failed!</h1>\n";
    print $conn->errorMessage . "<br>Tried to lookup Sub Account Number <font color=\"blue\">$sub_num</font> before creating.<br>$sys_admin";
    CleanUp();
  }
  if ($result->ntuples > 0)
  {
    print "<h1>Error:  Sub Account Number <font color=\"blue\">$sub_num</font> is already in use!</h1>\n<br>$back_button";
    CleanUp();
  }

  $result = $conn->exec("select sub_acc_number from sub_acc_tb where sub_acc_name = '$sub_name'");
  if ($result->resultStatus != PGRES_TUPLES_OK)
  {
    print "<h1>Error:  Accessing database failed!</h1>\n";
    print $conn->errorMessage . "<br>Tried to lookup Sub Account Name <font color=\"blue\">$sub_name</font> before creating.<br>$sys_admin";
    CleanUp();
  }
  if ($result->ntuples > 0)
  {
    print "<h1>Error:  Sub Account Name <font color=\"blue\">$sub_name</font> is already in use!</h1>\n<br>$back_button";
    CleanUp();
  }

  # It is safe to create the Sub Account.

  # start a transaction
  $result = $conn->exec("begin work");
  if ($result->resultStatus != PGRES_COMMAND_OK)
  {
    print "<h1>Error:  Starting Transaction failed!</h1>\n";
    print $conn->errorMessage . "<br>Before creation of Sub Account <font color=\"blue\">$sub_name - $sub_num</font>.<br>$sys_admin";
    CleanUp();
  }

  # create the Sub Account
  $result = $conn->exec("insert into sub_acc_tb (sub_acc_name, sub_acc_number, type) values ('$sub_name', $sub_num, $sub_type)");
  if ($result->resultStatus != PGRES_COMMAND_OK)
  {
    print "<h1>Error:  Creating Sub Account failed!</h1>\n";
    print $conn->errorMessage . "<br>Attempted creation of Sub Account <font color=\"blue\">$sub_name - $sub_num</font>.<br>$sys_admin";
    CleanUp();
  }

  # commit the work
  $result = $conn->exec("commit work");
  if ($result->resultStatus != PGRES_COMMAND_OK)
  {
    print "<h1>Error:  Committing Transaction failed!</h1>\n";
    print $conn->errorMessage . "<br>After creation of Sub Account <font color=\"blue\">$sub_name - $sub_num</font>.<br>$sys_admin";
    CleanUp();
  }

  print "Sub Account <font color=\"blue\">$sub_name - $sub_num</font> Successfully created!<br>\n";

  print "<form name=\"sub_acct_form\" method=post action=\"$site_dir/cgi-bin/sub_accounts_config3.cgi\">\n";
  print "<input type=hidden name=\"submitted_by\" value=\"\">\n";
  print "<input type=hidden name=\"sub_acct\" value=\"$sub_num|$sub_name\">\n";
  if (length $ledger_db > 0)
  {
    print "<input type=hidden name=\"ledger\" value=\"$ledger_db\">\n";
  }
  print "<a href=\"\" onClick=\"document.sub_acct_form.submitted_by.value='create';SubmitForm2(); return false;\">To create another, go <u>here</u>.</a>\n";
  print "</form>\n";
}
elsif ($mode == 3) # create stock
{
  # first verify that the Sub Account doesn't already exist.
  $result = $conn->exec("select type from sub_acc_tb where sub_acc_name = '$sub_name' and sub_acc_number = $sub_num");
  if ($result->resultStatus != PGRES_TUPLES_OK)
  {
    print "<h1>Error:  Accessing database failed!</h1>\n";
    print $conn->errorMessage . "<br>Tried to lookup Sub Account <font color=\"blue\">$sub_name - $sub_num</font> before creating.<br>$sys_admin";
    CleanUp();
  }
  if ($result->ntuples != 0)
  {
    print "<h1>Error:  Sub Account <font color=\"blue\">$sub_name - $sub_num</font> already exists!</h1>\n$back_button";
    CleanUp();
  }

  # make sure that they aren't using the same name or number in other Sub Account entries.
  $result = $conn->exec("select sub_acc_name from sub_acc_tb where sub_acc_number = $sub_num");
  if ($result->resultStatus != PGRES_TUPLES_OK)
  {
    print "<h1>Error:  Accessing database failed!</h1>\n";
    print $conn->errorMessage . "<br>Tried to lookup Sub Account Number <font color=\"blue\">$sub_num</font> before creating.<br>$sys_admin";
    CleanUp();
  }
  if ($result->ntuples > 0)
  {
    print "<h1>Error:  Sub Account Number <font color=\"blue\">$sub_num</font> is already in use!</h1>\n<br>$back_button";
    CleanUp();
  }

  $result = $conn->exec("select sub_acc_number from sub_acc_tb where sub_acc_name = '$sub_name'");
  if ($result->resultStatus != PGRES_TUPLES_OK)
  {
    print "<h1>Error:  Accessing database failed!</h1>\n";
    print $conn->errorMessage . "<br>Tried to lookup Sub Account Name <font color=\"blue\">$sub_name</font> before creating.<br>$sys_admin";
    CleanUp();
  }
  if ($result->ntuples > 0)
  {
    print "<h1>Error:  Sub Account Name <font color=\"blue\">$sub_name</font> is already in use!</h1>\n<br>$back_button";
    CleanUp();
  }

  # now validate that the stock hasn't already been created.
  $result = $conn->exec("SELECT ticker, name FROM stocks_tb WHERE sub_acct = $sub_num");
  if ($result->resultStatus != PGRES_TUPLES_OK)
  {
    print "<h1>Error:  Accessing database failed!</h1>\n";
    print $conn->errorMessage . "<br>Tried to lookup Sub Account Number <font color=\"blue\">$sub_num</font> in stocks_tb before creating.<br>$sys_admin";
    CleanUp();
  }
  if ($result->ntuples > 0)
  {
    my $ticker = $result->getvalue(0, 0);
    print "<h1>Error:  Stock with ticker = '$ticker' is already created for SubAccount = '$sub_name - $sub_num'!</h1>\n<br>$back_button";
    CleanUp();
  }

  if ($ticker !~ /^\s*$/)
  {
    $result = $conn->exec("SELECT name, sub_acct FROM stocks_tb WHERE ticker = '$ticker'");
    if ($result->resultStatus != PGRES_TUPLES_OK)
    {
      print "<h1>Error:  Accessing database failed!</h1>\n";
      print $conn->errorMessage . "<br>Tried to lookup Stock Ticker <font color=\"blue\">$ticker</font> in stocks_tb before creating.<br>$sys_admin";
      CleanUp();
    }
    if ($result->ntuples > 0)
    {
      my $name = $result->getvalue(0, 0);
      my $sub_acct = $result->getvalue(0, 1);
      print "<h1>Error:  Stock with ticker = '$ticker', name = '$name' is already created for SubAccount = '$sub_acct'!</h1>\n<br>$back_button";
      CleanUp();
    }
  }

  $result = $conn->exec("SELECT ticker, sub_acct FROM stocks_tb WHERE name = '$stockName'");
  if ($result->resultStatus != PGRES_TUPLES_OK)
  {
    print "<h1>Error:  Accessing database failed!</h1>\n";
    print $conn->errorMessage . "<br>Tried to lookup Stock Name <font color=\"blue\">$stockName</font> in stocks_tb before creating.<br>$sys_admin";
    CleanUp();
  }
  if ($result->ntuples > 0)
  {
    my $ticker = $result->getvalue(0, 0);
    my $sub_acct = $result->getvalue(0, 1);
    print "<h1>Error:  Stock with name = '$stockName', ticker = '$ticker' is already created for SubAccount = '$sub_acct'!</h1>\n<br>$back_button";
    CleanUp();
  }

  # It is safe to create the Sub Account.

  # start a transaction
  $result = $conn->exec("begin work");
  if ($result->resultStatus != PGRES_COMMAND_OK)
  {
    print "<h1>Error:  Starting Transaction failed!</h1>\n";
    print $conn->errorMessage . "<br>Before creation of Sub Account <font color=\"blue\">$sub_name - $sub_num</font>.<br>$sys_admin";
    CleanUp();
  }

  # create the Sub Account
  $result = $conn->exec("insert into sub_acc_tb (sub_acc_name, sub_acc_number, type) values ('$sub_name', $sub_num, $sub_type)");
  if ($result->resultStatus != PGRES_COMMAND_OK)
  {
    print "<h1>Error:  Creating Sub Account failed!</h1>\n";
    print $conn->errorMessage . "<br>Attempted creation of Sub Account <font color=\"blue\">$sub_name - $sub_num</font>.<br>$sys_admin";
    CleanUp();
  }

  # create the stock
  $ticker = uc($ticker);
  $result = $conn->exec("INSERT INTO stocks_tb (ticker, name, sub_acct, market) VALUES ('$ticker', '$stockName', $sub_num, '$market')");
  if ($result->resultStatus != PGRES_COMMAND_OK)
  {
    print "<h1>Error:  Creating Stock failed!</h1>\n";
    print $conn->errorMessage . "<br>Attempted creation of Stock <font color=\"blue\">$ticker</font>.<br>$sys_admin";
    CleanUp();
  }

  # commit the work
  $result = $conn->exec("commit work");
  if ($result->resultStatus != PGRES_COMMAND_OK)
  {
    print "<h1>Error:  Committing Transaction failed!</h1>\n";
    print $conn->errorMessage . "<br>After creation of Stock <font color=\"blue\">$ticker</font>.<br>$sys_admin";
    CleanUp();
  }

  print "Stock <font color=\"blue\">$sub_name - $sub_num</font> ";
  if ($ticker !~ /^\s*$/)
  {
    print "with ticker = <b>$ticker</b> ";
  }
  print "Successfully created!<br>\n";

  print "<form name=\"sub_acct_form\" method=post action=\"$site_dir/cgi-bin/sub_accounts_config3.cgi\">\n";
  print "<input type=hidden name=\"submitted_by\" value=\"\">\n";
  print "<input type=hidden name=\"sub_acct\" value=\"$sub_num|$sub_name\">\n";
  if (length $ledger_db > 0)
  {
    print "<input type=hidden name=\"ledger\" value=\"$ledger_db\">\n";
  }
  print "<a href=\"\" onClick=\"document.sub_acct_form.submitted_by.value='createStock';SubmitForm2(); return false;\">To create another, go <u>here</u>.</a>\n";
  print "</form>\n";
}
elsif ($mode == 4) # edit stock
{
  # see if we need to actually update anything.
  if ($old_sub_name eq $sub_name && $oldTicker eq $ticker && $oldStockName eq $stockName && $oldMarket eq $market)
  {
    print "<h1>No changes were made.</h1>\n";
    print "Not updating database.<br>\n";
  }
  else
  {
    # first verify that the Sub Account does exist.
    $result = $conn->exec("select type from sub_acc_tb where sub_acc_name = '$old_sub_name' and sub_acc_number = $sub_num and type = $sub_type");
    if ($result->resultStatus != PGRES_TUPLES_OK)
    {
      print "<h1>Error:  Accessing database failed!</h1>\n";
      print $conn->errorMessage . "<br>Tried to lookup Sub Account <font color=\"blue\">$old_sub_name - $sub_num</font> before upating.<br>$sys_admin";
      CleanUp();
    }
    if ($result->ntuples != 1)
    {
      print "<h1>Error:  Sub Account <font color=\"blue\">$old_sub_name - $sub_num</font> does not exist!</h1>\n";
      print "It may have already been deleted.<br>$sys_admin";
      CleanUp();
    }

    # verify that the stock info still exists.
    $result = $conn->exec("SELECT sub_acct FROM stocks_tb WHERE ticker = '$oldTicker' AND name = '$oldStockName' AND sub_acct = $sub_num AND market = '$oldMarket'");
    if ($result->resultStatus != PGRES_TUPLES_OK)
    {
      print "<h1>Error:  Accessing database failed!</h1>\n";
      print $conn->errorMessage . "<br>Tried to lookup Stock <font color=\"blue\">$oldStockName</font> with Ticker <b>$oldTicker</b> before updating.<br>$sys_admin";
      CleanUp();
    }
    if ($result->ntuples != 1)
    {
      print "<h1>Error:  Stock <font color=\"blue\">$oldStockName</font> with Ticker <b>$oldTicker</b>, Sub Account Number <b>$sub_num</b> does not exist!</h1>\n";
      print "It may have already been deleted.<br>$sys_admin";
      CleanUp();
    }

    # make sure that they aren't using the same name or number in other Sub Account entries.
    if (not $old_sub_name eq $sub_name)
    {
      $result = $conn->exec("select sub_acc_number from sub_acc_tb where sub_acc_name = '$sub_name'");
      if ($result->resultStatus != PGRES_TUPLES_OK)
      {
        print "<h1>Error:  Accessing database failed!</h1>\n";
        print $conn->errorMessage . "<br>Tried to lookup Sub Account Name <font color=\"blue\">$sub_name</font> before updating.<br>$sys_admin";
        CleanUp();
      }
      if ($result->ntuples > 0)
      {
        my $sub_num = $result->getvalue(0, 0);
        print "<h1>Error:  Sub Account Name <font color=\"blue\">$sub_name</font> is already in use by Sub Account <b>$sub_num</b>!<br>$back_button";
        CleanUp();
      }
    }

    # make sure the Stock info isn't being used anywhere else.
    if ($oldStockName ne $stockName)
    {
      $result = $conn->exec("SELECT ticker, sub_acct FROM stocks_tb WHERE name = '$stockName'");
      if ($result->resultStatus != PGRES_TUPLES_OK)
      {
        print "<h1>Error:  Accessing database failed!</h1>\n";
        print $conn->errorMessage . "<br>Tried to lookup Stock Name <font color=\"blue\">$stockName</font> before updating.<br>$sys_admin";
        CleanUp();
      }
      if ($result->ntuples > 0)
      {
        my $ticker = $result->getvalue(0, 0);
        my $sub_num = $result->getvalue(0, 1);
        print "<h1>Error:  Stock Name <font color=\"blue\">$stockName</font> is already in use by Stock with Ticker <b>$ticker</b>, Sub Account <b>$sub_num</b>!<br>$back_button";
        CleanUp();
      }
    }
    if ($oldTicker ne $ticker && $ticker !~ /^\s*$/)
    {
      $result = $conn->exec("SELECT name, sub_acct FROM stocks_tb WHERE ticker = '$ticker'");
      if ($result->resultStatus != PGRES_TUPLES_OK)
      {
        print "<h1>Error:  Accessing database failed!</h1>\n";
        print $conn->errorMessage . "<br>Tried to lookup Ticker <font color=\"blue\">$ticker</font> before updating.<br>$sys_admin";
        CleanUp();
      }
      if ($result->ntuples > 0)
      {
        my $name = $result->getvalue(0, 0);
        my $sub_num = $result->getvalue(0, 1);
        print "<h1>Error:  Ticker <font color=\"blue\">$ticker</font> is already in use by Stock with Name <b>$name</b>, Sub Account <b>$sub_num</b>!<br>$back_button";
        CleanUp();
      }
    }

    # It is safe to update the Sub Account.

    # start a transaction
    $result = $conn->exec("begin work");
    if ($result->resultStatus != PGRES_COMMAND_OK)
    {
      print "<h1>Error:  Starting Transaction failed!</h1>\n";
      print $conn->errorMessage . "<br>Before updating of Stock <b>$oldStockName</b>, Ticker <b>$oldTicker</b>, Sub Account <font color=\"blue\">$old_sub_name - $sub_num</font>.<br>$sys_admin";
      CleanUp();
    }

    # update the Sub Account
    $result = $conn->exec("update sub_acc_tb set sub_acc_name = '$sub_name' where sub_acc_name = '$old_sub_name' and sub_acc_number = $sub_num and type = $sub_type");
    if ($result->resultStatus != PGRES_COMMAND_OK)
    {
      print "<h1>Error:  Updating of Sub Account failed!</h1>\n";
      print $conn->errorMessage . "<br>Attempted updating of Sub Account <font color=\"blue\">$old_sub_name - $sub_num</font> to <font color=\"blue\">$sub_name - $sub_num</font> failed.<br>$sys_admin";
      CleanUp();
    }

    # update the Stock
    $ticker = uc($ticker);
    $result = $conn->exec("UPDATE stocks_tb SET ticker = '$ticker', name = '$stockName', market = '$market' WHERE ticker = '$oldTicker' AND name = '$oldStockName' AND market = '$oldMarket' AND sub_acct = $sub_num");
    if ($result->resultStatus != PGRES_COMMAND_OK)
    {
      print "<h1>Error:  Updating of Stock failed!</h1>\n";
      print $conn->errorMessage . "<br>Attempted updating of Stock from Ticker <b>$oldTicker</b>, Name <b>$oldStockName</b>, Market <b>$oldMarket</b>, Sub Account <font color=\"blue\">$sub_num</font> to Ticker <b>$ticker</b>, Name <b>$stockName</b>, Market <b>$market</b> failed.<br>$sys_admin";
      CleanUp();
    }

    # commit the work
    $result = $conn->exec("commit work");
    if ($result->resultStatus != PGRES_COMMAND_OK)
    {
      print "<h1>Error:  Committing Transaction failed!</h1>\n";
      print $conn->errorMessage . "<br>After updating Stock with Ticker <b>$ticker</b>, Name <b>$stockName</b>, Sub Account <font color=\"blue\">$sub_name - $sub_num</font>.<br>$sys_admin";
      CleanUp();
    }

    print "Stock with Ticker <b>$ticker</b>, Name <b>$stockName</b>, Sub Account <font color=\"blue\">$sub_name - $sub_num</font> Successfully Updated!<br>\n";
  }
  print "<form name=\"sub_acct_form\" method=post action=\"$site_dir/cgi-bin/sub_accounts_config3.cgi\">\n";
  print "<input type=hidden name=\"submitted_by\" value=\"edit\">\n";
  print "<input type=hidden name=\"sub_acct\" value=\"$sub_num|$sub_name\">\n";
  if (length $ledger_db > 0)
  {
    print "<input type=hidden name=\"ledger\" value=\"$ledger_db\">\n";
  }
  print "<a href=\"\" onClick=\"SubmitForm2(); return false;\">To edit again, go <u>here</u>.</a>\n";
  print "</form>\n";
}

# print a horizontal rule to break the menu from the behind the scenes links
print "<br><hr>\n";

print "<form name=\"sub_acct_admin\" method=post action=\"$site_dir/cgi-bin/sub_accounts_config2.cgi\">\n";
print "<input type=hidden name=\"nothing\" value=\"\">\n";
if (length $ledger_db > 0)
{
  print "<input type=hidden name=\"ledger\" value=\"$ledger_db\">\n";
}
print "<div align=left><a href=\"\" onClick=\"SubmitForm(); return false;\">Sub Account Administration</a></div>\n";
print "</form>\n";

if (length $ledger_db == 0)
{
  print "<br><div align=left><a href=\"$site_dir/cgi-bin/account_config.cgi\">Account Configuration</a></div>\n";
  print "<br><div align=left><a href=\"$site_dir/cgi-bin/prg_config.cgi\">Program Configuration</a></div>\n";
}
else
{
  print "<form name=\"form1\" method=post action=\"\">\n";
  print "<input type=hidden name=\"ledger\" value=\"$ledger_db\">\n";
  print "<br><div align=left><a href=\"$site_dir/cgi-bin/account_config.cgi\" onClick=\"go_here(document.form1, '$site_dir/cgi-bin/account_config.cgi'); return false;\">Account Configuration</a></div>\n";
  print "<br><div align=left><a href=\"$site_dir/cgi-bin/prg_config.cgi\" onClick=\"go_here(document.form1, '$site_dir/cgi-bin/prg_config.cgi'); return false;\">Program Configuration</a></div>\n";
  print "<input type=hidden name=\"open\" value=\"Open\">\n";
  print "<br><div align=left><a href=\"$site_dir/cgi-bin/ledger.cgi\" onClick=\"go_here(document.form1, '$site_dir/cgi-bin/ledger.cgi'); return false;\">Return to Ledger Summary</a></div>\n";
  print "</form>\n";
}

print "</body>\n";
print "</html>\n";
exit 0;

sub getStockMarkets
{
  my $result = $conn->exec("SELECT DISTINCT(market) FROM stocks_tb WHERE market <> 'None' ORDER BY market");
  if ($result->resultStatus != PGRES_TUPLES_OK)
  {
    PrintErrorHeader();
    print "<h1>Error:  Accessing database failed!</h1>\n";
    print $conn->errorMessage . "<br>Tried to get list of Stock Markets from database.<br>$sys_admin";
    CleanUp();
  }

  my @values = ();

  for (my $i=0; $i < $result->ntuples; $i++)
  {
    $values[$i] = $result->getvalue($i, 0);
  }

  push @values, "None";
  
  return @values;
}
